/*
	OuDia - Win32 Application Software to draw a "Train Service Planning
 Diagram" based on a "Train Timetable".

Copyright (C) 2006-2017 take-okm

This program is free software; you can redistribute it and/or modify it 
under the terms of the GNU General Public License as published by the Free 
Software Foundation; either version 3 of the License, or (at your option) 
any later version. 

This program is distributed in the hope that it will be useful, but WITHOUT 
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or 
FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for 
more details. 

You should have received a copy of the GNU General Public License along with
 this program. If not, see <http://www.gnu.org/licenses/>.

  In addition, as a special exception, take-okm
  gives permission to link the code of this program with
  the "MFC(Microsoft Foundation Class library) Version 9.0" 
  (or with modified versions of "MFC Version 9.0" that use the same license as 
  "MFC Version 9.0" ), and distribute linked combinations including
  the two.  You must obey the GNU General Public License in all
  respects for all of the code used other than  "MFC".  If you modify
  this file, you may extend this exception to your version of the
  file, but you are not obligated to do so.  If you do not wish to
  do so, delete this exception statement from your version.


(: 

	OuDia - Ԏ\ƂɁA_CO`悷Win32AvP[V
B

Copyright (C) 2006-2017 take-okm 

̃vO̓t[\tgEFAłBȂ͂At[\tgEFA
cɂĔsꂽGNU ʌOp(o[W3Aȍ~̃o[W
̂ǂꂩ)߂̉ōĔЕz܂͉ 邱Ƃł܂B

̃vO͗Lpł邱ƂĔЕz܂A*S̖ۏ *łB
Ɖ\̕ۏ؂ړIւ̓ḰAOɎꂽ̂ ܂߁AS
܂BڂGNU ʌOpB

Ȃ͂̃vOƋɁAGNU ʌOp̃Rs[ꕔ 󂯎
Ă͂łB󂯎ĂȂ΁A<http://www.gnu.org/licenses/> 
B

)

  āAʂȗOƂāAtake-okm ͂̃vÕR[h 
  "MFC(Microsoft Foundation Class library) Version 9.0" 
  (  邢 "MFC Version 9.0" ƓCZXKpꂽ
  "MFC Version 9.0" ̉ςꂽo[W)ƃNA
  Nꂽ҂܂ތ앨Еz鋖^܂B
  Ȃ "MFC" ȊOŎgĂ邷ׂ
  ̃R[hɊւĂ͑SʓIGNUʌOp_񏑂ɏ]Ȃ
  Ȃ܂BȂ̃t@CςȂ΁AȂ̗͂O
  Ȃ̃o[W̃t@CɈ݂邱Ƃł܂A
  `͂܂BO݂Ȃ΁A̗O
  Ȃ̃o[W͍폜ĂB)
*/
/*
// ****************************************************************
//	CentDedRessya.h
// ****************************************************************
*/
/** @file */
#ifndef  CentDedRessya_h
#define  CentDedRessya_h


#include <deque>
using namespace std ;


#include "Cont/Ccont_deque.h"
#include "cont/CaContGet_ptref.h"

#include "CentDed.h"
#include "CentDedEkiJikoku.h"
#include "CdDedJikan.h"
#include "CentDedEkiCont.h"


// ****************************************************************
//	CentDedRessya
// ****************************************************************
/**
 * @brief
 *	yTvz  DiagramEdit ́AHŉ^swԁxP{\܂B
 *	
 *	̃NX̃CX^X́Aʏ́wHxi CentDedRosen j
 *	܂܂B
 *	
 *	ۂɂ́A
 *	
 *	- wHx (CentDedRosen) w_Cx ( CentDedDia ) 
 *	Oȏ㕡
 *	- ew_Cx ( CentDedDia ) wԁx (CentDedRessya ) 
 *	Oȏ㕡
 *	
 *	Ƃ֌WɂȂĂ܂B
 *	
 *	̃NX́AwHxi CentDedRosen jɑ݂
 *	wwx ( CentDedEki )̐Awwx(CentDedEkiJikokuj
 *	IuWFNgێ܂BwHx ( CentDedRosen )ɕ܂
 *	ׂẮwԁx( CentDedRessya )܂
 *	wwx ( CentDedEkiJikoku ) IuWFNg̐́A
 *	wHx ( CentDedRosen )́wwx ( CentDedEki ) ̐ƓłȂĂ
 *	Ȃ܂B
 *	  ̓Ƃ邽߁Awԁx ( CentDedRessya ) ɑ΂
 *	wwx ( CentDedEkiJikoku ) IuWFNg̒ǉE폜̑͐
 *	Ă܂B
 *	wwx̒ǉE폜̑́AwHxIuWFNgɑ΂Ă̂
 *	̂Ƃ܂B̃NX 
 *	wHx ( CentDedRosen ) Ew_Cx ( CentDedDia ) 
 *	 friend NXɎw肵Ă̂͂̂߂łB
 *	
 *	܂ÃNXێAwԎIndexx́A
 *	wHx( CentDedRosen )ێwԎʁx ( CentDedRessyasyubetsu )
 *	IuWFNgɑΉ܂B
 *	
 *	̃IuWFNǵALȗԃf[^ȂwNullԁx
 *	Ƃ邱Ƃł܂B
 *	wNullԁx̗Ԃ́Aw\r[xł͋sƂĕ\܂B
 *	
 *	<H4>
 *	ywIndex  wOrder , Orderz
 *	</H4>
 *	  wHx ( CentDedRosen ) IuWFNg̓
 *	wwx ( CentDedEki )IuWFNgw肷@Ay
 *	wԁx ( CentDedRessya )IuWFNg̓
 *	wwx ( CentDedEkiJikoku ) IuWFNgw肷@ɂ́A
 *	wwIndexxEwwOrderx̂Q܂BǂA
 *	0 ȏ ( w̐)  ̐ŁAwwxw肵܂B
 *	
 *	  wwIndexx́AH̉Ԃ̎nwiԂ̏Iwj 0 E 
 *	Ԃ̏IwiԂ̎nwj  ( w̐ - 1 ) ƂȂ܂B
 *	
 *	  wwOederx́AԂ̕ʂ̃CfNXłBԁE
 *	ƂɎnw 0 E Iw ( w̐ - 1 ) 
 *	Ȃ܂B
 *
 *	  ]āAwwIndexx 0 ̉ẃAԂɂƂẮwwOederx 
 *	 0 łAԂɂƂẮwwOrderx  iw̐ - 1 jƂȂ܂B 
 *	
 *	  wHx ( CentDedRosen ) NXł́AƂ
 *	wwx( CentDedEki ) IuWFNgw肷̂ɁwwIndexxg܂B
 *	wwxێRei CentDedRosen::m_CentDedEkiCont ̓Y
 *	wwIndexxɂȂĂ܂B
 *	\n  Ƃ͑ΏƓIɁAwԁx(NXł́AƂ
 *	wwx ( CentDedEkiJikoku ) IuWFNgw肷̂ɂ
 *	wwOrderxg܂Bwwx ( CentDedEkiJikoku ) ێRei
 *	  CentDedRessya::m_CentDedEkiJikokuCont ̓YAwwOrderx 
 *	ƂȂ܂B
 *	  ǂ̃NXɂĂAwwIndexxƁwwOrderx̑ݕϊs
 *	\bh EkiIndexOfEkiOrder() , EkiOrderOfEkiIndex() 񋟂Ă܂B
 *	
 *	wOrderx́AwԁxIuWFNgŁA̎
 *	iw̒Êꂩjw肷鏇łB
 *	wOrderx́Aȉ̖@܂B
 *	l͈̔͂́A0 ȏ w̐*2 łB
 *	
 *	- wwOrderx*2 + 0 EEEwwOrderx̉w̒(Ƃȍ~)
 *	ύX܂B
 *	- wwOrderx*2 + 1 EEEwwOrderx̉w̔(Ƃȍ~)
 *	ύX܂B
 *	
 */
class CentDedRessya
{
// ********************************
//	Ci[^Cv
// ********************************
 public:
	typedef deque< CentDedEkiJikoku* > CentDedEkiJikokuCont ;
	
// ********************************
///@name 
// ********************************
///@{
 private:
	/**
	 *	̗ԂwNullԁxȂ^A
	 *	LȗԑێĂ̂ȂUłB
	 *	
	 *	̑^̏ꍇA 
	 *	-	m_iRessyasyubetsuIndex,
	 *	-	m_strRessyabangou ;
	 *	-	m_strRessyamei ;
	 *	-	m_strGousuu ;
	 *	-	m_strBikou ;
	 *
	 *	сA
	 *		m_CentDedEkiJikokuCont Ɋi[Ă 
	 *	CentDedEkiJikoku ́AӖ܂B
	 *	
	 *	Kl true łB
	 *	set...() \bhŁAm_eRessyahoukou ȊO
	 *	ꂩ̑ݒ肵Ƃɂ́A
	 *	IɋUɕς܂B
	 *	clear() ŁA^ƂȂ܂B
	 */
	bool m_bIsNull ;

	/**
	 *	̗Ԃ̗ԕ܂B
	 *	
	 *	Kl Ressyahoukou_Kudari łB
	 *
	 *	RXgN^Ō܂܂B
	 */
	ERessyahoukou	m_eRessyahoukou ;

	/**
	 *	̗Ԃ́wԎʁxA
	 *	wԎIndexxŕێ܂B
	 *	
	 *	Kl 0 łB
	 */
	int	m_iRessyasyubetsuIndex ;
	
	/**
	 *	̗Ԃ́wԔԍxB
	 *	
	 *	Kl͋󕶎łB
	 */
	string m_strRessyabangou ;
	
	/**
	 *	̗Ԃ́wԖxB
	 *	
	 *	Kl͋󕶎łB
	 */
	string m_strRessyamei ;
	
	/**
	 *	̗Ԃ́wxB
	 *	
	 *	Kl͋󕶎łB
	 */
	string m_strGousuu ;
	
	/**
	 *	̗Ԃ́wlxB
	 *	
	 *	Kl͋󕶎łB
	 */
	string m_strBikou ;
	
///@}
// ********************************
///@name 
// ********************************
///@{
 private:
	/**
	 *	̗Ԃ̊ew̎B
	 *	vf́Awwx( CentDedEki ) ̐ɓȂ܂B
	 *	ÝwwOrderxłB
	 *
	 *	̃ReĩIuWFNg̐Ej̐Ӗthisɂ܂B
	 *
	 *	Ԃł́Avf 0 ƂȂ܂B
	 *
	 *	ׂẮwwx
	 *	w^sȂx(Ekiatsukai_None ),
	 *	̏ꍇA̗Ԃ́wNullԁxƂȂ܂B
	 */
	CentDedEkiJikokuCont	m_CentDedEkiJikokuCont ;

///@}

// --------------------------------
///@name CentDedRosenCentDedRessyaCont po֐
// --------------------------------
///@{
 protected:
	/**
	 *	wwxIuWFNg̑̕ύXʒm܂B
	 *	
	 *	̊֐́AwnwEIw̉w`ύXɔAȄCx
	 *	s킹܂B
	 * @param iEkiOrder [in]
	 *	IuWFNg}ʒuwwOrderxŎw肵ĂB
	 *	͈͂ 0 ȏ m_iEkiCount ȉłB
	 * @return
	 *	 0 ȏAG[Ȃ畉̐łB
	 */
	int onSetCentDedEki( const IfContGet<CentDedEkiCont::CdDedEki>* pCentDedEkiCont , int iEkiOrder ) ;

	/**
	 *	wwxIuWFNgAẅʒuɑ}܂B
	 * @param aCentEkiJikoku [in]
	 *	}wwxIuWFNgw肵ĂB
	 *	̃IuWFNg̔j̐Ӗ́ANX[U[ɂ܂B
	 *	̃IuWFNǵÅ֐I͔jł܂B
	 * @param iEkiOrder [in]
	 *	IuWFNg}ʒuwwOrderxŎw肵ĂB
	 *	͈͂ 0 ȏ getCentEkiJikokuCount() ȉłB
	 *	INT_MAX w肷ƁAw肵̂Ƃ݂Ȃ܂B
	 * @return
	 *	 0 ȏAG[Ȃ畉̐łB
	 *	-	-1 ;	//	CfNXsłB
	 */
	int insertCentDedEkiJikoku( const CentDedEkiJikoku& aCentEkiJikoku , 
		int iEkiOrder = INT_MAX ) ;
	
	/**
	 *	wwxIuWFNgAẅʒu폜܂B
	 * @param iEkiOrder [in]
	 *	IuWFNg}ʒuwwOrderxŎw肵ĂB
	 *	͈͂ 0 ȏ getCentEkiJikokuCount() łB
	 *	INT_MAX w肷ƁAw肵̂Ƃ݂Ȃ܂B
	 * @return
	 *	 0 ȏAG[Ȃ畉̐łB
	 *	-	-1 ;	//	CfNXsłB
	 */
	int eraseCentDedEkiJikoku( int iEkiOrder = INT_MAX ) ;

	//	w̒ǉE폜̂
	friend class CentDedRessyaCont ;
///@}
	

// ********************************
//	RXgN^
// ********************************
 public:
	/**
	 * @param iEkiJikokuCount [in]
	 *	̗ԂsH́wwx̐w肵ĂB
	 *	̃RXgN^ł́A m_CentDedEkiJikokuCont ̗vfA
	 *	̈ŏ܂B
	 *	i[ CentDedEkiJikoku ́A 
	 *	CentDedEkiJikoku::m_eEkiatsukai	 Ekiatsukai_None ƂȂ܂B
	 * @param eRessyahoukou [in]
	 *	̗Ԃ̗ԕ܂B
	 *	\n
	 *	̒l Ressyahoukou_Null ̏ꍇÁwԁx͖łB
	 *	Kl Ressyahoukou_Null łB
	 * @param iRessyasyubetsuIndex [in]
	 *	̗Ԃ́wԎʁxA
	 *	wԎIndexxŕێ܂B
	 *	\n
	 *	Kl 0 łB
	 */
	CentDedRessya( 
		int iEkiJikokuCount , 
		ERessyahoukou	eRessyahoukou ,
		int	iRessyasyubetsuIndex = 0 ) ;
	
	/**
	 *	Rs[RXgN^B
	 */
	CentDedRessya( const CentDedRessya& value );

	/**
	 *	̃NXւ̑s܂A
	 *	this ́wԕx ( m_eRessyahoukou ) E
	 *	wwx (CentDedEkiJikoku ) ͕̐ύX܂B
	 *
	 *	this  m_CentDedEkiJikokuCont ̐ value  m_CentDedEkiJikokuCount
	 *	菭Ȃꍇ́As this  m_CentDedEkiJikokuCount vf
	 *	w^sȂxƂȂ܂B
	 *
	 *	this  m_CentDedEkiJikokuCont ̐ value  m_CentDedEkiJikokuCount
	 *	葽ꍇ́Aߏ蕪 value  m_CentDedEkiJikokuCount vf
	 *	̂Ă܂B
	 */
	CentDedRessya& operator=( const CentDedRessya& value );
 public:
	virtual ~CentDedRessya() ;
		
// ********************************
//	CentDedRessya
// ********************************
 public:
	// ********************************
	///@name 
	// ********************************
	///@{
	ERessyahoukou	getRessyahoukou()const ;
	int	getRessyasyubetsuIndex()const ;
	CentDedRessya& setRessyasyubetsuIndex( int value ) ;
	string getRessyabangou()const{
		return m_strRessyabangou ;};
	CentDedRessya& setRessyabangou( const string& value ){
		m_bIsNull = false ;
		m_strRessyabangou = value ; return *this ; } ;
	string getRessyamei()const{
		return m_strRessyamei ;};
	CentDedRessya& setRessyamei( const string& value ){
		m_bIsNull = false ;
		 m_strRessyamei = value ; return *this ; } ;
	string getGousuu()const{
		return m_strGousuu ;};
	CentDedRessya& setGousuu( const string& value ){
		m_bIsNull = false ;
		 m_strGousuu = value ; return *this ; } ;
	string getBikou()const{
		return m_strBikou ;};
	CentDedRessya& setBikou( const string& value ){
		m_bIsNull = false ;
		 m_strBikou = value ; return *this ; } ;
	///@}
	
	// ********************************
	///@name -CentDedEkiJikoku
	// ********************************
	///@{
	
	/**
	 * @return
	 *	wwx ̐Ԃ܂B
	 */
	int getCentDedEkiJikokuCount()const ;
	
	/**
	 *	wwOrderxɑΉAwwxIuWFNg擾
	 *	Ƃł܂B
	 * @param iEkiOrder [in]
	 *	wwOrderxw肵ĂB
	 *	͈͂ 0 ȏ getCentEkiJikokuCount() łB
	 *	INT_MAX w肷ƁAw肵̂Ƃ݂Ȃ܂B
	 * @return 
	 *	ΉwwxIuWFNg
	 */
	CentDedEkiJikoku getCentDedEkiJikoku( int iEkiOrder )const ;

	/**
	 *	wwOrderxɑΉAwwxIuWFNgݒ肷
	 *	Ƃł܂B
	 * @param iEkiOrder [in]
	 *	wwOrderxw肵ĂB
	 *	͈͂ 0 ȏ getCentEkiJikokuCount() łB
	 *	INT_MAX w肷ƁAw肵̂Ƃ݂Ȃ܂B
	 * @param value [in]
	 *	wwxw肵ĂB
	 * @return 
	 *	ΉwwxIuWFNg
	 */
	CentDedRessya& setCentDedEkiJikoku( int iEkiOrder , 
		const CentDedEkiJikoku& value ) ;

	
	///@}
	// ********************************
	///@name wwOrderxPʂ̑
	// ********************************
	///@{
	/**
	 *	wwOrder(wIndex)xAwwIndexxɕϊ܂B
	 * @param iEkiOrder [in]
	 *	wwOrderxw肵ĂB
	 * @return 
	 *	0ȏ́wwIndexxԂ܂B
	 *	sȏꍇ́A -1 Ԃ܂B
	 */
	int EkiIndexOfEkiOrder( int iEkiOrder ) ;
	
	/**
	 *	wwIndexxwwOrder(wIndex)xɕϊ܂B
	 * @param iEkiIndex [in]
	 *	wwIndexxw肵ĂB
	 * @return 
	 *	0ȏ́wwOrderxԂ܂B
	 *	sȏꍇ́A -1 Ԃ܂B
	 */
	int EkiOrderOfEkiIndex( int iEkiIndex ) ;
	
	/**
	 *	wwOrderxɑΉAwwxIuWFNgAύX
	 *	Ƃł܂B
	 *
	 *	̂ƂAwxEwxύXꂽA
	 *	Ȍ̉wׂČJ艺܂B
	 *
	 *	ij
	 *
	 *	  ܂ł(this)wx 10:00 ŁA
	 *	V(value )wx 10:03 ̏ꍇ́A
	 *	́wwOrderx́wxƁA
	 *	肠Ƃ́wwOrderx́wxwxׂāA
	 *	RJ艺܂B
	 *	
	 *	  ܂ł(this)wx IsNull ŁA
	 *	V(value )wx 10:03 ̏ꍇ́A
	 *	́wwOrderx́wx 10:03 ɍXV܂B
	 *	́wwOrderx́wxƁA
	 *	肠Ƃ́wwOrderx́wxEwxɂ͉e
	 *	^܂B
	 *
	 *	  ܂ł(this)wx 10:00 ŁA
	 *	V(value )wx IsNull ̏ꍇ́A
	 *	́wwOrderx́wx IsNull ɍXV܂B
	 *	́wwOrderx́wxƁA
	 *	肠Ƃ́wwOrderx́wxEwxɂ͉e
	 *	^܂B
	 *
	 *	  wxɊւĂAύXꂽꍇ́A̍ɏ]
	 *	肠Ƃ́wwOrderx́wxEwx̌Jグ/J艺
	 *	s܂B
	 *
	 *	
	 *
	 * @param iEkiOrder [in]
	 *	wwOrderxw肵ĂB
	 *	͈͂ 0 ȏ getCentEkiJikokuCount() łB
	 *	INT_MAX w肷ƁAw肵̂Ƃ݂Ȃ܂B
	 * @param value [in]
	 *	wwxw肵ĂB
	 * @return 
	 *	ΉwwxIuWFNg
	 */
	CentDedRessya& modifyCentDedEkiJikoku( int iEkiOrder , 
		const CentDedEkiJikoku& value ) ;
	
	/**
	 * @return
	 *	̗Ԃ̎nẃwwOrderxԂ܂B
	 *	ׂẮwwxw^sȂx̏ꍇ́A-1 Ԃ܂B
	 *	̏ꍇA̗Ԏ̂w^sȂxƂȂ܂B
	 */
	int getSihatsuEki()const ;

	/**
	 *	̗Ԃ̎nwݒ肵܂B
	 *	wwOrderxnwŵׂẮwwx
	 *	 Ekiatsukai_None ɕς܂B
	 * @param iEkiOrder [in]
	 *	IuWFNg}ʒuwwOrderxŎw肵ĂB
	 *	͈͂ 0 ȏ getCentEkiJikokuCount() łB
	 * @return
	 *	 0 ȏAG[Ȃ畉̐łB
	 *	-	-1 ;	//	wwOrderxsłB
	 */
	int setSihatsuEki( int iEkiOrder ) ;
	
	/**
	 * @return
	 *	̗Ԃ̏IẃwwOrderxԂ܂B
	 *	ׂẮwwxw^sȂx̏ꍇ́A-1 Ԃ܂B
	 *	̏ꍇA̗Ԏ̂w^sȂxƂȂ܂B
	 */
	int getSyuuchakuEki()const ;

	/**
	 *	̗Ԃ̏Iwݒ肵܂B
	 *	wwOrderxIw傫ŵׂẮwwx
	 *	 Ekiatsukai_None ɕς܂B
	 * @param iEkiOrder [in]
	 *	IuWFNg}ʒuwwOrderxŎw肵ĂB
	 *	͈͂ 0 ȏ getCentEkiJikokuCount() łB
	 * @return
	 *	 0 ȏAG[Ȃ畉̐łB
	 *	-	-1 ;	//	wwOrderxsłB
	 */
	int setSyuuchakuEki( int iEkiOrder ) ;
	///@}
	// ********************************
	///@name wOrderxPʂ̑
	// ********************************
	///@{
	
	/**
	 *	̗Ԃ́AwOrderxɑΉ鎞擾܂B
	 *	
	 * @param iJikokuOrder [in]
	 *	擾鎞́wOrderxw肵ĂB
	 * @return
	 *	Ή鎞Ԃ܂B
	 *	p[^sȏꍇ́A NullԂ̎Ԃ܂B
	 */
	CdDedJikoku getEkiJikoku( int iJikokuOrder ) ;
	
	/**
	 *	̗Ԃ́AwOrderxɑΉ鎞ύX܂B
	 * @attention
	 *	̊֐́Aw̉wȍ~̉w
	 *	Jグ^J艺͍s܂B
	 * @param aCdDedJikoku [in]
	 *	w肵ĂB
	 * @param iJikokuOrder [in]
	 *	ύX鎞́wOrderxw肵ĂB
	 * @return
	 *	 0 ȏAG[Ȃ畉̐łB
	 *	- 	-1 ;	//	p[^s
	 *
	 */
	int setEkiJikoku( const CdDedJikoku& aCdDcdJikoku , int iJikokuOrder ) ;
	
	/**
	 *	̗Ԃ́Aw̎ȍ~̎ύX܂B
	 *	w肵wȍ~́AwNullxԂׂ̂Ẳw̎A
	 *	Jグ^J艺܂B
	 *	
	 * @param iJikokuOrder [in]
	 *	ύX鎞́wOrderxw肵ĂB
	 * @param aCdDedJikan [in]
	 *	JグEJ艺sԂw肵ĂB
	 * @return
	 *	 0 ȏAG[Ȃ畉̐łB
	 *	- 	-1 ;	//	p[^s
	 *
	 */
	int modifyRessyaJikoku(  
		const CdDedJikan& aCdDedJikan , int iJikokuOrder ) ;
	
	/**
	 *	̗Ԃ́AẃwOrderxȑOŁA
	 *	wNullxԂ̎A
	 *	ɌāiwOrderx0̕Ɍāj܂B
	 *	
	 * @param iJikokuOrder [in]
	 *	̋N_ƂȂύX鎞wOrderxŎw肵ĂB
	 * @return
	 *	NullԂ̎ꍇ́A0 ȏ́wOrderx擾܂B
	 *	ȂꍇAp[^sȏꍇ́A
	 *	-1 Ԃ܂B
	 */
	int findrevJikoku( int iJikokuOrder ) ;
	
	
	///@}
	
	// ********************************
	///@name 
	// ********************************
	///@{
	/**
	 * @return
	 *	̗ԂwNullԁxȂ^łB
	 *
	 *	ׂẮwwx
	 *	w^sȂx(Ekiatsukai_None ),
	 *	̏ꍇA̗Ԃ́wNullԁxƂȂ܂B
	 */
	bool isNull()const ;
	/**
	 *	̗ԂwNullԁxƂ܂B
	 */
	void clear() ;
	
	
	
	///@}
};
#endif /*CentDedRessya_h*/
