/*
	OuDia - Win32 Application Software to draw a "Train Service Planning
 Diagram" based on a "Train Timetable".

Copyright (C) 2006-2017 take-okm

This program is free software; you can redistribute it and/or modify it 
under the terms of the GNU General Public License as published by the Free 
Software Foundation; either version 3 of the License, or (at your option) 
any later version. 

This program is distributed in the hope that it will be useful, but WITHOUT 
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or 
FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for 
more details. 

You should have received a copy of the GNU General Public License along with
 this program. If not, see <http://www.gnu.org/licenses/>.

  In addition, as a special exception, take-okm
  gives permission to link the code of this program with
  the "MFC(Microsoft Foundation Class library) Version 9.0" 
  (or with modified versions of "MFC Version 9.0" that use the same license as 
  "MFC Version 9.0" ), and distribute linked combinations including
  the two.  You must obey the GNU General Public License in all
  respects for all of the code used other than  "MFC".  If you modify
  this file, you may extend this exception to your version of the
  file, but you are not obligated to do so.  If you do not wish to
  do so, delete this exception statement from your version.


(: 

	OuDia - Ԏ\ƂɁA_CO`悷Win32AvP[V
B

Copyright (C) 2006-2017 take-okm 

̃vO̓t[\tgEFAłBȂ͂At[\tgEFA
cɂĔsꂽGNU ʌOp(o[W3Aȍ~̃o[W
̂ǂꂩ)߂̉ōĔЕz܂͉ 邱Ƃł܂B

̃vO͗Lpł邱ƂĔЕz܂A*S̖ۏ *łB
Ɖ\̕ۏ؂ړIւ̓ḰAOɎꂽ̂ ܂߁AS
܂BڂGNU ʌOpB

Ȃ͂̃vOƋɁAGNU ʌOp̃Rs[ꕔ 󂯎
Ă͂łB󂯎ĂȂ΁A<http://www.gnu.org/licenses/> 
B

)

  āAʂȗOƂāAtake-okm ͂̃vÕR[h 
  "MFC(Microsoft Foundation Class library) Version 9.0" 
  (  邢 "MFC Version 9.0" ƓCZXKpꂽ
  "MFC Version 9.0" ̉ςꂽo[W)ƃNA
  Nꂽ҂܂ތ앨Еz鋖^܂B
  Ȃ "MFC" ȊOŎgĂ邷ׂ
  ̃R[hɊւĂ͑SʓIGNUʌOp_񏑂ɏ]Ȃ
  Ȃ܂BȂ̃t@CςȂ΁AȂ̗͂O
  Ȃ̃o[W̃t@CɈ݂邱Ƃł܂A
  `͂܂BO݂Ȃ΁A̗O
  Ȃ̃o[W͍폜ĂB)
*/
/*
// ****************************************************************
//	CSequentialByteBuffer.h
// ****************************************************************
*/
/** @file */
#ifndef  CSequentialByteBuffer_h
#define  CSequentialByteBuffer_h

#include <memory.h>
#include <stdlib.h>
#include "container/IfSequentialByteBuffer.h"

// ****************************************************************
//	CSequentialByteBuffer
// ****************************************************************
/**
 * @brief
 * yTvz
 * 	  L[`ŃoCgf[^ۑAobt@NXłB
 *
 * ygz
 *
 * PD  RXgN^ŁAIuWFNg𐶐ĂB
 * 	  ev[ǵAobt@̒PʃoCgłBthiśA
 * 	f[^̃oCg܂邽тɁAobt@g܂B
 *
 * QD  Ȍ́ASo֐gpł܂BWrite()Ńobt@ւ
 * 	f[^݁AReadł̓obt@f[^ǂݍނƂł܂B
 * 	Read() ́AǍɐf[^obt@菜܂B
 */
template < int iExpandSize = 8192 >
class CSequentialByteBuffer: public IfSequentialByteBuffer
{
// --------------------------------
//	f[^
// --------------------------------
 private:
	/**
	 *	obt@̒PʃoCg̃f[^
	 *	ێ\̂łB
	 *	̍\̂̓`FC`܂B
	 */
	struct NODE
	{
		/**
		 *	obt@{̂łB
		 */
		char		m_abyBuffer[ iExpandSize ] ;
		
		/**
		 * 	m_byBuffer ̂ALȃf[^݂擪̓YB
		 */
		int			m_iPos ;
		/**
		 * 	m_byBuffer ̂A
		 * 	Lȃf[^̃oCgB
		 */
		int			m_iSize ;
		
		/**
		 * 	̃m[hւ̃|C^łB
		 * 	ȂꍇNULLɂȂ܂B
		 */
		NODE*		m_pNext ;
	};
	/**
	 * 	擪̃m[hւ̃|C^ł
	 * 	m[hPȂꍇNULLł
	 */
	NODE*			m_pnodeFirst ;
	
	/**
	 *
	 *	̃m[hւ̃|C^ł
	 *	m[hPȂꍇNULLł
	 */
	NODE*			m_pnodeLast ;
	
// ********************************
//	RXgN^
// ********************************
 public:
	CSequentialByteBuffer() : m_pnodeFirst( NULL ) , m_pnodeLast( NULL ) 
	{
	};
	~CSequentialByteBuffer() 
	{
		Clear() ;
	};
	CSequentialByteBuffer( const CSequentialByteBuffer<iExpandSize>& src ) 
		: m_pnodeFirst( NULL ) , m_pnodeLast( NULL ) 
	{
		NODE*	pNode = NULL ;
		for ( pNode = src.m_pnodeFirst ; 
				pNode != NULL ; 
				pNode = pNode->m_pNext ){
			Write( &pNode->m_abyBuffer[ pNode->m_iPos ] , 
				pNode->m_iSize ) ;
		}
		
		
	};
	CSequentialByteBuffer& operator=
					( const CSequentialByteBuffer<iExpandSize>& src )
	{
		Clear() ;
		NODE*	pNode = NULL ;
		for ( pNode = src.m_pnodeFirst ; 
				pNode != NULL ; 
				pNode = pNode->m_pNext ){
			Write( &pNode->m_abyBuffer[ pNode->m_iPos ] , 
				pNode->m_iSize ) ;
		}
		

		return ( *this ) ;
	};
// ********************************
//	IfSequentialByteBuffer
// ********************************
 public:
	/**
	 * 	obt@Ƀf[^݂܂B
	 * @param pData  [in]
	 * 	ރf[^̐擪AhXw肵Ă
	 * @param sizeData [in]
	 * 	ރf[^̃TCYw肵ĂB
	 * @return
	 * 	݂ɐoCgԂ܂B
	 * 	-	-1:	mۂł܂B
	 */
	int Write( const char* pData , int sizeData ) 
	{
		int	iRv = 0 ;
		while ( iRv >= 0 && sizeData > 0 ){
			if ( iRv >= 0 ){
				if ( m_pnodeLast == NULL ){
					//	݃obt@̏ꍇ́Aobt@NODE
					//	Vɍ쐬A
					//	擪EƂēo^܂B
					NODE*	pNode = new NODE ;
					if ( pNode == NULL ){
						iRv = -1 ;	//	-1:	mۂł܂B
					}	else	{
						pNode->m_iPos = 0 ;
						pNode->m_iSize = 0 ;
						pNode->m_pNext = NULL ;
						m_pnodeFirst = m_pnodeLast = pNode ;
					}
				}
			}
			if ( iRv >= 0 ){
				int	iLastPos = m_pnodeLast->m_iPos + m_pnodeLast->m_iSize ;
				if ( iExpandSize - iLastPos  == 0 ){
					//	NODȄꍇ́A
					//	VNODE쐬Aɒǉ܂B
					NODE*	pNode = new NODE ;
					if ( pNode == NULL ){
						iRv = -1 ;	//	-1:	mۂł܂B
					}	else	{
						pNode->m_iPos = 0 ;
						pNode->m_iSize = 0 ;
						pNode->m_pNext = NULL ;
						m_pnodeLast->m_pNext = pNode ;
						m_pnodeLast = pNode ;
					}
				}
				
			}
			if ( iRv >= 0 ){
				//	NODEɃf[^
				int	iLastPos = m_pnodeLast->m_iPos + m_pnodeLast->m_iSize ;
				int sizeDataWriteNext = sizeData ;
				if ( sizeDataWriteNext > iExpandSize - iLastPos ){
					sizeDataWriteNext = iExpandSize - iLastPos ;
				}
				//sizeDataWriteNext =  ̃m[hɏ߂oCg
				
				memcpy( &m_pnodeLast->m_abyBuffer[ iLastPos ]
					, pData , sizeDataWriteNext ) ;
				pData += sizeDataWriteNext ;
				sizeData -= sizeDataWriteNext ;
				iRv += sizeDataWriteNext ;

				m_pnodeLast->m_iSize += sizeDataWriteNext ;
			}
			
		}
		return ( iRv ) ;
	};
	
	/**
	 * 	obt@f[^ǂݍ݂܂B
	 * 	ǂݍ񂾃f[^́Aobt@菜܂B
	 * @param pData  [out]
	 * 	̊֐́ÃAhXɓǂݍ񂾃f[^݂܂B
	 * 	svȂif[^̓ǂݎ̂ĂsꍇjNULLnĂ܂܂B
	 * @param sizeData [in]
	 * 	ǂݍލőoCgipDatãobt@TCYjw肵Ă
	 * @return
	 * 	ǍɐoCgԂ܂B
	 */
	int Read( char* pData , int sizeData ) 
	{
		int iRv = 0 ;	

		NODE*	pNode = NULL ;
		for ( pNode = m_pnodeFirst ; 
				pNode != NULL && iRv >= 0 && sizeData > 0 ;
				pNode = pNode->m_pNext ){
			if ( iRv >= 0 ){
				//	NODEf[^ǂݍ
				int sizeDataReadNext = sizeData ;
				if ( sizeDataReadNext > pNode->m_iSize ){
					sizeDataReadNext = pNode->m_iSize ;
				}
				//sizeDataReadNext =  擪̂̃m[hǂݍ߂oCg
				
				//	[U[obt@ɃRs[
				if ( pData != NULL ){
					memcpy( pData  , 
						&pNode->m_abyBuffer[ pNode->m_iPos ]
						, sizeDataReadNext ) ;
					pData +=  sizeDataReadNext ;
				}
				sizeData -= sizeDataReadNext ;
				iRv += sizeDataReadNext ;
				
				//	ǂݍ񂾃f[^m[h폜
				pNode->m_iPos  += sizeDataReadNext ;
				pNode->m_iSize -= sizeDataReadNext ;

			}
		}
		
		//	̃m[h͍폜
		while ( m_pnodeFirst != NULL && m_pnodeFirst->m_iSize == 0 ){
					NODE*	pNodeToDelete = m_pnodeFirst ;
					m_pnodeFirst = m_pnodeFirst->m_pNext ;
					delete pNodeToDelete ;
		}
		if ( m_pnodeFirst == NULL ){
			m_pnodeLast = NULL ;
		}
		
		return ( iRv ) ;
	}
	
	/**
	 * 	obt@̐擪f[^ǂݍ݂܂A
	 * 	ǂݍ񂾃f[^obt@菜܂
	 * @param pData  [out]
	 * 	̊֐́ÃAhXɓǂݍ񂾃f[^݂܂B
	 * 	svȂNULLnĂ܂܂B
	 * @param sizeData [in]
	 * 	ǂݍލőoCgipDatãobt@TCYjw肵Ă
	 * @return
	 * 	ǍɐoCgԂ܂B
	 */
	int Peek( char* pData , int sizeData )const 
	{
		int iRv = 0 ;	

		NODE*	pNode = NULL ;
		for ( pNode = m_pnodeFirst ; 
				pNode != NULL && iRv >= 0 && sizeData > 0 ;
				pNode = pNode->m_pNext ){
			if ( iRv >= 0 ){
				//	NODEf[^ǂݍ
				int sizeDataReadNext = sizeData ;
				if ( sizeDataReadNext > pNode->m_iSize ){
					sizeDataReadNext = pNode->m_iSize ;
				}
				//sizeDataReadNext =  擪̂̃m[hǂݍ߂oCg
				
				//	[U[obt@ɃRs[
				if ( pData != NULL ){
					memcpy( pData  , 
						&pNode->m_abyBuffer[ pNode->m_iPos ]
						, sizeDataReadNext ) ;
					pData +=  sizeDataReadNext ;
				}
				sizeData -= sizeDataReadNext ;
				iRv += sizeDataReadNext ;
			}
		}
		
		return ( iRv ) ;
	}
	
	/**
	 * @return
	 * 	݃obt@ɂoCgԂ܂B
	 */
	int Size()const 
	{
		int	iRv = 0 ;
		NODE*	pNode = NULL ;
		for ( pNode = m_pnodeFirst ; 
				pNode != NULL ; 
				pNode = pNode->m_pNext ){
			iRv += pNode->m_iSize ;
		}
		return ( iRv ) ;
	}
	
	/**
	 * 	obt@̃f[^j܂B
	 */
	void Clear() 
	{
		//	̃m[h͍폜
		while ( m_pnodeFirst != NULL  ){
					NODE*	pNodeToDelete = m_pnodeFirst ;
					m_pnodeFirst = m_pnodeFirst->m_pNext ;
					delete pNodeToDelete ;
			
		}
		if ( m_pnodeFirst == NULL ){
			m_pnodeLast = NULL ;
		}
	}
};

// --------------------------------
//	ftHg̃obt@̃Vmj
// --------------------------------
typedef CSequentialByteBuffer<>	CSequentialByteBuf ;



#endif /*CSequentialByteBuffer_h*/
