/*
	OuDia - Win32 Application Software to draw a "Train Service Planning
 Diagram" based on a "Train Timetable".

Copyright (C) 2006-2017 take-okm

This program is free software; you can redistribute it and/or modify it 
under the terms of the GNU General Public License as published by the Free 
Software Foundation; either version 3 of the License, or (at your option) 
any later version. 

This program is distributed in the hope that it will be useful, but WITHOUT 
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or 
FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for 
more details. 

You should have received a copy of the GNU General Public License along with
 this program. If not, see <http://www.gnu.org/licenses/>.

  In addition, as a special exception, take-okm
  gives permission to link the code of this program with
  the "MFC(Microsoft Foundation Class library) Version 9.0" 
  (or with modified versions of "MFC Version 9.0" that use the same license as 
  "MFC Version 9.0" ), and distribute linked combinations including
  the two.  You must obey the GNU General Public License in all
  respects for all of the code used other than  "MFC".  If you modify
  this file, you may extend this exception to your version of the
  file, but you are not obligated to do so.  If you do not wish to
  do so, delete this exception statement from your version.


(: 

	OuDia - Ԏ\ƂɁA_CO`悷Win32AvP[V
B

Copyright (C) 2006-2017 take-okm 

̃vO̓t[\tgEFAłBȂ͂At[\tgEFA
cɂĔsꂽGNU ʌOp(o[W3Aȍ~̃o[W
̂ǂꂩ)߂̉ōĔЕz܂͉ 邱Ƃł܂B

̃vO͗Lpł邱ƂĔЕz܂A*S̖ۏ *łB
Ɖ\̕ۏ؂ړIւ̓ḰAOɎꂽ̂ ܂߁AS
܂BڂGNU ʌOpB

Ȃ͂̃vOƋɁAGNU ʌOp̃Rs[ꕔ 󂯎
Ă͂łB󂯎ĂȂ΁A<http://www.gnu.org/licenses/> 
B

)

  āAʂȗOƂāAtake-okm ͂̃vÕR[h 
  "MFC(Microsoft Foundation Class library) Version 9.0" 
  (  邢 "MFC Version 9.0" ƓCZXKpꂽ
  "MFC Version 9.0" ̉ςꂽo[W)ƃNA
  Nꂽ҂܂ތ앨Еz鋖^܂B
  Ȃ "MFC" ȊOŎgĂ邷ׂ
  ̃R[hɊւĂ͑SʓIGNUʌOp_񏑂ɏ]Ȃ
  Ȃ܂BȂ̃t@CςȂ΁AȂ̗͂O
  Ȃ̃o[W̃t@CɈ݂邱Ƃł܂A
  `͂܂BO݂Ȃ΁A̗O
  Ȃ̃o[W͍폜ĂB)
*/
/*
// ****************************************************************
//	CdDedJikoku.h
// ****************************************************************
*/
/** @file */
#ifndef  CdDedJikoku_h
#define  CdDedJikoku_h
#include <string>
// ****************************************************************
//	CdDedJikoku
// ****************************************************************
/**
 @brief
 yTvz
	  bPʂ̎\Pf[^NXłB
	
	  t̊TO͂܂B
	  ̊Ԃ́A00:00 ̂QSԂ̎\܂B
	  00:00ȑOE24:00ȍ~̎w肵ꍇ́ATCNbNl
	ێ܂B
	  Ƃ΁ÃNX̃IuWFNg 25:00 ݒ肵悤ƂƁA
	IuWFNg 1:00 ێ܂B
	
	  ̃NX́AIɂ 00:00 ̌oߕb𑮐 m_iTotalSeconds 
	ŕێ܂BEEb́ÃNX̔hƂĈʒut܂B

	  ̃NX́AwNullԁxƂł܂B́A
	uthis LȎێĂȂvƂlłB

	̃NXێ鎞́A CConv::encode() ŕ񉻂邱Ƃł܂B

	()  "10:30:45"

	܂ACConv::encode() ō쐬A deocde() ŉ߂邱Ƃ
	ł܂B
 */
class CdDedJikoku
{
public:
	// ********************************
	//	萔
	// ********************************
	/**
		24Ԃ̕b
	*/
	static const int TOTALSECONDS_A_DAY = 24*60*60 ;

public:
	// ****************************************************************
	//	CdDedJikoku::CConv
	// ****************************************************************
	/**
		CdDedJikoku ̓e𕶎񉻂NXłB
		ƂāÃtH[}bgێ܂B
	*/
	class CConv
	{
	public:
		/** ̕ϊ@ */
		enum EHour
		{
			/**  00  09 ̏ꍇA10̈ʂ "0" Ƃ܂B*/ 
			EHour_Zero ,
			/**  00  09 ̏ꍇA10̈ʂ "0" 폜܂B */
			EHour_ZeroToNone ,	
			/**  00  09 ̏ꍇA10̈ʂ "0" Xy[Xɂ܂B*/ 
			EHour_ZeroToSpace ,
		};
		/** b̕ϊ@ */
		enum ESecond
		{
			/** bɏo͂܂B */
			ESecond_Output ,
			/** bɏo͂܂B */
			ESecond_NoSecond ,
			/** b0ȂAbo͂܂B */
			ESecond_NotIfZero ,
		};
	private:
		/** 
			- true: FFb ̊Ԃ̃R ":" o͂܂ 
			- false: FFb ̊Ԃ̃R ":" o͂܂ 
		*/
		bool m_bNoColon ;

		/** ̕ϊ@ */
		EHour	m_eHour ;
		
		/** b̕ϊ@ */
		ESecond m_eSecond ;

	public:
		CConv() ;

		/**
		@param bNoColon [in]
			 FFb ̊Ԃ̃R ":" o͂܂ 
		@param eHour [in]
			̕ϊ@w肵ĂB
		@param eSecond [in]
			b̕ϊ@w肵ĂB
		*/
		CConv( 
			bool bNoColon ,
			EHour	eHour  ,
			ESecond eSecond ) ;
		
		bool getNoColon()const
		{	return m_bNoColon ;};
		CConv& setNoColon( bool value )
		{	m_bNoColon = value ; return *this ;};

		EHour	getHour()const{	return m_eHour ;};
		CConv& setHour( EHour value )
		{	m_eHour = value ; return *this ;};
		
		ESecond	getSecond()const{	return m_eSecond ;};
		CConv& setSecond( ESecond value )
		{	m_eSecond = value ; return *this ;};


		/**
			𕶎ŕ\܂B
		 @param aJikoku [in]
			w肵ĂB
		 @return
			aJikoku 𕶎񉻂̂Ԃ܂B
			aJikoku wNullԁx̏ꍇ́A󕶎Ԃ܂B
		*/
		std::string encode( const CdDedJikoku& aJikoku )const ;

	};

private:
	// ********************************
	///@name 
	// ********************************
	///@{
	/**
		 00:00 ̌oߕbێ܂B
		LȒl͈̔͂́A 0 ȏ 24*60*60 
		( 0:00 ȏ 24:00 )łB
	
		AwNullԁx̂Ƃ́AINT_MIN ƂȂ܂B
		ftHgRXgN^ł́AwNullԁxƂ܂B
	 */
	int	m_iTotalSeconds ;
	///@}

 protected:
	// --------------------------------
	///@name ֐
	// --------------------------------
	///@{
	/**
		oߕb𐳋K܂B
	
		l 0 ȏ 24*60*60 
		( 0:00 ȏ 24:00 )Ƃ܂B
		
	 @param iTotalSeconds [in]
		KǑoߕbw肵ĂB
		̐ł܂܂B
			-1 ́AwNullԁxƂ݂͂Ȃ܂B
	 @return
		K̒lԂ܂B
	 
		ij
	
		- iTotalSeconds = -1 ̏ꍇ̖߂ĺA 23:59:59 
		- iTotalSeconds = 24*60*60 ̏ꍇ̖߂ĺA 0  
	 */
	static int adjustTotalSeconds( int iTotalSeconds ) ;

	///@}
 public:
	// ********************************
	//	RXgN^
	// ********************************
	/**
		wNullԁxɏ܂B
	 */
	CdDedJikoku() ;
	
	/**
	 @param iTotalSeconds [in]
		 00:00 ̌oߕbw肵ĂB
		0 ȏ 24*60*60 ( 0:00 ȏ 24:00 )
		͈̔͊O̒lw肵ꍇ́Å֐
			0 ȏ 24*60*60 ( 0:00 ȏ 24:00 )
		ɐKĂ m_iTotalSeconds 
		ݒ肵܂B
	 @attention
		-1 ́AwNullԁxƂ݂͂ȂA23:59:59 
		݂Ȃ܂B
	*/
	CdDedJikoku( int iTotalSeconds ) ;
	
	/**
	 @param iHour [in]
		B͈͂ 0 ȏ 24 B
	 @param iMinute [in]
		B͈͂ 0 ȏ 60 B
	 @param iSecond [in]
		bB͈͂ 0 ȏ 60 B
	 */
	CdDedJikoku( int iHour , int iMinute , int iSecond = 0 ) ;

	/**
		gď܂B
	 @param value [in]
		w肵ĂB
		
	 ()̗
		-	"13:15:45"
		-	"13:15"
		-	"131545"
		-	"1315"
		-	"9:15:45"
		-	"9:15"
		-	"91545"
		-	"915"
	 */
	CdDedJikoku( const std::string& strTime ) ;

public:
	// ********************************
	//	CdDedJikoku
	// ********************************
	// ********************************
	///@name CdDedJikoku-
	// ********************************
	///@{

	int getTotalSeconds()const{	return m_iTotalSeconds ; } ;
	/**
	 @param iTotalSeconds [in]
		 00:00 ̌oߕbw肵ĂB
		0 ȏ 24*60*60 ( 0:00 ȏ 24:00 )
		͈̔͊O̒lw肵ꍇ́Å֐
			0 ȏ 24*60*60 ( 0:00 ȏ 24:00 )
		ɐKĂ m_iTotalSeconds 
		ݒ肵܂B
	*/
	CdDedJikoku& setTotalSeconds( int value ) ;
	
	/**
	 @return
		B
	 @attention
		this  wNullԁx̏ꍇ́A0Ԃ܂B
	 */
	int getHour()const{	return m_iTotalSeconds / ( 60 * 60 )  ; } ;
	
	/**
	 @return
		B
	 @attention
		this  wNullԁx̏ꍇ́A0Ԃ܂B
	 */
	int getMinute()const{	return m_iTotalSeconds / ( 60 ) % ( 60 )  ; } ;
	
	/**
	 @return
		bB
	 @attention
		this  wNullԁx̏ꍇ́A0Ԃ܂B
	 */
	int getSecond()const{	return m_iTotalSeconds % ( 60 )  ; } ;
	
	/**
		Aݒ肵܂B
	 @param iHour [in]
		B͈͂ 0 ȏ 24 B
	 @param iMinute [in]
		B͈͂ 0 ȏ 60 B
	 @param iSecond [in]
		bB͈͂ 0 ȏ 60 B
	 */
	CdDedJikoku& setTime( int iHour , int iMinute , int iSecond = 0 ) ;
	
	/**
	 @return
		this wNullԁxȂ^Ԃ܂B
	 */
	bool isNull()const{	return m_iTotalSeconds == INT_MIN ; } ;

	/**
		this wNullԁxƂ܂B
	 */
	CdDedJikoku& setNull() ;
	
	///@}
	
	// ********************************
	///@name CdDedJikoku-
	// ********************************
	///@{
	/**
		Q̎Ar܂B
	 @param value [in]
		rΏۂ̃IuWFNgw肵ĂB
	 @return
		this - value sʂ̕Ԃ܂B
		-	+1 ;	//	this > valueB
					//	܂́A this wNullԁx value  wNullԁx
		-	0 ;		//	this == valueB
					//	܂́A this  value  wNullԁx
		-	-1 ;	//	this < valueB
					//	܂́A this wNullԁx value  wNullԁx
	*/
	int compare( const CdDedJikoku& value )const ;
	
	/**
		Q̎Ar܂B
	 @param value [in]
		rΏۂ̃IuWFNgw肵ĂB
	 @param jikokuKitenJikoku [in]
		_CON_w肵ĂB
		̊֐́A\[gɁA̒lł
		݂Ȃ܂B
		(F̎5:00w肳ꂽꍇ́A5:00<23:59<0:00<4:59 ƂĔrs܂)
	 @return
		this - value sʂ̕Ԃ܂B
		-	+1 ;	//	this > valueB
					//	܂́A this wNullԁx value  wNullԁx
		-	0 ;		//	this == valueB
					//	܂́A this  value  wNullԁx
		-	-1 ;	//	this < valueB
					//	܂́A this wNullԁx value  wNullԁx
	*/
	int compare( 
		const CdDedJikoku& value , 
		const CdDedJikoku& jikokuKitenJikoku )const ;
	


	/**	compare() ƓłB	 */
	bool operator>( const CdDedJikoku& value )const{
		return ( compare( value ) == 1 ) ; } ;
	/**	compare() ƓłB	 */
	bool operator>=( const CdDedJikoku& value )const{
		return ( compare( value ) != -1  ) ; } ;
	/**	compare() ƓłB	 */
	bool operator==( const CdDedJikoku& value )const{
		return ( compare( value ) == 0 ) ; } ;
	/**	compare() ƓłB	 */
	bool operator<=( const CdDedJikoku& value )const{
		return ( compare( value ) != 1  ) ; } ;
	/**	compare() ƓłB	 */
	bool operator<( const CdDedJikoku& value )const{
		return ( compare( value ) == -1 ) ; } ;

	/**
		this ێĂ鎞ɑ΂āAbZ܂B
	 @param value [in]
		Zbw肵ĂB
		̐w肷邱Ƃł܂B
	 @attention
		this  wNullԁx̏ꍇ́AwNullԁx̂܂ܕς܂B
	 */
	CdDedJikoku& addSeconds( int value ) ;

	/** addSeconds() Ɠł */
	CdDedJikoku& operator+=( int value ) {
		return addSeconds( value ) ; } ;
	/** addSeconds() ƓłB*/
	CdDedJikoku& operator-=( int value ) {
		return addSeconds( -value ) ; } ;



	/**
		Q̎̍AbŕԂ܂B
		́AΒlPQԈȉ̑Ƃ܂B
	 @param value [in]
		rΏۂ̃IuWFNgw肵ĂB
	 @return
		this - value sʂ̕bԂ܂B
		this < value ̏ꍇ́A̐Ԃ܂B\n
		Athis - value ̐ΒlPQԂ𒴂Ăꍇ́A
		tłPQԖ̒lԂ܂B
		
		() 
		
		this  1:00  value  23:00 ̏ꍇAPvZł -22 ԂłA
		̒l̐Βl12Ԃ𒴂Ă܂B̏ꍇA+2 ԂԂ܂
	
		  1:00 23:00 ̂QQԑOł܂A
		íj1:00  23:00̂QԌłƂ܂B
		̊֐Ԃ̂́AΒl̏̒lłB
	 @attention
		this E value ̂ꂩ wNullԁx̏ꍇ́A0Ԃ܂B
	 */
	int subJikoku( const CdDedJikoku& value  )const ;

	/**
		encode() ɂĐꂽ
		͂Athis ̑ɔf܂B
	
		񂪉ߕs\ȏꍇ́Athis  wNullԁx
		ƂȂ܂B
	 @param value [in]
		w肵ĂB
	 @return
		0ȏAG[Ȃ畉̐łB
		-	-1 ;	//	ڐsĂ܂B
		-	-2 ;	//	EEb̕\LsłB
	
	 ()̗
		-	"13:15:45"
		-	"13:15"
		-	"131545"
		-	"1315"
		-	"9:15:45"
		-	"9:15"
		-	"91545"
		-	"915"
	
	 */
	int decode( const std::string& value ) ;
	///@}
};


#endif /*CdDedJikoku_h*/
