/*
	OuDia - Win32 Application Software to draw a "Train Service Planning
 Diagram" based on a "Train Timetable".

Copyright (C) 2006-2017 take-okm

This program is free software; you can redistribute it and/or modify it 
under the terms of the GNU General Public License as published by the Free 
Software Foundation; either version 3 of the License, or (at your option) 
any later version. 

This program is distributed in the hope that it will be useful, but WITHOUT 
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or 
FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for 
more details. 

You should have received a copy of the GNU General Public License along with
 this program. If not, see <http://www.gnu.org/licenses/>.

  In addition, as a special exception, take-okm
  gives permission to link the code of this program with
  the "MFC(Microsoft Foundation Class library) Version 9.0" 
  (or with modified versions of "MFC Version 9.0" that use the same license as 
  "MFC Version 9.0" ), and distribute linked combinations including
  the two.  You must obey the GNU General Public License in all
  respects for all of the code used other than  "MFC".  If you modify
  this file, you may extend this exception to your version of the
  file, but you are not obligated to do so.  If you do not wish to
  do so, delete this exception statement from your version.


(: 

	OuDia - Ԏ\ƂɁA_CO`悷Win32AvP[V
B

Copyright (C) 2006-2017 take-okm 

̃vO̓t[\tgEFAłBȂ͂At[\tgEFA
cɂĔsꂽGNU ʌOp(o[W3Aȍ~̃o[W
̂ǂꂩ)߂̉ōĔЕz܂͉ 邱Ƃł܂B

̃vO͗Lpł邱ƂĔЕz܂A*S̖ۏ *łB
Ɖ\̕ۏ؂ړIւ̓ḰAOɎꂽ̂ ܂߁AS
܂BڂGNU ʌOpB

Ȃ͂̃vOƋɁAGNU ʌOp̃Rs[ꕔ 󂯎
Ă͂łB󂯎ĂȂ΁A<http://www.gnu.org/licenses/> 
B

)

  āAʂȗOƂāAtake-okm ͂̃vÕR[h 
  "MFC(Microsoft Foundation Class library) Version 9.0" 
  (  邢 "MFC Version 9.0" ƓCZXKpꂽ
  "MFC Version 9.0" ̉ςꂽo[W)ƃNA
  Nꂽ҂܂ތ앨Еz鋖^܂B
  Ȃ "MFC" ȊOŎgĂ邷ׂ
  ̃R[hɊւĂ͑SʓIGNUʌOp_񏑂ɏ]Ȃ
  Ȃ܂BȂ̃t@CςȂ΁AȂ̗͂O
  Ȃ̃o[W̃t@CɈ݂邱Ƃł܂A
  `͂܂BO݂Ȃ΁A̗O
  Ȃ̃o[W͍폜ĂB)
*/
/*
// ****************************************************************
//	CentDedRessyasyubetsu.h
// ****************************************************************
*/
/** @file */
#ifndef  CentDedRessyasyubetsu_h
#define  CentDedRessyasyubetsu_h

#include <string>

#include "DcdCd\DcDrawProp\CdColorProp.h"


// ****************************************************************
//	CentDedRessyasyubetsu
// ****************************************************************
/**
   @brief
  	yTvz  DiagramEdit ́AHŉ^sԂ́wԎʁx
  	Pނ\܂B
  	
  	  ƂāAwʖxƁA̗Ԏʂ\鎞\r[E
  	_COr[ł̕`FEX^Cێ܂B
 */
class CentDedRessyasyubetsu
{
// ********************************
//	Ci[^Cv
// ********************************
 public:
	/**
		Ԑ()̌`\񋓂łB
	*/
	enum ESenStyle
	{
		/// 
		SenStyle_Jissen = 0 ,
		/// j
		SenStyle_Hasen ,
		/// _
		SenStyle_Tensen ,
		/// _
		SenStyle_Ittensasen ,
	};
	/**
		Ԑ()̐̌`󑮐\Pf[^NXB
	*/
	class CdDiagramLineStyle
	{
	private:
		// ********************************
		///@name 
		// ********************************
		///@{
		/**
	  		_CO̐FB
		  
	  		KĺAB
		 */
		CdColorProp	m_colorDiagramSenColor ;

		/**
			_CO̐X^CB
		  
	  		KĺA SenStyle_Jissen
		 */
		ESenStyle	m_eDiagramSenStyle ;
		
		/**
	  		_CO̐̑B
		  
	  		_CO̐ł trueB
	  		אȂ false łB
		  
	  		KĺA false łB
		 */
		bool m_bDiagramSenIsBold ;

	public:
		// ********************************
		//	RXgN^
		// ********************************
		CdDiagramLineStyle( 
			const CdColorProp& colorDiagramSenColor ,
			ESenStyle	eDiagramSenStyle ,
			bool bDiagramSenIsBold )
			:
			m_colorDiagramSenColor( colorDiagramSenColor ) ,
			m_eDiagramSenStyle( eDiagramSenStyle ),
			m_bDiagramSenIsBold( bDiagramSenIsBold )
		{};

		CdDiagramLineStyle():
			m_colorDiagramSenColor( CdColorProp( 0 , 0 , 0 ) ),
			m_eDiagramSenStyle( SenStyle_Jissen ),
			m_bDiagramSenIsBold( false )
		{};

		// ********************************
		///@name CdDiagramLineStyle::
		// ********************************
		///@{
		CdColorProp	getDiagramSenColor()const
		{	return m_colorDiagramSenColor ;};
		void setDiagramSenColor( const CdColorProp value )
		{	m_colorDiagramSenColor = value ;};
		ESenStyle	getDiagramSenStyle()const
		{	return m_eDiagramSenStyle ;};
		void setDiagramSenStyle( ESenStyle value )
		{	m_eDiagramSenStyle = value ;};
		bool	getDiagramSenIsBold()const
		{	return m_bDiagramSenIsBold ;};
		void setDiagramSenIsBold( bool value )
		{	m_bDiagramSenIsBold = value ;};
	};


	/**
		Ԏʖ́Aԉw̕@̑I\񋓂łB
	*/
	enum EStopMarkDrawType
	{
		/**
			ԉw=ԉw𖾎@
			
			lB_COr[ŒԉwON̏ꍇ́A
			ZԒԉwɁ`悵܂B
		*/
		EStopMarkDrawType_DrawOnStop = 0 ,
		
		/**
			ԉw=Ȃ
		
			ԉws܂B
			
			ewԂȂǁAԉw̕Kv̂ȂԎʂł邱Ƃ
			܂B
			
			_COr[̑ԉw=ON
			(CDcdDiagram::m_eStopMarkDraw==
				CDcdDiagram::EStopMarkDraw_DrawOnBriefStop )
			sꍇłA̗Ԏʂ̗Ԃɂ́A
			ԉw͍s܂B
		*/
		EStopMarkDrawType_Nothing ,

		/**
			݂͎gĂ܂Bɗ\񂳂Ă܂B
			
			ԉw=ʉ߉w𖾎

			_COr[ŒԉwON̏ꍇ́A
			ʉ߉wɋL`悵܂Bԉwւ̕`͍s܂B
		*/
		EStopMarkDrawType_DrawOnPass ,
	};



private:
	// ********************************
	///@name 
	// ********************************
	///@{
	/**
	  	ʖB
	  
	  	KĺA󕶎B
	  
	  	̒l󕶎̏ꍇÃIuWFNg͖łB
	 */
	std::string	m_strSyubetsumei ;
	
	/**
	  	́iʖ̗́jB
	  
	  	KĺA󕶎B
	 */
	std::string	m_strRyakusyou ;
	
	/**
	  	\F(_CO̗ԏ̕F˂܂)
	  
	  	KĺAB
	 */
	CdColorProp	m_colorJikokuhyouMojiColor ;

	/**
		\r[ŁA̗Ԏʂ̎\邽߂̎\tHgB
		͈͂́A 0 ȏA CdDedDispProp::JIKOKUHYOUFONT_COUNT łB
	
	- 0Fw\r[ 1x
	- 1: w\r[ 2x
	- 2: w\r[ 3x
@@- @@@F
	
	*/
	int m_iJikokuhyouFontIndex ;

	/**
		Ԑ()̐̌`󑮐B
	*/
	CdDiagramLineStyle	m_CdDiagramLineStyle ;

	/**
		Ԏʖ́Aԉw̕@B
		ĺA EStopMarkDrawType_DrawOnStop B
	*/
	EStopMarkDrawType m_eStopMarkDrawType ;
	///@}
 public:
	// ********************************
	//	RXgN^
	// ********************************
	/**
	   @param strSyubetsumei [in]
	  	ʖB
	   @param strRyakusyou [in]
	  	́iʖ̗́jB
	   @param colorJikokuhyouMojiColor [in]
	  	\FB
	   @param colorDiagramSenColor [in] 
	  	_CO̐FB
	   @param eDiagramSenStyle [in]
	  	_CO̐X^CB
	   @param bDiagramSenIsBold [in]
	  	_CO̐̑B
	  	_CO̐ł trueB
	  	אȂ false łB
	 */
	CentDedRessyasyubetsu( 
			const std::string& strSyubetsumei ,
			const std::string& strRyakusyou ,
			CdColorProp	colorJikokuhyouMojiColor = CdColorProp( 0 , 0 ,0 ), 
			CdColorProp	colorDiagramSenColor = CdColorProp( 0 , 0 , 0 ),
			ESenStyle	eDiagramSenStyle = SenStyle_Jissen ,
			bool bDiagramSenIsBold = false ) :
		m_strSyubetsumei( strSyubetsumei ) ,
		m_strRyakusyou( strRyakusyou ) ,
		m_colorJikokuhyouMojiColor( colorJikokuhyouMojiColor ) , 
		m_iJikokuhyouFontIndex( 0 ) ,
		m_CdDiagramLineStyle( colorDiagramSenColor , eDiagramSenStyle , bDiagramSenIsBold ) ,
		m_eStopMarkDrawType( EStopMarkDrawType_DrawOnStop ){};

	CentDedRessyasyubetsu() :
		m_colorJikokuhyouMojiColor( CdColorProp( 0 , 0 , 0 ) ) , 
		m_iJikokuhyouFontIndex( 0 ) ,
		m_eStopMarkDrawType( EStopMarkDrawType_DrawOnStop ){};



// ********************************
//	CentDedRessyasyubetsu
// ********************************
 public:
	// ********************************
	///@name 
	// ********************************
	///@{
	std::string	getSyubetsumei()const{	return 	m_strSyubetsumei ;};
	CentDedRessyasyubetsu& setSyubetsumei( const std::string& value )
	{	m_strSyubetsumei = value ; return *this ; } ;

	std::string	getRyakusyou()const{	return m_strRyakusyou ;};
	CentDedRessyasyubetsu& setRyakusyou( const std::string& value )
	{	m_strRyakusyou = value ; return *this ; } ;
	
	CdColorProp	getJikokuhyouMojiColor()const{
		return m_colorJikokuhyouMojiColor ;};
	CentDedRessyasyubetsu& setJikokuhyouMojiColor( const CdColorProp&	value )
	{	m_colorJikokuhyouMojiColor = value ; return *this ; } ;

	int getJikokuhyouFontIndex()const
	{	return m_iJikokuhyouFontIndex ;};
	CentDedRessyasyubetsu& setJikokuhyouFontIndex( int value )
	{	m_iJikokuhyouFontIndex = value ; return *this ;};

	CdDiagramLineStyle	getCdDiagramLineStyle()const
	{	return m_CdDiagramLineStyle ;};
	void setCdDiagramLineStyle( const CdDiagramLineStyle& value )
	{	m_CdDiagramLineStyle = value ;};
	/// getCdDiagramLineStyle(),getDiagramSenColor() ƓłB݊̂߂ɎcĂ܂B
	CdColorProp	getDiagramSenColor()const{
		return 	m_CdDiagramLineStyle.getDiagramSenColor() ;};
	/// setCdDiagramLineStyle() őւł܂B݊̂߂ɎcĂ܂B
	CentDedRessyasyubetsu& setDiagramSenColor( const CdColorProp&	value ){
		m_CdDiagramLineStyle.setDiagramSenColor( value ); return *this ; } ;
	/// getCdDiagramLineStyle(),getDiagramSenStyle() ƓłB݊̂߂ɎcĂ܂B
	ESenStyle	getDiagramSenStyle()const{
		return m_CdDiagramLineStyle.getDiagramSenStyle() ;};
	/// setCdDiagramLineStyle() őւł܂B݊̂߂ɎcĂ܂B
	CentDedRessyasyubetsu& setDiagramSenStyle( ESenStyle value ){
		m_CdDiagramLineStyle.setDiagramSenStyle( value ); return *this ;};
	/// getCdDiagramLineStyle(),getDiagramSenIsBold() ƓłB݊̂߂ɎcĂ܂B
	bool getDiagramSenIsBold()const{ 
		return m_CdDiagramLineStyle.getDiagramSenIsBold() ; };
	/// setCdDiagramLineStyle() őւł܂B݊̂߂ɎcĂ܂B
	CentDedRessyasyubetsu& setDiagramSenIsBold( bool value ){
		m_CdDiagramLineStyle.setDiagramSenIsBold( value ) ; return *this ;};



	EStopMarkDrawType getStopMarkDrawType()const
	{ return m_eStopMarkDrawType ;};
	CentDedRessyasyubetsu& setStopMarkDrawType( EStopMarkDrawType value )
	{	m_eStopMarkDrawType = value ; return *this ;};

	///@}

	// ********************************
	///@name 
	// ********************************
	///@{
	/**
	@return
		this( m_strSyubetsumei 󕶎)Ȃ^łB
	*/
	bool isNull()const{	return m_strSyubetsumei.empty() ;};
	///@}
};


#endif /*CentDedRessyasyubetsu_h*/


