/*
	OuDia - Win32 Application Software to draw a "Train Service Planning
 Diagram" based on a "Train Timetable".

Copyright (C) 2006-2017 take-okm

This program is free software; you can redistribute it and/or modify it 
under the terms of the GNU General Public License as published by the Free 
Software Foundation; either version 3 of the License, or (at your option) 
any later version. 

This program is distributed in the hope that it will be useful, but WITHOUT 
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or 
FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for 
more details. 

You should have received a copy of the GNU General Public License along with
 this program. If not, see <http://www.gnu.org/licenses/>.

  In addition, as a special exception, take-okm
  gives permission to link the code of this program with
  the "MFC(Microsoft Foundation Class library) Version 9.0" 
  (or with modified versions of "MFC Version 9.0" that use the same license as 
  "MFC Version 9.0" ), and distribute linked combinations including
  the two.  You must obey the GNU General Public License in all
  respects for all of the code used other than  "MFC".  If you modify
  this file, you may extend this exception to your version of the
  file, but you are not obligated to do so.  If you do not wish to
  do so, delete this exception statement from your version.


(: 

	OuDia - Ԏ\ƂɁA_CO`悷Win32AvP[V
B

Copyright (C) 2006-2017 take-okm 

̃vO̓t[\tgEFAłBȂ͂At[\tgEFA
cɂĔsꂽGNU ʌOp(o[W3Aȍ~̃o[W
̂ǂꂩ)߂̉ōĔЕz܂͉ 邱Ƃł܂B

̃vO͗Lpł邱ƂĔЕz܂A*S̖ۏ *łB
Ɖ\̕ۏ؂ړIւ̓ḰAOɎꂽ̂ ܂߁AS
܂BڂGNU ʌOpB

Ȃ͂̃vOƋɁAGNU ʌOp̃Rs[ꕔ 󂯎
Ă͂łB󂯎ĂȂ΁A<http://www.gnu.org/licenses/> 
B

)

  āAʂȗOƂāAtake-okm ͂̃vÕR[h 
  "MFC(Microsoft Foundation Class library) Version 9.0" 
  (  邢 "MFC Version 9.0" ƓCZXKpꂽ
  "MFC Version 9.0" ̉ςꂽo[W)ƃNA
  Nꂽ҂܂ތ앨Еz鋖^܂B
  Ȃ "MFC" ȊOŎgĂ邷ׂ
  ̃R[hɊւĂ͑SʓIGNUʌOp_񏑂ɏ]Ȃ
  Ȃ܂BȂ̃t@CςȂ΁AȂ̗͂O
  Ȃ̃o[W̃t@CɈ݂邱Ƃł܂A
  `͂܂BO݂Ȃ΁A̗O
  Ȃ̃o[W͍폜ĂB)
*/
/*
// ****************************************************************
//	CConverter_WinGdi.h
// ****************************************************************
*/
/** @file */
#ifndef  CConverter_WinGdi_h

#include <windows.h>

#include "str\tstring.h"
#include "Ou\Ou.h"

#include "DcdCd\Pos\CdDcdPosXy.h"
#include "DcdCd\Pos\CdDcdZoneXy.h"
#include "DcdCd\Pos\CdDcdSizeXy.h"

#include "DcdCd\DcDrawProp\CdDrawTextProp.h"
#include "DcdCd\DcDrawProp\CdColorProp.h"
#include "DcdCd\DcDrawProp\CdFontProp.h"
#include "DcdCd\DcDrawProp\CdPenProp.h"
#include "DcdCd\DcDrawProp\CdBrushProp.h"
#include "CGdiHFontHolder.h"
#include "CGdiHPenHolder.h"
#include "CGdiHBrushHolder.h"
// ****************************************************************
//	CConverter_WinGdi
// ****************************************************************
/**
* @brief
* yTvz
* 	WIN32Ŏgp\̂ƁADcDrawŎgpNXƂ̊Ԃ̑ݕϊ
* 	s܂B
*/
class CConverter_WinGdi
{
 public:
	// ********************************
	///	@name W֐Q
	// ********************************
	///@{
	/**
	 *	POINT ^ CdDcdPosXy ɕϊ܂B
	 * @param aPOINT [in]
	 *	ϊ
	 * @param pCdDcdPosXy [out]
	 *	̊֐͂̃AhXɁAϊl݂܂B
	 */
	void toCdDcdPosXy( const POINT& aPOINT , CdDcdPosXy* pCdDcdPosXy ) ; 

	CdDcdPosXy CdDcdPosXyOf( const POINT& aPOINT ) {
		CdDcdPosXy	aCdDcdPosXy ;
		toCdDcdPosXy( aPOINT , &aCdDcdPosXy ) ;
		return ( aCdDcdPosXy ) ;
	};
	
	/**
	 *	CdDcdPosXy  POINT ^ɕϊ܂B
	 * @param aCdDcdPosXy [in]
	 *	ϊ
	 * @param pPOINT [out]
	 *	̊֐͂̃AhXɁAϊl݂܂B
	 */
	void toPOINT( const CdDcdPosXy& aCdDcdPosXy , POINT* pPOINT ) ;
	
	POINT POINTOf( const CdDcdPosXy& aCdDcdPosXy ) {
		POINT	aPOINT ;
		toPOINT( aCdDcdPosXy  , &aPOINT ) ;
		return ( aPOINT ) ;
	};

	/**
	 *	RECT ^ CdDcdZoneXy ɕϊ܂B
	 * @param aPOINT [in]
	 *	ϊ
	 * @param pCdDcdZoneXy [out]
	 *	̊֐͂̃AhXɁAϊl݂܂B
	 */
	void toCdDcdZoneXy( const RECT& aRECT , CdDcdZoneXy* pCdDcdZoneXy ) ; 

	CdDcdZoneXy CdDcdZoneXyOf( const RECT& aRECT ) {
		CdDcdZoneXy	aCdDcdZoneXy ;
		toCdDcdZoneXy( aRECT , &aCdDcdZoneXy ) ;
		return ( aCdDcdZoneXy ) ;
	};
	
	/**
	 *	CdDcdZoneXy  RECT ^ɕϊ܂B
	 * @param aCdDcdPosXy [in]
	 *	ϊ
	 * @param pPOINT [out]
	 *	̊֐͂̃AhXɁAϊl݂܂B
	 */
	void toRECT( const CdDcdZoneXy& aCdDcdZoneXy , RECT* pRECT ) ;
	
	RECT RECTOf( const CdDcdZoneXy& aCdDcdZoneXy ) {
		RECT	aRECT ;
		toRECT( aCdDcdZoneXy  , &aRECT ) ;
		return ( aRECT ) ;
	};

	///@}
	// ********************************
	///	@name Color֐Q
	// ********************************
	///@{
	/**
		COLORREF ACdColorProp ɕϊ܂B
	@param value [in]
		ϊ̒lw肵ĂB
	@return 
		ϊ̒lw肵ĂB
	*/
	CdColorProp CdColorPropOf( COLORREF value )const;

	/**
		CdColorProp  COLORREF ɕϊ܂B
	@param value [in]
		ϊ̒lw肵ĂB
	@return 
		ϊ̒lw肵ĂB
	*/
	COLORREF COLORREFOf( const CdColorProp& value )const;

	/**
	*	 VXeJ[̑A
	*	CdColorProp IuWFNg֕ϊ܂B
	* @param fnObject [in]
	* 	GetSysColor() Ŏw肷A\vf
	*	̒萔w肵ĂB
	* @return
	* 	 CdColorProp \̂Ԃ܂B
	*/
	CdColorProp CdColorPropOfSysColor( int nIndex ) ;
	
	///@}
	// ********************************
	///	@name Font֐Q
	// ********************************
	///@{
	
	/**
		CdFontPropIuWFNg̓eA LOGFONT \̂֕ϊ܂B
	
	 	CdFontProp IuWFNgɐݒ肳Ă鍂
	 	PointTextHeight Ŏw肳Ăꍇ́ALOGFONTɕϊ
	 	ۂɂ́A̕ϊɂ́AtHg̕`sHDCKvłB
	 	ÃP[XHDC̎wȗꍇ́AXN[DC
	 	ƂLOGFONT\̂쐬܂B

		CdFontProp::m_strFacename 󕶎Ƃꍇ́A
		DEFAULT_GUI_FONT ō̗pĂtHg[܂B
	 @param aCdFontProp [in]
	 	tHgw肵ĂB
	 @param pLOGFONT [out]
	 	̊֐͂̍\̂ɁA݂܂B
	 @param hDc [in]
	 	CdFontProp IuWFNgɐݒ肳Ă鍂
	 	PointTextHeight Ŏw肳Ăꍇ́ALOGFONTɕϊ
	 	ۂɂ́A̕ϊɂ́AtHg̕`sHDCKvłB
	 	ɂ́AHDCw肵ĂB
	 	ÃP[XHDC̎wȗꍇ́AXN[DC
	 	ƂLOGFONT\̂쐬܂B
	 	CdFontProp IuWFNgɐݒ肳Ă鍂
	 	Logicalunit... Ŏw肳Ăꍇ́AHDCɂ
	 	Ӗ܂B
	*/
	void toLOGFONT( const CdFontProp& aCdFontProp , 
			LOGFONT*	pLOGFONT ,
			HDC hDc = NULL ) ;

	/**
	*	CdFontPropIuWFNgA LOGFONT \̂֕ϊ܂B
	*	́AtoLOGFONT Ɠł
	*
	* @retval 
	* 	쐬LOGFONT\̂Ԃ܂B
	*/
	LOGFONT LOGFONTOf( const CdFontProp& aCdFontProp , 
			HDC hDc = NULL ) {
		LOGFONT	aLOGFONT ;
		toLOGFONT( aCdFontProp , &aLOGFONT , hDc ) ;
		return ( aLOGFONT ) ;
	};

	/**
	*	 LOGFONT \̂̓eACdFontPropIuWFNg֕ϊ܂B
	*	ACdFontPropۗ̕LʂLOGFONT\̂Ȃ߁A
	*	ϊCdFontPropIuWFNgł́A񂪈ꕔ܂B
	* @param aLOGFONT [in]
	* 	LOGFONT\̂w肵ĂB
	* @param pCdFontProp [out]
	* 	̊֐͂̃IuWFNg\̂ɁA݂܂B
	*/
	void toCdFontProp( 
			const LOGFONT&	aLOGFONT ,
			CdFontProp* pCdFontProp ) ;

	/**
	*	XgbNIuWFNg̑A
	*	CdFontPropIuWFNg֕ϊ܂B
	*	ACdFontPropۗ̕LʂLOGFONT\̂Ȃ߁A
	*	ϊCdFontPropIuWFNgł́A񂪈ꕔ܂B
	* @param fnObject [in]
	* 	GetStockObject() Ŏw肷AXgbNtHgIuWFNg
	*	̒萔w肵ĂB
	* @param pCdFontProp [out]
	* 	̊֐͂̃IuWFNg\̂ɁA݂܂B
	*/
	void toCdFontProp( 
			int fnObject ,
			CdFontProp* pCdFontProp ) ;

	/**
	*	 LOGFONT \̂̓eACdFontPropIuWFNg֕ϊ܂B
	*	́AtoCdFontProp Ɠł
	* @param aLOGFONT [in]
	* 	LOGFONT\̂w肵ĂB
	* @return
	* 	 CdFontProp \̂Ԃ܂B
	*/
	CdFontProp CdFontPropOf( 
			const LOGFONT&	aLOGFONT ){
		CdFontProp	rv ;
		toCdFontProp( aLOGFONT , &rv ) ;
		return ( rv ) ;
	};
	/**
	*	 XgbNIuWFNg̑A
	*	CdFontPropIuWFNg֕ϊ܂B
	*	́AtoCdFontProp Ɠł
	* @param fnObject [in]
	* 	GetStockObject() Ŏw肷AXgbNtHgIuWFNg
	*	̒萔w肵ĂB
	* @return
	* 	 CdFontProp \̂Ԃ܂B
	*/
	CdFontProp CdFontPropOf( 
						int fnObject ){
		CdFontProp	rv ;
		toCdFontProp( fnObject , &rv ) ;
		return ( rv ) ;
	};

	/**
	 	CdFontPropIuWFNg̑ƂɁAtHg𐶐܂
	 @param aCdFontProp [in]
	 	tHgw肵ĂB
	 @param hDc [in]
	 	CdFontProp IuWFNgɐݒ肳Ă鍂
	 	PointTextHeight Ŏw肳Ăꍇ́ALOGFONTɕϊ
	 	ۂɂ́A̕ϊɂ́AtHg̕`sHDCKvłB
		ɂ́AHDCw肵ĂB
	 	ÃP[XHDC̎wȗꍇ́AXN[DC
	 	ƂLOGFONT\̂쐬܂B
	 	CdFontProp IuWFNgɐݒ肳Ă鍂
	 	Logicalunit... Ŏw肳Ăꍇ́AHDCɂ
	 	Ӗ܂B
	 @return
		tHg̃nhԂ܂B
		̃nh̔j̐Ӗ́A֐ďoɂ܂B
		֐ďóAnhsvɂȂ DeleteObject() 
		nhȂĂ͂Ȃ܂B
	*/
	HFONT	CreateFont(  const CdFontProp& aCdFontProp , 
			HDC hDc = NULL ) ;

	/**
	 	CdFontPropIuWFNg̑ƂɁAtHg𐶐܂
	 @param aCdFontProp [in]
	 	tHgw肵ĂB
	 @param hDc [in]
	 	CdFontProp IuWFNgɐݒ肳Ă鍂
	 	PointTextHeight Ŏw肳Ăꍇ́ALOGFONTɕϊ
	 	ۂɂ́A̕ϊɂ́AtHg̕`sHDCKvłB
		ɂ́AHDCw肵ĂB
	 	ÃP[XHDC̎wȗꍇ́AXN[DC
	 	ƂLOGFONT\̂쐬܂B
	 	CdFontProp IuWFNgɐݒ肳Ă鍂
	 	Logicalunit... Ŏw肳Ăꍇ́AHDCɂ
	 	Ӗ܂B
	 @return
		tHg̃nhێ CGdiHFontHolder Ԃ܂B
		nh̐ɂꍇ́ANULLłB
	*/
	virtual Ou<CGdiHFontHolder>	createGdiHFontHolder( 
		const CdFontProp& aCdFontProp , 
		HDC hDc = NULL ) ;
	

	/**
	* 	CdFontPropIuWFNg̑DCƂɁA
	*	w̃eLXg`悵ꍇ̑傫vZ܂B
	* @param strTextExtent [in]
	*	̊֐́A̕\ł镝Ԃ܂B
	* @param iLinesExtent [in]
	*	̊֐́A̍s\ł鍂Ԃ܂B
	* @param aCdDrawTextProp [in]
	* 	tHgw肵ĂB
	* @param hDc [in]
	* 	CdFontProp IuWFNgɐݒ肳Ă鍂
	* 	PointTextHeight Ŏw肳Ăꍇ́ALOGFONTɕϊ
	* 	ۂɂ́A̕ϊɂ́AtHg̕`sHDCKvłB
	* 	ɂ́AHDCw肵ĂB
	* 	ÃP[XHDC̎wȗꍇ́AXN[DC
	* 	ƂLOGFONT\̂쐬܂B
	* 	CdFontProp IuWFNgɐݒ肳Ă鍂
	* 	Logicalunit... Ŏw肳Ăꍇ́AHDCɂ
	* 	Ӗ܂B
	* @return
	*	tHg̃nhԂ܂B
	*	̃nh̔j̐Ӗ́A֐ďoɂ܂B
	*	֐ďóAnhsvɂȂ DeleteObject() 
	*	nhȂĂ͂Ȃ܂B
	*/
	CdDcdSizeXy	DrawtextCalcrect( 
		const tstring& strExtent ,
		int iLinesExtent ,
		const CdDrawTextProp& aCdDrawTextProp , 
		HDC hDc = NULL ) ;

	///@}
	
	// ********************************
	///	@name Pen֐Q
	// ********************************
	
	///@{
	
	/**
	*	CdPenPropIuWFNg̓eA LOGPEN \̂֕ϊ܂B
	*
	* @param aCdPenProp [in]
	* 	yw肵ĂB
	* @param pLOGPEN [out]
	* 	̊֐͂̍\̂ɁA݂܂B
	*/
	void toLOGPEN( const CdPenProp& aCdPenProp , 
			LOGPEN*	pLogPen ) ;

	/**
	*	CdPenPropIuWFNgA LOGPEN \̂֕ϊ܂B
	*	́AtoLOGPEN Ɠł
	*
	* @retval 
	* 	쐬LOGFONT\̂Ԃ܂B
	*/
	LOGPEN LOGPENOf( const CdPenProp& aCdPenProp ) {
		LOGPEN	aLOGPEN ;
		toLOGPEN( aCdPenProp , &aLOGPEN ) ;
		return ( aLOGPEN ) ;
	};

	/**
	*	 LOGPEN \̂̓eACdPenPropIuWFNg֕ϊ܂B
	* @param aLOGPEN [in]
	* 	LOGPEN\̂w肵ĂB
	* @param pCdPenProp [out]
	* 	̊֐͂̃IuWFNg\̂ɁA݂܂B
	*/
	void toCdPenProp( 
			const LOGPEN&	aLOGPEN ,
			CdPenProp* pCdPenProp ) ;

	/**
	*	XgbNIuWFNg̑A
	*	CdPenPropIuWFNg֕ϊ܂B
	* @param fnObject [in]
	* 	GetStockObject() Ŏw肷AXgbNtHgIuWFNg
	*	̒萔w肵ĂB
	* @param pCdPenProp [out]
	* 	̊֐͂̃IuWFNg\̂ɁA݂܂B
	*/
	void toCdPenProp( 
			int fnObject ,
			CdPenProp* pCdPenProp ) ;
	
	/**
	*	 LOGPEN \̂̓eACdPenPropIuWFNg֕ϊ܂B
	* @param aLOGPEN [in]
	* 	LOGPEN\̂w肵ĂB
	* @return
	* 	 CdPenProp \̂Ԃ܂B
	*/
	CdPenProp CdPenPropOf( 
			const LOGPEN&	aLOGPEN ){
		CdPenProp	rv ;
		toCdPenProp( aLOGPEN , &rv ) ;
		return ( rv ) ;
	};
	/**
	*	XgbNIuWFNg̑A
	*	CdPenPropIuWFNg֕ϊ܂B
	* @param fnObject [in]
	* 	GetStockObject() Ŏw肷AXgbNtHgIuWFNg
	*	̒萔w肵ĂB
	* @return
	* 	 CdPenProp \̂Ԃ܂B
	*/
	CdPenProp CdPenPropOf( 
						int fnObject ){
		CdPenProp	rv ;
		toCdPenProp( fnObject , &rv ) ;
		return ( rv ) ;
	};

	/**
	* 	CdPenPropIuWFNg̑ƂɁAy𐶐܂
	* @param aCdPenProp [in]
	* 	yw肵ĂB
	* @return
	*	ỹnhԂ܂B
	*	̃nh̔j̐Ӗ́A֐ďoɂ܂B
	*	֐ďóAnhsvɂȂ DeleteObject() 
	*	nhȂĂ͂Ȃ܂B
	*/
	HPEN	CreatePen(  const CdPenProp& aCdPenProp ) ;
	
	/**
	 	CdPenPropIuWFNg̑ƂɁAy𐶐܂
	 @param aCdPenProp [in]
	 	yw肵ĂB
	 @return
		ỹnhێ CGdiHPenHolder Ԃ܂B
		nh̐ɂꍇ́ANULLłB
	*/
	Ou<CGdiHPenHolder>		createGdiHPenHolder(  const CdPenProp& aCdPenProp ) ;
	///@}

	// ********************************
	///	@name Brush֐Q
	// ********************************
	
	///@{
	/**
	*	CdBrushPropIuWFNg̓eA LOGBRUSH \̂֕ϊ܂B
	*
	* @param aCdBrushProp [in]
	* 	uVw肵ĂB
	* @param pLOGBRUSH [out]
	* 	̊֐͂̍\̂ɁA݂܂B
	*/
	void toLOGBRUSH( const CdBrushProp& aCdBrushProp , 
			LOGBRUSH*	pLogbrush ) ;
	/**
	*	CdBrushPropIuWFNgA LOGBRUSH \̂֕ϊ܂B
	*	́AtoLOGBRUSH Ɠł
	*
	* @retval 
	* 	쐬LOGBRUSH\̂Ԃ܂B
	*/
	LOGBRUSH LOGBRUSHOf( const CdBrushProp& aCdBrushProp ) {
		LOGBRUSH	aLOGBRUSH ;
		toLOGBRUSH( aCdBrushProp , &aLOGBRUSH ) ;
		return ( aLOGBRUSH ) ;
	};

	/**
	*	 LOGBRUSH \̂̓eACdBrushPropIuWFNg֕ϊ܂B
	* @param aLOGBRUSH [in]
	* 	LOGBRUSH\̂w肵ĂB
	* @param pCdBrushProp [out]
	* 	̊֐͂̃IuWFNg\̂ɁA݂܂B
	*/
	void toCdBrushProp( 
			const LOGBRUSH&	aLOGBRUSH ,
			CdBrushProp* pCdBrushProp ) ;

	/**
	*	XgbNIuWFNg̑A
	*	CdBrushPropIuWFNg֕ϊ܂B
	* @param fnObject [in]
	* 	GetStockObject() Ŏw肷AXgbNtHgIuWFNg
	*	̒萔w肵ĂB
	* @param pCdBrushProp [out]
	* 	̊֐͂̃IuWFNg\̂ɁA݂܂B
	*/
	void toCdBrushProp( 
			int fnObject ,
			CdBrushProp* pCdBrushProp ) ;
	
	/**
	*	 LOGBRUSH \̂̓eACdBrushPropIuWFNg֕ϊ܂B
	*	́AtoCdBrushProp Ɠł
	* @param aLOGBRUSH [in]
	* 	LOGBRUSH\̂w肵ĂB
	* @return
	* 	 CdBrushProp \̂Ԃ܂B
	*/
	CdBrushProp CdBrushPropOf( 
			const LOGBRUSH&	aLOGBRUSH ){
		CdBrushProp	rv ;
		toCdBrushProp( aLOGBRUSH , &rv ) ;
		return ( rv ) ;
	};
	/**
	*	 XgbNIuWFNg̑
	*	CdBrushPropIuWFNg֕ϊ܂B
	* @param fnObject [in]
	* 	GetStockObject() Ŏw肷AXgbNtHgIuWFNg
	*	̒萔w肵ĂB
	* @return
	* 	 CdBrushProp \̂Ԃ܂B
	*/
	CdBrushProp CdBrushPropOf( 
						int fnObject ){
		CdBrushProp	rv ;
		toCdBrushProp( fnObject , &rv ) ;
		return ( rv ) ;
	};

	/**
	* 	CdBrushPropIuWFNg̑ƂɁAy𐶐܂
	* @param aCdBrushProp [in]
	* 	yw肵ĂB
	* @return
	*	ỹnhԂ܂B
	*	̃nh̔j̐Ӗ́A֐ďoɂ܂B
	*	֐ďóAnhsvɂȂ DeleteObject() 
	*	nhȂĂ͂Ȃ܂B
	*/
	HBRUSH	CreateBrush(  const CdBrushProp& aCdBrushProp ) ;
	
	/**
	 	CdBrushPropIuWFNg̑ƂɁAuV𐶐܂
	 @param aCdBrushProp [in]
	 	uVw肵ĂB
	 @return
		uṼnhێ CGdiHBrushHolder Ԃ܂B
		nh̐ɂꍇ́ANULLłB
	*/
	Ou<CGdiHBrushHolder>		createGdiHBrushHolder( const CdBrushProp& aCdBrushProp ) ;
	///@}
	// ********************************
	///@name	_WƃfoCXW̕ϊ	
	// ********************************
	///@{
	/**
	 *	foCXW_W֕ϊ܂
	 * @param value [in] 
	 *	ϊO̍Wlw肵ĂB
	 * @param hdc [in] 
	 *	foCXReLXg̃nhw肵܂B 
	 */
	CdDcdPosXy DPtoLP( const CdDcdPosXy& value , HDC hDc ) ;  

	/**
	 *	_WfoCXW֕ϊ܂
	 * @param value [in] 
	 *	ϊO̍Wlw肵ĂB
	 * @param hdc [in] 
	 *	foCXReLXg̃nhw肵܂B 
	 */
	CdDcdPosXy LPtoDP( const CdDcdPosXy& value , HDC hDc ) ;  

	/**
	 *	foCXW_W֕ϊ܂
	 * @param value [in] 
	 *	ϊO̍Wlw肵ĂB
	 * @param hdc [in] 
	 *	foCXReLXg̃nhw肵܂B 
	 */
	CdDcdSizeXy DPtoLP( const CdDcdSizeXy& value , HDC hDc ) ;  

	/**
	 *	_WfoCXW֕ϊ܂
	 * @param value [in] 
	 *	ϊO̍Wlw肵ĂB
	 * @param hdc [in] 
	 *	foCXReLXg̃nhw肵܂B 
	 */
	CdDcdSizeXy LPtoDP( const CdDcdSizeXy& value , HDC hDc ) ;  


	/**
	 *	foCXW_W֕ϊ܂
	 * @param value [in] 
	 *	ϊO̍Wlw肵ĂB
	 * @param hdc [in] 
	 *	foCXReLXg̃nhw肵܂B 
	 */
	CdDcdZoneXy DPtoLP( const CdDcdZoneXy& value , HDC hDc ) ;  

	/**
	 *	_WfoCXW֕ϊ܂
	 * @param value [in] 
	 *	ϊO̍Wlw肵ĂB
	 * @param hdc [in] 
	 *	foCXReLXg̃nhw肵܂B 
	 */
	CdDcdZoneXy LPtoDP( const CdDcdZoneXy& value , HDC hDc ) ;  
	///@}
};
// ****************************************************************
//	ʊ֐
// ****************************************************************
/**
 *	w̃foCX  HDC  
 *	GetDeviceCaps() ̒l̂Lq
 *	쐬܂B
 *	͉̕ǃeLXgłA
 *	fobOȊO̎g͂܂B
 *
 * @param hDc [in]
 *	ΏۂƂȂfoCX HDC w肵ĂB
 * @return
 *	Ԃ܂B
 *
 *	ΏۂƂȂfoCX̑ĺAȉ̂̂łB
 *
 *	- TECHNOLOGY
 *	- HORZSIZE
 *	- VERTSIZE
 *	- HORZRES
 *	- VERTRES
 *	- LOGPIXELSX
 *	- LOGPIXELSY
 *	- PHYSICALWIDTH
 *	- PHYSICALHEIGHT
 *	- PHYSICALOFFSETX
 *	- PHYSICALOFFSETY
 */	
std::string	DeviceCapsToString( HDC hDc ) ;


#define  CConverter_WinGdi_h
#endif /*CConverter_WinGdi_h*/


