/*
	OuDia - Win32 Application Software to draw a "Train Service Planning
 Diagram" based on a "Train Timetable".

Copyright (C) 2006-2017 take-okm

This program is free software; you can redistribute it and/or modify it 
under the terms of the GNU General Public License as published by the Free 
Software Foundation; either version 3 of the License, or (at your option) 
any later version. 

This program is distributed in the hope that it will be useful, but WITHOUT 
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or 
FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for 
more details. 

You should have received a copy of the GNU General Public License along with
 this program. If not, see <http://www.gnu.org/licenses/>.

  In addition, as a special exception, take-okm
  gives permission to link the code of this program with
  the "MFC(Microsoft Foundation Class library) Version 9.0" 
  (or with modified versions of "MFC Version 9.0" that use the same license as 
  "MFC Version 9.0" ), and distribute linked combinations including
  the two.  You must obey the GNU General Public License in all
  respects for all of the code used other than  "MFC".  If you modify
  this file, you may extend this exception to your version of the
  file, but you are not obligated to do so.  If you do not wish to
  do so, delete this exception statement from your version.


(: 

	OuDia - Ԏ\ƂɁA_CO`悷Win32AvP[V
B

Copyright (C) 2006-2017 take-okm 

̃vO̓t[\tgEFAłBȂ͂At[\tgEFA
cɂĔsꂽGNU ʌOp(o[W3Aȍ~̃o[W
̂ǂꂩ)߂̉ōĔЕz܂͉ 邱Ƃł܂B

̃vO͗Lpł邱ƂĔЕz܂A*S̖ۏ *łB
Ɖ\̕ۏ؂ړIւ̓ḰAOɎꂽ̂ ܂߁AS
܂BڂGNU ʌOpB

Ȃ͂̃vOƋɁAGNU ʌOp̃Rs[ꕔ 󂯎
Ă͂łB󂯎ĂȂ΁A<http://www.gnu.org/licenses/> 
B

)

  āAʂȗOƂāAtake-okm ͂̃vÕR[h 
  "MFC(Microsoft Foundation Class library) Version 9.0" 
  (  邢 "MFC Version 9.0" ƓCZXKpꂽ
  "MFC Version 9.0" ̉ςꂽo[W)ƃNA
  Nꂽ҂܂ތ앨Еz鋖^܂B
  Ȃ "MFC" ȊOŎgĂ邷ׂ
  ̃R[hɊւĂ͑SʓIGNUʌOp_񏑂ɏ]Ȃ
  Ȃ܂BȂ̃t@CςȂ΁AȂ̗͂O
  Ȃ̃o[W̃t@CɈ݂邱Ƃł܂A
  `͂܂BO݂Ȃ΁A̗O
  Ȃ̃o[W͍폜ĂB)
*/
/*
// ****************************************************************
//	CDcdFreeLine.h
// ****************************************************************
*/
/** @file */
#ifndef  CDcdFreeLine_h
#define  CDcdFreeLine_h


#include "DcDraw\IfDcDraw.h"
#include "DcdCd\DcDrawProp\CdDcdFreeLineProp.h"

// ****************************************************************
//	CDcdFreeLine
// ****************************************************************
/**
 * @brief
 * yTvz
 * IfDcdTarget Ŏw肳ꂽ̈́AŎw肳ꂽQ̍W̊ԂɁA
 * `悵܂B
 * 
 * 	̃NX́A IfDcdTarget::getZone() ̗̈Oւ̐̕`
 *	Nbv܂B
 * 
 * ̃NXł́ÃX^CEF́A CDcdFreeLine::CdLineProp 
 * w肵܂B
 * ̃NX́ÃX^CƂāAʏ Win32 ̃ył̓T|[g
 * Ȃu̔jvu̓_vȂǂ̕`悪ł܂B
 * 
 */
class CDcdFreeLine : public IfDcDraw
{
// ********************************
//	Ci[^Cv
// ********************************
 public:

// ********************************
///@name	
// ********************************
///@{
 private:
	/**
	 *	N_̍WB
	 */
	CdDcdPosXy	m_posOrg ;
	/**
	 *	I_̍WB
	 */
	CdDcdPosXy	m_posDst ;
	
	/**
	 *	Pf[^NXłB̌`ƐF̑ێ܂B
	 */
	CdDcdFreeLineProp	m_CdLineProp ;
	
	/**
	 *	DcdTarget͈̔͂ɁAN_ƏI_␳włB
	 *
	 *	̑^ȂÃNX DcDraw() ́A
	 *	m_posOrg , m_posDst  DcdTargetZone ̓ɕ␳Ă
	 *	`s܂B
	 *
	 *	ɂA` DcdTarget  Zone ͈̔͂ŃNbsO
	 *	邱Ƃł܂Aʏ͂̕@g킸A
	 *	DC ɃNbsÖݒ肷i CaDcdTargetClip gj
	 *	ȒPłB
	 *	
	 *	l false łB
	 */
	bool m_bAdjustForDcdTarget ;
	
///@}

// ********************************
//	RXgN^
// ********************************
 public:
	/**
	 * @param posOrg [in]
	 *	N_̍WB
	 * @param posDst [in]
	 *	I_̍WB
	 * @param aCdLineProp [in]
	 *	Pf[^NXłB̌`ƐF̑ێ܂B
	 */
	CDcdFreeLine( const CdDcdPosXy& posOrg , const CdDcdPosXy& posDst , 
		const CdDcdFreeLineProp& aCdLineProp ) :
		m_posOrg( posOrg ) , m_posDst( posDst ) ,
		m_CdLineProp( aCdLineProp ) , 
		m_bAdjustForDcdTarget( false ) {};
	/**
	 * @param aCdLineProp [in]
	 *	Pf[^NXłB̌`ƐF̑ێ܂B
	 */
	CDcdFreeLine( const CdDcdFreeLineProp& aCdLineProp ) :
		m_CdLineProp( aCdLineProp ) , 
		m_bAdjustForDcdTarget( false ){};
	
	CDcdFreeLine() : 
		m_bAdjustForDcdTarget( false ){};

// ********************************
///@name	IfDcDraw
// ********************************
///@{
 public:
	/**
	 * 	`v܂B
	 * 	̊֐́A pIfDcdTarget ɁA`s܂B
	 * @param pIfDcdTarget  [in]
	 * 	̃IuWFNgɕ`s킹DCƗ̈w肵ĂB
	 * @return
	 * 	`sꍇ͐^Ë̗ւ̕`悪łȂꍇ͋UłB
	 */
	virtual bool DcDraw( IfDcdTarget* pIfDcdTarget ) ;
	
	/**
	 * 	̃IuWFNg`悷ACȇ傫܂Ăꍇ́A
	 * 	̑傫𒲂ׂ邱Ƃł܂B
	 * 	֐Ăяo IfDcDraw IuWFNg`悷ꍇɂ́A
	 * 	֐ĂяóÅ֐ŃACȇ傫𒲂ׂāA
	 * 	K؂ȃCAEglĂADcDraw() s邱Ƃł܂B
	 * @param pIfDcdTarget [in]
	 * 	̃IuWFNgɕ`s킹DCƗ̈w肵ĂB
	 * @param pCdDcdSizeXy [out]
	 * 	̃IuWFNg̕`悷ACȇ傫܂Ăꍇ́A
	 * 	̊֐͂̃AhXɁÃACẽTCYԂ܂B
	 * 	̃IuWFNg̕`悷ACȇ傫܂ĂȂꍇ́A
	 * 	̒l͕słB
	 * @return
	 * 	̃IuWFNg̕`悷ACȇ傫܂ĂāA
	 * 	̑傫 *pCdDcdSizeXyɏ񂾏ꍇ͐^łB
	 * 	łȂꍇ́AUłB
	 *
	 * [I[oCh]
	 *	  ̋N_ƏI_\ m_posOrg , m_posDst ͂ޒ`̈ɁA
	 *	y̑̈Ԃ܂B
	 */
	virtual bool getItemSize( IfDcdTarget* pIfDcdTarget , 
							CdDcdSizeXy* pCdDcdSizeXy ) ;
///@}

// ********************************
//	CDcdFreeLine
// ********************************
 public:
	// ********************************
	///@name	
	// ********************************
	///@{
	CdDcdPosXy	getOrg()const{	return 	m_posOrg ;};
	CDcdFreeLine& setOrg( const CdDcdPosXy& value ){
		m_posOrg = value ; return *this ; } ;
	CdDcdPosXy	getDst()const{	return m_posDst ;};
	CDcdFreeLine& setDst( const CdDcdPosXy& value ){
		m_posDst = value ; return *this ; } ;
	CdDcdFreeLineProp	getCdLineProp()const{	return m_CdLineProp ;};
	CDcdFreeLine& setCdLineProp( const CdDcdFreeLineProp& value ){
		m_CdLineProp = value ; return *this ; } ;
	bool getAdjustForDcdTarget()const{ return m_bAdjustForDcdTarget ;};
	CDcdFreeLine& setAdjustForDcdTarget( bool value ){
		m_bAdjustForDcdTarget = value ; return *this ; } ;
	///@}

};

#endif /*CDcdFreeLine_h*/


