/*
	OuDia - Win32 Application Software to draw a "Train Service Planning
 Diagram" based on a "Train Timetable".

Copyright (C) 2006-2017 take-okm

This program is free software; you can redistribute it and/or modify it 
under the terms of the GNU General Public License as published by the Free 
Software Foundation; either version 3 of the License, or (at your option) 
any later version. 

This program is distributed in the hope that it will be useful, but WITHOUT 
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or 
FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for 
more details. 

You should have received a copy of the GNU General Public License along with
 this program. If not, see <http://www.gnu.org/licenses/>.

  In addition, as a special exception, take-okm
  gives permission to link the code of this program with
  the "MFC(Microsoft Foundation Class library) Version 9.0" 
  (or with modified versions of "MFC Version 9.0" that use the same license as 
  "MFC Version 9.0" ), and distribute linked combinations including
  the two.  You must obey the GNU General Public License in all
  respects for all of the code used other than  "MFC".  If you modify
  this file, you may extend this exception to your version of the
  file, but you are not obligated to do so.  If you do not wish to
  do so, delete this exception statement from your version.


(: 

	OuDia - Ԏ\ƂɁA_CO`悷Win32AvP[V
B

Copyright (C) 2006-2017 take-okm 

̃vO̓t[\tgEFAłBȂ͂At[\tgEFA
cɂĔsꂽGNU ʌOp(o[W3Aȍ~̃o[W
̂ǂꂩ)߂̉ōĔЕz܂͉ 邱Ƃł܂B

̃vO͗Lpł邱ƂĔЕz܂A*S̖ۏ *łB
Ɖ\̕ۏ؂ړIւ̓ḰAOɎꂽ̂ ܂߁AS
܂BڂGNU ʌOpB

Ȃ͂̃vOƋɁAGNU ʌOp̃Rs[ꕔ 󂯎
Ă͂łB󂯎ĂȂ΁A<http://www.gnu.org/licenses/> 
B

)

  āAʂȗOƂāAtake-okm ͂̃vÕR[h 
  "MFC(Microsoft Foundation Class library) Version 9.0" 
  (  邢 "MFC Version 9.0" ƓCZXKpꂽ
  "MFC Version 9.0" ̉ςꂽo[W)ƃNA
  Nꂽ҂܂ތ앨Еz鋖^܂B
  Ȃ "MFC" ȊOŎgĂ邷ׂ
  ̃R[hɊւĂ͑SʓIGNUʌOp_񏑂ɏ]Ȃ
  Ȃ܂BȂ̃t@CςȂ΁AȂ̗͂O
  Ȃ̃o[W̃t@CɈ݂邱Ƃł܂A
  `͂܂BO݂Ȃ΁A̗O
  Ȃ̃o[W͍폜ĂB)
*/
/*
// ****************************************************************
//	DcdCd\Pos\CdDcdZoneXy.h
// ****************************************************************
*/
/** @file */
#ifndef  CdDcdZoneXy_h
#define  CdDcdZoneXy_h

#include "./CdDcdZone.h"
#include "./CdDcdPosXy.h"
#include "./CdDcdSizeXy.h"


// ****************************************************************
//	CdDcdZoneXy.h
// ****************************************************************
/**
 @brief
 yTvz
	   XY W̋`͈͂\Pf[^NXłB
*/
class CdDcdZoneXy
{
private:
	// ********************************
	///@name	
	// ********************************
	///@{
	///	X͈̔͂łB
	CdDcdZone	m_zoneX ;
	///	Y͈̔͂łB
	CdDcdZone	m_zoneY ;
	///@}

public:
	// ********************************
	//	RXgN^
	// ********************************
	CdDcdZoneXy(){} ;
	
	/**
	 @param tX [in]
	 	 X W̒lw肵ĂB
	 @param tY [in]
	 	 Y W̒lw肵ĂB
	*/
	CdDcdZoneXy( const CdDcdZone& tX , const CdDcdZone& tY ) : 
		m_zoneX( tX ) , m_zoneY( tY ) {};

	/**
	 	ẅʒuP͈̔͂\IuWFNg𐶐܂
	 @param posX [in]
	 	XW̒lw肵ĂB
	 @param posY [in]
	 	YW̒lw肵ĂB
	*/
	CdDcdZoneXy( DcdPos posX , DcdPos posY ) : 
		m_zoneX( posX , 1 ) , m_zoneY( posY , 1 ) {};

	/**
	 	N_ʒuƃTCYw肵āAIuWFNg𐶐܂B
	 @param posXy [in]
	 	N_w肵ĂB
	 @param sizeXy [in]
	 	YW̒lw肵ĂB
	*/
	CdDcdZoneXy( const CdDcdPosXy& posXy ,
				const CdDcdSizeXy& sizeXy ) : 
		m_zoneX( posXy.getX() , sizeXy.getX() ) , 
		m_zoneY( posXy.getY() , sizeXy.getY() ) {};

	/**
	 	N_ʒuP͈̔͂\IuWFNg𐶐܂B
	 @param posXy [in]
	 	N_w肵ĂB
	 @param sizeXy [in]
	 	YW̒lw肵ĂB
	*/
	CdDcdZoneXy( const CdDcdPosXy& posXy ) : 
		m_zoneX( posXy.getX() , 1 ) , 
		m_zoneY( posXy.getY() , 1 ) {};

 public:
	// ********************************
	///@name	CdDcdZoneXy-
	// ********************************
	///@{
	CdDcdZone getX()const{	return ( m_zoneX ) ;	};
	CdDcdZoneXy&  setX( const CdDcdZone& ev ){	
		m_zoneX = ev ;	return ( *this ) ;	};
	CdDcdZone getY()const{	return ( m_zoneY ) ;	};
	CdDcdZoneXy&  setY( const CdDcdZone ev ){	
		m_zoneY = ev ;	return ( *this ) ;	};
	/**
	 @return
	 	N_̈ʒuԂ܂B
	*/
	CdDcdPosXy	getPos()const{
		return ( CdDcdPosXy( m_zoneX.getPos() , m_zoneY.getPos() ) ) ;
	};
		
	/**
	 	N_ݒ肵܂B
	 @param posXy [in]
	 	N_w肵ĂB
	*/
	CdDcdZoneXy&	setPos( const CdDcdPosXy posXy ){
		m_zoneX.setPos( posXy.getX() ) ;
		m_zoneY.setPos( posXy.getX() ) ;
		return *this ;
	};
		
	/**
	 @return
	 	̈̃TCYԂ܂B
	*/
	CdDcdSizeXy	getSize()const{
		return ( CdDcdSizeXy( m_zoneX.getSize() , m_zoneY.getSize() ) ) ;
	};
		
	/**
	 	TCYݒ肵܂B
	 @param sizeXy [in]
	 	TCYw肵ĂB
	*/
	CdDcdZoneXy&	setSize( const CdDcdSizeXy sizeXy ){
		m_zoneX.setSize( sizeXy.getX() ) ;
		m_zoneY.setSize( sizeXy.getY() ) ;
		return *this ;
	};
		
	/**
	 @return
	   ͈͂̏I_ʒu̎̈ʒuԂ܂B
	 	̈ʒúA͈͂ɂ͊܂܂܂B
	*/
	CdDcdPosXy	getEndPos()const{
		return ( CdDcdPosXy( m_zoneX.getEndPos() , m_zoneY.getEndPos() ) ) ;
	};
	
	///@}

	// ********************************
	///@name	CdDcdZoneXy-
	// ********************************
	///@{
	
	/**
	 	  ͈͂̑傫\l̕A̐E܂͕̐ɕύX܂B
	 	  ̏ꍇłAW͈͕͂ς܂B
	 	() Pos = 1,Size=5̃IuWFNgɁA ev=-1 ł̃\bhĂяo
	 	Pos = 5 ,Size=-5 ɂȂ܂B
	 @param ev [in]
	 	𐳂̐ɂȂPE̐ɂȂ|Pw肵ĂB
	*/
	CdDcdZoneXy& setSizeSign( int ev = 1 ){
		m_zoneX.setSizeSign( ev ) ;
		m_zoneY.setSizeSign( ev ) ;
		return *this ;
	};
	
	/**
	 	CdDcdZoneXyƂ̔rs܂B
	 @param ev [in]
	 	rΏۂw肵ĂB
	 @return
	 	ׂĂ̑łΐ^łB
	*/
	bool IsEqualTo( const CdDcdZoneXy& ev )const{
		return ( m_zoneX.IsEqualTo( ev.m_zoneX ) 
						&& m_zoneY.IsEqualTo( ev.m_zoneY ) ) ;
	};
	
	/**
	 	͈̔͂ƁAw肳ꂽʂ͈̔͂Ƃ̊ԂŁAĂ͈͂
	 	߂܂B
	 @param ev [in]
	 	߂ΏۂɂȂ CdDcdZone IuWFNgw肵ĂB
	 @return
	 	͈̔͂ƁAev ƂĂ̈Ԃ܂B
		x,yꂼɂāÄ߂܂B
	
	   - this  ev ̂ꂩ Size Oł΁AN_thisƓA
	 	  TCYÕIuWFNgԂ܂B
	   - thisev̕قȂꍇ́Aev̕̕𔽓]āA
	 	  ͈͂߂܂B̏ꍇA߂l̕
	 	  thisƓɂȂ܂B
	   - this  ev ɌĂ̈悪Ȃꍇ́AN_thisƓA
	 	  TCYÕIuWFNgԂ܂B
	*/
	CdDcdZoneXy CrossZone( const CdDcdZoneXy& ev )const{
		return ( CdDcdZoneXy( m_zoneX.CrossZone( ev.getX() ) , 
							  m_zoneY.CrossZone( ev.getY() ) ) ) ; 
	};
	/**
	  	͈̔͂ƁAw肳ꂽʂ͈̔͂܂ށA
		ł͈͂߂܂B
	 @param ev [in]
	  	܂߂ΏۂɂȂ CdDcdZoneXy IuWFNgw肵ĂB
	 @return
	  	͈̔͂ƁAev ܂̈Ԃ܂B
	    - thisev̕قȂꍇ́Aev̕̕𔽓]āA
	  	͈͂߂܂B̏ꍇA߂l̕
	  	thisƓɂȂ܂B
	*/
	CdDcdZoneXy ZoneOr( const CdDcdZoneXy& ev )const{
		return ( CdDcdZoneXy( m_zoneX.ZoneOr( ev.getX() ) , 
							  m_zoneY.ZoneOr( ev.getY() ) ) ) ; 
	};
	
	/**
	 	ẅʒu͈̔͂Ɋ܂܂Ă邩ǂ𔻒f܂B
	 @param ev [in]
	 	肷ʒuw肵ĂB
	 @return
	 	ʒu͈̔͂Ɋ܂܂Ăΐ^łB
	*/
	bool IsInner( const CdDcdPosXy& ev )const{	
		return ( m_zoneX.IsInner( ev.getX() ) 
			  && m_zoneY.IsInner( ev.getY() )  ) ;
	};
	
	/**
	 	w̋`̈悪͈̔͂Ɋ܂܂Ă邩ǂ𔻒f܂B
	 @param ev [in]
	 	肷ʒuw肵ĂB
	 @return
	 	ʒu͈̔͂Ɋ܂܂Ăΐ^łB
	*/
	bool IsInner( const CdDcdZoneXy& ev )const{	
		return ( m_zoneX.IsInner( ev.getX() ) 
			  && m_zoneY.IsInner( ev.getY() )  ) ;
	};
	
	///@}

	// ********************************
	///@name	Zq	
	// ********************************
	///@{
	bool operator ==( const CdDcdZoneXy& ev )const{	
		return (  IsEqualTo( ev ) ) ; 
	};
	bool operator !=( const CdDcdZoneXy& ev )const{
		return ( !IsEqualTo( ev ) ) ; 
	};
	///@}
	
};


#endif /*CdDcdZoneXy_h*/

