/*
	OuDia - Win32 Application Software to draw a "Train Service Planning
 Diagram" based on a "Train Timetable".

Copyright (C) 2006-2017 take-okm

This program is free software; you can redistribute it and/or modify it 
under the terms of the GNU General Public License as published by the Free 
Software Foundation; either version 3 of the License, or (at your option) 
any later version. 

This program is distributed in the hope that it will be useful, but WITHOUT 
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or 
FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for 
more details. 

You should have received a copy of the GNU General Public License along with
 this program. If not, see <http://www.gnu.org/licenses/>.

  In addition, as a special exception, take-okm
  gives permission to link the code of this program with
  the "MFC(Microsoft Foundation Class library) Version 9.0" 
  (or with modified versions of "MFC Version 9.0" that use the same license as 
  "MFC Version 9.0" ), and distribute linked combinations including
  the two.  You must obey the GNU General Public License in all
  respects for all of the code used other than  "MFC".  If you modify
  this file, you may extend this exception to your version of the
  file, but you are not obligated to do so.  If you do not wish to
  do so, delete this exception statement from your version.


(: 

	OuDia - Ԏ\ƂɁA_CO`悷Win32AvP[V
B

Copyright (C) 2006-2017 take-okm 

̃vO̓t[\tgEFAłBȂ͂At[\tgEFA
cɂĔsꂽGNU ʌOp(o[W3Aȍ~̃o[W
̂ǂꂩ)߂̉ōĔЕz܂͉ 邱Ƃł܂B

̃vO͗Lpł邱ƂĔЕz܂A*S̖ۏ *łB
Ɖ\̕ۏ؂ړIւ̓ḰAOɎꂽ̂ ܂߁AS
܂BڂGNU ʌOpB

Ȃ͂̃vOƋɁAGNU ʌOp̃Rs[ꕔ 󂯎
Ă͂łB󂯎ĂȂ΁A<http://www.gnu.org/licenses/> 
B

)

  āAʂȗOƂāAtake-okm ͂̃vÕR[h 
  "MFC(Microsoft Foundation Class library) Version 9.0" 
  (  邢 "MFC Version 9.0" ƓCZXKpꂽ
  "MFC Version 9.0" ̉ςꂽo[W)ƃNA
  Nꂽ҂܂ތ앨Еz鋖^܂B
  Ȃ "MFC" ȊOŎgĂ邷ׂ
  ̃R[hɊւĂ͑SʓIGNUʌOp_񏑂ɏ]Ȃ
  Ȃ܂BȂ̃t@CςȂ΁AȂ̗͂O
  Ȃ̃o[W̃t@CɈ݂邱Ƃł܂A
  `͂܂BO݂Ȃ΁A̗O
  Ȃ̃o[W͍폜ĂB)
*/
// ****************************************************************
// $Id: CMuiCopied.h 10 2012-08-26 09:48:47Z okm $
// ****************************************************************
/** @file */
#ifndef Mu_CMuiCopied_h
#define Mu_CMuiCopied_h

#include "./Mui.h"
#include <deque>


// ****************************************************************
// CMuiCopied
// ****************************************************************
/**
@brief
	NXCX^X̃Rs[ێReiłB

	NXCX^X̃Rs[ێReiłB
	UReiɒǉCX^X̃Rs[ɑ΂ẮA
	getMuPtr() ŃRs[CX^Xւ̃|C^擾邱Ƃł܂B
	ɂARs[CX^Xɑ΂Ēڃ\bhĂяoA
	̏ԂύX邱Ƃł܂B

	̃NX́AIɂ̓CX^XRs[RXgN^newɂ蕡A
	̃Rs[̃|C^ێ܂BnewŕCX^XdeleteÃNX
	s܂B 
	Reiŕێ̂̓|C^Ȃ̂ŁAԂւ̗vf̒ǉE폜
	rIZԂōs܂B

@param ElementType
	ReiɊi[vf̌^w肵ĂB
@param ContType
	ElementType* ێSTLReiw肵ĂB
	Kł std::deque łA std::vector gƂł܂B
*/
template < class ElementType , class ContType =std::deque<ElementType*> >
class CMuiCopied : public Mui<ElementType>
{
private:
	// ********************************
	///@name W
	// ********************************
	/**
		ElementType  new ŐCX^XێReiłB
		̃ReiێCX^X̔j̐Ӗ this ɂ܂B
	*/
	ContType	m_Cont ;

private:
	// ********************************
	///@name 
	// ********************************
	///@{
	// ********************************
	//	"Mu< ElementType* >" EEE getMuPtr()
	// ********************************
	/**
	 @brief
		CaMup::getMuPtr() \bhԂC^[tF[X
		NXłB
	 */
	class XMuPtr : public Mu< ElementType* >
	{
	public:
		virtual int	size()const
		{
			CMuiCopied* pOuter = (CMuiCopied*)((char*)this - offsetof(CMuiCopied,m_xMuPtr) ) ;
			return pOuter->m_Cont.size() ; 
		} ;
		virtual ElementType* get( int idx )const 
		{
			CMuiCopied* pOuter = (CMuiCopied*)((char*)this - offsetof(CMuiCopied,m_xMuPtr) ) ;
			if ( idx == INT_MAX )
			{
				idx = pOuter->m_Cont.size() - 1 ;
			}
			ElementType*	pRv = pOuter->m_Cont[idx] ;
			return ( pRv ) ;
		};
	}	m_xMuPtr ;
	friend class XMuPtr ;
	//*******************************
	// 	"Mu< const ElementType* >" EEE getMuConstPtr() 
	//*******************************
	/**
	 @brief
		CaMup::getMuConstPtr() \bhԂC^[tF[X
		NXłB
	 */
	class XMuConstPtr : public Mu< const ElementType* >
	{
	public:
		virtual int	size()const
		{
			CMuiCopied* pOuter = (CMuiCopied*)((char*)this - offsetof(CMuiCopied,m_xMuConstPtr) ) ;
			return pOuter->m_Cont.size() ; 
		} ;
		virtual const ElementType* get( int idx )const 
		{
			CMuiCopied* pOuter = (CMuiCopied*)((char*)this - offsetof(CMuiCopied,m_xMuConstPtr) ) ;
			if ( idx == INT_MAX )
			{
				idx = pOuter->m_Cont.size() - 1 ;
			}
			ElementType*	pRv = pOuter->m_Cont[idx] ;
			return ( pRv ) ;
		};
	}	m_xMuConstPtr ;
	friend class XMuConstPtr ;


	///@}

public:
	// ********************************
	//	RXgN^
	// ********************************
	CMuiCopied(){} ; 
	CMuiCopied( const CMuiCopied<ElementType,ContType>& value )
	{
		//	vf𕡐
		for ( int idx = 0 ; idx < value.size() ; idx ++ )
		{
			m_Cont.push_back( new ElementType( value.get( idx ) ) ) ;
		}
	};

	CMuiCopied& operator=( const CMuiCopied<ElementType,ContType>& value ) 
	{
		//	ׂĂ̗vfj
		while ( m_Cont.size() > 0 )
		{
			ElementType* p = m_Cont.back() ;
			delete p ;
			m_Cont.pop_back() ;
		}

		//	vf𕡐
		for ( int idx = 0 ; idx < value.size() ; idx ++ )
		{
			m_Cont.push_back( new ElementType( value.get( idx ) ) ) ;
		}
		return *this ;
	};
	virtual ~CMuiCopied()
	{
		//	ׂĂ̗vfj
		while ( m_Cont.size() > 0 )
		{
			ElementType* p = m_Cont.back() ;
			delete p ;
			m_Cont.pop_back() ;
		}
	} ; 
public:
	// ********************************
	///@name	Mu
	// ********************************
	///@{
	
	/**
	 @return
	 	ReiɊi[Ăvf̌Ԃ܂B
	*/
	virtual int	size()const{	return m_Cont.size() ;};
	/**
	 	ReíACfNXŎw肳ꂽꏊɊi[Ă
	 	vf̃Rs[Ԃ܂B
	 @param iIndex [in]
	 	0 n܂CfNXw肵ĂB
	 	͈͂ 0 ȏ size() łB
		AAINT_MAX ́Aw肵̂Ƃ݂Ȃ܂B
	 @return
	 	CfNXŎw肳ꂽvfԂ܂B
	*/
	virtual ElementType get( int iIndex )const
	{
		if ( iIndex == INT_MAX )
		{
			iIndex = m_Cont.size() - 1 ;
		}
		ElementType* p = m_Cont[iIndex] ;
		return *p ;
	};
	///@}
public:
	// ********************************
	///@name Mui
	// ********************************
	///@{
	/**
	 	ReíACfNXŎw肳ꂽꏊɁA
	 	vf̃Rs[ǉ܂B
	 @param element [in]
	 	vfw肵ĂB
	 @param iIndex [in]
	 	On܂CfNXw肵ĂB
	 	͈͂͂Oȏ size() ȉłB
	 	ÓA擪Esize()Ȃ疖ւ̒ǉɂȂ܂B
		AAINT_MAX ́Aw肵̂Ƃ݂Ȃ܂B
	 @return
	 	0ȏ͐A̐̓G[ł
	*/
	virtual int insert( const ElementType& element , int iIndex = INT_MAX ) 
	{
		int iRv = 0 ;
		if ( iIndex == INT_MAX )
		{
			iIndex = m_Cont.size() ;
		}
		// --------------------------------	
		if ( !( 0 <= iIndex && iIndex <= (int)m_Cont.size() ) )
		{
			iRv = -1 ;	//	CfNX͈͊OłB
		}
		else
		{
			m_Cont.insert( 
				m_Cont.begin() + iIndex , 
				new ElementType( element ) ) ;
		}
		// --------------------------------	
		return iRv ;
	}
	
	/**
	 	ReíACfNXŎw肳ꂽꏊ
	 	vf폜܂B
	 @param iIndex [in]
	 	On܂CfNXw肵ĂB
	 	͈͂͂Oȏ size() łB
	 	AAINT_MAX ́Aw肵̂Ƃ݂Ȃ܂B
	 @param iSize [in]
	 	폜vf̐w肵ĂB
	 	AAINT_MAX ́A iIndex 疖܂ł\܂B
	 @attention
		iIndex  iSize ̗ INT_MAX ɂ邱Ƃ͂ł܂B
	 @return
	 	0ȏ͐A̐̓G[ł
	*/
	virtual int erase( int iIndex  , int iSize = 1 ) 
	{
		int iRv = 0 ;
		if ( iIndex == INT_MAX && iSize != INT_MAX )
		{
			iIndex = m_Cont.size() - iSize ;
		}
		else if ( iIndex != INT_MAX && iSize == INT_MAX )
		{
			iSize = m_Cont.size() - iIndex ;
		}
		// --------------------------------	
		if ( !( 0 <= iIndex && iIndex + iSize <= (int)m_Cont.size() ) )
		{
			iRv = -1 ;	//	CfNX͈͊OłB
		}
		else
		{
			//	w̗vfj
			while ( iSize > 0 )
			{
				iSize -- ;
				ElementType* p = m_Cont[iIndex+iSize] ;
				delete p ;
				m_Cont.erase( m_Cont.begin() + iIndex + iSize );
			}
		}
		// --------------------------------	
		return iRv ;
	}
	
	/**
	 	ReíACfNXŎw肳ꂽꏊɁA
	 	vf㏑܂B
	 @param element [in]
	 	vfw肵ĂB
	 @param iIndex [in]
	 	On܂CfNXw肵ĂB
	 	͈͂͂Oȏ size() łB
		AAINT_MAX ́Aw肵̂Ƃ݂Ȃ܂B
	 @return
	 	0ȏ͐A̐̓G[ł
	*/
	virtual int set( const ElementType& element , int iIndex ) 
	{
		int iRv = 0 ;
		if ( iIndex == INT_MAX )
		{
			iIndex = m_Cont.size() - 1 ;
		}
		// --------------------------------	
		if ( !( 0 <= iIndex && iIndex < (int)m_Cont.size() ) )
		{
			iRv = -1 ;	//	CfNX͈͊OłB
		}
		else
		{
			//	w̗vfj
			ElementType* p = m_Cont[iIndex] ;
			delete p ;
			m_Cont[iIndex] = new ElementType( element ) ;
		}
		// --------------------------------	
		return iRv ;
	}
	///@}
public:
	// ********************************
	///@name CMuiCopied
	// ********************************
	///@{
	/**
		CX^X𒼐ڑ삷邽߂ Mu C^[tF[XԂ܂B
	*/
	virtual Mu<ElementType*>* getMuPtr()
	{	return &m_xMuPtr ;};
	
	/**
		CX^X𒼐ڑ삷邽߂ Mu C^[tF[XԂ܂B
	*/
	virtual const Mu<const ElementType*>* getMuPtr()const 
	{	return &m_xMuConstPtr ;};
	
	
	///@}
};



#endif //Mu_CMuiCopied_h

