/*
	OuDia - Win32 Application Software to draw a "Train Service Planning
 Diagram" based on a "Train Timetable".

Copyright (C) 2006-2017 take-okm

This program is free software; you can redistribute it and/or modify it 
under the terms of the GNU General Public License as published by the Free 
Software Foundation; either version 3 of the License, or (at your option) 
any later version. 

This program is distributed in the hope that it will be useful, but WITHOUT 
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or 
FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for 
more details. 

You should have received a copy of the GNU General Public License along with
 this program. If not, see <http://www.gnu.org/licenses/>.

  In addition, as a special exception, take-okm
  gives permission to link the code of this program with
  the "MFC(Microsoft Foundation Class library) Version 9.0" 
  (or with modified versions of "MFC Version 9.0" that use the same license as 
  "MFC Version 9.0" ), and distribute linked combinations including
  the two.  You must obey the GNU General Public License in all
  respects for all of the code used other than  "MFC".  If you modify
  this file, you may extend this exception to your version of the
  file, but you are not obligated to do so.  If you do not wish to
  do so, delete this exception statement from your version.


(: 

	OuDia - Ԏ\ƂɁA_CO`悷Win32AvP[V
B

Copyright (C) 2006-2017 take-okm 

̃vO̓t[\tgEFAłBȂ͂At[\tgEFA
cɂĔsꂽGNU ʌOp(o[W3Aȍ~̃o[W
̂ǂꂩ)߂̉ōĔЕz܂͉ 邱Ƃł܂B

̃vO͗Lpł邱ƂĔЕz܂A*S̖ۏ *łB
Ɖ\̕ۏ؂ړIւ̓ḰAOɎꂽ̂ ܂߁AS
܂BڂGNU ʌOpB

Ȃ͂̃vOƋɁAGNU ʌOp̃Rs[ꕔ 󂯎
Ă͂łB󂯎ĂȂ΁A<http://www.gnu.org/licenses/> 
B

)

  āAʂȗOƂāAtake-okm ͂̃vÕR[h 
  "MFC(Microsoft Foundation Class library) Version 9.0" 
  (  邢 "MFC Version 9.0" ƓCZXKpꂽ
  "MFC Version 9.0" ̉ςꂽo[W)ƃNA
  Nꂽ҂܂ތ앨Еz鋖^܂B
  Ȃ "MFC" ȊOŎgĂ邷ׂ
  ̃R[hɊւĂ͑SʓIGNUʌOp_񏑂ɏ]Ȃ
  Ȃ܂BȂ̃t@CςȂ΁AȂ̗͂O
  Ȃ̃o[W̃t@CɈ݂邱Ƃł܂A
  `͂܂BO݂Ȃ΁A̗O
  Ȃ̃o[W͍폜ĂB)
*/
/*
// ****************************************************************
//	CRfEditCmd_Ressya.cpp
// $Id: CRfEditCmd_Ressya.cpp 366 2016-08-18 20:26:22Z okm $
// ****************************************************************
*/
#include "stdafx.h"
#include <stdlib.h>
#include "NsOu/OuNew.h"
#include "NsMu/CaMui.h"
#include "CRfEditCmd_Ressya.h"

#ifndef _CONSOLE
#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif
#endif

#ifndef min
#define min	__min	 
#endif /*min*/

namespace DedRosenFileData{ namespace EditCmd{

// ****************************************************************
//	CRfEditCmd_Ressya
// ****************************************************************
// ********************************
//	RXgN^
// ********************************
CRfEditCmd_Ressya::CRfEditCmd_Ressya( 
		int iDiaIndex ,
		ERessyahoukou eERessyahoukou ,
		int iIndexDst , 
		int iSizeDst , 
		const CentDedRessyaCont& aCentDedRessyaContSrc ) :
	m_iDiaIndex( iDiaIndex ) ,
	m_ERessyahoukou( eERessyahoukou ) ,
	m_iIndexDst( iIndexDst ) ,
	m_iSizeDst( iSizeDst ) ,
	m_CentDedRessyaContSrc( aCentDedRessyaContSrc ) ,
	m_CaMuiSelect( &m_CentDedRessyaContSrc , m_CentDedRessyaContSrc.getMuPtr() ) ,
	m_pCentDedRessyaContOld( NULL ) 
{
	m_CaMuiSelect.setSelectAll( true ) ;
}


CRfEditCmd_Ressya::CRfEditCmd_Ressya( 
		const CDedRosenFileData& aCDedRosenFileData ,
		int iDiaIndex ,
		ERessyahoukou eRessyahoukou , 
		int iIndex , 
		int iSize ) 
		:
		m_iDiaIndex( iDiaIndex ) ,
		m_ERessyahoukou( eRessyahoukou ) ,
		m_iIndexDst( iIndex ) ,
		m_iSizeDst( iSize ) ,
		m_CentDedRessyaContSrc( aCDedRosenFileData.getCentDedRosen()->getCentDedDiaCont()
			->getMuPtr()->get( iDiaIndex )
			->getCentDedRessyaCont(eRessyahoukou )->createEmptyCont() ) ,
		m_CaMuiSelect( &m_CentDedRessyaContSrc , m_CentDedRessyaContSrc.getMuPtr() ) ,
		m_pCentDedRessyaContOld( NULL ) 
{
	const CentDedRessyaCont* pCentDedRessyaCont = aCDedRosenFileData.getCentDedRosen()->getCentDedDiaCont()->getMuPtr()->get( iDiaIndex )->getCentDedRessyaCont(eRessyahoukou) ; 

	CaMui<CentDedRessya> aMui( &m_CaMuiSelect ) ;
	aMui.insert( pCentDedRessyaCont , iIndex , iSize ) ;

	m_CaMuiSelect.setSelectAll( true ) ;
}


CRfEditCmd_Ressya::~CRfEditCmd_Ressya()
{
	if ( m_pCentDedRessyaContOld != NULL ){
		delete m_pCentDedRessyaContOld ;
		m_pCentDedRessyaContOld = NULL ;
	}
}

// ********************************
///	CRfEditCmd-
// ********************************
int CRfEditCmd_Ressya::execute( 
		CDedRosenFileData* pCDedRosenFileData ) 
{
	int iRv = 0 ;
	// --------------------------------
	CentDedRosen*	pCentDedRosen = pCDedRosenFileData->getCentDedRosen() ;
	CentDedDia*	pCentDedDia = NULL ;
	if ( iRv >= 0 ){
		pCentDedDia =  pCentDedRosen->getCentDedDiaCont()->getMuPtr()->get( m_iDiaIndex ) ;
		if ( pCentDedDia == NULL ){
			iRv = -2 ;	//	m_iDiaIndex ̒lsłB
		}
	}
	CentDedRessyaCont*	pCentDedRessyaCont = NULL ;
	if ( iRv >= 0 ){
		pCentDedRessyaCont = pCentDedDia->getCentDedRessyaCont( m_ERessyahoukou ) ;
		if ( m_iIndexDst == INT_MAX ){
			m_iIndexDst = pCentDedRessyaCont->size() ;
		}
		if ( !( 0 <= m_iIndexDst && 
				m_iIndexDst <= pCentDedRessyaCont->size() - m_iSizeDst ) ){
			iRv = -1 ;	//	m_iIndexDst ̒lsłB
		}
	}
	// --------------------------------
	//	폜vf̕ۑ
	// --------------------------------
	if ( iRv >= 0 ){
		if ( m_pCentDedRessyaContOld != NULL ){
			delete m_pCentDedRessyaContOld ;
			m_pCentDedRessyaContOld = NULL ;
		}
		m_pCentDedRessyaContOld = new CentDedRessyaCont( 
			pCentDedRessyaCont->createEmptyCont() ) ;
		CaMui<CentDedRessya>	aCaCont( m_pCentDedRessyaContOld ) ;
		aCaCont.insert( 
			pCentDedRessyaCont , 
			m_iIndexDst , 
			m_iSizeDst , 0 ) ;

	}

	// --------------------------------
	//	̗vf̍폜
	// --------------------------------
	if ( iRv >= 0 ){
		int iGensyouSize = m_iSizeDst - m_CentDedRessyaContSrc.size() ;
		if ( iGensyouSize > 0 ){
			int iResult = pCentDedRessyaCont->erase( 
				m_iIndexDst + m_iSizeDst - iGensyouSize , 
				iGensyouSize
			) ;
			if ( iResult < 0 ){
				iRv = -11 ;	//	vf̍폜Ɏs܂B
			}
		}
	}
	// --------------------------------
	//	vf̒u
	// --------------------------------
	int iOkikaeSize = 0 ;
	if ( iRv >= 0 ){
		iOkikaeSize = min( m_iSizeDst , m_CentDedRessyaContSrc.size() ) ;
		for ( int cnt = 0 ; iRv >= 0 && cnt < iOkikaeSize ; cnt ++ ){
			int iResult = pCentDedRessyaCont->set( 
				m_CentDedRessyaContSrc.get( cnt ) , 
				m_iIndexDst + cnt )  ;
			if ( iResult < 0 ){
				iRv = -13 ;	//	vf̒uɎs܂B
			}
		}
	}

	// --------------------------------
	//	̗vf̒ǉ
	// --------------------------------
	if ( iRv >= 0 ){
		int iZoukaSize = m_CentDedRessyaContSrc.size() - m_iSizeDst ;
		if ( iZoukaSize > 0 ){
			for ( int cnt = 0 ; iRv >= 0 && cnt < iZoukaSize ; cnt ++ ){
				int iResult = pCentDedRessyaCont->insert(
					m_CentDedRessyaContSrc.get( iOkikaeSize + cnt ) ,
					m_iIndexDst + iOkikaeSize + cnt ) ; 
				if ( iResult < 0 ){
					iRv = -12 ;	//	vf̒ǉɎs܂B
				}
			}
		}

	}

	return ( iRv ) ;
}
Ou<CRfEditCmd> 
CRfEditCmd_Ressya::createUndoCmd()  
{
	if ( m_pCentDedRessyaContOld != NULL ){
		OuNew<CRfEditCmd>	pCmd(  
			new CRfEditCmd_Ressya( 
				m_iDiaIndex ,
				m_ERessyahoukou , 
				m_iIndexDst , 
				m_CentDedRessyaContSrc.size() ,
				*m_pCentDedRessyaContOld 
			) ) ;
		delete m_pCentDedRessyaContOld ;
		m_pCentDedRessyaContOld = NULL ;
		return pCmd ; 
	}
	return ( Ou<CRfEditCmd>() ) ;
}
	

} } // namespace EditCmd namespace DedRosenFileData

