/*
	OuDia - Win32 Application Software to draw a "Train Service Planning
 Diagram" based on a "Train Timetable".

Copyright (C) 2006-2017 take-okm

This program is free software; you can redistribute it and/or modify it 
under the terms of the GNU General Public License as published by the Free 
Software Foundation; either version 3 of the License, or (at your option) 
any later version. 

This program is distributed in the hope that it will be useful, but WITHOUT 
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or 
FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for 
more details. 

You should have received a copy of the GNU General Public License along with
 this program. If not, see <http://www.gnu.org/licenses/>.

  In addition, as a special exception, take-okm
  gives permission to link the code of this program with
  the "MFC(Microsoft Foundation Class library) Version 9.0" 
  (or with modified versions of "MFC Version 9.0" that use the same license as 
  "MFC Version 9.0" ), and distribute linked combinations including
  the two.  You must obey the GNU General Public License in all
  respects for all of the code used other than  "MFC".  If you modify
  this file, you may extend this exception to your version of the
  file, but you are not obligated to do so.  If you do not wish to
  do so, delete this exception statement from your version.


(: 

	OuDia - Ԏ\ƂɁA_CO`悷Win32AvP[V
B

Copyright (C) 2006-2017 take-okm 

̃vO̓t[\tgEFAłBȂ͂At[\tgEFA
cɂĔsꂽGNU ʌOp(o[W3Aȍ~̃o[W
̂ǂꂩ)߂̉ōĔЕz܂͉ 邱Ƃł܂B

̃vO͗Lpł邱ƂĔЕz܂A*S̖ۏ *łB
Ɖ\̕ۏ؂ړIւ̓ḰAOɎꂽ̂ ܂߁AS
܂BڂGNU ʌOpB

Ȃ͂̃vOƋɁAGNU ʌOp̃Rs[ꕔ 󂯎
Ă͂łB󂯎ĂȂ΁A<http://www.gnu.org/licenses/> 
B

)

  āAʂȗOƂāAtake-okm ͂̃vÕR[h 
  "MFC(Microsoft Foundation Class library) Version 9.0" 
  (  邢 "MFC Version 9.0" ƓCZXKpꂽ
  "MFC Version 9.0" ̉ςꂽo[W)ƃNA
  Nꂽ҂܂ތ앨Еz鋖^܂B
  Ȃ "MFC" ȊOŎgĂ邷ׂ
  ̃R[hɊւĂ͑SʓIGNUʌOp_񏑂ɏ]Ȃ
  Ȃ܂BȂ̃t@CςȂ΁AȂ̗͂O
  Ȃ̃o[W̃t@CɈ݂邱Ƃł܂A
  `͂܂BO݂Ȃ΁A̗O
  Ȃ̃o[W͍폜ĂB)
*/
// ****************************************************************
//	$Id: CPropEditUI_Ekijikoku.cpp 357 2016-08-18 16:59:16Z okm $
// ****************************************************************

/** @file */

#include "stdafx.h"
#include "NsMu\CConvTable.h"
#include "CPropEditUi_EkiJikoku.h"
#include "str\CStrCharSizeMb.h"
#include "str\strLf.h"

namespace ViewJikokuhyou{
	using namespace OuLib::Str;

		
/** _CAO{bNXւ̎̏ێ܂B */
const CdDedJikoku::CConv	g_CdDedJikokuConv(
	true ,		//	NoColon 
	CdDedJikoku::CConv::EHour_ZeroToNone ,		//	HourZeroToNone 
	CdDedJikoku::CConv::ESecond_NotIfZero ) ;	//	NoSecond


/**
	UI`߂āAɕϊ܂B
	GfBbgRg[̓e2̏ꍇ́A
	ỎwOrderƂɁA⊮܂B
@param strUIJikoku [in]
	UI`̎w肵ĂB
@param jikokuRevOrder [in]
	ÓwwxB
	̒ĺAstrControl̂(2)̏ꍇA⊮̂Ɏg܂B
	wNULLԁx̏ꍇA̕⊮͍s܂B
@param pCdDedJikoku [out]
	̊֐́Ả߂ɐA̓eϊ
	ɏ݂܂B
@return
	 0 ȏBւ̕ϊłȂΕ̐łB
	-	-1 ;	//	ڐsĂ܂B
	-	-2 ;	//	EEb̕\LsłB
*/
static int	getJikokuFromUI( 
	const string& strUIJikoku , 
	const CdDedJikoku& jikokuRevOrder , 
	CdDedJikoku* pCdDedJikoku ) 
{
	int	iRv = 0 ;
	CdDedJikoku	aCdDedJikoku ;
	string	strControl = CStrCharSizeMb::strToSingleByte( 
		OuLib::Str::strTrim( strUIJikoku ) ) ;

	int iResult = aCdDedJikoku.decode( strControl ) ;
	if ( iResult < 0 )
	{
		iRv = iResult ;
		//	񂪉߂ł܂B
	}
	//iRv = 
	//-	-1 ;	//	ڐsĂ܂B
	//-	-2 ;	//	EEb̕\LsłB

	//	2ŁAỎwꍇ́A
	//	Ɏ⊮
	if ( iRv == -1 && 
		 !jikokuRevOrder.isNull() && 
		strControl.size() == 2 && 
		isdigit( strControl[0] ) && 
		isdigit( strControl[1] ) )
	{
		int iMin = atoi( strControl.c_str() ) ;
		if ( 0 <= iMin && iMin < 60 )
		{
			aCdDedJikoku.setTime( jikokuRevOrder.getHour() , iMin ) ;
			CdDedJikan	jikanSub = aCdDedJikoku.subJikoku( 
				jikokuRevOrder ) ;
			if ( jikanSub.getTotalSeconds() < 0 )
			{
				aCdDedJikoku = aCdDedJikoku.getTotalSeconds() + 60*60 ;
			}
			//aCdDedJikoku = ݓ͂ꂽ2̕ɁA
			//	jikokuRevOrder ȌƂȂ鎞⊮

			iRv = 0 ;	//	⊮ɐ܂B 
		}
	}

	// --------------------------------
	if ( pCdDedJikoku != NULL )
	{
		*pCdDedJikoku = aCdDedJikoku ;
	}
	return iRv ;
}

	// ********************************
	//@name G[bZ[W
	// ********************************
const char* const CPropEditUi_EkiJikoku::ERRMSG_INVALID_CHAKUJIKOKU = "Invalid ChakuJikoku.";
const char* const CPropEditUi_EkiJikoku::ERRMSG_INVALID_HATSUJIKOKU = "Invalid HatsuJikoku.";




	// ================================
	//@name ֐
	// ================================


const CConvTable<CentDedEkiJikoku::EEkiatsukai,int>& getEkiatsukaiConvTable()
{
	static CConvTable<CentDedEkiJikoku::EEkiatsukai,int>	aTable ;
	if ( aTable.size() == 0 )
	{
		aTable.add( CentDedEkiJikoku::Ekiatsukai_None     , 0 ) ;//	^sȂ
		aTable.add( CentDedEkiJikoku::Ekiatsukai_Teisya   , 1 ) ;//	
		aTable.add( CentDedEkiJikoku::Ekiatsukai_Tsuuka   , 2 ) ;//	ʉ
		aTable.add( CentDedEkiJikoku::Ekiatsukai_Keiyunasi, 3 ) ;// oRȂ
	}
	return aTable ;
}

	// ================================
	//@name UiData - TargetԂ̃f[^]
	// ================================

	

void CPropEditUi_EkiJikoku::UiDataFromTarget( UIDATA* pUiData ) 
{
	CdDedJikoku::CConv	aJikokuConv( g_CdDedJikokuConv ) ;
	for ( int i = 0 ; i < m_pTarget->size() ; i ++ )
	{
		CentDedRessya* pRessya = m_pTarget->get( i ) ;
		CentDedEkiJikoku aEkiJikoku 
			= pRessya->getCentDedEkiJikoku( m_iEkiOrder ) ;

		/*	 w 
			 -	 0: ^sȂ
			 -	 1: 
			 -	 2: ʉ
			 -	 3: oRȂ
			 -	-1: IȂ
		*/
		if ( i == 0 )
		{
			pUiData->iEkiatsukai = getEkiatsukaiConvTable().rightFrom( 
				aEkiJikoku.getEkiatsukai() ) ;
		}
		else if ( pUiData->iEkiatsukai != getEkiatsukaiConvTable().rightFrom( 
			aEkiJikoku.getEkiatsukai() ) )
		{
			pUiData->iEkiatsukai = -1 ;
		}

		/* 	*/
		if ( i == 0 )
		{
			//	PIA
			//	wʉ߁EԂȂALETarget𔽉f
			//@@oRȂȂL
			//@@^sȂȂL
			if ( pUiData->iEkiatsukai == 1		// 
				|| pUiData->iEkiatsukai ==2 )	// ʉ
			{
				pUiData->strChakujikoku = aJikokuConv.encode( 
					aEkiJikoku.getChakujikoku() ) ;
			}
			pUiData->bChakujikokuIsEnable = true ;
		}
		else 
		{
			//ÍA͋E
			pUiData->strChakujikoku = "" ;
			pUiData->bChakujikokuIsEnable = false ;
		}

		/* 	*/
		if ( i == 0 )
		{
			//	PIA
			//	wʉ߁EԂȂALETarget𔽉f
			//@@oRȂȂL
			//@@^sȂȂL
			if ( pUiData->iEkiatsukai == 1		// 
				|| pUiData->iEkiatsukai ==2 )	// ʉ
			{
				pUiData->strHatsujikoku 
					= aJikokuConv.encode( aEkiJikoku.getHatsujikoku() ) ;
			}
			pUiData->bHatsujikokuIsEnable = true ;
		}
		else
		{
			//ÍA͋E
			pUiData->strHatsujikoku = "" ;
			pUiData->bHatsujikokuIsEnable = false ;
		}
	}
	// --------------------------------

	//	 ̌JグEJ艺ON/OFFB
	pUiData->bModifyHatsujikoku = *m_pbModifyHatsujikoku ;

}
void CPropEditUi_EkiJikoku::AdjustUiData( 
		UIDATA* pUiData , 
		const UIDATA* pUiDataPrev , 
		bool bStartEdit )
{
	//	w
	if ( bStartEdit || pUiDataPrev->iEkiatsukai != pUiData->iEkiatsukai )
	{
	}
	
	//	wɊ֌W鐳K
	{
		//[PI]
		if ( m_pTarget->size() == 1 )
		{
			//@ywzw^sȂEoRȂŁA
			//	ύXꂽAw͒Ԃɂ
			{
				if ( ( pUiData->iEkiatsukai == 0 || pUiData->iEkiatsukai == 3 )
					&& !bStartEdit
					&& ( pUiDataPrev->strChakujikoku != pUiData->strChakujikoku
					 || pUiDataPrev->strHatsujikoku != pUiData->strHatsujikoku)
				 )
				{
					pUiData->iEkiatsukai = 1 ;	
				}
			}
			//@yEzw^sȂEoRȂɕύXꂽA
			//	E͖ɂ
			//@yEzwԁEʉ߂ɕύXꂽA
			//	E͗LɂB
			{
				if ( !bStartEdit 
					&& pUiDataPrev->iEkiatsukai !=  pUiData->iEkiatsukai )
				{
					if ( pUiData->iEkiatsukai == 0 
						|| pUiData->iEkiatsukai == 3 )
					{
						pUiData->bChakujikokuIsEnable = false ;
						pUiData->bHatsujikokuIsEnable = false ;
					}
					else 
					{
						pUiData->bChakujikokuIsEnable = true ;
						pUiData->bHatsujikokuIsEnable = true ;
					}
				}
			}
		}
		//mI]
		else if ( m_pTarget->size() > 1 )
		{
			//@yEzE͖E
			pUiData->bChakujikokuIsEnable = false ;
			pUiData->bHatsujikokuIsEnable = false ;
		}
	}


	//	O̎Order̉w擾
	//	̒ĺAȗĕ݂̂͂ꂽƂɁA
	//	⊮̂Ɏg܂B
	CdDedJikoku jikokuRevOrder ;
	if ( pUiData->bChakujikokuIsEnable )
	{
		CentDedRessya* pRessya = m_pTarget->get( 0 ) ;
		CdDedJikokuOrder aJikokuOrderRev = pRessya->findrevJikoku( 
			CdDedJikokuOrder( m_iEkiOrder - 1 , 
				CdDedJikokuOrder::EkiJikokuItem_Hatsu ) ) ;
		if ( !aJikokuOrderRev.getIsNull() )
		{
			jikokuRevOrder = pRessya->getEkiJikoku( aJikokuOrderRev ) ;
		}
	}
	//jikokuRevOrder = O̎Order̉w

	/*  	*/
	if ( bStartEdit || pUiDataPrev->strChakujikoku != pUiData->strChakujikoku )
	{
		//@yzύXꂽA
		//@@(1)𔼊pɕϊ
		//@@(2)2͂ȂA⊮܂B
		if ( pUiData->bChakujikokuIsEnable )
		{
			CdDedJikoku aJikoku ;
			int iResult = getJikokuFromUI( 
				pUiData->strChakujikoku , 
				jikokuRevOrder , 
				&aJikoku ) ;
			if ( iResult >= 0 )
			{
				pUiData->strChakujikoku = g_CdDedJikokuConv.encode( aJikoku ) ;
			}
		}
	}
	
	//	O̎Order𒅎ōXVB
	//	̒ĺAȗĕ݂̂͂ꂽƂɁA
	//	⊮̂Ɏg܂B
	{
		CdDedJikoku aJikoku( pUiData->strChakujikoku ) ;
		if ( !aJikoku.isNull() )
		{
			jikokuRevOrder = aJikoku ;
		}
	}
		//jikokuRevOrder = O̎Order̉wB
		//	AA̓͂΁AB

	/* 	*/
	if ( bStartEdit || pUiDataPrev->strHatsujikoku != pUiData->strHatsujikoku )
	{
		//@yzύXꂽA
		//@@(1)𔼊pɕϊ
		//@@(2)2͂ȂA⊮܂B
		if ( pUiData->bHatsujikokuIsEnable )
		{
			CdDedJikoku aJikoku ;
			int iResult = getJikokuFromUI( 
				pUiData->strHatsujikoku , 
				jikokuRevOrder , 
				&aJikoku ) ;
			if ( iResult >= 0 )
			{
				pUiData->strHatsujikoku = g_CdDedJikokuConv.encode( aJikoku ) ;
			}
		}
	}
	//@yzύXAw̌JグEJ艺x=wLxŁA
	//		͍ς݂ȂǍJグEJ艺s܂B@
	if ( !bStartEdit 
		&& pUiDataPrev->strChakujikoku != pUiData->strChakujikoku )
	{
		if ( pUiData->bModifyHatsujikoku )
		{
			//	̑OlEݒlE̓͂擾
			CdDedJikoku	jikokuChakuPrev( pUiDataPrev->strChakujikoku ) ;
			CdDedJikoku	jikokuChaku( pUiData->strChakujikoku ) ;
			CdDedJikoku jikokuHatsu( pUiData->strHatsujikoku ) ;
			if ( !jikokuChakuPrev.isNull() 
				&& !jikokuChaku.isNull()
				&& !jikokuHatsu.isNull() )
			{
				jikokuHatsu.addSeconds( jikokuChaku.subJikoku( jikokuChakuPrev ) );
				pUiData->strHatsujikoku = g_CdDedJikokuConv.encode( jikokuHatsu ) ;
			}
		}
	}
}	

int CPropEditUi_EkiJikoku::CheckUiData( 
		bool bNewItem , 
		const UIDATA* pUiData , 
		const UIDATA* pUiDataStartEdit ) 
{
	int iRv = 0 ; 
	//	w
	if ( iRv >= 0 )
	{
		if ( bNewItem || pUiDataStartEdit->iEkiatsukai != pUiData->iEkiatsukai )
		{
		}
	}
	//	
	if ( iRv >= 0 )
	{
		if ( bNewItem 
			|| pUiDataStartEdit->strChakujikoku != pUiData->strChakujikoku )
		{
			//@yz󕶎łȂȂA
			//	l̎ւ̕ϊ݂āAsȂG[\
			CdDedJikoku aJikoku ;
			int iResult = aJikoku.decode( pUiData->strChakujikoku ) ;
			if ( iResult < 0 )
			{
				iRv =  -11 ;
			}
		}
	}
	//	
	if ( iRv >= 0 )
	{
		if ( bNewItem 
			|| pUiDataStartEdit->strHatsujikoku != pUiData->strHatsujikoku )
		{

			//@yz󕶎łȂȂA
			//	l̎ւ̕ϊ݂āAsȂG[\
			CdDedJikoku aJikoku ;
			int iResult = aJikoku.decode( pUiData->strHatsujikoku ) ;
			if ( iResult < 0 )
			{
				iRv = -12 ;
			}
		}
	}
	// --------------------------------
	//	G[bZ[W\܂
	// --------------------------------
	if ( iRv < 0 )
	{
		switch( iRv )
		{
		case -11 :
			ShowError( ERRMSG_INVALID_CHAKUJIKOKU ) ;
			SetFocus( offsetof( UIDATA , strChakujikoku )) ;
			break ;
		case -12 :
			ShowError( ERRMSG_INVALID_HATSUJIKOKU ) ;
			SetFocus( offsetof( UIDATA , strHatsujikoku ) );
			break ;
		}
	}
	return iRv ;
}

int CPropEditUi_EkiJikoku::UiDataToTarget( 
		bool bNewItem , 
		const UIDATA* pUiData , 
		const UIDATA* pUiDataStartEdit ) 
{

	int iRv = 0 ; 
	for ( int i = 0 ; iRv >= 0 && i < m_pTarget->size() ; i ++ )
	{
		CentDedRessya* pRessya = m_pTarget->get( i ) ; 
		CentDedEkiJikoku aEkiJikoku 
			= pRessya->getCentDedEkiJikoku( m_iEkiOrder ) ;
		
		if ( bNewItem 
			|| pUiDataStartEdit->iEkiatsukai != pUiData->iEkiatsukai )
		{
			aEkiJikoku.setEkiatsukai( 
				getEkiatsukaiConvTable().leftFrom(  pUiData->iEkiatsukai ) ) ;
		}
		// strChakujikoku
		if ( bNewItem 
			|| pUiDataStartEdit->strChakujikoku != pUiData->strChakujikoku )
		{
			if ( pUiData->bChakujikokuIsEnable )
			{
				CdDedJikoku	aJikoku ;
				int iResult = aJikoku.decode( pUiData->strChakujikoku ) ;
				if ( iResult >= 0 )
				{
					aEkiJikoku.setChakujikoku( aJikoku ) ;
				}
			}
		}
		// strHatsujikoku
		if ( bNewItem 
			|| pUiDataStartEdit->strHatsujikoku != pUiData->strHatsujikoku )
		{
			if ( pUiData->bHatsujikokuIsEnable )
			{
				CdDedJikoku	aJikoku ;
				int iResult = aJikoku.decode( pUiData->strHatsujikoku ) ;
				if ( iResult >= 0 )
				{
					aEkiJikoku.setHatsujikoku( aJikoku ) ;
				}
			}
		}
		// --------------------------------
		//	Ԃɉw(JグEJ艺̏ꍇ܂)
		if ( pUiData->bModifyHatsujikoku )
		{
			pRessya->modifyCentDedEkiJikoku( m_iEkiOrder , aEkiJikoku ) ;
		}
		else
		{
			pRessya->setCentDedEkiJikoku( m_iEkiOrder , aEkiJikoku ) ;
		}
	}
	
	if (  bNewItem || pUiDataStartEdit->bModifyHatsujikoku != pUiData->bModifyHatsujikoku  )
	{
		*m_pbModifyHatsujikoku = pUiData->bModifyHatsujikoku ;
	}
	return iRv ;
}	



	// ********************************
	//	RXgN^
	// ********************************
CPropEditUi_EkiJikoku::CPropEditUi_EkiJikoku( 
		bool bNewItem , 
		Mu<CentDedRessya*>* pTarget , 
		bool* pbModifyHatsujikoku ,
		int iEkiOrder ) 
		: CPropEditUi2( bNewItem ) 
		, m_pTarget( pTarget ) 
		, m_pbModifyHatsujikoku( pbModifyHatsujikoku )
		, m_iEkiOrder( iEkiOrder )
{
}



} //namespace ViewJikokuhyou

