/*
	OuDia - Win32 Application Software to draw a "Train Service Planning
 Diagram" based on a "Train Timetable".

Copyright (C) 2006-2017 take-okm

This program is free software; you can redistribute it and/or modify it 
under the terms of the GNU General Public License as published by the Free 
Software Foundation; either version 3 of the License, or (at your option) 
any later version. 

This program is distributed in the hope that it will be useful, but WITHOUT 
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or 
FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for 
more details. 

You should have received a copy of the GNU General Public License along with
 this program. If not, see <http://www.gnu.org/licenses/>.

  In addition, as a special exception, take-okm
  gives permission to link the code of this program with
  the "MFC(Microsoft Foundation Class library) Version 9.0" 
  (or with modified versions of "MFC Version 9.0" that use the same license as 
  "MFC Version 9.0" ), and distribute linked combinations including
  the two.  You must obey the GNU General Public License in all
  respects for all of the code used other than  "MFC".  If you modify
  this file, you may extend this exception to your version of the
  file, but you are not obligated to do so.  If you do not wish to
  do so, delete this exception statement from your version.


(: 

	OuDia - Ԏ\ƂɁA_CO`悷Win32AvP[V
B

Copyright (C) 2006-2017 take-okm 

̃vO̓t[\tgEFAłBȂ͂At[\tgEFA
cɂĔsꂽGNU ʌOp(o[W3Aȍ~̃o[W
̂ǂꂩ)߂̉ōĔЕz܂͉ 邱Ƃł܂B

̃vO͗Lpł邱ƂĔЕz܂A*S̖ۏ *łB
Ɖ\̕ۏ؂ړIւ̓ḰAOɎꂽ̂ ܂߁AS
܂BڂGNU ʌOpB

Ȃ͂̃vOƋɁAGNU ʌOp̃Rs[ꕔ 󂯎
Ă͂łB󂯎ĂȂ΁A<http://www.gnu.org/licenses/> 
B

)

  āAʂȗOƂāAtake-okm ͂̃vÕR[h 
  "MFC(Microsoft Foundation Class library) Version 9.0" 
  (  邢 "MFC Version 9.0" ƓCZXKpꂽ
  "MFC Version 9.0" ̉ςꂽo[W)ƃNA
  Nꂽ҂܂ތ앨Еz鋖^܂B
  Ȃ "MFC" ȊOŎgĂ邷ׂ
  ̃R[hɊւĂ͑SʓIGNUʌOp_񏑂ɏ]Ȃ
  Ȃ܂BȂ̃t@CςȂ΁AȂ̗͂O
  Ȃ̃o[W̃t@CɈ݂邱Ƃł܂A
  `͂܂BO݂Ȃ΁A̗O
  Ȃ̃o[W͍폜ĂB)
*/
// ****************************************************************
// $Id: CdXColSpecCont.cpp 261 2016-01-23 03:59:53Z okm $
// ****************************************************************
#pragma once

#include "stdafx.h"
#include "CdXColSpecCont.h"

namespace ViewJikokuhyou{ namespace JikokuhyouColSpec{


	// ********************************
	//	RXgN^
	// ********************************
CdXColSpecCont::CdXColSpecCont( 
		const CentDedRessyaCont* pCentDedRessyaCont ) 
	: m_eRessyahoukou( pCentDedRessyaCont->getRessyahoukou() ) 
	, m_iRessyaCount( 0 )
	, m_iColumnNumber_Ressya_begin( 0 ) 
	, m_iColumnNumber_Ressya_end( 0 ) 
{
	scan( pCentDedRessyaCont ) ;
}

CdXColSpecCont::CdXColSpecCont() 
	:m_eRessyahoukou( Ressyahoukou_Kudari) 
	, m_iRessyaCount( 0 ) 
	, m_iColumnNumber_Ressya_begin( 0 ) 
	, m_iColumnNumber_Ressya_end( 0 ) 
{
}



	// ********************************
	//@name 
	// ********************************
ERessyahoukou	CdXColSpecCont::getRessyahoukou()const 
{
	return m_eRessyahoukou ;
}
int CdXColSpecCont::getColumnNumber_Ressya_begin()const 
{
	return m_iColumnNumber_Ressya_begin ;
}
int CdXColSpecCont::
getColumnNumber_Ressya_end()const 
{
	return m_iColumnNumber_Ressya_end ;
}
	// ********************************
	//@name CdXColSpecCont-
	// ********************************
void CdXColSpecCont::scan( 
		const CentDedRessyaCont* pCentDedRessyaCont ) 
{

	m_eRessyahoukou = pCentDedRessyaCont->getRessyahoukou() ;
	m_iRessyaCount = pCentDedRessyaCont->size() ;

	//w
	m_contColumnSpec.insert( CdXColSpec( 
		CdXColSpec::ColumnType_Ekimei ) ) ;
	//
	m_contColumnSpec.insert( CdXColSpec( 
		CdXColSpec::ColumnType_Chakuhatsu ) ) ;

	//	Ԃ̐擪̗ԍ
	m_iColumnNumber_Ressya_begin = m_contColumnSpec.size() ;

	// ͒ǉ܂

	
	//	Ԃ̏I[̎ʂ Xԍ
	m_iColumnNumber_Ressya_end = m_iColumnNumber_Ressya_begin + m_iRessyaCount ;

	//VKԒǉʒu
	m_contColumnSpec.insert( CdXColSpec( 
		CdXColSpec::ColumnType_NewRessya , 
		m_iRessyaCount ) ) ;
}


int CdXColSpecCont::size() 
{
	return m_contColumnSpec.size() + m_iRessyaCount ;
}

CdXColSpec CdXColSpecCont::ColumnNumberToSpec( 
		int iXColumnNumber ) 
{
	CdXColSpec	aRv ;
	if ( iXColumnNumber < 2 )
	{
		aRv = m_contColumnSpec.get( iXColumnNumber ) ;
	}
	else if ( 2 <= iXColumnNumber && 
		iXColumnNumber < 2 + m_iRessyaCount )
	{
		//	ԗ
		aRv = CdXColSpec( CdXColSpec::ColumnType_Ressya , 
			iXColumnNumber -2 ) ;
	}
	else
	{
		//	ԗȍ~
		iXColumnNumber -= ( m_iRessyaCount ) ;
		if ( 0 <= iXColumnNumber && iXColumnNumber < m_contColumnSpec.size() )
		{
			aRv = m_contColumnSpec.get( iXColumnNumber ) ;
		}
	}
	return aRv ;
}

int CdXColSpecCont::ColumnNumberFromSpec( 
		const CdXColSpec& aCdXColSpec ) 
{
	int iRv = -1 ;
	{
		for ( int iColumnNumber = 0 ; 
			iRv == -1 && iColumnNumber < m_contColumnSpec.size() ;
			iColumnNumber ++ )
		{
			if ( aCdXColSpec == m_contColumnSpec.get( iColumnNumber ) )
			{
				iRv = iColumnNumber ;
			}
		}
		if ( aCdXColSpec.getColumnType() == CdXColSpec::ColumnType_NewRessya )
		{
			iRv += m_iRessyaCount ;
		}
	}
	if ( iRv == -1 && 
		aCdXColSpec.getColumnType() == 
			CdXColSpec::ColumnType_Ressya )
	{
		if ( 0 <= aCdXColSpec.getRessyaIndex() && 
			aCdXColSpec.getRessyaIndex() < m_iRessyaCount )
		{
			iRv = aCdXColSpec.getRessyaIndex() + 2 ;
		}
	}
	return iRv ;
}


void CdXColSpecCont::clear() 
{
	*this = CdXColSpecCont() ;
}

} } //namespace JikokuhyouColSpec namespace ViewJikokuhyou

