/*
	OuDia - Win32 Application Software to draw a "Train Service Planning
 Diagram" based on a "Train Timetable".

Copyright (C) 2006-2017 take-okm

This program is free software; you can redistribute it and/or modify it 
under the terms of the GNU General Public License as published by the Free 
Software Foundation; either version 3 of the License, or (at your option) 
any later version. 

This program is distributed in the hope that it will be useful, but WITHOUT 
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or 
FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for 
more details. 

You should have received a copy of the GNU General Public License along with
 this program. If not, see <http://www.gnu.org/licenses/>.

  In addition, as a special exception, take-okm
  gives permission to link the code of this program with
  the "MFC(Microsoft Foundation Class library) Version 9.0" 
  (or with modified versions of "MFC Version 9.0" that use the same license as 
  "MFC Version 9.0" ), and distribute linked combinations including
  the two.  You must obey the GNU General Public License in all
  respects for all of the code used other than  "MFC".  If you modify
  this file, you may extend this exception to your version of the
  file, but you are not obligated to do so.  If you do not wish to
  do so, delete this exception statement from your version.


(: 

	OuDia - Ԏ\ƂɁA_CO`悷Win32AvP[V
B

Copyright (C) 2006-2017 take-okm 

̃vO̓t[\tgEFAłBȂ͂At[\tgEFA
cɂĔsꂽGNU ʌOp(o[W3Aȍ~̃o[W
̂ǂꂩ)߂̉ōĔЕz܂͉ 邱Ƃł܂B

̃vO͗Lpł邱ƂĔЕz܂A*S̖ۏ *łB
Ɖ\̕ۏ؂ړIւ̓ḰAOɎꂽ̂ ܂߁AS
܂BڂGNU ʌOpB

Ȃ͂̃vOƋɁAGNU ʌOp̃Rs[ꕔ 󂯎
Ă͂łB󂯎ĂȂ΁A<http://www.gnu.org/licenses/> 
B

)

  āAʂȗOƂāAtake-okm ͂̃vÕR[h 
  "MFC(Microsoft Foundation Class library) Version 9.0" 
  (  邢 "MFC Version 9.0" ƓCZXKpꂽ
  "MFC Version 9.0" ̉ςꂽo[W)ƃNA
  Nꂽ҂܂ތ앨Еz鋖^܂B
  Ȃ "MFC" ȊOŎgĂ邷ׂ
  ̃R[hɊւĂ͑SʓIGNUʌOp_񏑂ɏ]Ȃ
  Ȃ܂BȂ̃t@CςȂ΁AȂ̗͂O
  Ȃ̃o[W̃t@CɈ݂邱Ƃł܂A
  `͂܂BO݂Ȃ΁A̗O
  Ȃ̃o[W͍폜ĂB)
*/
// CDlgRosenView.cpp : Cve[V t@C
//	$Id: CDlgRosenView.cpp 295 2016-06-11 05:14:13Z okm $

#include "stdafx.h"

#include <deque>

#include "NsOu/dynamic_castOu.h"
#include "TreeCtrl\CaTreeCtrl.h"

#include "..\DiagramEdit.h"
#include "..\CRfEditCmdHolder.h"
#include "..\DedRosenFileData\EditCmd\EditCmd.h"
#include "CDlgRosenView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

namespace ViewRosen{

using namespace std ;
using OuMfc::TreeCtrl::CaTreeCtrl ;

/////////////////////////////////////////////////////////////////////////////
// CDlgRosenView _CAO
// --------------------------------
//@name	֐
// --------------------------------
int CDlgRosenView::onEnterItem( HTREEITEM aItem  , int iAction ) 
{
	int iRv = 0 ;

	CaTreeCtrl::Itemlocation	aItemPos ;
	if ( aItem != NULL )
	{
		CaTreeCtrl	aCaTreeCtrl( &m_treeROSEN ) ;
		aCaTreeCtrl.HTREEITEM_to_Itemlocation( aItem , &aItemPos ) ;
	}
	//	H
	if ( aItemPos.size() == 1 && 
			aItemPos[0] == 0 && 
			iAction != 1 )
	{
		//	wHt@C̃vpeBx
		//	_CAOi[_jN܂B
		getCDiagramEditApp()->getCMainFrame()->execCDlgRosenFileProp() ;

		iRv = 1 ;
	}
	//	w
	if ( aItemPos.size() == 2 && 
			aItemPos[0] == 0 && 
			aItemPos[1] == 0 &&
			iAction != 2 )
	{
		//	wwxr[J܂B
		getCDiagramEditApp()->openCEkiDoc() ;

		iRv = 1 ;
	}
	//	Ԏ
	if ( aItemPos.size() == 2 && 
			aItemPos[0] == 0 && 
			aItemPos[1] == 1 &&
			iAction != 2 )
	{
		//	wԎʁxr[J܂B
		getCDiagramEditApp()->openCRessyasyubetsuDoc() ;

		iRv = 1 ;
	}
	//	_C
	if ( aItemPos.size() == 2 && 
			aItemPos[0] == 0 && 
			aItemPos[1] == 2 &&
			iAction != 1 )
	{
		//	w_Cꗗx_CAO([_)J܂B
		getCDiagramEditApp()->getCMainFrame()->execCDlgDiaList() ;

		iRv = 1 ;
	}
	//	\聄
	if ( aItemPos.size() == 4 && 
			aItemPos[0] == 0 && 
			aItemPos[1] == 2 && 
			aItemPos[3] == 0 &&
			iAction != 2 )
	{
		//	w\xr[J܂B
		const CentDedDia*	pCentDedDia = getCDiagramEditDoc()->getCDedRosenFileData()->
			getCentDedRosen()->getCentDedDiaCont()->getMuPtr()->get( aItemPos[2] ) ;
		if ( pCentDedDia != NULL )
		{
			getCDiagramEditApp()->openCJikokuhyouDoc( 
				pCentDedDia , 
				Ressyahoukou_Kudari , 
				NULL ) ;
		} 
		iRv = 1 ;
	}
	//	\聄
	if ( aItemPos.size() == 4 && 
			aItemPos[0] == 0 && 
			aItemPos[1] == 2 &&
			aItemPos[3] == 1 &&
			iAction != 2 )
	{
		//	w\xr[J܂B
		const CentDedDia*	pCentDedDia = getCDiagramEditDoc()->getCDedRosenFileData()->
			getCentDedRosen()->getCentDedDiaCont()->getMuPtr()->get( aItemPos[2] ) ;
		if ( pCentDedDia != NULL ){
			getCDiagramEditApp()->openCJikokuhyouDoc( 
				pCentDedDia , 
				Ressyahoukou_Nobori , 
				NULL ) ;
		} 
		iRv = 1 ;
	}
	//	_CO
	if ( aItemPos.size() == 4 && 
			aItemPos[0] == 0 && 
			aItemPos[1] == 2 && 
			aItemPos[3] == 2 &&
			iAction != 2 )
	{
		//	w_COxr[J܂B
		const CentDedDia*	pCentDedDia = getCDiagramEditDoc()->getCDedRosenFileData()->
			getCentDedRosen()->getCentDedDiaCont()->getMuPtr()->get( aItemPos[2] ) ;
		if ( pCentDedDia != NULL ){
			getCDiagramEditApp()->openCDedDiagramDoc( pCentDedDia ) ;
		} 
		iRv = 1 ;
	}
	//	Rg
	if ( aItemPos.size() == 2 && 
			aItemPos[0] == 0 && 
			aItemPos[1] == 3 &&
			iAction != 2 )
	{
		//	wRgxr[J܂B
		{
			getCDiagramEditApp()->openCDedCommentDoc() ;
		} 
		iRv = 1 ;
	}
	return ( iRv ) ;
}

	// ********************************
	//@name	CWnd
	// ********************************
BOOL CDlgRosenView::PreTranslateMessage(MSG* pMsg)
{

	// -------------------------------- 
	//        _CAO(̃Rg[)ɃtH[JXԂ 
	// ANZ[^ɂ郁j[R}hւ̃ANZX 
	//        s߂ɂ́ACt[EChE PreTranslateMessage()  
	//        ϏȂĂ͂Ȃ܂B 
	if ( WM_KEYFIRST <= pMsg->message && pMsg->message <= WM_KEYLAST ) 
	{ 
		if ( AfxGetMainWnd()->PreTranslateMessage( pMsg ) ) 
		{ 
			return TRUE ; 
		} 
	} 
	// -------------------------------- 
	return CDialog::PreTranslateMessage(pMsg); 
}

// ********************************
//	CDlgRosenView
// ********************************
	// ********************************
	//@name 
	// ********************************
void CDlgRosenView::UpdateROSEN( const CentDedRosen* pCentDedRosen ) 
{
	// --------------------------------
	//	݂̑IACe擾
	// --------------------------------
	CaTreeCtrl::Itemlocation	aItemPos ;
	{
		HTREEITEM	hItem = m_treeROSEN.GetSelectedItem() ;
		if ( hItem != NULL ){
			CaTreeCtrl	aCaTreeCtrl( &m_treeROSEN ) ;
			aCaTreeCtrl.HTREEITEM_to_Itemlocation( hItem , &aItemPos ) ;
		}
	}


	// --------------------------------
	//	UASACej
	// --------------------------------
	m_treeROSEN.DeleteAllItems() ;

	// --------------------------------
	//	H  sNgO̗
	// --------------------------------
	HTREEITEM itemRosen = NULL ;
	{
		CString	strItem ;
		strItem.LoadString( IDS_WORD_ROSEN ) ;
		
		string	strRosenName = pCentDedRosen->getName() ;
		if ( strRosenName.size() > 0 ){
			strItem = strRosenName.c_str() ;
		}

		int nImage = 0 ;
		int nSelectedImage = 0 ;

		itemRosen = m_treeROSEN.InsertItem( strItem , nImage , nSelectedImage , TVI_ROOT , TVI_LAST ) ;
		m_treeROSEN.SetItemState( itemRosen , TVIS_EXPANDED  ,  TVIS_EXPANDED  ) ;
	}

	// --------------------------------
	//	w  n}L̉w
	// --------------------------------
	{
		CString	strItem ;
		strItem.LoadString( IDS_WORD_EKI ) ;
		int nImage = 1 ;
		int nSelectedImage = 1 ;

		m_treeROSEN.InsertItem( strItem , nImage , nSelectedImage , itemRosen , TVI_LAST ) ;
	}
	// --------------------------------
	//	Ԏ  S`̃T{
	// --------------------------------
	{
		CString	strItem ;
		strItem.LoadString( IDS_WORD_RESSYASYUBETSU ) ;
		int nImage = 2 ;
		int nSelectedImage = 2 ;

		m_treeROSEN.InsertItem( strItem , nImage , nSelectedImage , itemRosen , TVI_LAST ) ;
	}
	// --------------------------------
	//	_C      w\ǂACR
	// --------------------------------
	HTREEITEM itemDia = NULL ;
	{
		CString	strItem ;
		strItem.LoadString( IDS_WORD_DIA ) ;
		int nImage = 3 ;
		int nSelectedImage = 3 ;

		itemDia = m_treeROSEN.InsertItem( strItem , nImage , nSelectedImage , itemRosen , TVI_LAST ) ;
		m_treeROSEN.SetItemState( itemDia , TVIS_EXPANDED ,  TVIS_EXPANDED ) ;

	}
	//itemDia = w_CxACe

	// --------------------------------
	//	(_C)  w\ǂACR
	// --------------------------------
	{
		int nImage = 4 ;
		int nSelectedImage = 4 ;
		
		const CentDedRosen*	pCentDedRosen = 
			getCDiagramEditDoc()->getCDedRosenFileData()->getCentDedRosen() ;
		const Mu<const CentDedDia*>* pCentDedDiaContGet = pCentDedRosen->getCentDedDiaCont()->getMuPtr();

		int idxDia ;
		for ( idxDia = 0 ; idxDia < pCentDedDiaContGet->size() ; idxDia ++ ){
			const CentDedDia*	pCentDedDia = pCentDedDiaContGet->get( idxDia ) ;
			string	strDiaName = pCentDedDia->getName() ;

			HTREEITEM itemDiaName = m_treeROSEN.InsertItem( strDiaName.c_str() , 
				nImage , nSelectedImage , itemDia , TVI_LAST ) ;
			m_treeROSEN.SetItemState( itemDiaName , TVIS_EXPANDED ,  TVIS_EXPANDED ) ;

			// --------------------------------
			//	莞\/莞\  
			// --------------------------------
			{
				CString	strItem ;
				strItem.LoadString( IDS_WORD_KUDARIJIKOKUHYOU ) ;
				int nImage = 5 ;
				int nSelectedImage = 5 ;

				m_treeROSEN.InsertItem( strItem , 
					nImage , nSelectedImage , itemDiaName , TVI_LAST ) ;
			}
			{
				CString	strItem ;
				strItem.LoadString( IDS_WORD_NOBORIJIKOKUHYOU ) ;
				int nImage = 6 ;
				int nSelectedImage = 6 ;

				m_treeROSEN.InsertItem( strItem , 
					nImage , nSelectedImage , itemDiaName , TVI_LAST ) ;
			}
			// --------------------------------
			//	_CO  _CO̐}
			// --------------------------------
			{
				CString	strItem ;
				strItem.LoadString( IDS_WORD_DIAGRAM ) ;
				int nImage = 7 ;
				int nSelectedImage = 7 ;

				m_treeROSEN.InsertItem( strItem , 
					nImage , nSelectedImage , itemDiaName , TVI_LAST ) ;
			}
			
		}
	}
	// --------------------------------
	//	Rg(0,3)
	// --------------------------------
	{
		CString	strItem ;
		strItem.LoadString( IDS_WORD_COMMENT ) ;
		int nImage = 8 ;
		int nSelectedImage = 8 ;

		itemDia = m_treeROSEN.InsertItem( strItem , nImage , nSelectedImage , itemRosen , TVI_LAST ) ;
		m_treeROSEN.SetItemState( itemDia , TVIS_EXPANDED ,  TVIS_EXPANDED ) ;

	}


	// --------------------------------
	//	ACeI
	// --------------------------------
	if ( aItemPos.size() > 0 ){
		HTREEITEM	hItem = NULL ;
		{
			CaTreeCtrl	aCaTreeCtrl( &m_treeROSEN ) ;
			hItem = aCaTreeCtrl.HTREEITEM_from_Itemlocation( &aItemPos ) ;
		}
		
		
		if ( hItem != NULL ){
			m_treeROSEN.Select( hItem , TVGN_CARET ) ;
		}
	}
}

void CDlgRosenView::OnUpdate( CView* pSender, LPARAM lHint, CObject* pHint ) 
{
	// --------------------------------
	//	HViewXV
	// --------------------------------
	if ( lHint == LHINT_SUBVIEW_TO_ROOTDOC ){
		return ;
	}
	// --------------------------------
	//pHint= 
	//	pHint CRfEditCmdHolder IuWFNgȂA
	//	ΉҏWR}h CRfEditCmd ێĂ܂B
	//	̏ꍇAthis  CRfEditCmd ̓eɍœK
	//	XVs܂B
	//	NULLȂASXVvĂ܂B


	// --------------------------------
	//	CRfEditCmd ɍœKꂽXV
	// --------------------------------
	Ou<CRfEditCmd> pCmd ;
	if ( pHint != NULL && pHint->IsKindOf( RUNTIME_CLASS( CRfEditCmdHolder ) ) ){
		CRfEditCmdHolder* pCHolder = (CRfEditCmdHolder*)pHint ;
		pCmd = pCHolder->getCmd() ;
	}
	if ( pCmd != NULL ){
		if ( 
			dynamic_castOu<CRfEditCmd_Comment>( pCmd ) ||
			dynamic_castOu<CRfEditCmd_Eki>( pCmd ) ||
			dynamic_castOu<CRfEditCmd_Ressya>( pCmd ) ||
			dynamic_castOu<CRfEditCmd_Ressyasyubetsu>( pCmd ) ||
			dynamic_castOu<CRfEditCmd_RessyasyubetsuSwap>( pCmd ) 
		){
			//	̃r[́Aȉ̏󋵂ł͍XV͕svłB
			//		Rg̕ҏW
			//		w̕ҏW
			//		Ԃ̕ҏW
			//		Ԃ̒ʉ
			//		Ԏʂ̕ҏW
			//		Ԏʂ̓
		}
		else
		{
			//	SXVs킹܂B
			//CRfEditCmd_DedRosenFileDataProp
			//	H̕ύX𔽉fKv܂B
			//CDedRosenFileData_Dia
			//	_C̒ǉE폜
			//CDedRosenFileData_DiaProp
			//	_C̕ύX
			//CRfEditCmd_Rosen
			//	HIuWFNg̑Su
			//CRfEditCmd_RosenFileData
			//	Ht@Cf[^̑Su
			pHint = NULL ;
		}
	}

	//	SXVs܂B
	if ( pHint == NULL ){
			getCDiagramEditApp()->getCDlgRosenView()->UpdateROSEN( 
				getCDiagramEditDoc()->getCDedRosenFileData()->getCentDedRosen() ) ;
	}
}

// ----------------------------------------------------------------
//	MFC
// ----------------------------------------------------------------

CDlgRosenView::CDlgRosenView(CWnd* pParent /*=NULL*/)
	: CDialog(CDlgRosenView::IDD, pParent)
{
	//{{AFX_DATA_INIT(CDlgRosenView)
		//  - ClassWizard ͂̈ʒuɃ}bsOp̃}Nǉ܂͍폜܂B
	//}}AFX_DATA_INIT
}


void CDlgRosenView::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDlgRosenView)
	DDX_Control(pDX, IDC_TREE_ROSEN, m_treeROSEN);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CDlgRosenView, CDialog)
	//{{AFX_MSG_MAP(CDlgRosenView)
	ON_WM_SIZE()
	ON_NOTIFY(NM_CLICK, IDC_TREE_ROSEN, OnClickTreeRosen)
	ON_NOTIFY(NM_DBLCLK, IDC_TREE_ROSEN, OnDblclkTreeRosen)
	//}}AFX_MSG_MAP
	ON_COMMAND(ID_MENUITEM_OPEN, &CDlgRosenView::OnMenuitemOpen)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDlgRosenView bZ[W nh

BOOL CDlgRosenView::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	// --------------------------------
	m_imagelistROSEN.Create( IDB_TREE_ROSEN , 16 , 16 , RGB( 255 , 255 , 255 ) ) ;
	m_treeROSEN.SetImageList( &m_imagelistROSEN , TVSIL_NORMAL   ) ;


	// --------------------------------
	
	return TRUE;  // Rg[ɃtH[JXݒ肵ȂƂA߂l TRUE ƂȂ܂
	              // O: OCX vpeB y[W̖߂l FALSE ƂȂ܂
}

void CDlgRosenView::OnSize(UINT nType, int cx, int cy) 
{
	//CDialog::OnSize(nType, cx, cy);
	

	if ( GetDlgItem( IDC_TREE_ROSEN ) == NULL ){
		return ;
	}
	// --------------------------------
	//	eEChĚ݂̈ʒu擾
	// --------------------------------
	CRect	rectThis ;
	{
		GetClientRect( &rectThis  ) ;
	}
	CRect	rectIDC_TREE_ROSEN ;
	{
		WINDOWPLACEMENT aWINDOWPLACEMENT ;
		aWINDOWPLACEMENT.length = sizeof(aWINDOWPLACEMENT) ;
		GetDlgItem( IDC_TREE_ROSEN ) ->GetWindowPlacement( &aWINDOWPLACEMENT ) ;
		rectIDC_TREE_ROSEN = aWINDOWPLACEMENT.rcNormalPosition ;
	}
	// --------------------------------
	//	eEChE̐VʒuZ
	// --------------------------------
	CRect	rectIDC_TREE_ROSENNew  ;
	{
		rectIDC_TREE_ROSENNew = rectIDC_TREE_ROSEN ;
		rectIDC_TREE_ROSENNew.right = rectThis.right ; 
		if ( rectIDC_TREE_ROSENNew.right < rectIDC_TREE_ROSENNew.left ){
			rectIDC_TREE_ROSENNew.right = rectIDC_TREE_ROSENNew.left ;
		}
		rectIDC_TREE_ROSENNew.bottom = rectThis.bottom ; 
		if ( rectIDC_TREE_ROSENNew.bottom < rectIDC_TREE_ROSENNew.top ){
			rectIDC_TREE_ROSENNew.bottom = rectIDC_TREE_ROSENNew.top ;
		}
	}
	// --------------------------------
	//	eEChE̐Vʒuݒ
	// --------------------------------
	GetDlgItem( IDC_TREE_ROSEN )->SetWindowPos( NULL , 
		rectIDC_TREE_ROSENNew.left , 
		rectIDC_TREE_ROSENNew.top , 
		rectIDC_TREE_ROSENNew.Width() , 
		rectIDC_TREE_ROSENNew.Height() , 
		SWP_NOZORDER ) ;   
	
}

void CDlgRosenView::OnOK() 
{
	// q_CAȌꍇ́AOnOK()EOnCancel()
	//	́AI[oChāA
	//	CDlalog::OnOK()̌ďo͗}~ȂĂ
	//	Ȃ܂B
	//
	//CDialog::OnOK();

	//	OnOK() ɂ́A^[L[̑܂B

	// --------------------------------
	int iRv = 0 ;
	HTREEITEM	aItem = NULL ;
	{
		aItem = m_treeROSEN.GetSelectedItem() ;
	}
	{
		iRv = onEnterItem( aItem , 0 ) ;
	}
	// --------------------------------
	
}

void CDlgRosenView::OnCancel() 
{
	// q_CAȌꍇ́AOnOK()EOnCancel()
	//	́AȂ悤ɃI[oChȂĂ͂Ȃ܂B
	//
	//CDialog::OnCancel();
}

void CDlgRosenView::OnClickTreeRosen(NMHDR* pNMHDR, LRESULT* pResult) 
{
	
	//	NM_DBLCLK (tree view)
	//	Return nonzero to prevent the default processing, 
	//	or zero to allow the default processing.
	//
	//	0 ;	//	W̏s܂B
	//	1 ;	//	W̏s܂B
	*pResult = 0 ;

	// --------------------------------
	int iRv = 0 ;
	HTREEITEM	aItem = NULL ;
	{
		CPoint	aPoint ;
		GetCursorPos( &aPoint ) ;
		m_treeROSEN.ScreenToClient( &aPoint ) ;
		UINT iFlags = 0 ;	
		aItem = m_treeROSEN.HitTest( aPoint , &iFlags ) ;

		// --------------------------------
		/*
		//	TreeRg[̃Cxg̓e
		LogMsg( "CDlgRosenView::OnClickTreeRosen()" ) ;
		if ( iFlags & TVHT_ABOVE ){
			LogMsg( "\tTVHT_ABOVE" ) ;
		}
		if ( iFlags & TVHT_BELOW ){
			LogMsg( "\tTVHT_BELOW" ) ;
		}
		if ( iFlags & TVHT_NOWHERE ){
			//	́AACêȂ̈
			LogMsg( "\tTVHT_NOWHERE" ) ;
		}
		if ( iFlags & TVHT_ONITEM ){
			//	ACẽACR
			//	ACẽx
			LogMsg( "\tTVHT_ONITEM" ) ;
		}
		if ( iFlags & TVHT_ONITEMBUTTON ){
			//	[+][-]{^
			LogMsg( "\tTVHT_ONITEMBUTTON" ) ;
		}
		if ( iFlags & TVHT_ONITEMICON ){
			//	ACẽACR
			LogMsg( "\tTVHT_ONITEMICON" ) ;
		}
		if ( iFlags & TVHT_ONITEMINDENT ){
			LogMsg( "\tTVHT_ONITEMINDENT" ) ;
		}
		if ( iFlags & TVHT_ONITEMLABEL ){
			//	ACẽx
			LogMsg( "\tTVHT_ONITEMLABEL" ) ;
		}
		if ( iFlags & TVHT_ONITEMRIGHT ){
			//	ACẻE
			LogMsg( "\tTVHT_ONITEMRIGHT" ) ;
		}
		if ( iFlags & TVHT_ONITEMSTATEICON ){
			LogMsg( "\tTVHT_ONITEMSTATEICON" ) ;
		}
		if ( iFlags & TVHT_TOLEFT ){
			LogMsg( "\tTVHT_TOLEFT" ) ;
		}
		if ( iFlags & TVHT_TORIGHT ){
			LogMsg( "\tTVHT_TORIGHT" ) ;
		}
		*/
		// --------------------------------
		if ( ( iFlags & TVHT_ONITEM ) )
		{
			iRv = onEnterItem( aItem , 1 ) ;
			if ( iRv == 1 )
			{
				//	*pResult  1 ɂƁANbNꂽACe
				//	IԃACeɂȂ܂B
				//
				//	*pResult = 1 ;
			}
		}
	}
}

void CDlgRosenView::OnDblclkTreeRosen(NMHDR* pNMHDR, LRESULT* pResult) 
{
	//	NM_DBLCLK (tree view)
	//	Return nonzero to prevent the default processing, 
	//	or zero to allow the default processing.
	//
	//	0 ;	//	W̏s܂B
	//	1 ;	//	W̏s܂B
	*pResult = 0 ;

	// --------------------------------
	int iRv = 0 ;
	HTREEITEM	aItem = NULL ;
	{
		CPoint	aPoint ;
		GetCursorPos( &aPoint ) ;
		m_treeROSEN.ScreenToClient( &aPoint ) ;
		UINT iFlags = 0 ;	
		aItem = m_treeROSEN.HitTest( aPoint , &iFlags ) ;

		// --------------------------------
		if ( ( iFlags & TVHT_ONITEM ) ){
			iRv = onEnterItem( aItem , 2 ) ;
			if ( iRv == 1 ){
				//	*pResult  0 ɂƁA_uNbNꂽACe
				//	qACeWJ܂B
				*pResult = 1 ;
			}
		}
	}
}

void CDlgRosenView::OnMenuitemOpen()
{
	if ( m_treeROSEN.getItemContextMenu() != NULL )
	{
		onEnterItem( m_treeROSEN.getItemContextMenu() , 1 ) ;
	}
}
} //namespace ViewRosen
