/*
	OuDia - Win32 Application Software to draw a "Train Service Planning
 Diagram" based on a "Train Timetable".

Copyright (C) 2006-2017 take-okm

This program is free software; you can redistribute it and/or modify it 
under the terms of the GNU General Public License as published by the Free 
Software Foundation; either version 3 of the License, or (at your option) 
any later version. 

This program is distributed in the hope that it will be useful, but WITHOUT 
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or 
FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for 
more details. 

You should have received a copy of the GNU General Public License along with
 this program. If not, see <http://www.gnu.org/licenses/>.

  In addition, as a special exception, take-okm
  gives permission to link the code of this program with
  the "MFC(Microsoft Foundation Class library) Version 9.0" 
  (or with modified versions of "MFC Version 9.0" that use the same license as 
  "MFC Version 9.0" ), and distribute linked combinations including
  the two.  You must obey the GNU General Public License in all
  respects for all of the code used other than  "MFC".  If you modify
  this file, you may extend this exception to your version of the
  file, but you are not obligated to do so.  If you do not wish to
  do so, delete this exception statement from your version.


(: 

	OuDia - Ԏ\ƂɁA_CO`悷Win32AvP[V
B

Copyright (C) 2006-2017 take-okm 

̃vO̓t[\tgEFAłBȂ͂At[\tgEFA
cɂĔsꂽGNU ʌOp(o[W3Aȍ~̃o[W
̂ǂꂩ)߂̉ōĔЕz܂͉ 邱Ƃł܂B

̃vO͗Lpł邱ƂĔЕz܂A*S̖ۏ *łB
Ɖ\̕ۏ؂ړIւ̓ḰAOɎꂽ̂ ܂߁AS
܂BڂGNU ʌOpB

Ȃ͂̃vOƋɁAGNU ʌOp̃Rs[ꕔ 󂯎
Ă͂łB󂯎ĂȂ΁A<http://www.gnu.org/licenses/> 
B

)

  āAʂȗOƂāAtake-okm ͂̃vÕR[h 
  "MFC(Microsoft Foundation Class library) Version 9.0" 
  (  邢 "MFC Version 9.0" ƓCZXKpꂽ
  "MFC Version 9.0" ̉ςꂽo[W)ƃNA
  Nꂽ҂܂ތ앨Еz鋖^܂B
  Ȃ "MFC" ȊOŎgĂ邷ׂ
  ̃R[hɊւĂ͑SʓIGNUʌOp_񏑂ɏ]Ȃ
  Ȃ܂BȂ̃t@CςȂ΁AȂ̗͂O
  Ȃ̃o[W̃t@CɈ݂邱Ƃł܂A
  `͂܂BO݂Ȃ΁A̗O
  Ȃ̃o[W͍폜ĂB)
*/
/*
// ****************************************************************
//	CconvCentDed.h
// $Id: CconvCentDed.h 378 2016-11-16 21:10:54Z okm $
// ****************************************************************
*/
#ifndef  CconvCentDed_h
#define  CconvCentDed_h

/** @file */

#include "str\OuPropertiesText\CNodeContainer.h"
#include "str\OuPropertiesText\ErrorInfo\COuErrorInfoContainer.h"
#include "str\CEnumToString.h"
#include "DcdCd\DcDrawProp\CdDcdFreeLineProp.h"
#include "DcdCd\DcDrawProp\CdColorProp.h"

#include "CentDedEki.h"
#include "CentDedRessyasyubetsu.h"
#include "CentDedEkiJikoku.h"
#include "CentDedRessya.h"
#include "CentDedRessyaCont.h"
#include "CentDedDia.h"
#include "CentDedRosen.h"

namespace entDed{
	using namespace OuLib::Str;

// ****************************************************************
//	CconvCentDed
// ****************************************************************
/**
	@brief
	  DiagramEdit ̃GeBeBNX̃IuWFNg̑f[^̓eA
	̃f[^`ɕϊ֐^Ă܂B

	OuPropertiesText::CNodeContainer IuWFNgƂ̊Ԃ̕ϊT|[gĂ܂B 
	
*/
class CconvCentDed
{
public:
	// ********************************
	///@name COuErrorInfo::m_strReason , m_Prop  Name
	// ********************************
	///@{
	
	/**
		"Ekijikokukeisiki" ܂B
		@param Ekijikokukeisiki
			w肳Ăw`
	*/
	static const char* ERRREASON_EkijikokukeisikiIsInvalid(){	return "Ekijikokukeisiki is invalid." ;};

	/**
		"Ekikibo" ܂B
		@param Ekikibo
			w肳ĂwK
	*/
	static const char* ERRREASON_EkikiboIsInvalid(){	return "Ekikibo is invalid." ;};

	/**
		"DiagramRessyajouhouHyouji" ܂B
		@param DiagramRessyajouhouHyoujiKudari
			w肳Ăe
		@param DiagramRessyajouhouHyoujiNobori
			w肳Ăe
	*/
	static const char* ERRREASON_DiagramRessyajouhouHyoujiIsInvalid(){	return "DiagramRessyajouhouHyouji is invalid." ;};

	/**
		"Eki" fBNgł͂܂B
		@param Index
			ΏۂƂȂ Eki ̔ԍ(0N_)w肵ĂB
	*/
	static const char* ERRREASON_EkiIsNotDirectory(){	return "Eki Is Not Directory." ;};
	static const char* ERRPROP_Index(){	return "Index" ;};

	/**
		"Syubetsumei" ܂B
		@param Syubetsumei
			w肳Ăʖ
	*/
	static const char* ERRREASON_SyubetsumeiIsInvalid(){	return "Syubetsumei is invalid." ;};
	/**
		"DiagramSenStyle" ܂B
		@param DiagramSenStyle
			w肳Ăl
	*/
	static const char* ERRREASON_DiagramSenStyleIsInvalid(){	return "DiagramSenStyle is invalid." ;};

	/**
		"Ressyasyubetsu" fBNgł͂܂B
		@param Index
			ΏۂƂȂ Ressyasyubetsu ̔ԍ(0N_)w肵ĂB
	*/
	static const char* ERRREASON_RessyasyubetsuIsNotDirectory(){	return "Ressyasyubetsu is invalid." ;};

	/**
		"DiaName" ܂B
	*/
	static const char* ERRREASON_DiaNameInvalid(){	return "DiaName is invalid." ;};

	/**
		"RessyaCont" ܂B
		@param Ressyahoukou
			ȂRessyaCont̗ԕB "Kudari"  "Nobori" ̂ꂩłB
	*/
	static const char* ERRREASON_ResyaContIsNotExist(){	return "Ressyahoukou is Not Exist." ;};

	static const char* ERRPROP_Ressyahoukou(){	return "Ressyahoukou" ;};

	/**
		N_słB
	@param Jikoku
		w肳ꂽ
	*/
	static const char* ERRREASON_KitenjikokuIsInvalid(){	return "Kitenjikoku Is Invelid." ;};

	static const char* ERRPROP_Jikoku(){	return "Jikoku" ;};

	/**
		_CO̊̉wԕsłB
	@param Value
		ݒ肳Ăl
	*/
	static const char* ERRREASON_DiagramDgrYZahyouKyoriDefaultIsInvalid(){	return "DiagramDgrYZahyouKyoriDefault Is Invelid." ;};

	static const char* ERRPROP_Value(){	return "Value" ;};
	/**
		ľ`܂B
	@param Name
		ږ
	@param Value
		ݒ肳Ăl
	*/
	static const char* ERRREASON_InvalidValueFormat(){	return "Invalid Value Format." ;};

	static const char* ERRPROP_Name(){	return "Name" ;};



	///@}
 public:

	// ********************************
	//	CentDedEki
	// ********************************
	/**
	@return
		CentDedEki::EEkijikokukeisiki ƕ̊Ԃ̃Ro[^IuWFNgԂ܂B
	*/
	static const CEnumToString< CentDedEki::EEkijikokukeisiki >& getEEkijikokukeisikiToString();

	/**
	@return
		CentDedEki::EEkikibo ƕ̊Ԃ̃Ro[^IuWFNgԂ܂B
	*/
	static const CEnumToString< CentDedEki::EEkikibo >& getEEkikiboToString();

	/**
	@return
		CentDedEki::EDiagramRessyajouhouHyouji ƕ̊Ԃ̃Ro[^IuWFNgԂ܂B
	*/
	static const CEnumToString< CentDedEki::EDiagramRessyajouhouHyouji >& 
		getEDiagramRessyajouhouHyoujiToString() ;

	/**
		  OuPropertiesText IuWFNgɁA
		  CentDedEki ̑ǉ܂B
		@param aCentDedEki [in]
		  CentDedEki w肵ĂB
		@param pCNodeContainer [in,out]
		  ̊֐́ÃIuWFNgɁAaCentDedEki ̓eǉ܂B
		@return
		   0 ȏAG[Ȃ畉̐łB
	 */
	int CentDedEki_To_OuPropertiesText( 
			const CentDedEki& aCentDedEki , 
			OuPropertiesText::CNodeContainer* pCNodeContainer ) ;
	
	/**
		  OuPropertiesText IuWFNgA
		  CentDedEki_To_OuPropertiesText() ֐ɂč쐬ꂽ
		ACeǂݍ݁A CentDedEki IuWFNgɔf܂B
		
		@param pCentDedEki [out]
		  ̊֐͂̃IuWFNgɁA𔽉f܂B
		@param pCNodeContainer [in]
		  ێĂ OuPropertiesText IuWFNgw肵ĂB
		@param pCOuErrorInfoContainer [in,out]
		  ̊֐̓G[AG[̏̃IuWFNgɒǉ܂B
		@return
		   0 ȏAG[Ȃ畉̐łB
			-	-22 ;	//	Ekijikokukeisiki ̒lsłB
			-	-32 ;	//	Ekikibo ̒lsłB
			-	-41 ;	//	DiagramRessyajouhouHyoujiKudari ̒lsłB
			-	-42 ;	//	DiagramRessyajouhouHyoujiNobori ̒lsłB
	 */
	int CentDedEki_From_OuPropertiesText( 
			CentDedEki* pCentDedEki ,
			const OuPropertiesText::IfNodeContainerConst* pCNodeContainer ,
			OuPropertiesText::ErrorInfo::COuErrorInfoContainer* pCOuErrorInfoContainer ) ;
	
	// ********************************
	//	CentDedEkiCont
	// ********************************
	
	/**
		  OuPropertiesText IuWFNgɁA
		  CentDedEkiCont ̑ǉ܂B

		  ̊֐́A CentDedEki IuWFNg "Eki" Directory ƂĒǉ܂B
		@param aCentDedEkiCont [in]
		  CentDedEkiCont w肵ĂB
		@param pCNodeContainer [in,out]
		  ̊֐́ÃIuWFNgɁAaCentDedEkiCont ̓eǉ܂B
		@return
		   0 ȏAG[Ȃ畉̐łB
	 */
	int CentDedEkiCont_To_OuPropertiesText( 
			const CentDedEkiCont& aCentDedEkiCont , 
			OuPropertiesText::CNodeContainer* pCNodeContainer ) ;
	
	/**
		  OuPropertiesText IuWFNgA
		  CentDedEki_To_OuPropertiesText() ֐ɂč쐬ꂽ
		ACeǂݍ݁A CentDedEki IuWFNgɔf܂B
		
		@param pCentDedEkiCont [in,out]
		  ̊֐͂̃IuWFNgɁAǉ܂B
		@param pCNodeContainer [in]
		  ێĂ OuPropertiesText IuWFNgw肵ĂB
		@param pCOuErrorInfoContainer [in,out]
		  ̊֐̓G[AG[̏̃IuWFNgɒǉ܂B
		@return
		   0 ȏAG[Ȃ畉̐łB
			-	-22 ;	//	Ekijikokukeisiki ̒lsłB
			-	-32 ;	//	Ekikibo ̒lsłB
			-	-41 ;	//	DiagramRessyajouhouHyoujiKudari ̒lsłB
			-	-42 ;	//	DiagramRessyajouhouHyoujiNobori ̒lsłB
			-	-101 ;	//	Eki fBNgł͂܂B
	 */
	int CentDedEkiCont_From_OuPropertiesText( 
			CentDedEkiCont* aCentDedEkiCont ,
			const OuPropertiesText::IfNodeContainerConst* pCNodeContainer ,
			OuPropertiesText::ErrorInfo::COuErrorInfoContainer* pCOuErrorInfoContainer ) ;
	
	// ********************************
	//	CentDedRessyasyubetsu
	// ********************************
	/**
	@return
		CentDedRessyasyubetsu::ESenStyle  Ƃ̊Ԃ̃Ro[^IuWFNg
		Ԃ܂B
	*/
	static const CEnumToString< CentDedRessyasyubetsu::ESenStyle >& 
		getESenStyleToString();
	static const CEnumToString< CentDedRessyasyubetsu::EStopMarkDrawType >& 
		getEStopMarkDrawTypeToString() ;

	/**
		  OuPropertiesText IuWFNgɁA
		  CentDedRessyasyubetsu::CdDiagramLineStyle ̑ǉ܂B
		@param aCdDiagramLineStyle [in]
		  CentDedRessyasyubetsu::CdDiagramLineStyle w肵ĂB
		@param pCNodeContainer [in,out]
		  ̊֐́ÃIuWFNgɁAeǉ܂B
		@return
		   0 ȏAG[Ȃ畉̐łB
		  ݂̂ƂA 0 Ԃ܂B
	 */
	int CdDiagramLineStyle_To_OuPropertiesText( 
			const CentDedRessyasyubetsu::CdDiagramLineStyle& aCdDiagramLineStyle , 
			OuPropertiesText::CNodeContainer* pCNodeContainer ) ;

	/**
		  OuPropertiesText IuWFNgA
		  CentDedRessyasyubetsu_To_OuPropertiesText() ֐ɂč쐬ꂽ
		ACeǂݍ݁A CentDedRessyasyubetsu IuWFNgɔf܂B
		
		@param pCdDiagramLineStyle [out]
		  ̊֐͂̃IuWFNgɁA𔽉f܂B
		@param pCNodeContainer [in]
		  ێĂ OuPropertiesText IuWFNgw肵ĂB
		@param pCOuErrorInfoContainer [in,out]
		  ̊֐̓G[AG[̏̃IuWFNgɒǉ܂B
		@return
		   0 ȏAG[Ȃ畉̐łB
			-	-52 ;	//	DiagramSenStyle ̒lsłB
	 */
	int CdDiagramLineStyle_From_OuPropertiesText( 
			CentDedRessyasyubetsu::CdDiagramLineStyle* pCdDiagramLineStyle ,
			const OuPropertiesText::IfNodeContainerConst* pCNodeContainer ,
			OuPropertiesText::ErrorInfo::COuErrorInfoContainer* pCOuErrorInfoContainer ) ;

	/**
		  OuPropertiesText IuWFNgɁA
		  CentDedRessyasyubetsu ̑ǉ܂B
		@param aCentDedRessyasyubetsu [in]
		  CentDedRessyasyubetsu w肵ĂB
		@param pCNodeContainer [in,out]
		  ̊֐́ÃIuWFNgɁACDedRosenFileData ̓eǉ܂B
		@return
		   0 ȏAG[Ȃ畉̐łB
			-	-11 ;	//	Syubetsumei w肳Ă܂B
			-	-52 ;	//	DiagramSenStyle ̒lsłB
	 */
	int CentDedRessyasyubetsu_To_OuPropertiesText( 
			const CentDedRessyasyubetsu& aCentDedRessyasyubetsu , 
			OuPropertiesText::CNodeContainer* pCNodeContainer ) ;
	
	/**
		  OuPropertiesText IuWFNgA
		  CentDedRessyasyubetsu_To_OuPropertiesText() ֐ɂč쐬ꂽ
		ACeǂݍ݁A CentDedRessyasyubetsu IuWFNgɔf܂B
		
		@param pCentDedRessyasyubetsu [out]
		  ̊֐͂̃IuWFNgɁA𔽉f܂B
		@param pCNodeContainer [in]
		  ێĂ OuPropertiesText IuWFNgw肵ĂB
		@param pCOuErrorInfoContainer [in,out]
		  ̊֐̓G[AG[̏̃IuWFNgɒǉ܂B
		@return
		   0 ȏAG[Ȃ畉̐łB
			-	-11 ;	//	Syubetsumei w肳Ă܂B
			-	-52 ;	//	DiagramSenStyle ̒lsłB
			-	-101 ;	//	ľ`܂B
	 */
	int CentDedRessyasyubetsu_From_OuPropertiesText( 
			CentDedRessyasyubetsu* pCentDedRessyasyubetsu ,
			const OuPropertiesText::IfNodeContainerConst* pCNodeContainer ,
			OuPropertiesText::ErrorInfo::COuErrorInfoContainer* pCOuErrorInfoContainer ) ;
	

	/**
		CentDedRessyasyubetsu::CdDiagramLineStyle ̒lƂɁA
		CDcdFreeLine::CdLineProp IuWFNgɑ
		ݒ肵܂B
	 @param aLineStyle
		̌`w肵ĂB
	 @param pCdLineProp [out]
		̊֐͂̃IuWFNgɁA
		ݒ肵܂B

	 */
	void CentDedRessyasyubetsu_to_CDcdFreeLineProp(
		const CentDedRessyasyubetsu::CdDiagramLineStyle& aLineStyle , 
		CdDcdFreeLineProp* pCdLineProp )	;

	// ********************************
	//	CentDedRessyasyubetsuCont
	// ********************************
	
	/**
	  OuPropertiesText IuWFNgɁA
	  CentDedRessyasyubetsuCont ̓eǉ܂B
	  ̊֐́A CentDedRessyasyubetsu IuWFNg 
	  "Ressyasyubetsu" Directory ƂĒǉ܂B
	@param aCentDedRessyasyubetsuCont [in]
	  CentDedRessyasyubetsuCont w肵ĂB
	@param pCNodeContainer [in,out]
	  ̊֐́ÃIuWFNgɁACDedRosenFileData ̓eǉ܂B
	@return
	   0 ȏAG[Ȃ畉̐łB
		-	-11 ;	//	Syubetsumei w肳Ă܂B
		-	-52 ;	//	DiagramSenStyle ̒lsłB
	 */
	int CentDedRessyasyubetsuCont_To_OuPropertiesText( 
			const CentDedRessyasyubetsuCont& aCentDedRessyasyubetsuCont , 
			OuPropertiesText::CNodeContainer* pCNodeContainer ) ;
	
	/**
	  OuPropertiesText IuWFNgA
	  CentDedRessyasyubetsuCont_To_OuPropertiesText() ֐ɂč쐬ꂽ
	ACeǂݍ݁A CentDedRessyasyubetsu IuWFNgɔf܂B
	
	@param pCentDedRessyasyubetsuCont [in,out]
	  ̊֐͂̃IuWFNgɁA㏑܂B
	  pCentDedRessyasyubetsuCont ̗vfȂꍇ́A
	  vfǉ܂B
	@param pCNodeContainer [in]
	  ێĂ OuPropertiesText IuWFNgw肵ĂB
	@param pCOuErrorInfoContainer [in,out]
	  ̊֐̓G[AG[̏̃IuWFNgɒǉ܂B
	@return
	   0 ȏAG[Ȃ畉̐łB
		-	-11 ;	//	Syubetsumei w肳Ă܂B
		-	-52 ;	//	DiagramSenStyle ̒lsłB
		-	-101 ;	//	Ressyasyubetsu fBNgł͂܂B
	 */
	int CentDedRessyasyubetsuCont_From_OuPropertiesText( 
			CentDedRessyasyubetsuCont* pCentDedRessyasyubetsuCont ,
			const OuPropertiesText::IfNodeContainerConst* pCNodeContainer ,
			OuPropertiesText::ErrorInfo::COuErrorInfoContainer* pCOuErrorInfoContainer ) ;

	
	// ********************************
	//	CentDedEkiJikoku
	// ********************************
	/**
		CentDedEkijikoku ̑𕶎ɕϊ܂B
	@param pCentDedEkijikoku[in]
		ϊsIuWFNgw肵ĂB
	@return
		ϊʂԂ܂B
	*/
	std::string CentDedEkiJikoku_To_string( 
		const CentDedEkiJikoku* pCentDedEkijikoku ) ;

	/**
		CentDedEkijikoku_To_string() ŐA
		CentDedEkijikoku ̑ɔf܂B
	@param pCentDedEkijikoku[out]
		̊֐͂̃IuWFNgɁA𔽉f܂B
	@param strValue[in]
		ێ镶w肵ĂB
	@return
		 0 ȏAG[Ȃ畉̐łB
		- ݂̂ƂAG[͂܂B
		
	*/
	int CentDedEkiJikoku_From_string( 
			CentDedEkiJikoku* pCentDedEkijikoku , 
			const std::string strValue ) ;
	
	// ********************************
	//	CentDedRessya
	// ********************************
	/**
	@return
		ERessyahoukou ƕƂ̊Ԃ̃Ro[^IuWFNgԂ܂B
	*/
	static const CEnumToString<ERessyahoukou>& getERessyahoukouToString() ;

	/**
		  OuPropertiesText IuWFNgɁA
		  CentDedRessya ̑ǉ܂B
		@param pCentDedRessya [in]
		  CentDedRessya w肵ĂB
		@param pCNodeContainer [in,out]
		  ̊֐́ÃIuWFNgɁA CentDedRessya ̓eǉ܂B
		@return
		   0 ȏAG[Ȃ畉̐łB
			-	-12 ;	//	Ressyahoukou ̒lsłB
	 */
	int CentDedRessya_To_OuPropertiesText( 
			const CentDedRessya* pCentDedRessya , 
			OuPropertiesText::CNodeContainer* pCNodeContainer ) ;
	
	/**
		  OuPropertiesText IuWFNgA
		  CentDedRessya_To_OuPropertiesText() ֐ɂč쐬ꂽ
		ACeǂݍ݁A CentDedRessya IuWFNgɔf܂B
		
		  A
	
			- ԕ
			- IuWFNg܂ wwx ̐
	
		́AύX܂B̒ĺA֐ďoɂĐݒ肳Ă
		Kv܂B
		@param pCentDedRessya [in,out]
		  ̊֐͂̃IuWFNgɁAԂ̑𔽉f܂B
			AIuWFNg̑wԕx
			܂ wwx ͕̐ύX܂B
			̒ĺA֐ďoɂĐݒ肳ĂKv܂B
		@param pCNodeContainer [in]
		  ێĂ OuPropertiesText IuWFNgw肵ĂB
		@param pCOuErrorInfoContainer [out]
		  ̊֐̓G[AG[̏̃IuWFNgɒǉ܂B
		@return
		   0 ȏAG[Ȃ畉̐łB
			- ݂̂ƂAG[͂܂B
	 */
	int CentDedRessya_From_OuPropertiesText( 
			CentDedRessya* pCentDedRessya ,
			const OuPropertiesText::IfNodeContainerConst* pCNodeContainer ,
			OuPropertiesText::ErrorInfo::COuErrorInfoContainer* pCOuErrorInfoContainer ) ;
	
	
	// ********************************
	//	CentDedRessyaCont
	// ********************************
	
	/**
		  OuPropertiesText IuWFNgɁA
		  CentDedRessyaCont ̑ǉ܂B
		@param pCentDedRessyaCont [in]
		  CentDedRessya w肵ĂB
		@param pCNodeContainer [in,out]
		  ̊֐́ÃIuWFNgɁA CDedRosenFileData ̓eǉ܂B
		@return
		   0 ȏAG[Ȃ畉̐łB
			-	-12 ;	//	Ressyahoukou ̒lsłB
	 */
	int CentDedRessyaCont_To_OuPropertiesText( 
			const CentDedRessyaCont* pCentDedRessyaCont , 
			OuPropertiesText::CNodeContainer* pCNodeContainer ) ;
	
	/**
		  OuPropertiesText IuWFNgA
		  CentDedRessya_To_OuPropertiesText() ֐ɂč쐬ꂽ
		ACeǂݍ݁A CentDedRessyaCont IuWFNgɔf܂B
		
		@param pCentDedRessyaCont [in,out]
			̊֐͂̃Rei̖ɁA
			OuPropertiesText IuWFNgɕۑĂ鑮̃IuWFNg
			ǉ܂B\n
			AǉIuWFNg wwx ̐́A
			m_iEkiCount Ɍ܂Ă܂B aCdConectedString ɕۑĂ
			Ԃ葽wwxێĂꍇ́AIw̎
			؎̂ĂƂȂ܂B
		@param pCNodeContainer [in]
		  ێĂ OuPropertiesText IuWFNgw肵ĂB
		@param pCOuErrorInfoContainer [out]
		  ̊֐̓G[AG[̏̃IuWFNgɒǉ܂B
		@return
		   0 ȏAG[Ȃ畉̐łB
			- ݂̂ƂAG[͂܂B
	 */
	int CentDedRessyaCont_From_OuPropertiesText( 
			CentDedRessyaCont* pCentDedRessyaCont ,
			const OuPropertiesText::IfNodeContainerConst* pCNodeContainer ,
			OuPropertiesText::ErrorInfo::COuErrorInfoContainer* pCOuErrorInfoContainer ) ;
	
	
	// ********************************
	//	CentDedDia
	// ********************************
	
	/**
		  OuPropertiesText IuWFNgɁA
		  CentDedDia ̑ǉ܂B
		@param pCentDedDia [in]
		  CentDedDia w肵ĂB
		@param pCNodeContainer [in,out]
		  ̊֐́ÃIuWFNgɁA pCentDedDia ̓eǉ܂B
		@return
		   0 ȏAG[Ȃ畉̐łB
		-	-12 ;	//	DiagramEkiatsukai ̒lsłB
	 */
	int CentDedDia_To_OuPropertiesText( 
			const CentDedDia* pCentDedDia , 
			OuPropertiesText::CNodeContainer* pCNodeContainer ) ;
	
	/**
		  OuPropertiesText IuWFNgA
		  CentDedDia_To_OuPropertiesText() ֐ɂč쐬ꂽ
		ACeǂݍ݁A CentDedDia IuWFNgɔf܂B
		
		@param pCentDedDia [in,out]
		  ̊֐͂̃IuWFNgɁA𔽉f܂B
		  ̃IuWFNgɂ́A炩 ww̐xEwԎʐx
		ݒ肳ĂȂĂ͂Ȃ܂B
		@param pCNodeContainer [in]
		  ێĂ OuPropertiesText IuWFNgw肵ĂB
		@param pCOuErrorInfoContainer [out]
		  ̊֐̓G[AG[̏̃IuWFNgɒǉ܂B
		@return
		   0 ȏAG[Ȃ畉̐łB
		-	-11 ;	//	DiaName w肳Ă܂B
		-	-12 ;	//	RessyaCont܂B
	 */
	int CentDedDia_From_OuPropertiesText( 
			CentDedDia* pCentDedDia ,
			const OuPropertiesText::IfNodeContainerConst* pCNodeContainer ,
			OuPropertiesText::ErrorInfo::COuErrorInfoContainer* pCOuErrorInfoContainer ) ;
	
	// ********************************
	//	CentDedDiaCont
	// ********************************
	
	/**
		  OuPropertiesText IuWFNgɁA
		  CentDedDiaCont ̑ǉ܂B
		@param pCentDedDiaCont [in]
		  CentDedDiaCont w肵ĂB
		@param pCNodeContainer [in,out]
		  ̊֐́ÃIuWFNgɁA CDedRosenFileData ̓eǉ܂B
		@return
		   0 ȏAG[Ȃ畉̐łB
		-	-12 ;	//	DiagramEkiatsukai ̒lsłB
	 */
	int CentDedDiaCont_To_OuPropertiesText( 
			const CentDedDiaCont* pCentDedDiaCont , 
			OuPropertiesText::CNodeContainer* pCNodeContainer ) ;
	
	/**
		  OuPropertiesText IuWFNgA
		  CentDedDiaCont_To_OuPropertiesText() ֐ɂč쐬ꂽ
		ACeǂݍ݁A CentDedDiaCont IuWFNgɔf܂B
		
		@param pCentDedDiaCont [in,out]
		  ̊֐͂̃IuWFNgɁA𔽉f܂B
		  ̃IuWFNgɂ́A炩 ww̐xEwԎʐx
		ݒ肳ĂȂĂ͂Ȃ܂B
		@param pCNodeContainer [in]
		  ێĂ OuPropertiesText IuWFNgw肵ĂB
		@param pCOuErrorInfoContainer [out]
		  ̊֐̓G[AG[̏̃IuWFNgɒǉ܂B
		@return
		   0 ȏAG[Ȃ畉̐łB
		-	-11 ;	//	DiaName w肳Ă܂B
		-	-12 ;	//	RessyaCont܂B
	 */
	int CentDedDiaCont_From_OuPropertiesText( 
			CentDedDiaCont* pCentDedDiaCont ,
			const OuPropertiesText::IfNodeContainerConst* pCNodeContainer ,
			OuPropertiesText::ErrorInfo::COuErrorInfoContainer* pCOuErrorInfoContainer ) ;
	
	// ********************************
	//	CentDedRosen
	// ********************************
	
	/**
		  OuPropertiesText IuWFNgɁA
		  CentDedRosen ̑ǉ܂B
		@param pCentDedRosen [in]
		  CentDedRosen w肵ĂB
		@param pCNodeContainer [in,out]
		  ̊֐́ÃIuWFNgɁA CDedRosenFileData ̓e𔽉f܂B
		  pCNodeContainer ܂ŕێĂIuWFNg͔j܂B
		@return
		   0 ȏAG[Ȃ畉̐łB
			-	-22 ;	//	Ekijikokukeisiki ̒lsłB
			-	-32 ;	//	Ekikibo ̒lsłB
			-	-111 ;	//	Syubetsumei w肳Ă܂B
			-	-152 ;	//	DiagramSenStyle ̒lsłB
			-	-212 ;	//	DiagramEkiatsukai ̒lsłB
	 */
	int CentDedRosen_To_OuPropertiesText( 
			const CentDedRosen* pCentDedRosen , 
			OuPropertiesText::CNodeContainer* pCNodeContainer ) ;
	
	/**
		  OuPropertiesText IuWFNgA
		  CentDedRosen_To_OuPropertiesText() ֐ɂč쐬ꂽ
		ACeǂݍ݁A CentDedRosen IuWFNgɔf܂B
		
		@param pCentDedRosen [out]
		  ̊֐͂̃IuWFNgɁA𔽉f܂B
		@param pCNodeContainer [in]
		  ێĂ OuPropertiesText IuWFNgw肵ĂB
		@param pCOuErrorInfoContainer [out]
		  ̊֐̓G[AG[̏̃IuWFNgɒǉ܂B
		@return
		   0 ȏAG[Ȃ畉̐łB
			-	-22 ;	//	Ekijikokukeisiki ̒lsłB
			-	-32 ;	//	Ekikibo ̒lsłB
			-	-41 ;	//	DiagramRessyajouhouHyoujiKudari ̒lsłB
			-	-42 ;	//	DiagramRessyajouhouHyoujiNobori ̒lsłB
			-	-101 ;	//	Eki fBNgł͂܂B
			-	-111 ;	//	Syubetsumei w肳Ă܂B
			-	-152 ;	//	DiagramSenStyle ̒lsłB
			-	-201 ;	//	Ressyasyubetsu fBNgł͂܂B
			-	-211 ;	//	DiaName w肳Ă܂B
			-	-212 ;	//	RessyaCont܂B
			-	-352 ;	//	N_̐ݒ肪sK؂łB
			-	-353 ;	//	_CO̊̉wԕsłB
	 */
	int CentDedRosen_From_OuPropertiesText( 
			CentDedRosen* pCentDedRosen ,
			const OuPropertiesText::IfNodeContainerConst* pCNodeContainer ,
			OuPropertiesText::ErrorInfo::COuErrorInfoContainer* pCOuErrorInfoContainer ) ;
	
	
	
};	

} //namespace entDed

#endif /*CconvCentDed_h*/
	
