/*
	OuDia - Win32 Application Software to draw a "Train Service Planning
 Diagram" based on a "Train Timetable".

Copyright (C) 2006-2017 take-okm

This program is free software; you can redistribute it and/or modify it 
under the terms of the GNU General Public License as published by the Free 
Software Foundation; either version 3 of the License, or (at your option) 
any later version. 

This program is distributed in the hope that it will be useful, but WITHOUT 
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or 
FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for 
more details. 

You should have received a copy of the GNU General Public License along with
 this program. If not, see <http://www.gnu.org/licenses/>.

  In addition, as a special exception, take-okm
  gives permission to link the code of this program with
  the "MFC(Microsoft Foundation Class library) Version 9.0" 
  (or with modified versions of "MFC Version 9.0" that use the same license as 
  "MFC Version 9.0" ), and distribute linked combinations including
  the two.  You must obey the GNU General Public License in all
  respects for all of the code used other than  "MFC".  If you modify
  this file, you may extend this exception to your version of the
  file, but you are not obligated to do so.  If you do not wish to
  do so, delete this exception statement from your version.


(: 

	OuDia - Ԏ\ƂɁA_CO`悷Win32AvP[V
B

Copyright (C) 2006-2017 take-okm 

̃vO̓t[\tgEFAłBȂ͂At[\tgEFA
cɂĔsꂽGNU ʌOp(o[W3Aȍ~̃o[W
̂ǂꂩ)߂̉ōĔЕz܂͉ 邱Ƃł܂B

̃vO͗Lpł邱ƂĔЕz܂A*S̖ۏ *łB
Ɖ\̕ۏ؂ړIւ̓ḰAOɎꂽ̂ ܂߁AS
܂BڂGNU ʌOpB

Ȃ͂̃vOƋɁAGNU ʌOp̃Rs[ꕔ 󂯎
Ă͂łB󂯎ĂȂ΁A<http://www.gnu.org/licenses/> 
B

)

  āAʂȗOƂāAtake-okm ͂̃vÕR[h 
  "MFC(Microsoft Foundation Class library) Version 9.0" 
  (  邢 "MFC Version 9.0" ƓCZXKpꂽ
  "MFC Version 9.0" ̉ςꂽo[W)ƃNA
  Nꂽ҂܂ތ앨Еz鋖^܂B
  Ȃ "MFC" ȊOŎgĂ邷ׂ
  ̃R[hɊւĂ͑SʓIGNUʌOp_񏑂ɏ]Ȃ
  Ȃ܂BȂ̃t@CςȂ΁AȂ̗͂O
  Ȃ̃o[W̃t@CɈ݂邱Ƃł܂A
  `͂܂BO݂Ȃ΁A̗O
  Ȃ̃o[W͍폜ĂB)
*/
/*
// ****************************************************************
//	CentDedEkiJikoku.cpp
//	$Id: CentDedEkiJikoku.cpp 378 2016-11-16 21:10:54Z okm $
// ****************************************************************
*/
/** @file */
#include "stdafx.h"
#include "CentDedEkiJikoku.h"
#include "CentDedEkiJikokuCont.h"

namespace entDed{

// ****************************************************************
//	CentDedEkiJikoku::CXEkiJikokuTrackCont
// ****************************************************************
CentDedEkiJikoku*
CentDedEkiJikoku::CXEkiJikokuTrackCont::getEkiJikoku() 
{
	CentDedEkiJikoku* pOuter = (CentDedEkiJikoku*)( ((char*)this) - offsetof( CentDedEkiJikoku , m_EkiJikokuTrackCont ) ) ;
	return pOuter ;
}

const CentDedEkiJikoku* 
CentDedEkiJikoku::CXEkiJikokuTrackCont::getEkiJikoku()const 
{
	const CentDedEkiJikoku* pOuter = (const CentDedEkiJikoku*)( ((char*)this) - offsetof( CentDedEkiJikoku , m_EkiJikokuTrackCont ) ) ;
	return pOuter ;
}


// ****************************************************************
//	CentDedEkiJikoku
// ****************************************************************


// ********************************
//	RXgN^
// ********************************
CentDedEkiJikoku::CentDedEkiJikoku() :
		m_eEkiatsukai( Ekiatsukai_None ) 
{
};
CentDedEkiJikoku::CentDedEkiJikoku( 
		EEkiatsukai	eEkiatsukai , 
		CdDedJikoku	jikokuChakujikoku , 
		CdDedJikoku	jikokuHatsujikoku ) 
{
	set( eEkiatsukai , jikokuChakujikoku , jikokuHatsujikoku ) ;			
};

CentDedEkiJikoku& CentDedEkiJikoku::operator=( const CentDedEkiJikoku& value ) 
{
	CentDedEkiJikokuCont* pEkiJikokuCont = dynamic_cast<CentDedEkiJikokuCont*>( getParent() ) ;
	if ( pEkiJikokuCont != NULL )
	{
		int iResult = pEkiJikokuCont->setable( value , pEkiJikokuCont->getIndex( this ) ) ;
		if ( iResult < 0 ){
			throw( LException() ) ;
		}
	}
	super::operator=( value ) ; 

	// --------------------------------
	m_eEkiatsukai = value.m_eEkiatsukai ;
	m_jikokuChakujikoku = value.m_jikokuChakujikoku ;
	m_jikokuHatsujikoku = value.m_jikokuHatsujikoku ;
	m_EkiJikokuTrackCont = value.m_EkiJikokuTrackCont ;

	return *this ;
}

	// ********************************
	//@name CParentBase-
	// ********************************
void CentDedEkiJikoku::setParent( CParentBase* pParent )
{
	super::setParent( pParent ) ; 
	adjust() ;
}


	// ********************************
	//@name CentDedEkiJikoku-
	// ********************************
CentDedEkiJikoku::EEkiatsukai	CentDedEkiJikoku::getEkiatsukai()const{	return m_eEkiatsukai ;};

CentDedEkiJikoku& CentDedEkiJikoku::setEkiatsukai( CentDedEkiJikoku::EEkiatsukai value )
{
	m_eEkiatsukai = value ;
	if ( m_eEkiatsukai == Ekiatsukai_None ||
		m_eEkiatsukai == Ekiatsukai_Keiyunasi  ){
		m_jikokuChakujikoku.setNull() ;
		m_jikokuHatsujikoku.setNull() ;
	}

	//	wωƂ):adjusts
	//(ww^sȂx܂́woRȂx̏ꍇA
	//́AԐIndexEƂNULL ɂ邽)
	adjust() ;

	return *this ; 
} ;

CdDedJikoku	CentDedEkiJikoku::getChakujikoku( bool bHatsuIfNull )const
{
	if ( bHatsuIfNull && m_jikokuChakujikoku.isNull() ){
		return m_jikokuHatsujikoku ;
	}
	return m_jikokuChakujikoku ;
};

CentDedEkiJikoku& CentDedEkiJikoku::setChakujikoku( const CdDedJikoku& value )
{
	m_jikokuChakujikoku = value ; 

	//	- 	m_eEkiatsukai == Ekiatsukai_None E
	//		܂ Ekiatsukai_Keiyunasi ̉wɑ΂
	//		Êꂩ Null ݒ肷ƁAthis 
	//		m_eEkiatsukai = Ekiatsukai_Teisya ƂȂ܂B
	if ( 
		( m_eEkiatsukai == Ekiatsukai_None ||  
		  m_eEkiatsukai == Ekiatsukai_Keiyunasi ) && 
		( !m_jikokuChakujikoku.isNull() ||
		  ! m_jikokuHatsujikoku.isNull() )   ){
		m_eEkiatsukai = Ekiatsukai_Teisya ;

		//	wωƂ):adjusts
		//(ww^sȂx܂́woRȂx̏ꍇA
		//́AԐIndexEƂNULL ɂ邽)
		adjust() ;
	}
		
	return *this ;
};

CdDedJikoku	CentDedEkiJikoku::getHatsujikoku( bool bChakuIfNull )const{
	if ( bChakuIfNull && m_jikokuHatsujikoku.isNull() ){
		return m_jikokuChakujikoku ;
	}
	return m_jikokuHatsujikoku ;
};

CentDedEkiJikoku& CentDedEkiJikoku::setHatsujikoku( const CdDedJikoku& value )
{
	m_jikokuHatsujikoku = value ; 

	//- 	m_eEkiatsukai == Ekiatsukai_None E
	//	܂ Ekiatsukai_Keiyunasi ̉wɑ΂
	//	Êꂩ Null ݒ肷ƁAthis 
	//	m_eEkiatsukai = Ekiatsukai_Teisya ƂȂ܂B
	if ( 
		( m_eEkiatsukai == Ekiatsukai_None ||  
		  m_eEkiatsukai == Ekiatsukai_Keiyunasi ) && 
		( !m_jikokuChakujikoku.isNull() ||
		  ! m_jikokuHatsujikoku.isNull() )   ){
		m_eEkiatsukai = Ekiatsukai_Teisya ;

		//	wωƂ):adjusts
		//(ww^sȂx܂́woRȂx̏ꍇA
		//́AԐIndexEƂNULL ɂ邽)
		adjust() ;


	}
	return *this ;
};



CentDedEkiJikoku& CentDedEkiJikoku::set( 
		EEkiatsukai	eEkiatsukai , 
		CdDedJikoku	jikokuChakujikoku , 
		CdDedJikoku	jikokuHatsujikoku )
{
	m_eEkiatsukai = eEkiatsukai ; 
	m_jikokuChakujikoku =  jikokuChakujikoku ;
	m_jikokuHatsujikoku =  jikokuHatsujikoku ;


	if ( m_eEkiatsukai == Ekiatsukai_None ||
		m_eEkiatsukai == Ekiatsukai_Keiyunasi  )
	{
		m_jikokuChakujikoku.setNull() ;
		m_jikokuHatsujikoku.setNull() ;
	}
	//	wωƂ):adjusts
	//(ww^sȂx܂́woRȂx̏ꍇA
	//́AԐIndexEƂNULL ɂ邽)
	adjust() ;

	return ( *this ) ;
};

	// ********************************
	//@name CentDedEkiJikoku-
	// ********************************
void CentDedEkiJikoku::adjustByEkijikokukeisiki(
		bool bChakujikokuHyouji , bool bHatsujikokuHyouji ,
		bool bIsSihatsueki , bool bSyuuchakueki ) 
{
	//[w`ɒEȂA
	//  wɒȂA]
	//  ɂ͔Rs[ANULLB
	if ( bChakujikokuHyouji && !bHatsujikokuHyouji && 
		m_jikokuChakujikoku.isNull() && !m_jikokuHatsujikoku.isNull() )
	{
		m_jikokuChakujikoku = m_jikokuHatsujikoku ;
		m_jikokuHatsujikoku.setNull() ;
	}
	//[w`ɒȂE
	//  wɒAȂ]
	//  ɂ͒Rs[ANULLB
	else if ( !bChakujikokuHyouji && bHatsujikokuHyouji && 
		!m_jikokuChakujikoku.isNull() && m_jikokuHatsujikoku.isNull() )
	{
		m_jikokuHatsujikoku = m_jikokuChakujikoku ;
		m_jikokuChakujikoku.setNull() ;
	}
	//[wnwE
	//  w`ɒEA
	//  wɒAȂ]
	//  ɂ͒Rs[ANULLB
	else if ( bIsSihatsueki && 
		bChakujikokuHyouji && bHatsujikokuHyouji && 
		!m_jikokuChakujikoku.isNull() && m_jikokuHatsujikoku.isNull() )
	{
		m_jikokuHatsujikoku = m_jikokuChakujikoku ;
		m_jikokuChakujikoku.setNull() ;
	}
	//[wIwE
	//  w`ɒE
	//  wɒȂA]
	//  ɂ͔Rs[ANULLB
	else if ( bSyuuchakueki && 
		bChakujikokuHyouji && bHatsujikokuHyouji && 
		m_jikokuChakujikoku.isNull() && !m_jikokuHatsujikoku.isNull() )
	{
		m_jikokuChakujikoku = m_jikokuHatsujikoku ;
		m_jikokuHatsujikoku.setNull() ;
	}


}

void CentDedEkiJikoku::adjust() 
{
	m_EkiJikokuTrackCont.adjust() ;
}


} //namespace entDed
