/*
	OuDia - Win32 Application Software to draw a "Train Service Planning
 Diagram" based on a "Train Timetable".

Copyright (C) 2006-2017 take-okm

This program is free software; you can redistribute it and/or modify it 
under the terms of the GNU General Public License as published by the Free 
Software Foundation; either version 3 of the License, or (at your option) 
any later version. 

This program is distributed in the hope that it will be useful, but WITHOUT 
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or 
FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for 
more details. 

You should have received a copy of the GNU General Public License along with
 this program. If not, see <http://www.gnu.org/licenses/>.

  In addition, as a special exception, take-okm
  gives permission to link the code of this program with
  the "MFC(Microsoft Foundation Class library) Version 9.0" 
  (or with modified versions of "MFC Version 9.0" that use the same license as 
  "MFC Version 9.0" ), and distribute linked combinations including
  the two.  You must obey the GNU General Public License in all
  respects for all of the code used other than  "MFC".  If you modify
  this file, you may extend this exception to your version of the
  file, but you are not obligated to do so.  If you do not wish to
  do so, delete this exception statement from your version.


(: 

	OuDia - Ԏ\ƂɁA_CO`悷Win32AvP[V
B

Copyright (C) 2006-2017 take-okm 

̃vO̓t[\tgEFAłBȂ͂At[\tgEFA
cɂĔsꂽGNU ʌOp(o[W3Aȍ~̃o[W
̂ǂꂩ)߂̉ōĔЕz܂͉ 邱Ƃł܂B

̃vO͗Lpł邱ƂĔЕz܂A*S̖ۏ *łB
Ɖ\̕ۏ؂ړIւ̓ḰAOɎꂽ̂ ܂߁AS
܂BڂGNU ʌOpB

Ȃ͂̃vOƋɁAGNU ʌOp̃Rs[ꕔ 󂯎
Ă͂łB󂯎ĂȂ΁A<http://www.gnu.org/licenses/> 
B

)

  āAʂȗOƂāAtake-okm ͂̃vÕR[h 
  "MFC(Microsoft Foundation Class library) Version 9.0" 
  (  邢 "MFC Version 9.0" ƓCZXKpꂽ
  "MFC Version 9.0" ̉ςꂽo[W)ƃNA
  Nꂽ҂܂ތ앨Еz鋖^܂B
  Ȃ "MFC" ȊOŎgĂ邷ׂ
  ̃R[hɊւĂ͑SʓIGNUʌOp_񏑂ɏ]Ȃ
  Ȃ܂BȂ̃t@CςȂ΁AȂ̗͂O
  Ȃ̃o[W̃t@CɈ݂邱Ƃł܂A
  `͂܂BO݂Ȃ΁A̗O
  Ȃ̃o[W͍폜ĂB)
*/
/** @file */
//$Id: CentDedEkiJikokuTrack.cpp 378 2016-11-16 21:10:54Z okm $

#include "stdafx.h"
#include "CentDedEkiJikokuTrack.h"
#include "CentDedEkiJikokuTrackCont.h"
#include "CentDedEki.h"
#include "CentDedEkiJikokuCont.h"
#include "CentDedRessya.h"
#include "CentDedRosen.h"

namespace entDed{


	// ********************************
	//	RXgN^
	// ********************************
CentDedEkiJikokuTrack::CentDedEkiJikokuTrack() 
{
}
CentDedEkiJikokuTrack::CentDedEkiJikokuTrack( 
		CdDedJikoku nyusenJikoku ,
		CentDedEkiTrackSelector track ) 
		: m_NyusenJikoku( nyusenJikoku )
		, m_Track( track )
{
}

CentDedEkiJikokuTrack& 
CentDedEkiJikokuTrack::operator=( const CentDedEkiJikokuTrack& value ) 
{
	CentDedEkiJikokuTrackCont* pEkiJikokuTrackCont = dynamic_cast<CentDedEkiJikokuTrackCont*>( getParent() ) ;
	if ( pEkiJikokuTrackCont != NULL )
	{
		int iResult = pEkiJikokuTrackCont->setable( value , pEkiJikokuTrackCont->getIndex( this ) ) ;
		if ( iResult < 0 ){
			throw( LException() ) ;
		}
	}
	super::operator=( value ) ; 
	// --------------------------------
	m_NyusenJikoku = value.m_NyusenJikoku ;
	m_Track = value.m_Track ;

	return *this ;
}
	// ********************************
	//@name CParentBase-
	// ********************************
void CentDedEkiJikokuTrack::setParent( CParentBase* pParent )
{
	super::setParent( pParent ) ;
	adjust() ;
}

	// ********************************
	//@name CentDedEkiJikokuTrack-
	// ********************************
CdDedJikoku CentDedEkiJikokuTrack::getNyusenJikoku()const
{ return m_NyusenJikoku ;}

void CentDedEkiJikokuTrack::setNyusenJikoku( const CdDedJikoku value )
{ 
	//setNyusenJikoku:CentDedEkiJikokuTrack wwẍꕔłꍇŁA
	//@ww^sȂx܂́woRȂx̏ꍇANULLȊO̎̐ݒ̓G[(O)
	CentDedEkiJikokuTrackCont* pEkiJikokuTrackCont = dynamic_cast<CentDedEkiJikokuTrackCont*>( getParent() ) ;
	if ( pEkiJikokuTrackCont != NULL )
	{
		CentDedEkiJikoku* pEkiJikoku = pEkiJikokuTrackCont->getEkiJikoku() ;
		if ( pEkiJikoku != NULL )
		{
			if ( pEkiJikoku->getEkiatsukai() == CentDedEkiJikoku::Ekiatsukai_None
				|| pEkiJikoku->getEkiatsukai() == CentDedEkiJikoku::Ekiatsukai_Keiyunasi )
			{
				if ( !value.isNull() )
				{
					throw( LException() ) ;
				}
			}
		}
	}

	m_NyusenJikoku = value ;
}
	
CentDedEkiTrackSelector CentDedEkiJikokuTrack::getTrack()const
{ return m_Track ;}

void CentDedEkiJikokuTrack::setTrack( const CentDedEkiTrackSelector& value )
{ 
	// CentDedEkiJikokuTrack H(CentDedRosen)̈ꕔł
	//ꍇŁAԐwqwԐReixCentDedEkiTrackCont ̗vfɑΉ
	//Ȃꍇ̓G[B(OX[)
	CentDedEkiJikokuTrackCont* pEkiJikokuTrackCont = dynamic_cast<CentDedEkiJikokuTrackCont*>( getParent() ) ;
	if ( pEkiJikokuTrackCont != NULL )
	{
	
		const CentDedEki* pEki = pEkiJikokuTrackCont->getEki() ;
		if ( pEki != NULL )
		{
			const CentDedEkiTrackCont* pEkTrackCont = pEki->getEkiTrackCont() ;
			if ( !value.isNull() && value.getiIndex() >= pEkTrackCont->size() )
			{
				throw( LException() ) ;	//	ԐIndexACentDedEkiTrackCont̗vfɑΉĂ܂
			}
		}
	}
	//setEkiTrack:CentDedEkiJikokuTrack wwẍꕔłꍇŁA
	//@ww^sȂx܂́woRȂx̏ꍇANULLȊO̔Ԑ̐ݒ̓G[(O)
	if ( pEkiJikokuTrackCont != NULL )
	{
		CentDedEkiJikoku* pEkiJikoku = pEkiJikokuTrackCont->getEkiJikoku() ;
		if ( pEkiJikoku != NULL )
		{
			if ( pEkiJikoku->getEkiatsukai() == CentDedEkiJikoku::Ekiatsukai_None
				|| pEkiJikoku->getEkiatsukai() == CentDedEkiJikoku::Ekiatsukai_Keiyunasi )
			{
				if ( !value.isNull() )
				{
					throw( LException() ) ;
				}
			}
		}
	}

	// --------------------------------
	m_Track = value ;
}

	// ********************************
	//@name CentDedEkiJikokuTrack-
	// ********************************
void CentDedEkiJikokuTrack::adjust() 
{
	//CentDedEkiJikokuTrack H(CentDedRosen)̈ꕔłꍇŁA
	//ԐwqwԐReixCentDedEkiTrackCont ̗vf
	//ΉĂȂꍇ́AwwȂxɕύX
	CentDedEkiJikokuTrackCont* pEkiJikokuTrackCont = dynamic_cast<CentDedEkiJikokuTrackCont*>( getParent() ) ;
	if ( pEkiJikokuTrackCont != NULL )
	{
		const CentDedEki* pEki = pEkiJikokuTrackCont->getEki() ;
		if ( pEki != NULL )
		{
			const CentDedEkiTrackCont* pEkTrackCont = pEki->getEkiTrackCont() ;
			if ( !this->m_Track.isNull() && this->m_Track.getiIndex() >= pEkTrackCont->size() )
			{
				this->m_Track.setNull() ;	//	ԐIndexACentDedEkiTrackCont̗vfɑΉĂ܂
			}
		}
	}

	//CentDedEkiJikokuTrack wwẍꕔłꍇŁA
	//@ww^sȂx܂́woRȂx̏ꍇAENULLB
	//@́AԐIndexEƂNULLݒ肷B
	if ( pEkiJikokuTrackCont != NULL )
	{
		CentDedEkiJikoku* pEkiJikoku = pEkiJikokuTrackCont->getEkiJikoku() ;
		if ( pEkiJikoku != NULL )
		{
			if ( pEkiJikoku->getEkiatsukai() == CentDedEkiJikoku::Ekiatsukai_None
				|| pEkiJikoku->getEkiatsukai() == CentDedEkiJikoku::Ekiatsukai_Keiyunasi )
			{
				m_Track.setNull() ;
				m_NyusenJikoku.setNull() ;
			}
		}
	}
}
	
	
	// ********************************
	//@name CentDedRosen-qIuWFNg̑̒ʒm
	// ********************************
void CentDedEkiJikokuTrack::onEkiTrackInsert( int iEkiTrackIndex )
{
	//Ԑ̒ǉ(OnInsertEkiTrack):wIuWFNg̔Ԑwq̎w
	//CfNX̏ꍇACfNX́AReiւ̒ǉɍ킹ăVtgB
	if ( !m_Track.isNull() && m_Track.getiIndex() >= iEkiTrackIndex )
	{
		m_Track.setIndex( m_Track.getiIndex() + 1 ) ;
	}
}

void CentDedEkiJikokuTrack::onEkiTrackErase( int iEkiTrackIndex )
{
	//Ԑ̍폜(OnEraseEkiTrack):wIuWFNg̔Ԑwq̎w
	//CfNX̏ꍇACfNX́AReiւ̍폜ɍ킹ăVtgB
	//@wIuWFNg̔Ԑwq̎wCfNXŁA
	// CfNX폜Ώۂ̂̂łꍇAwwȂxɕύX
	if ( !m_Track.isNull() )
	{
		if ( m_Track.getiIndex() > iEkiTrackIndex )
		{
			m_Track.setIndex( m_Track.getiIndex() - 1 ) ;
		}
		else if ( m_Track.getiIndex() == iEkiTrackIndex )
		{
			m_Track.setNull() ;
		}
	}
}









} //namespace entDed


