/*
	OuDia - Win32 Application Software to draw a "Train Service Planning
 Diagram" based on a "Train Timetable".

Copyright (C) 2006-2017 take-okm

This program is free software; you can redistribute it and/or modify it 
under the terms of the GNU General Public License as published by the Free 
Software Foundation; either version 3 of the License, or (at your option) 
any later version. 

This program is distributed in the hope that it will be useful, but WITHOUT 
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or 
FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for 
more details. 

You should have received a copy of the GNU General Public License along with
 this program. If not, see <http://www.gnu.org/licenses/>.

  In addition, as a special exception, take-okm
  gives permission to link the code of this program with
  the "MFC(Microsoft Foundation Class library) Version 9.0" 
  (or with modified versions of "MFC Version 9.0" that use the same license as 
  "MFC Version 9.0" ), and distribute linked combinations including
  the two.  You must obey the GNU General Public License in all
  respects for all of the code used other than  "MFC".  If you modify
  this file, you may extend this exception to your version of the
  file, but you are not obligated to do so.  If you do not wish to
  do so, delete this exception statement from your version.


(: 

	OuDia - Ԏ\ƂɁA_CO`悷Win32AvP[V
B

Copyright (C) 2006-2017 take-okm 

̃vO̓t[\tgEFAłBȂ͂At[\tgEFA
cɂĔsꂽGNU ʌOp(o[W3Aȍ~̃o[W
̂ǂꂩ)߂̉ōĔЕz܂͉ 邱Ƃł܂B

̃vO͗Lpł邱ƂĔЕz܂A*S̖ۏ *łB
Ɖ\̕ۏ؂ړIւ̓ḰAOɎꂽ̂ ܂߁AS
܂BڂGNU ʌOpB

Ȃ͂̃vOƋɁAGNU ʌOp̃Rs[ꕔ 󂯎
Ă͂łB󂯎ĂȂ΁A<http://www.gnu.org/licenses/> 
B

)

  āAʂȗOƂāAtake-okm ͂̃vÕR[h 
  "MFC(Microsoft Foundation Class library) Version 9.0" 
  (  邢 "MFC Version 9.0" ƓCZXKpꂽ
  "MFC Version 9.0" ̉ςꂽo[W)ƃNA
  Nꂽ҂܂ތ앨Еz鋖^܂B
  Ȃ "MFC" ȊOŎgĂ邷ׂ
  ̃R[hɊւĂ͑SʓIGNUʌOp_񏑂ɏ]Ȃ
  Ȃ܂BȂ̃t@CςȂ΁AȂ̗͂O
  Ȃ̃o[W̃t@CɈ݂邱Ƃł܂A
  `͂܂BO݂Ȃ΁A̗O
  Ȃ̃o[W͍폜ĂB)
*/
/** @file */
//$Id: CentDedEkiTrack.h 378 2016-11-16 21:10:54Z okm $
#ifndef  entDed_CentDedEkiTrack_h
#define  entDed_CentDedEkiTrack_h

#include <string>
#include "NsMu\CChildBase.h"

namespace entDed{

using namespace std ;
using namespace OuLib::NsMu ;

/**
@brief
  ẃwԐx\܂
  
  wԐxɂ́Aȉ3킪܂B
  
 - {
 - {
 - OԐ
 


 -------------------------------- 

@̃IuWFNgwԐReix(CentDedEkiTrackCont)̈ꕔłꍇAԐ̎ނύX邱Ƃ͂ł܂B

̃G[EC
 -------------------------------- 

㏑(operator=) : ̃IuWFNgAeIuWFNgCentDedEkiTrackCont ̎qłꍇŁA CentDedEkiTrackCont::set() ŃG[ɂȂꍇAOX[ɂȂ܂B

eIuWFNg̕ύX(setParent()):  adjust()s

ɍ悤ɑC(adjust)
 -------------------------------- 

@ɂȂ

*/
class CentDedEkiTrack : public CChildBase
{
	typedef CChildBase	super ;
public:
	// ****************************************************************
	//	Ci[^Cv
	// ****************************************************************
	
	/**
	 Ԑ̎
	*/
	enum ETrackType
	{
		/// {
		ETrackType_NoboriMain , 
		/// {
		ETrackType_KudariMain , 
		/// OԐ
		ETrackType_Named , 
	};
	
	/**
		̃NXX[O
	*/
	class LException
	{
	};
	
public:
	// ********************************
	///@name 
	// ********************************
	///@{
	/**
		Ԑ̎
	*/
	ETrackType	m_eTrackType ;
	
	/** OBm_eTrackType  ETrackType_Named ȊȌꍇ͖ł */
	string m_strName ;
	
	///@}

public:
	// ********************************
	//	RXgN^
	// ********************************
	CentDedEkiTrack()  ;
	
	explicit CentDedEkiTrack( ETrackType eTrackType , const string& strName = "" ) ;
	/** 
		ETrackType_Named ̃IuWFNg𐶐܂ 
	@param strName
		O
	*/
	explicit CentDedEkiTrack( const string& strName ) ;

	/** 
		̃IuWFNgAeIuWFNgCentDedEkiTrackCont 
		qłꍇŁA CentDedEkiTrackCont::set() ŃG[
		ȂꍇAOX[ɂȂ܂B
	@param value 
		
	@exception LException 
	  value ނ̈قȂԐłB
	*/
	CentDedEkiTrack& operator=( const CentDedEkiTrack& value ) ;
	
	
public:
	// ********************************
	///@name CParentBase-
	// ********************************
	///@{
	/** eIuWFNg̕ύX(setParent()):  adjust()s */
	virtual void setParent( CParentBase* pParent ) ;
	///@}
public:
	// ********************************
	///@name CentDedEkiTrack-
	// ********************************
	///@{
	/** @see m_eTrackType */
	ETrackType	getTrackType()const{ return m_eTrackType ;}
	/** @see eTrackType */
	void setTrackType( ETrackType eTrackType );
	/** @see m_strName  */
	string getName()const{ return m_strName ;}
	/** @see m_strName */
	void setName( const string& value ){ m_strName = value ;}
	///@}

public:
	// ********************************
	///@name CentDedEkiTrack-
	// ********************************
	///@{
	/**
		this ̑ɔĂꍇAɍ悤ɁA
		C܂B

		̃NXł́A͂܂B

	*/
	void adjust() ;
	///@}
};

} //namespace entDed

#endif //entDed_CentDedEkiTrack_h



