/*
	OuDia - Win32 Application Software to draw a "Train Service Planning
 Diagram" based on a "Train Timetable".

Copyright (C) 2006-2017 take-okm

This program is free software; you can redistribute it and/or modify it 
under the terms of the GNU General Public License as published by the Free 
Software Foundation; either version 3 of the License, or (at your option) 
any later version. 

This program is distributed in the hope that it will be useful, but WITHOUT 
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or 
FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for 
more details. 

You should have received a copy of the GNU General Public License along with
 this program. If not, see <http://www.gnu.org/licenses/>.

  In addition, as a special exception, take-okm
  gives permission to link the code of this program with
  the "MFC(Microsoft Foundation Class library) Version 9.0" 
  (or with modified versions of "MFC Version 9.0" that use the same license as 
  "MFC Version 9.0" ), and distribute linked combinations including
  the two.  You must obey the GNU General Public License in all
  respects for all of the code used other than  "MFC".  If you modify
  this file, you may extend this exception to your version of the
  file, but you are not obligated to do so.  If you do not wish to
  do so, delete this exception statement from your version.


(: 

	OuDia - Ԏ\ƂɁA_CO`悷Win32AvP[V
B

Copyright (C) 2006-2017 take-okm 

̃vO̓t[\tgEFAłBȂ͂At[\tgEFA
cɂĔsꂽGNU ʌOp(o[W3Aȍ~̃o[W
̂ǂꂩ)߂̉ōĔЕz܂͉ 邱Ƃł܂B

̃vO͗Lpł邱ƂĔЕz܂A*S̖ۏ *łB
Ɖ\̕ۏ؂ړIւ̓ḰAOɎꂽ̂ ܂߁AS
܂BڂGNU ʌOpB

Ȃ͂̃vOƋɁAGNU ʌOp̃Rs[ꕔ 󂯎
Ă͂łB󂯎ĂȂ΁A<http://www.gnu.org/licenses/> 
B

)

  āAʂȗOƂāAtake-okm ͂̃vÕR[h 
  "MFC(Microsoft Foundation Class library) Version 9.0" 
  (  邢 "MFC Version 9.0" ƓCZXKpꂽ
  "MFC Version 9.0" ̉ςꂽo[W)ƃNA
  Nꂽ҂܂ތ앨Еz鋖^܂B
  Ȃ "MFC" ȊOŎgĂ邷ׂ
  ̃R[hɊւĂ͑SʓIGNUʌOp_񏑂ɏ]Ȃ
  Ȃ܂BȂ̃t@CςȂ΁AȂ̗͂O
  Ȃ̃o[W̃t@CɈ݂邱Ƃł܂A
  `͂܂BO݂Ȃ΁A̗O
  Ȃ̃o[W͍폜ĂB)
*/
/*
// ****************************************************************
//	CentDedRosen.cpp
// ****************************************************************
*/
#include "stdafx.h"
#include <assert.h>

#include "NsMu/CaMui.h" 
#include "CentDedRosen.h"

using namespace std ;


#ifdef _MFC_VER 
#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif
#endif

namespace entDed{

const char nameRessyasyubetsuDefault[] = "" ; 

// ----------------------------------------------------------------
//	CentDedRosen::CXCentDedEkiCont
// ----------------------------------------------------------------
	// ********************************
	//	RXgN^
	// ********************************

	// ********************************
	//	Mui
	// ********************************

int CentDedRosen::CXCentDedEkiCont::insert( const CentDedEki& element , int iIndex )
{
	int iRv = 0 ;
	if ( iRv >= 0 ){
		if ( iIndex == INT_MAX ){
			iIndex = size() ;
		}
		if ( !( 0 <= iIndex && iIndex <= size() ) ){
			iRv = -1 ;
		}
	}	
	if ( iRv >= 0 ){
		iRv = super::insert( element , iIndex ) ;
	}
	return ( iRv ) ;
}
int CentDedRosen::CXCentDedEkiCont::erase( int iIndex  , int iSize ) 
{
	int iRv = 0 ;
	
	if ( iRv >= 0 ){
		if ( iIndex == INT_MAX && iSize == INT_MAX ){
			iRv = -1 ;
		}	else if ( iIndex == INT_MAX ){
			iIndex = size() - iSize ;
		}	else if ( iSize == INT_MAX ){
			iSize = size() - iIndex ;
		}
		if ( !( 0 <= iIndex && iIndex + iSize <= size() ) ){
			iRv = -1 ;
		}
	}	
	
	if ( iRv >= 0 ){
		iRv = super::erase( iIndex , iSize ) ;
	}

	return ( iRv ) ;
};
		// ********************************
		//@name CentDedEkiCont-֘A
		// ********************************
CentDedRosen*  CentDedRosen::CXCentDedEkiCont::getRosen()
{
	CentDedRosen* pOuter = (CentDedRosen*)( ((char*)this) - offsetof( CentDedRosen , m_CentDedEkiCont ) ) ;
	return pOuter ;
}
const CentDedRosen*  CentDedRosen::CXCentDedEkiCont::getRosen()const 
{
	const CentDedRosen* pOuter = (const CentDedRosen*)( ((char*)this) - offsetof( CentDedRosen , m_CentDedEkiCont ) ) ;
	return pOuter ;
}

// ----------------------------------------------------------------
//	CentDedRosen::CXCentDedRessyasyubetsuCont
// ----------------------------------------------------------------
	// ********************************
	//	RXgN^
	// ********************************
CentDedRosen::CXCentDedRessyasyubetsuCont::	CXCentDedRessyasyubetsuCont() 
{
	//̗Ԏʂ̒ǉ́ACentDedRosen::CentDedRosen ōs܂B
}
	// ********************************
	//	Mui
	// ********************************


		// ********************************
		//@name CentDedEkiCont-֘A
		// ********************************
CentDedRosen* CentDedRosen::CXCentDedRessyasyubetsuCont::getRosen()
{
	CentDedRosen* pOuter = (CentDedRosen*)( ((char*)this) - offsetof( CentDedRosen , m_CentDedRessyasyubetsuCont ) ) ;
	return pOuter ;
}
const CentDedRosen* CentDedRosen::CXCentDedRessyasyubetsuCont:: getRosen()const 
{
	const CentDedRosen* pOuter = (const CentDedRosen*)( ((char*)this) - offsetof( CentDedRosen , m_CentDedRessyasyubetsuCont ) ) ;
	return pOuter ;
}

// ----------------------------------------------------------------
//	CentDedRosen::CXCentDedDiaCont
// ----------------------------------------------------------------
		// ********************************
		//	RXgN^
		// ********************************

		// ********************************
		//@name CentDedDiaCont-֘A
		// ********************************
CentDedRosen* CentDedRosen::CXCentDedDiaCont::getRosen()
{
	CentDedRosen* pOuter = (CentDedRosen*)( ((char*)this) - offsetof( CentDedRosen , m_CentDedDiaCont ) ) ;
	return pOuter ;
}
const CentDedRosen* CentDedRosen::CXCentDedDiaCont::getRosen()const 
{
	const CentDedRosen* pOuter = (const CentDedRosen*)( ((char*)this) - offsetof( CentDedRosen , m_CentDedDiaCont ) ) ;
	return pOuter ;
}
		

// ****************************************************************
//	CentDedRosen
// ****************************************************************

// ********************************
//	RXgN^
// ********************************
CentDedRosen::CentDedRosen() 
	: m_jikokuKitenJikoku( 0 , 0 , 0 ) 
	, m_iDiagramDgrYZahyouKyoriDefault( 60 )
{
	//	ftHǵwԎʁx̖Oݒ肵܂B
	m_CentDedRessyasyubetsuCont.insert( 
		CentDedRessyasyubetsu( nameRessyasyubetsuDefault , ""  ) , 
		INT_MAX ) ;
}
	

CentDedRosen::CentDedRosen( const CentDedRosen& value )
	: m_CentDedRessyasyubetsuCont( value.m_CentDedRessyasyubetsuCont ) 
{
	m_strName = value.m_strName ;
	m_jikokuKitenJikoku = value.m_jikokuKitenJikoku ;
	m_iDiagramDgrYZahyouKyoriDefault = value.m_iDiagramDgrYZahyouKyoriDefault ;
	m_strComment = value.m_strComment ;

	CaMui<CentDedEki>( &m_CentDedEkiCont ).insert( &value.m_CentDedEkiCont , 0 , INT_MAX , 0 ) ;
	m_CentDedDiaCont = value.m_CentDedDiaCont ;
}
	
CentDedRosen& CentDedRosen::operator=( const CentDedRosen& value )
{
	// --------------------------------
	//	܂ł̒lj
	// --------------------------------

	m_CentDedDiaCont.erase( 0 , INT_MAX ) ;

	//	ftHgԂ݂̂ɂ܂B
	m_CentDedRessyasyubetsuCont.erase( 1 , INT_MAX ) ;
	m_CentDedRessyasyubetsuCont.set( 
		CentDedRessyasyubetsu( nameRessyasyubetsuDefault , ""  ) , 
		INT_MAX ) ;

	m_CentDedEkiCont.erase( 0 , INT_MAX ) ;

	// --------------------------------
	//	lRs[
	// --------------------------------
	
	m_strName = value.m_strName ;
	m_jikokuKitenJikoku = value.m_jikokuKitenJikoku ;
	m_iDiagramDgrYZahyouKyoriDefault = value.m_iDiagramDgrYZahyouKyoriDefault ;
	m_strComment = value.m_strComment ;
	m_CentDedEkiCont = value.m_CentDedEkiCont ;
	m_CentDedRessyasyubetsuCont = value.m_CentDedRessyasyubetsuCont ;

	m_CentDedDiaCont = value.m_CentDedDiaCont ;

	return ( *this ) ;
}

	
// ********************************
//	CentDedRosen
// ********************************
	// ********************************
	//@name 
	// ********************************
	// ********************************
	//@name -CentDedEki
	// ********************************
	
	// ********************************
	//@name -CentDedRessyasyubetsu
	// ********************************

	
	// ********************************
	//@name -CentDedDia
	// ********************************

	// ********************************
	//@name 
	// ********************************
void CentDedRosen::insert( 
	const CentDedRosen& rosenToAdd_enter ,
	int iEkiIndexToInsert ) 
{
	CentDedRosen rosenToAdd = rosenToAdd_enter ;
	//gwIndex(N_)EgIndex(I_)
	//	[g悪nw]
	//@@	gwIndex=-1
	//@@	gwIndex=͂ꂽg̉wIndex
	//	[g悪ԉw]
	//@@	gwIndex=͂ꂽg̉wIndex
	//@@	gwIndex=͂ꂽg̉wIndex
	//	[g悪Iw]
	//@@	gwIndex=w-1
	//@@	gwIndex=w
	int iEkiIndexToInsertMin = -1 ;
	int iEkiIndexToInsertMax = -1 ;
	{
		//[g悪nw]
		if ( iEkiIndexToInsert == 0 )
		{
			iEkiIndexToInsertMin = -1 ;
			iEkiIndexToInsertMax = iEkiIndexToInsert ;
		}
		//[g悪ԉw]
		//	gwIndex=͂ꂽg̉wIndex
		//	gwIndex=͂ꂽg̉wIndex
		else if ( 0 < iEkiIndexToInsert &&
			iEkiIndexToInsert < getCentDedEkiCont()->size() - 1 )
		{
			iEkiIndexToInsertMin = iEkiIndexToInsert ;
			iEkiIndexToInsertMax = iEkiIndexToInsert ;
		}
		//[g悪Iw]
		//	gwIndex=w-1
		//	gwIndex=w
		else
		{
			iEkiIndexToInsertMin = getCentDedEkiCont()->size() - 1 ;
			iEkiIndexToInsertMax = getCentDedEkiCont()->size() ;
		}
	}
	//[g悪ԉw]ȂẢw𕪊
	if ( 0 < iEkiIndexToInsertMin &&
			iEkiIndexToInsertMax < getCentDedEkiCont()->size() - 1 )
	{
		//@gwIndex=͂ꂽg̉wIndex
		//@gwIndex=͂ꂽg̉wIndex+1
		iEkiIndexToInsertMax = iEkiIndexToInsertMin + 1 ;

		//@gwIndexƓwAgwIndex+1̈ʒuɒǉ
		//@gwIndex̉w͉蒅
		//@gwIndex̉w͏蒅
		{
			CentDedEkiCont* pCentDedEkiCont = getCentDedEkiCont() ;
			CentDedEki*	pDedEkiInsertMin = pCentDedEkiCont->getMuPtr()->get( iEkiIndexToInsertMin ) ;
			pCentDedEkiCont->insert( *pDedEkiInsertMin , iEkiIndexToInsertMax ) ;
			CentDedEki*	pDedEkiInsertMax = pCentDedEkiCont->getMuPtr()->get( iEkiIndexToInsertMax ) ;
			pDedEkiInsertMin->setEkijikokukeisiki( CentDedEki::Jikokukeisiki_KudariChaku ) ;
			pDedEkiInsertMax->setEkijikokukeisiki( CentDedEki::Jikokukeisiki_NoboriChaku ) ;
		}

		//S_C̃[v
		CentDedDiaCont* pCentDedDiaCont = &m_CentDedDiaCont ;
		int idxDia ;
		for ( idxDia = 0 ; idxDia < pCentDedDiaCont->size() ; idxDia ++ )
		{
			CentDedDia* pCentDedDia = pCentDedDiaCont->getMuPtr()->get( idxDia ) ;
			//ԑSԂ̃[v
			//@gwOrderEgwOrder߂
			{
				CentDedRessyaCont* pCentDedRessyaCont = pCentDedDia->getCentDedRessyaCont( Ressyahoukou_Kudari ) ;
				int iEkiOrderToInsertMin = -1 ;
				int iEkiOrderToInsertMax = -1 ;
				{
					int iEkiOrder1 = pCentDedRessyaCont->EkiOrderOfEkiIndex( iEkiIndexToInsertMin ) ;
					int iEkiOrder2 = pCentDedRessyaCont->EkiOrderOfEkiIndex( iEkiIndexToInsertMax ) ;
					iEkiOrderToInsertMin = min( iEkiOrder1 , iEkiOrder2 ) ;
					iEkiOrderToInsertMax = max( iEkiOrder1 , iEkiOrder2 ) ;
				}

				for ( int idxRessya = 0 ; idxRessya < pCentDedRessyaCont->size() ; idxRessya ++ )
				{
					CentDedRessya* pCentDedRessya = pCentDedRessyaCont->getMuPtr()->get( idxRessya ) ;
					CentDedEkiJikoku aEkiJikokuToInserMin = pCentDedRessya->getCentDedEkiJikoku( iEkiOrderToInsertMin ) ;
					CentDedEkiJikoku aEkiJikokuToInserMax = pCentDedRessya->getCentDedEkiJikoku( iEkiOrderToInsertMax ) ;

					//@[gwOrdernw̗]
					//@gwOrderɁAgOrderRs[
					//@gwOrdeŕA^sȂƂB
					if ( pCentDedRessya->getSihatsuEki() == iEkiOrderToInsertMin )
					{
						aEkiJikokuToInserMax = aEkiJikokuToInserMin ;
						aEkiJikokuToInserMin.setEkiatsukai( CentDedEkiJikoku::Ekiatsukai_None ) ;
					}
					//@[gwIndexԉw̗]
					//@@gwOrderɁAgwOrder̉wRs[
					else if ( pCentDedRessya->getSihatsuEki() < iEkiOrderToInsertMin && 
						iEkiOrderToInsertMin < pCentDedRessya->getSyuuchakuEki() ) 
					{
						aEkiJikokuToInserMax = aEkiJikokuToInserMin ;
					}
					//@[gwOrderIw̗]
					//@@gwOrdeŕÂ܂܂ƂB
					//@@gwOrdeŕA^sȂƂB
					else if ( pCentDedRessya->getSyuuchakuEki() == iEkiOrderToInsertMin )
					{
						aEkiJikokuToInserMax.setEkiatsukai( CentDedEkiJikoku::Ekiatsukai_None ) ;
					}

					pCentDedRessya->setCentDedEkiJikoku( iEkiOrderToInsertMin , aEkiJikokuToInserMin ) ;
					pCentDedRessya->setCentDedEkiJikoku( iEkiOrderToInsertMax , aEkiJikokuToInserMax ) ;
				}
			}

			//ԑSԂ̃[v
			//  @gwOrderEgwOrder߂
			{
				CentDedRessyaCont* pCentDedRessyaCont = pCentDedDia->getCentDedRessyaCont( Ressyahoukou_Nobori ) ;
				int iEkiOrderToInsertMin = pCentDedRessyaCont->EkiOrderOfEkiIndex( iEkiIndexToInsertMin ) ;
				int iEkiOrderToInsertMax = pCentDedRessyaCont->EkiOrderOfEkiIndex( iEkiIndexToInsertMax ) ;
				for ( int idxRessya = 0 ; idxRessya < pCentDedRessyaCont->size() ; idxRessya ++ )
				{
					CentDedRessya* pCentDedRessya = pCentDedRessyaCont->getMuPtr()->get( idxRessya ) ;
					CentDedEkiJikoku aEkiJikokuToInserMin = pCentDedRessya->getCentDedEkiJikoku( iEkiOrderToInsertMax ) ;
					CentDedEkiJikoku aEkiJikokuToInserMax = pCentDedRessya->getCentDedEkiJikoku( iEkiOrderToInsertMin ) ;

					//[gwOrder傪nw̗]
					//gwOrdeŕÂ܂܂ƂB
					//gwOrdeŕA^sȂƂB
					if ( pCentDedRessya->getSihatsuEki() == iEkiOrderToInsertMax )
					{
						aEkiJikokuToInserMax.setEkiatsukai( CentDedEkiJikoku::Ekiatsukai_None ) ;
					}
					//[gwIndex傪ԉw̗]
					//@gwIndexɁAgwIndex̉wRs[
					//@gwIndex̉ww`(̂)ɍ킹ĕ␳
					//@(gwIndex̔NULLɕύX)
					//@gwIndex̉ww`(̂)ɍ킹ĕ␳
					//@(gwIndex̒NULLɕύX)
					else if ( pCentDedRessya->getSihatsuEki() < iEkiOrderToInsertMax && 
						iEkiOrderToInsertMax < pCentDedRessya->getSyuuchakuEki() ) 
					{
						aEkiJikokuToInserMin = aEkiJikokuToInserMax ;
					}
					//[gwIndex傪Iw̗]
					//gwIndexɁAwRs[
					//gwIndex́A^sȂƂB
					else if ( pCentDedRessya->getSyuuchakuEki() == iEkiOrderToInsertMax )
					{
						aEkiJikokuToInserMin = aEkiJikokuToInserMax ;
						aEkiJikokuToInserMax.setEkiatsukai( CentDedEkiJikoku::Ekiatsukai_None ) ;
					}

					pCentDedRessya->setCentDedEkiJikoku( iEkiOrderToInsertMin , aEkiJikokuToInserMin ) ;
					pCentDedRessya->setCentDedEkiJikoku( iEkiOrderToInsertMax , aEkiJikokuToInserMax ) ;
				}
			}
		}
		//gwIndex̉ww`ɍ킹ĕ␳
		//@ww`ɍ킹ĕ␳
		//@@@[w`ɒEȂA
		//@  @wɒȂA]
		//@  @ɂ͔Rs[ANULLB
		//@  @[w`ɒȂE
		//@  @wɒAȂ]
		//@  @ɂ͒Rs[ANULLB
		//@  @[wnwE
		//@  @w`ɒEA
		//@  @wɒAȂ]
		//@  @ɂ͒Rs[ANULLB
		//@  @[wIwE
		//@  @@w`ɒE
		//@  @@wɒȂA]
		//@  @@ɂ͔Rs[ANULLB
		//gwIndex̉ww`ɍ킹ĕ␳
		adjustByEkijikokukeisiki( iEkiIndexToInsertMin ) ;
		adjustByEkijikokukeisiki( iEkiIndexToInsertMax ) ;
	}
	//[g悪N_w]ȂẢw̉w`[蒅]Ƃ
	//@@[gwIndex=-1,gwIndex=0]
	//@@@@gwIndex蒅Ƃ
	//  @gwIndex̉ww`ɍ킹ĕ␳
	else if ( iEkiIndexToInsertMin == -1 &&
			iEkiIndexToInsertMax == 0 )
	{
		CentDedEkiCont* pCentDedEkiCont = getCentDedEkiCont() ;
		CentDedEki*	pDedEkiInsert = pCentDedEkiCont->getMuPtr()->get( iEkiIndexToInsertMax ) ;
		pDedEkiInsert->setEkijikokukeisiki( CentDedEki::Jikokukeisiki_NoboriChaku ) ;
		adjustByEkijikokukeisiki( iEkiIndexToInsertMax ) ;
	}
	//[g悪I_w]ȂẢw̉w`[蒅]Ƃ
	//@@[g悪Index=w-1 AND gwIndex=w]
	//@@@@gwIndex蒅Ƃ
	//  @gwIndex̉ww`ɍ킹ĕ␳
	else if ( iEkiIndexToInsertMin == getCentDedEkiCont()->size() - 1 &&
			iEkiIndexToInsertMax == getCentDedEkiCont()->size() ) 
	{
		CentDedEkiCont* pCentDedEkiCont = getCentDedEkiCont() ;
		CentDedEki*	pDedEkiInsert = pCentDedEkiCont->getMuPtr()->get( iEkiIndexToInsertMin ) ;
		pDedEkiInsert->setEkijikokukeisiki( CentDedEki::Jikokukeisiki_KudariChaku ) ;
		adjustByEkijikokukeisiki( iEkiIndexToInsertMin ) ;
	}




	//wǉ
	//@@gHt@C̉wׂĒǉB
	//@@@ǉwIndex́AgwIndex+1B
	//		[gHt@C̋N_w̉w`ȊO]
	//		  ̉w̉w`[蒅]Ƃ
	//		[gHt@C̏I_w̉w`ȊO]
	//		  ̉w̉w`[蒅]Ƃ
	//@@gwIndexɁAǉwZ
	{
		CentDedEkiCont* pCentDedEkiCont = &m_CentDedEkiCont ;
		const CentDedEkiCont* pCentDedEkiContToAdd = rosenToAdd.getCentDedEkiCont() ;
		for ( int idxEki = 0 ; idxEki < pCentDedEkiContToAdd->size() ; idxEki ++ )
		{
			CentDedEki aEki = *pCentDedEkiContToAdd->getMuPtr()->get( idxEki ) ;
			if ( idxEki == 0 && aEki.getEkijikokukeisiki() != CentDedEki::Jikokukeisiki_Hatsuchaku )
			{
				aEki.setEkijikokukeisiki( CentDedEki::Jikokukeisiki_NoboriChaku ) ;
			}
			else if ( idxEki == pCentDedEkiContToAdd->size() - 1 && 
				aEki.getEkijikokukeisiki() != CentDedEki::Jikokukeisiki_Hatsuchaku )
			{
				aEki.setEkijikokukeisiki( CentDedEki::Jikokukeisiki_KudariChaku ) ;
			}

			pCentDedEkiCont->insert( 
				aEki ,
				iEkiIndexToInsertMin + 1 + idxEki ) ;


			iEkiIndexToInsertMax ++ ;

		}
	}

	//[g悪ԉw]ȂAgwIndexrwƂȂԂ́A
	//@@@@@@@@@@ǉꂽw̉woRȂɂB
	if ( 0 < iEkiIndexToInsertMin &&
			iEkiIndexToInsertMax < getCentDedEkiCont()->size() - 1 )
	{
		//@@SԂ̃[v
		//@@@@Ẽ[v
		//@@@@  @gwOrderEgwOrder߂
		//@@@@@@[nwgwOrderO AND 
		//@@@@@@@IwgwOrder]
		//@@@@@@@gwOrder+1`gwOrder-1̉w
		//@@@@@@@oRȂɂB
		CentDedDiaCont* pCentDedDiaCont = &m_CentDedDiaCont ;
		int idxDia ;
		for ( idxDia = 0 ; idxDia < pCentDedDiaCont->size() ; idxDia ++ )
		{
			CentDedDia* pCentDedDia = pCentDedDiaCont->getMuPtr()->get( idxDia ) ;
			//ԑSԂ̃[v
			//@gwOrderEgwOrder߂
			for ( int iRessyahoukou = Ressyahoukou_Kudari ;
				iRessyahoukou <= Ressyahoukou_Nobori ;
				iRessyahoukou ++ )
			{
				ERessyahoukou eRessyahoukou = (ERessyahoukou)iRessyahoukou ;

				CentDedRessyaCont* pCentDedRessyaCont = pCentDedDia->getCentDedRessyaCont( eRessyahoukou ) ;
				int iEkiOrderToInsertMin = -1 ;
				int iEkiOrderToInsertMax = -1 ;
				{
					int iEkiOrder1 = pCentDedRessyaCont->EkiOrderOfEkiIndex( iEkiIndexToInsertMin ) ;
					int iEkiOrder2 = pCentDedRessyaCont->EkiOrderOfEkiIndex( iEkiIndexToInsertMax ) ;
					iEkiOrderToInsertMin = min( iEkiOrder1 , iEkiOrder2 ) ;
					iEkiOrderToInsertMax = max( iEkiOrder1 , iEkiOrder2 ) ;
				}

				for ( int idxRessya = 0 ; idxRessya < pCentDedRessyaCont->size() ; idxRessya ++ )
				{
					//@@@@@@[nwgwOrderO AND 
					//@@@@@@@IwgwOrder]
					//@@@@@@@gwOrder+1`gwOrder-1̉w
					//@@@@@@@oRȂɂB
					CentDedRessya* pCentDedRessya = pCentDedRessyaCont->getMuPtr()->get( idxRessya ) ;
					if ( pCentDedRessya->getSihatsuEki() < iEkiOrderToInsertMin && 
						iEkiOrderToInsertMax < pCentDedRessya->getSyuuchakuEki() )
					{

						CentDedEkiJikoku aEkijikokuKeiyunasi( 
							CentDedEkiJikoku::Ekiatsukai_Keiyunasi ,
							CdDedJikoku() , CdDedJikoku() ) ;
						for ( int iEkiOrder = iEkiOrderToInsertMin + 1 ;
							iEkiOrder <= iEkiOrderToInsertMax - 1 ;
							iEkiOrder ++ )
						{
							pCentDedRessya->setCentDedEkiJikoku( iEkiOrder ,aEkijikokuKeiyunasi ) ; 
						}
					}
				}
			}
		}
	}
	//Ԏʂ̃}[W
	//@@gHt@C̗Ԏʂɂ郋[v
	//@@@@[̗ԎʂҏW̘Ht@Cɑ݂Ȃ]Ԏʂ
	//@@@@@ҏW̘Ht@Cɒǉ
	//@@@@ԎʑΏƕ\(gHt@C̗ԎIndex
	//@@@@@gHt@C̗ԎIndex ̑Ώƕ\쐬
	deque<int>	arRessyasyubetsuIdx_AddedToThis ;
	{
		CentDedRessyasyubetsuCont* pCentDedRessyasyubetsuCont = this->getCentDedRessyasyubetsuCont() ;
		const CentDedRessyasyubetsuCont* pCentDedRessyasyubetsuContToAdd = rosenToAdd.getCentDedRessyasyubetsuCont() ;
		

		const Mu<const CentDedRessyasyubetsu*>* muCentDedRessyasyubetsuToAdd =
				pCentDedRessyasyubetsuContToAdd->getMuPtr() ;
		for ( int idxToAdd = 0 ; idxToAdd < muCentDedRessyasyubetsuToAdd->size() ; idxToAdd ++ )
		{
			const CentDedRessyasyubetsu* pCentDedRessyasyubetsuToAdd = 
				muCentDedRessyasyubetsuToAdd->get( idxToAdd ) ;

			Mu<CentDedRessyasyubetsu*>* muCentDedRessyasyubetsuThis =
				pCentDedRessyasyubetsuCont->getMuPtr() ;
			int idxThis = 0 ;
			for ( idxThis = 0 ; idxThis < muCentDedRessyasyubetsuThis->size() ; idxThis ++ )
			{
				const CentDedRessyasyubetsu* pCentDedRessyasyubetsuThis = muCentDedRessyasyubetsuThis->get( idxThis ) ;
				if ( pCentDedRessyasyubetsuThis->getSyubetsumei() == 
					pCentDedRessyasyubetsuToAdd->getSyubetsumei() )
				{
					break ;
				}
			}
			//idxThis = wǉHt@Cx̗Ԏ[idxToAdd] Ɠ
			//	this̗Ԏʂ̃CfNXB
			//	Ȃ΁A  muCentDedRessyasyubetsuThis->size()

			if ( idxThis == muCentDedRessyasyubetsuThis->size() )
			{
				//	̎ʂȂꍇ́A
				//	this ɒǉ܂B
				pCentDedRessyasyubetsuCont->insert( *pCentDedRessyasyubetsuToAdd ) ;
			}
			arRessyasyubetsuIdx_AddedToThis.push_back( idxThis ) ;
		}

	}
	//arRessyasyubetsuIdx_AddedToThis[ǉHt@Cx̗ԎʃCfNX] = 
	//	this̗ԎʃCfNX

	//_C̃}[W
	//@@gHt@C̃_Cɂ郋[v
	//@@@@[̃_CҏW̘Ht@Cɑ݂Ȃ]̃_C
	//@@@@@ҏW̘Ht@Cɒǉ
	//@@@@_CΏƕ\(gHt@C̃_CIndex
	//@@@@@gHt@C̃_CIndex ̑Ώƕ\쐬

	deque<int>	arDiaIdx_AddedToThis ;
	{
		CentDedDiaCont* pCentDedDiaCont = this->getCentDedDiaCont() ;
		const CentDedDiaCont* pCentDedDiaContToAdd = rosenToAdd.getCentDedDiaCont() ;
		
		const Mu<const CentDedDia*>* muCentDedDiaToAdd =
				pCentDedDiaContToAdd->getMuPtr() ;
		for ( int idxToAdd = 0 ; idxToAdd < muCentDedDiaToAdd->size() ; idxToAdd ++ )
		{
			const CentDedDia* pCentDedDiaToAdd = 
				muCentDedDiaToAdd->get( idxToAdd ) ;

			Mu<CentDedDia*>* muCentDedDiaThis =
				pCentDedDiaCont->getMuPtr() ;
			int idxThis = 0 ;
			for ( idxThis = 0 ; idxThis < muCentDedDiaThis->size() ; idxThis ++ )
			{
				const CentDedDia* pCentDedDiaThis = muCentDedDiaThis->get( idxThis ) ;
				if ( pCentDedDiaThis->getName() == 
					pCentDedDiaToAdd->getName() )
				{
					break ;
				}
			}
			//idxThis = wǉHt@Cx̃_CƓ
			//	this̃_C̃CfNXB
			//	Ȃ΁A  muCentDedDiaThis->size()

			if ( idxThis == muCentDedDiaThis->size() )
			{
				//	̃_CȂꍇ́A
				//	this 
				//	Ԃ̃_Cǉ܂B
				//	i_CIuWFNg𒼐ڒǉƁAԂǉ邽߁A
				//	܂܂) 
				CentDedEkiCont* pCentDedEkiCont = this->getCentDedEkiCont() ;
				CentDedRessyasyubetsuCont* pCentDedRessyasyubetsuCont = this->getCentDedRessyasyubetsuCont() ;
				CentDedDia	diaNew( pCentDedEkiCont->size() ) ;
				diaNew.setName( pCentDedDiaToAdd->getName() ) ;
				pCentDedDiaCont->insert( diaNew ) ;
			}
			arDiaIdx_AddedToThis.push_back( idxThis ) ;
		}

	}
	//arDiaIdx_AddedToThis[ǉHt@Cx̃_CCfNX] = 
	//	this̃_CCfNX

	//gHt@C̗ԂAҏW̘Ht@Cɒǉ
	//@@gHt@C̃_Cɂ郋[v
	//@@@@SԂ̃[v
	//@@@@@@ԂǉB
	//@@@@@@@ǉ_ĆA_CΏƕ\ɂĕϊ
	//@@@@@@@ԎIndex́AԎʑΏƕ\ɏ]ĕϊ
	//
	{
		const Mu<const CentDedDia*>* muCentDedDiaToAdd =
			((const CentDedDiaCont*)rosenToAdd.getCentDedDiaCont())->getMuPtr() ;

		for ( int idxDiaToAdd = 0 ; idxDiaToAdd < muCentDedDiaToAdd->size() ; idxDiaToAdd ++ )
		{
			const CentDedDia* pCentDedDiaToAdd = muCentDedDiaToAdd->get( idxDiaToAdd ) ;

			Mu<CentDedDia*>* muCentDedDiaThis =	this->getCentDedDiaCont()->getMuPtr() ;
			CentDedDia* pCentDedDiaThis = muCentDedDiaThis->get( arDiaIdx_AddedToThis[idxDiaToAdd] ) ;
			//pCentDedDiaThis = Ԃ̃Rs[ƂȂ CentDedDia ;

			//ԁ
			for ( int idxRessyahoukou = (int)Ressyahoukou_Kudari ;
				idxRessyahoukou <= (int)Ressyahoukou_Nobori ;
				idxRessyahoukou ++ )
			{

				ERessyahoukou eRessyahoukou = (ERessyahoukou)idxRessyahoukou ;
				const CentDedRessyaCont* pCentDedRessyaContToAdd = pCentDedDiaToAdd->getCentDedRessyaCont( eRessyahoukou ) ;
				const Mu<const CentDedRessya*>* muCentDedRessyaToAdd = pCentDedRessyaContToAdd->getMuPtr() ;
				CentDedRessyaCont* pCentDedRessyaContThis = pCentDedDiaThis->getCentDedRessyaCont( eRessyahoukou ) ;

				int iEkiOrderToInsert = -1 ;
				if ( eRessyahoukou == Ressyahoukou_Kudari )
				{
					iEkiOrderToInsert = pCentDedRessyaContThis->EkiOrderOfEkiIndex( iEkiIndexToInsertMin + 1 ) ;
				}
				else
				{
					iEkiOrderToInsert = pCentDedRessyaContThis->EkiOrderOfEkiIndex( iEkiIndexToInsertMax - 1 ) ;
				}
				//iEkiOrderToInsert = gHt@C̉wOrder0̗Ԃ}A
				//	this̉wOrder

				for ( int idxRessyaToAdd = 0 ; idxRessyaToAdd < muCentDedRessyaToAdd->size() ; idxRessyaToAdd ++ )
				{
					//	ݕҏW̘Ht@CɁAgHt@C̗Ԃ}
					//	ԎʁEẃÂƂɏC
					const CentDedRessya* pRessyaToAdd = muCentDedRessyaToAdd->get( idxRessyaToAdd ) ;
					pCentDedRessyaContThis->insert( *pRessyaToAdd ) ;
					CentDedRessya* pRessyaAdded = pCentDedRessyaContThis->getMuPtr()->get( INT_MAX ) ;
					//pRessyaAdded = gHt@Cɒǉꂽ
					//	ԎʁEẃÂƂɏC

					//	ԎʃCfNXA
					//	ݕҏW̘Ht@Cɍ킹čXVB
					pRessyaAdded->setRessyasyubetsuIndex( 
						arRessyasyubetsuIdx_AddedToThis[ pRessyaToAdd->getRessyasyubetsuIndex() ] ) ;

					//	wC
					for ( int iEkiOrder = 0 ; iEkiOrder < pCentDedRessyaContThis->getEkiCount() ; iEkiOrder ++ )
					{
						int iEkiOrderToAdd = iEkiOrder - iEkiOrderToInsert ;
						//iEkiOrderToAdd = thisiEkiOrderɑΉA
						//	gHt@C̉wOrder

						if ( 0 <= iEkiOrderToAdd && iEkiOrderToAdd < pCentDedRessyaContToAdd->getEkiCount() )
						{
							//	gHt@C̉wOrderɑΉꍇ́A
							//	gHt@C̉wRs[
							CentDedEkiJikoku aEkiJikokuToAdd = pRessyaToAdd->getCentDedEkiJikoku( iEkiOrderToAdd ) ; 
							pRessyaAdded->setCentDedEkiJikoku( iEkiOrder , aEkiJikokuToAdd ) ; 
						}
						else
						{
							//	gHt@C̉wOrderɑΉȂwɑ΂ẮA
							//	^sȂݒ
							pRessyaAdded->setCentDedEkiJikoku( iEkiOrder , CentDedEkiJikoku() ) ; 
						}
					}


				}
			}	
		}
	}


	//[gwIndexƑgwIndex+1ŁAw]w𕹍
	if ( 0 <= iEkiIndexToInsertMin )
	{
		CentDedEkiCont* pCentDedEkiContThis = getCentDedEkiCont() ;
		CentDedEki*	pEkiToInsertMin = pCentDedEkiContThis->getMuPtr()->get( iEkiIndexToInsertMin ) ;
		CentDedEki*	pEkiToInsertMin_1 = pCentDedEkiContThis->getMuPtr()->get( iEkiIndexToInsertMin + 1 ) ;
		if ( pEkiToInsertMin->getEkimei() == pEkiToInsertMin_1->getEkimei() )
		{
			//@@gwIndex̉w`𔭒ɕύX
			pEkiToInsertMin->setEkijikokukeisiki( CentDedEki::Jikokukeisiki_Hatsuchaku ) ;

			//@@S_C̃[v
			//        SԂ̃[v
			//@@@@@@[gwIndex^sȂ]
			//@@@@@@@gwIndex+1̉wgwIndexɃRs[
			//@@@@SԂ̃[v
			//@@@@@@[gwIndex^sȂ]
			//@@@@@@@gwIndex+1̉wgwIndexɃRs[
			CentDedDiaCont* pCentDedDiaCont = this->getCentDedDiaCont() ;
			for ( int idxDia = 0 ; idxDia < pCentDedDiaCont->size() ; idxDia ++ )
			{
				CentDedDia* pDia = pCentDedDiaCont->getMuPtr()->get( idxDia ) ;
				for ( int iRessyahoukou = Ressyahoukou_Kudari ;
					iRessyahoukou <= Ressyahoukou_Nobori ;
					iRessyahoukou ++ )
				{
					ERessyahoukou eRessyahoukou = (ERessyahoukou)iRessyahoukou ;

					CentDedRessyaCont* pRessyaCont = pDia->getCentDedRessyaCont( eRessyahoukou ) ;
					int iEkiOrderToInsertMin = pRessyaCont->EkiOrderOfEkiIndex( iEkiIndexToInsertMin ) ;
					int iEkiOrderToInsertMin_1 = pRessyaCont->EkiOrderOfEkiIndex( iEkiIndexToInsertMin + 1 ) ;
					for ( int idxRessya = 0 ; idxRessya < pRessyaCont->size() ; idxRessya ++ )
					{
						CentDedRessya* pRessya = pRessyaCont->getMuPtr()->get( idxRessya ) ;
						
						CentDedEkiJikoku aEkijikoku = pRessya->getCentDedEkiJikoku( iEkiOrderToInsertMin ) ;
						if ( aEkijikoku.getEkiatsukai() == CentDedEkiJikoku::Ekiatsukai_None )
						{
							aEkijikoku = pRessya->getCentDedEkiJikoku( iEkiOrderToInsertMin_1 ) ;
							pRessya->setCentDedEkiJikoku( iEkiOrderToInsertMin ,aEkijikoku ) ;
						}
					}
				}
			}
			//@@gwIndex+1̉w폜
			pCentDedEkiContThis->erase( iEkiIndexToInsertMin + 1 ) ;
			iEkiIndexToInsertMax -- ;
		}
	}

	//[gwIndexƑgwIndex-1ŁAw]w𕹍
	if ( iEkiIndexToInsertMax < getCentDedEkiCont()->size() - 1 )
	{
		CentDedEkiCont* pCentDedEkiContThis = getCentDedEkiCont() ;
		CentDedEki*	pEkiToInsertMax = pCentDedEkiContThis->getMuPtr()->get( iEkiIndexToInsertMax ) ;
		CentDedEki*	pEkiToInsertMax_1 = pCentDedEkiContThis->getMuPtr()->get( iEkiIndexToInsertMax - 1 ) ;
		if ( pEkiToInsertMax->getEkimei() == pEkiToInsertMax_1->getEkimei() )
		{
			//gwIndex̉w`𔭒ɕύX
			pEkiToInsertMax->setEkijikokukeisiki( CentDedEki::Jikokukeisiki_Hatsuchaku ) ;
			//S_C̃[v
			//@@SԂ̃[v
			//@@@@[gwIndex傪^sȂ]
			//@@@@@gwIndex-1̉wgwIndexɃRs[
			//@@SԂ̃[v
			//@@@@[gwIndex傪^sȂ]
			//@@@@@gwIndex-1̉wgwIndexɃRs[
			CentDedDiaCont* pCentDedDiaCont = this->getCentDedDiaCont() ;
			for ( int idxDia = 0 ; idxDia < pCentDedDiaCont->size() ; idxDia ++ )
			{
				CentDedDia* pDia = pCentDedDiaCont->getMuPtr()->get( idxDia ) ;
				for ( int iRessyahoukou = Ressyahoukou_Kudari ;
					iRessyahoukou <= Ressyahoukou_Nobori ;
					iRessyahoukou ++ )
				{
					ERessyahoukou eRessyahoukou = (ERessyahoukou)iRessyahoukou ;

					CentDedRessyaCont* pRessyaCont = pDia->getCentDedRessyaCont( eRessyahoukou ) ;
					int iEkiOrderToInsertMax = pRessyaCont->EkiOrderOfEkiIndex( iEkiIndexToInsertMax ) ;
					int iEkiOrderToInsertMax_1 = pRessyaCont->EkiOrderOfEkiIndex( iEkiIndexToInsertMax - 1 ) ;
					for ( int idxRessya = 0 ; idxRessya < pRessyaCont->size() ; idxRessya ++ )
					{
						CentDedRessya* pRessya = pRessyaCont->getMuPtr()->get( idxRessya ) ;
						
						CentDedEkiJikoku aEkijikoku = pRessya->getCentDedEkiJikoku( iEkiOrderToInsertMax ) ;
						if ( aEkijikoku.getEkiatsukai() == CentDedEkiJikoku::Ekiatsukai_None )
						{
							aEkijikoku = pRessya->getCentDedEkiJikoku( iEkiOrderToInsertMax_1 ) ;
							pRessya->setCentDedEkiJikoku( iEkiOrderToInsertMax ,aEkijikoku ) ;
						}
					}
				}
			}
			//@@gwIndex-1̉w폜
			pCentDedEkiContThis->erase( iEkiIndexToInsertMax - 1 ) ;
			iEkiIndexToInsertMax -- ;
		}
	}
	//AwǉHt@Cx̃RgAwݕҏWĂHt@Cx̃Rg̖ɒǉB
	{
		string strComment = this->getComment() ;
		strComment += "\n\n" ;
		strComment += rosenToAdd.getComment() ;
		this->setComment( strComment ) ;
	}
}

CentDedRosen CentDedRosen::createSubRosen( 
		int iEkiIndex , int iEkiCount )const 
{
	CentDedRosen rosenNew = *this ;
	/*	
	(1)@VHt@ĆA
	wݕҏWĂHt@CxA
	w肳ꂽ͈͈ȊỎw폜̂ɂȂ܂B
	*/
	{
		//	wVHt@Cx̏I_̉w폜
		rosenNew.getCentDedEkiCont()->erase( iEkiIndex + iEkiCount , INT_MAX ) ;
		//	wVHt@Cx̋N_̉w폜
		rosenNew.getCentDedEkiCont()->erase( 0 , iEkiIndex ) ;
	}
	/*
	(2)@VH^]ԂɊ܂܂ȂԂ́A폜܂B
	*/
	{
		Mu<CentDedDia*>* muCentDedDia = rosenNew.getCentDedDiaCont()->getMuPtr() ;

		for ( int idxDia = 0 ; idxDia < muCentDedDia->size() ; idxDia ++ )
		{
			CentDedDia* pCentDedDia = muCentDedDia->get( idxDia ) ;
			//pCentDedDia = ΏۂƂȂ_C

			//ԁ
			for ( int idxRessyahoukou = (int)Ressyahoukou_Kudari ;
				idxRessyahoukou <= (int)Ressyahoukou_Nobori ;
				idxRessyahoukou ++ )
			{
				ERessyahoukou eRessyahoukou = (ERessyahoukou)idxRessyahoukou ;
				CentDedRessyaCont* pCentDedRessyaCont = pCentDedDia->getCentDedRessyaCont( eRessyahoukou ) ;

				for ( int idxRessya = 0 ; idxRessya < pCentDedRessyaCont->size() ; idxRessya ++ )
				{
					bool bErase = false ;
					CentDedRessya* pRessya = pCentDedRessyaCont->getMuPtr()->get( idxRessya ) ;

					//	Ԃ^sĂԂȂԂ́A
					//	폜܂B
					if ( !bErase )
					{

						//	Ԃ^sĂԂ̍ŏ̉wOrder
						//	܂B
						int iEkiOrder = 0 ;
						for ( iEkiOrder = 0 ; 
							iEkiOrder < pRessya->getCentDedEkiJikokuCount() ;
							iEkiOrder ++ )
						{
							if ( pRessya->isRunBetweenNextEki( iEkiOrder ) )
							{
								break ;
							}
						}
						//iEkiOrder = Ԃ^sĂԂ̍ŏ̉wOrder
						//	Ȃꍇ́A
						//	pRessya->getCentDedEkiJikokuCount() ƓȂ܂B
						if ( iEkiOrder == pRessya->getCentDedEkiJikokuCount() )
						{
							bErase = true ;	
						}
					}


					//	Ԃ폜
					if ( bErase )
					{
						pCentDedRessyaCont->erase( idxRessya ) ;
						idxRessya -- ;
					}
				}
			}

		}
	}


	return rosenNew ;
}

void CentDedRosen::adjustByEkijikokukeisiki( int iEkiIndex ) 
{
	//S_C̃[v
	for ( int idxDia = 0 ; idxDia < m_CentDedDiaCont.size() ; idxDia ++ )
	{
		CentDedDia* pCentDedDia = m_CentDedDiaCont.getMuPtr()->get( idxDia ) ;
		pCentDedDia->adjustByEkijikokukeisiki(
			&m_CentDedEkiCont ,
			iEkiIndex ) ;
	}
}

void CentDedRosen::invert()
{
	//(0)@HIuWFNg̃Rs[쐬
	CentDedRosen	aRosenBefore = *this ;


	//(1)@Ht@C̉w̏̕яtɂ܂B
	//	ŏ̏Ԃ̘Ht@C̃Rs[AwRs[܂B
	{
		for ( int idxEki = 0 ;idxEki < m_CentDedEkiCont.size() ; idxEki ++ )
		{
			CentDedEki	aEki = aRosenBefore.getCentDedEkiCont()->get( 
				m_CentDedEkiCont.size() - idxEki - 1 ) ;

			m_CentDedEkiCont.set( aEki , idxEki ) ;
		}
	}
	//(2)@w̃vpeB́Aȉ̕ϊs܂B
	//y⑫z
	//	this ̉w̑ύXƁA܂܂ĂԂ̒E
	//	wnwEIw̉w`ύXɔAȄCx
	//	ɂAwύX܂B
	//	aRosenBefore ́A̕ύX󂯂Ỏwێ܂B
	{
		for ( int idxEki = 0 ; idxEki < m_CentDedEkiCont.size() ; idxEki ++ )  
		{
			CentDedEki*	pEki = m_CentDedEkiCont.getMuPtr()->get( idxEki ) ;

			//(2.1)w͂̂܂

			//(2.2)w`
			//	- 蒅蒅
			//	- 蒅蒅
			{
				CentDedEki::EEkijikokukeisiki eEkijikokukeisiki = pEki->getEkijikokukeisiki() ;
				if ( eEkijikokukeisiki == CentDedEki::Jikokukeisiki_KudariChaku )
				{
					eEkijikokukeisiki = CentDedEki::Jikokukeisiki_NoboriChaku ;
				}
				else if ( eEkijikokukeisiki == CentDedEki::Jikokukeisiki_NoboriChaku )
				{
					eEkijikokukeisiki = CentDedEki::Jikokukeisiki_KudariChaku ;
				}
				pEki->setEkijikokukeisiki( eEkijikokukeisiki ) ;
			}

			//(2.3)E
			//	- w̏ύXAN_(wIndex̏)1wVtgB
			//	- V葤I_(wIndex̍ł傫w)̋E͖ɂB
			{
				CentDedEki*	pEkiNext = NULL ;
				if ( idxEki + 1 < m_CentDedEkiCont.size() )
				{
					pEkiNext = m_CentDedEkiCont.getMuPtr()->get( idxEki + 1 ) ;
				}

				if ( pEkiNext != NULL )
				{
					pEki->setKyoukaisen( pEkiNext->getKyoukaisen() ) ;
				}
				else
				{
					pEki->setKyoukaisen( false ) ;
				}
			}

			//(2.4)_COԏ
			//	  ̓eƏ̓eւ܂B
			{
				CentDedEki::EDiagramRessyajouhouHyouji eRessyajouhouHyoujiKudari = pEki->getDiagramRessyajouhouHyoujiKudari() ;
				CentDedEki::EDiagramRessyajouhouHyouji eRessyajouhouHyoujiNobori = pEki->getDiagramRessyajouhouHyoujiNobori() ;
				pEki->setDiagramRessyajouhouHyoujiKudari( eRessyajouhouHyoujiNobori ) ;
				pEki->setDiagramRessyajouhouHyoujiNobori( eRessyajouhouHyoujiKudari ) ;
			}
		}
	}

	//(3)ׂẴ_CɂāAԂƏԂւ܂B
	//	̂ƂAԂUɂŁA
	//	ŏ̏(w̏̓ւsO)̘HIuWFNg̃Rs[
	//	Ԃ}܂BlłB
	//y⑫z
	//	this ̉w̑ύXƁA܂܂ĂԂ̒E
	//	wnwEIw̉w`ύXɔAȄCx
	//	ɂAwύX܂B
	//	aRosenBefore ́A̕ύX󂯂Ỏwێ܂B
	//	Rs[Ƃ邱ƂɂAw̕ύX邱Ƃł܂B
	{
		for ( int idxDia = 0 ; idxDia < m_CentDedDiaCont.size() ; idxDia ++ )
		{
			CentDedDia* pDia = m_CentDedDiaCont.getMuPtr()->get( idxDia ) ;

			//	E̗ԃReiɃA_v^t
			CaMui<CentDedRessya>	aRessyaContKudariAdapter( pDia->getCentDedRessyaCont( Ressyahoukou_Kudari ) ) ;
			CaMui<CentDedRessya>	aRessyaContNoboriAdapter( pDia->getCentDedRessyaCont( Ressyahoukou_Nobori ) ) ;

			//	ԃRei̓e폜A
			//	Ă̏Ԃ̃Rs[ǉ
			aRessyaContKudariAdapter.getAdaptee()->erase( 0 , INT_MAX ) ;
			aRessyaContKudariAdapter.insert( 
				aRosenBefore.getCentDedDiaCont()->getMuPtr()->get( idxDia )->getCentDedRessyaCont( Ressyahoukou_Nobori ) );

			//	ԃRei̓e폜A
			//	Ă̏Ԃ̃Rs[ǉ
			aRessyaContNoboriAdapter.getAdaptee()->erase( 0 , INT_MAX ) ;
			aRessyaContNoboriAdapter.insert( 
				aRosenBefore.getCentDedDiaCont()->getMuPtr()->get( idxDia )->getCentDedRessyaCont( Ressyahoukou_Kudari ) );

		}
	}


}
int CentDedRosen::swapRessyasyubetsu( int iRessyasyubetsuIndexA ,
		int iRessyasyubetsuIndexB ) 
{
	int iRv = 0 ;
	// --------------------------------
	if ( iRv >= 0 ){
		if ( iRessyasyubetsuIndexA == INT_MAX ){
			iRessyasyubetsuIndexA = m_CentDedRessyasyubetsuCont.size() - 1 ;
		}
		if ( !( 0 <= iRessyasyubetsuIndexA && 
				iRessyasyubetsuIndexA < m_CentDedRessyasyubetsuCont.size() ) ){
			iRv = -1 ;	//	CfNXs

		}
	}
	if ( iRv >= 0 ){
		if ( iRessyasyubetsuIndexB == INT_MAX ){
			iRessyasyubetsuIndexB = m_CentDedRessyasyubetsuCont.size() - 1 ;
		}
		if ( !( 0 <= iRessyasyubetsuIndexB && 
				iRessyasyubetsuIndexB < m_CentDedRessyasyubetsuCont.size() ) ){
			iRv = -1 ;	//	CfNXs

		}
	}
	if ( iRv >= 0 ){
		if ( iRessyasyubetsuIndexA == iRessyasyubetsuIndexB ){
			iRv = -1 ;	//	CfNXs
		}
	}
	// --------------------------------
	//m_CentDedRessyasyubetsuCont ̓ւ
	if ( iRv >= 0 ){
		Mu<CentDedRessyasyubetsu*>*	pIfContGet = m_CentDedRessyasyubetsuCont.getMuPtr() ;
		CentDedRessyasyubetsu	aCentDedRessyasyubetsuA = 
			*pIfContGet->get( iRessyasyubetsuIndexA ) ;
		CentDedRessyasyubetsu	aCentDedRessyasyubetsuB = 
			*pIfContGet->get( iRessyasyubetsuIndexB ) ;
		*pIfContGet->get( iRessyasyubetsuIndexA )  = 
			aCentDedRessyasyubetsuB ; 
		*pIfContGet->get( iRessyasyubetsuIndexB )  = 
			aCentDedRessyasyubetsuA ; 

		// --------------------------------
		//	Ԃ̓ւ
		// --------------------------------
		int iDiaIndex ;
		for ( iDiaIndex = 0 ; iDiaIndex < m_CentDedDiaCont.size() ; iDiaIndex ++ ){
			CentDedDia*	pCentDedDia = m_CentDedDiaCont.getMuPtr()->get( iDiaIndex ) ;
			int iRessyahoukou = 0 ;
			for ( iRessyahoukou = Ressyahoukou_Kudari ; 
					iRessyahoukou <= Ressyahoukou_Nobori ; 
					iRessyahoukou ++ ){
				ERessyahoukou	eRessyahoukou = (ERessyahoukou)iRessyahoukou ;
				
				CentDedRessyaCont* pCentDedRessyaCont = pCentDedDia->getCentDedRessyaCont( eRessyahoukou ) ;
				Mu< CentDedRessya* >* pCentDedRessyaContGet = pCentDedRessyaCont->getMuPtr() ;

				int iRessyaCount = pCentDedRessyaContGet->size() ;

				int iRessyaIndex ;

				//	iRessyasyubetsuIndexA -> iRessyasyubetsuIndexB
				//	iRessyasyubetsuIndexB -> iRessyasyubetsuIndexA 
				for ( iRessyaIndex = 0 ; 
						iRessyaIndex < iRessyaCount ; 
						iRessyaIndex ++ ){
					CentDedRessya*	pCentDedRessya = pCentDedRessyaContGet->get( iRessyaIndex ) ;
					
					int iRessyasyubetsuIndexCurr = pCentDedRessya->getRessyasyubetsuIndex() ;
					if ( iRessyasyubetsuIndexCurr == iRessyasyubetsuIndexA ){
						iRessyasyubetsuIndexCurr = iRessyasyubetsuIndexB ;	
					}	else if ( iRessyasyubetsuIndexCurr == iRessyasyubetsuIndexB ){
						iRessyasyubetsuIndexCurr = iRessyasyubetsuIndexA ;
					}
					pCentDedRessya->setRessyasyubetsuIndex( iRessyasyubetsuIndexCurr ) ;	
				}
			}
		}
	}

	return ( iRv ) ;
}

void CentDedRosen::clear() 
{
	m_strName.erase() ;
	m_jikokuKitenJikoku.setTime( 0 , 0 , 0 ) ;
	m_strComment.erase() ;

	m_CentDedDiaCont.erase( 0 , INT_MAX ) ;
	m_CentDedRessyasyubetsuCont.erase( 1 , INT_MAX ) ;
	m_CentDedEkiCont.erase( 0 , INT_MAX ) ;

	// --------------------------------
	{
		//	wԎʁx́AȂƂ݂͑ȂĂ͂Ȃ܂B
		m_CentDedRessyasyubetsuCont.set( 
			CentDedRessyasyubetsu( nameRessyasyubetsuDefault , ""  ) , 0 ) ;
	}
};


	// ********************************
	//@name CentDedRosen-qIuWFNg̑̒ʒm
	// ********************************

void CentDedRosen::onEkiInsert( int iEkiIndex )
{
	m_CentDedDiaCont.onEkiInsert( iEkiIndex ) ;
}
void CentDedRosen::onEkiErase( int iEkiIndex  )
{
	m_CentDedDiaCont.onEkiErase( iEkiIndex ) ;
}


void CentDedRosen::onEkiTrackInsert( int iEkiIndex , int iEkiTrackIndex )
{
	m_CentDedDiaCont.onEkiTrackInsert( iEkiIndex , iEkiTrackIndex ) ;
}
void CentDedRosen::onEkiTrackErase( int iEkiIndex , int iEkiTrackIndex )
{
	m_CentDedDiaCont.onEkiTrackErase( iEkiIndex , iEkiTrackIndex ) ;
}
void CentDedRosen::onRessyasyubetsuInsert( int iRessyasyubetsuIndex )
{
	m_CentDedDiaCont.onRessyasyubetsuInsert( iRessyasyubetsuIndex ) ;
}

void CentDedRosen::onRessyasyubetsuErase( int iRessyasyubetsuIndex )
{
	m_CentDedDiaCont.onRessyasyubetsuErase( iRessyasyubetsuIndex ) ;
}



} //namespace entDed
