/*
	OuDia - Win32 Application Software to draw a "Train Service Planning
 Diagram" based on a "Train Timetable".

Copyright (C) 2006-2017 take-okm

This program is free software; you can redistribute it and/or modify it 
under the terms of the GNU General Public License as published by the Free 
Software Foundation; either version 3 of the License, or (at your option) 
any later version. 

This program is distributed in the hope that it will be useful, but WITHOUT 
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or 
FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for 
more details. 

You should have received a copy of the GNU General Public License along with
 this program. If not, see <http://www.gnu.org/licenses/>.

  In addition, as a special exception, take-okm
  gives permission to link the code of this program with
  the "MFC(Microsoft Foundation Class library) Version 9.0" 
  (or with modified versions of "MFC Version 9.0" that use the same license as 
  "MFC Version 9.0" ), and distribute linked combinations including
  the two.  You must obey the GNU General Public License in all
  respects for all of the code used other than  "MFC".  If you modify
  this file, you may extend this exception to your version of the
  file, but you are not obligated to do so.  If you do not wish to
  do so, delete this exception statement from your version.


(: 

	OuDia - Ԏ\ƂɁA_CO`悷Win32AvP[V
B

Copyright (C) 2006-2017 take-okm 

̃vO̓t[\tgEFAłBȂ͂At[\tgEFA
cɂĔsꂽGNU ʌOp(o[W3Aȍ~̃o[W
̂ǂꂩ)߂̉ōĔЕz܂͉ 邱Ƃł܂B

̃vO͗Lpł邱ƂĔЕz܂A*S̖ۏ *łB
Ɖ\̕ۏ؂ړIւ̓ḰAOɎꂽ̂ ܂߁AS
܂BڂGNU ʌOpB

Ȃ͂̃vOƋɁAGNU ʌOp̃Rs[ꕔ 󂯎
Ă͂łB󂯎ĂȂ΁A<http://www.gnu.org/licenses/> 
B

)

  āAʂȗOƂāAtake-okm ͂̃vÕR[h 
  "MFC(Microsoft Foundation Class library) Version 9.0" 
  (  邢 "MFC Version 9.0" ƓCZXKpꂽ
  "MFC Version 9.0" ̉ςꂽo[W)ƃNA
  Nꂽ҂܂ތ앨Еz鋖^܂B
  Ȃ "MFC" ȊOŎgĂ邷ׂ
  ̃R[hɊւĂ͑SʓIGNUʌOp_񏑂ɏ]Ȃ
  Ȃ܂BȂ̃t@CςȂ΁AȂ̗͂O
  Ȃ̃o[W̃t@CɈ݂邱Ƃł܂A
  `͂܂BO݂Ȃ΁A̗O
  Ȃ̃o[W͍폜ĂB)
*/
/*
// ****************************************************************
//	CdColorProp.h
// ****************************************************************
*/
/** @file */
#ifndef  CdColorProp_h
#define  CdColorProp_h

#include "DcdCd\Pos\DcdType.h"

namespace DcDrawLib{
namespace DcdCd{
namespace DcDrawProp{

// ****************************************************************
//	CdColorProp
// ****************************************************************
/**
 @brief
 yTvz
	F̑ێPf[^NXłB

	CConverter_WinGdi NXgpƁACOLORREF\̂Ƃ̊Ԃőݕϊ
	sƂł܂B
*/
class CdColorProp
{
// ********************************
///@name	
// ********************************
///@{
 private:
	/**
	*	F̐Ԃ̗vfłB
	*/
	unsigned char m_iRed ;
	
	/**
	*	F̗΂̗vfłB
	*/
	unsigned char m_iGreen ;
	
	/**
	*	F̐̗vfłB
	*/
	unsigned char m_iBlue ;
	
///@}
// ********************************
//	RXgN^
// ********************************
 public:
	CdColorProp( 
		unsigned char iRed ,
		unsigned char iGreen ,
		unsigned char iBlue ) 
		: m_iRed( iRed ) 
		, m_iGreen( iGreen ) 
		, m_iBlue( iBlue )
	{};
	
	CdColorProp() 
		: m_iRed( 0 ) 
		, m_iGreen( 0 ) 
		, m_iBlue( 0 )
	{};

// ********************************
//	CdColorProp
// ********************************
public:
	// ********************************
	///@name	
	// ********************************
	///@{
	unsigned char getRed()const{	return m_iRed ;};
	CdColorProp& setRed( unsigned char value ){	m_iRed = value ; return *this ;};
	unsigned char getGreen()const{	return m_iGreen ;};
	CdColorProp& setGreen( unsigned char value ){	m_iGreen = value ; return *this ;};
	unsigned char getBlue()const{	return m_iBlue ;};
	CdColorProp& setBlue( unsigned char value ){	m_iBlue = value ; return *this ;};
	///@}


	/**
	 *	2̃IuWFNg̊eǂ𔻒肵܂B
	 * @param value [in]
	 *	ȓΏۂƂȂIuWFNgw肵ĂB
	 * @return 
	 *	value  *this Ƃ̊ԂŁAׂĂ̑ΐ^łB
	 */
	bool isEqualTo( const CdColorProp& value )const
	{
		return ( 
			m_iRed == value.m_iRed &&  
			m_iGreen == value.m_iGreen &&  
			m_iBlue == value.m_iBlue );
	};
	/**
	 *	isEqualTo() ƓłB
	 */
	bool operator==( const CdColorProp& value )const
	{	return ( isEqualTo( value ) ) ;	};	
	bool operator!=( const CdColorProp& value )const
	{	return ( !isEqualTo( value ) ) ;};	
	/**
	 *	this  b 
	 *	iOɂȂjȂ^łB
	 * @param b [in]
	 *	ȓΏۂƂȂIuWFNgw肵ĂB
	 * @return 
	 *	this  b 
	 *	iOɂȂjȂ^łB
	 */
	bool  less( const CdColorProp& value )const
	{
		if ( m_iRed != value.m_iRed )
		{
			return ( m_iRed < value.m_iRed ) ;
		}
		else if ( m_iGreen != value.m_iGreen )
		{
			return ( m_iGreen < value.m_iGreen ) ;
		}
		else if ( m_iBlue != value.m_iBlue )
		{
			return ( m_iBlue < value.m_iBlue ) ;
		}
		return ( false ) ;
	};
	/**
	 *	less() ƓłB
	 */
	bool operator<( const CdColorProp& b )const
	{	return less( b );	};
	

};

} //namespace DcDrawProp
} //namespace DcdCd
} //namespace DcDrawLib

#endif //CdColorProp_h
