/*
	OuDia - Win32 Application Software to draw a "Train Service Planning
 Diagram" based on a "Train Timetable".

Copyright (C) 2006-2017 take-okm

This program is free software; you can redistribute it and/or modify it 
under the terms of the GNU General Public License as published by the Free 
Software Foundation; either version 3 of the License, or (at your option) 
any later version. 

This program is distributed in the hope that it will be useful, but WITHOUT 
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or 
FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for 
more details. 

You should have received a copy of the GNU General Public License along with
 this program. If not, see <http://www.gnu.org/licenses/>.

  In addition, as a special exception, take-okm
  gives permission to link the code of this program with
  the "MFC(Microsoft Foundation Class library) Version 9.0" 
  (or with modified versions of "MFC Version 9.0" that use the same license as 
  "MFC Version 9.0" ), and distribute linked combinations including
  the two.  You must obey the GNU General Public License in all
  respects for all of the code used other than  "MFC".  If you modify
  this file, you may extend this exception to your version of the
  file, but you are not obligated to do so.  If you do not wish to
  do so, delete this exception statement from your version.


(: 

	OuDia - Ԏ\ƂɁA_CO`悷Win32AvP[V
B

Copyright (C) 2006-2017 take-okm 

̃vO̓t[\tgEFAłBȂ͂At[\tgEFA
cɂĔsꂽGNU ʌOp(o[W3Aȍ~̃o[W
̂ǂꂩ)߂̉ōĔЕz܂͉ 邱Ƃł܂B

̃vO͗Lpł邱ƂĔЕz܂A*S̖ۏ *łB
Ɖ\̕ۏ؂ړIւ̓ḰAOɎꂽ̂ ܂߁AS
܂BڂGNU ʌOpB

Ȃ͂̃vOƋɁAGNU ʌOp̃Rs[ꕔ 󂯎
Ă͂łB󂯎ĂȂ΁A<http://www.gnu.org/licenses/> 
B

)

  āAʂȗOƂāAtake-okm ͂̃vÕR[h 
  "MFC(Microsoft Foundation Class library) Version 9.0" 
  (  邢 "MFC Version 9.0" ƓCZXKpꂽ
  "MFC Version 9.0" ̉ςꂽo[W)ƃNA
  Nꂽ҂܂ތ앨Еz鋖^܂B
  Ȃ "MFC" ȊOŎgĂ邷ׂ
  ̃R[hɊւĂ͑SʓIGNUʌOp_񏑂ɏ]Ȃ
  Ȃ܂BȂ̃t@CςȂ΁AȂ̗͂O
  Ȃ̃o[W̃t@CɈ݂邱Ƃł܂A
  `͂܂BO݂Ȃ΁A̗O
  Ȃ̃o[W͍폜ĂB)
*/
/*
// ****************************************************************
//	CconvContentPosToTargetXy.h
// ****************************************************************
*/
/** @file */
#ifndef  DcDrawa_DcdCd_Pos_CconvContentPosToTargetXy_h
#define  DcDrawa_DcdCd_Pos_CconvContentPosToTargetXy_h
#include "DcdCd\Pos\CdDcdZoneXy.h"
#include "DcdCd\Pos\CconvContentPosToTarget.h"

namespace DcDrawLib{
namespace DcdCd{
namespace Pos{


// ****************************************************************
//	CconvContentPosToTargetXy
// ****************************************************************
/**
 @brief
  X,Y Wn̊ԂŁAContentPos(RegW)
TargetPos(^[QbgW)ɕϊ@񋟂NXłB
 */
class CconvContentPosToTargetXy
{
private:
	// ********************************
	///@name W
	// ********************************
	///@{
	/**
		X ̍Wϊ CconvContentPosToTarget IuWFNgłB
	 */
	CconvContentPosToTarget	m_convX ;
	
	/**
		Y ̍Wϊ CconvContentPosToTarget IuWFNgłB
	 */
	CconvContentPosToTarget	m_convY ;
	
	///@}
public:
	// ********************************
	//	RXgN^
	// ********************************
	/** m_convX,m_convY ̗ɁA[hݒ肵܂ */
	CconvContentPosToTargetXy( 
		CconvContentPosToTarget::EMode	eMode ) ;

	/** m_convX,m_convY  EModePosAndRate Ƃď܂B*/
	CconvContentPosToTargetXy( 
		DcdPos	iContentPosX ,
		double dTargetPosPerContentX ,
		DcdPos	iContentPosY ,
		double dTargetPosPerContentY ) ;

	/** m_convX,m_convY  EModeZone Ƃď܂B*/
	CconvContentPosToTargetXy( 
		DcdPos	iContentPosX ,
		DcdSize	iContentSizeX ,
		DcdPos	iContentPosY ,
		DcdSize	iContentSizeY ) ;

	/**
		m_convX,m_convY  EModeZone Ƃď܂B
	@param zoneContent[in]
		TargetZoneɕ\Reg̎n_Ƒ傫B
	*/
	CconvContentPosToTargetXy( 
		const CdDcdZoneXy&	zonexyContent ) ;

	CconvContentPosToTargetXy() ;

	virtual ~CconvContentPosToTargetXy() ;


public:
	// ********************************
	///@name CconvContentPosToTargetXy-W
	// ********************************
	///@{
	CconvContentPosToTarget* getX()
	{	return  &m_convX;	};
	const CconvContentPosToTarget* getX()const 
	{	return  &m_convX;	};
	CconvContentPosToTarget* getY() 
	{	return  &m_convY;	};
	const CconvContentPosToTarget* getY()const  
	{	return  &m_convY;	};
	///@}
	
	// ********************************
	///@name CconvContentPosToTargetXy-
	// ********************************
	///@{
	/**
	@return
		m_convX,m_convY ́A TargetPosւ̕ϊ[hB
	@attention
		m_convX,m_convY ŕϊ[hقȂꍇ́Å֐̖߂l
		`łB
	*/
	CconvContentPosToTarget::EMode	getMode()const ;

	/**
	@param value [in]
		m_convX,m_convY ́A TargetPosւ̕ϊ[hw肵ĂB
	*/
	void setMode( CconvContentPosToTarget::EMode	value ) ;
	
	/**
		TargetZoneɕ\Reg̎n_Ɗg嗦ݒ肷邱Ƃł܂B
	@param posContentPos [in]
		TargetPos̍ɕ`悳Content́AContentPosWB
	@param dTargetPosPerContentX [in]
		X̊g嗦BRegWṔATargetPos ̐B
	@param dTargetPosPerContentY [in]
		Y̊g嗦BRegWṔATargetPos ̐B
	@param pTargetZone[in]
		̃NXōWϊsۂɑΏۂƂȂ TargetZone w肵
		B
		m_eMode=EModePosAndRate ̂Ƃ́A̒l͏ȗ邱Ƃł܂B
		m_eMode=EModeZone ̂Ƃ͕K{łB
	@note
		l擾Ƃ́A getX() , getY() gpāA
		m_convX,m_convY ̃|C^擾ÃIuWFNg
		l擾ĂB
	*/
	void setContentPosAndRate( 
		const CdDcdPosXy& posContentPos , 
		double dTargetPosPerContentX , 
		double dTargetPosPerContentY , 
		const CdDcdZoneXy* pTargetZone ) ;
	
	/** 
		TargetZoneɕ\Reg̎n_Ƒ傫擾邱Ƃł܂B
	@param pTargetZone[in]
		̃NXōWϊsۂɑΏۂƂȂ TargetZone w肵
		B
		m_eMode=EModeZone ̂Ƃ́A̒l͏ȗ邱Ƃł܂B
		m_eMode=EModePosAndRate ̂Ƃ͕K{łB
	@return
		TargetZoneɕ\Reg̈ʒuƑ傫B
	*/
	CdDcdZoneXy getContentZone( const CdDcdZoneXy* pTargetZone ) ;

	/**
		TargetZoneɕ\Reg̎n_Ƒ傫ݒ肷邱Ƃł܂B
	@param zoneContent[in]
		TargetZoneɕ\Reg̎n_Ƒ傫B
	@param pTargetZone[in]
		̃NXōWϊsۂɑΏۂƂȂ TargetZone w肵
		B
		m_eMode=EModeZone ̂Ƃ́A̒l͏ȗ邱Ƃł܂B
		m_eMode=EModePosAndRate ̂Ƃ͕K{łB
	*/
	void setContentZone( const CdDcdZoneXy& zoneContent , const CdDcdZoneXy* pTargetZone ) ;
	///@}
	// ********************************
	///@name CconvContentPosToTargetXy-Wϊ
	// ********************************
	///@{
	/**
		ContentPos ̍W
		A
		TargetZone ̍W
		ɕϊ܂B
	@param value [in]
  		ϊO̒lw肵ĉB
	@param aTargetZone [in]
		̃NXōWϊsۂɑΏۂƂȂ TargetZone w肵
		B
	@return
  		ϊ̒lԂ܂B
	 */
	virtual CdDcdPosXy ContentPosToTarget( 
		const CdDcdPosXy& value ,
		const CdDcdZoneXy& aTargetZone ) ;
	
	/**
		TargetZone ̍W
		A
		ContentPos ̍W
		ɕϊ܂B
	@param value [in]
  		ϊO̒lw肵ĉB
	@param aTargetZone [in]
		̃NXōWϊsۂɑΏۂƂȂ TargetZone w肵
		B
	 */
	virtual CdDcdPosXy ContentPosFromTarget( 
		const CdDcdPosXy& value ,
		const CdDcdZoneXy& aTargetZone ) ;

	/**
		ContentPos ̍W
		A
		TargetZone ̍W
		ɕϊ܂B
	@param value [in]
  		ϊO̒lw肵ĉB
	@param aTargetZone [in]
		̃NXōWϊsۂɑΏۂƂȂ TargetZone w肵
		B
	 */
	virtual CdDcdZoneXy ContentZoneToTarget( 
		const CdDcdZoneXy& value ,
		const CdDcdZoneXy& aTargetZone ) ;
	
	/**
		TargetZone ̍W
		A
		ContentPos ̍W
		ɕϊ܂B
	@param value [in]
  		ϊO̒lw肵ĉB
	@param aTargetZone [in]
		̃NXōWϊsۂɑΏۂƂȂ TargetZone w肵
		B
	 */
	virtual CdDcdZoneXy ContentZoneFromTarget( 
		const CdDcdZoneXy& value ,
		const CdDcdZoneXy& aTargetZone ) ;
	///@}
};

} //namespace Pos
} //namespace DcdCd
} //namespace DcDrawLib

#endif /*DcDrawa_DcdCd_Pos_CconvContentPosToTargetXy_h*/
