/*
	OuDia - Win32 Application Software to draw a "Train Service Planning
 Diagram" based on a "Train Timetable".

Copyright (C) 2006-2017 take-okm

This program is free software; you can redistribute it and/or modify it 
under the terms of the GNU General Public License as published by the Free 
Software Foundation; either version 3 of the License, or (at your option) 
any later version. 

This program is distributed in the hope that it will be useful, but WITHOUT 
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or 
FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for 
more details. 

You should have received a copy of the GNU General Public License along with
 this program. If not, see <http://www.gnu.org/licenses/>.

  In addition, as a special exception, take-okm
  gives permission to link the code of this program with
  the "MFC(Microsoft Foundation Class library) Version 9.0" 
  (or with modified versions of "MFC Version 9.0" that use the same license as 
  "MFC Version 9.0" ), and distribute linked combinations including
  the two.  You must obey the GNU General Public License in all
  respects for all of the code used other than  "MFC".  If you modify
  this file, you may extend this exception to your version of the
  file, but you are not obligated to do so.  If you do not wish to
  do so, delete this exception statement from your version.


(: 

	OuDia - Ԏ\ƂɁA_CO`悷Win32AvP[V
B

Copyright (C) 2006-2017 take-okm 

̃vO̓t[\tgEFAłBȂ͂At[\tgEFA
cɂĔsꂽGNU ʌOp(o[W3Aȍ~̃o[W
̂ǂꂩ)߂̉ōĔЕz܂͉ 邱Ƃł܂B

̃vO͗Lpł邱ƂĔЕz܂A*S̖ۏ *łB
Ɖ\̕ۏ؂ړIւ̓ḰAOɎꂽ̂ ܂߁AS
܂BڂGNU ʌOpB

Ȃ͂̃vOƋɁAGNU ʌOp̃Rs[ꕔ 󂯎
Ă͂łB󂯎ĂȂ΁A<http://www.gnu.org/licenses/> 
B

)

  āAʂȗOƂāAtake-okm ͂̃vÕR[h 
  "MFC(Microsoft Foundation Class library) Version 9.0" 
  (  邢 "MFC Version 9.0" ƓCZXKpꂽ
  "MFC Version 9.0" ̉ςꂽo[W)ƃNA
  Nꂽ҂܂ތ앨Еz鋖^܂B
  Ȃ "MFC" ȊOŎgĂ邷ׂ
  ̃R[hɊւĂ͑SʓIGNUʌOp_񏑂ɏ]Ȃ
  Ȃ܂BȂ̃t@CςȂ΁AȂ̗͂O
  Ȃ̃o[W̃t@CɈ݂邱Ƃł܂A
  `͂܂BO݂Ȃ΁A̗O
  Ȃ̃o[W͍폜ĂB)
*/
/*
// ****************************************************************
//	CRandomSelect.cpp
//	$Id: CRandomSelect.cpp 324 2016-06-12 03:03:55Z okm $
// ****************************************************************
*/
/** @file */

#include "DcdGrid\WndDcdGrid3\CRandomSelect.h"
#include "DcdGrid\WndDcdGrid3\CFocus.h"
#include "DcdGrid\WndDcdGrid3\CXDcdGrid.h"
#include "DcdGrid\WndDcdGrid3\CWndDcdGrid.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

namespace DcDrawLib{
namespace DcdGrid{
namespace WndDcdGrid3{

	// --------------------------------
	//@name ֐
	// --------------------------------
CSelectCell* CRandomSelect::getFocusSelectCell() 
{
	CSelectCell* pCell = NULL ;

	CdDcdPosXy	xyFocusCellColumnNumber =
		m_pCWndDcdGrid->getCFocus()->getFocusCellColumnNumber() ;
	if ( xyFocusCellColumnNumber != CFocus::ColumnNumberPosXy_NULL() )
	{
		pCell = m_pCWndDcdGrid->getCSelect()->getCell( 
			xyFocusCellColumnNumber.getX() ,
			xyFocusCellColumnNumber.getY() ) ;
	}
	return pCell ;
}

	// --------------------------------
	//@name update_adjustProp ֐
	// --------------------------------
bool CRandomSelect::update_adjustProp_updateColumnNumberSelect() 
{
	bool bRv = false ;

	//	ύXΏۂ̒l̃LbV
	CdDcdPosXy posxyColumnNumberAnchorCellNew = m_ColumnNumberAnchorCell ;

	//	lfalseB
	//	ׂẴZ̑IԂKvƔfꂽ_ true B
	bool bClearSelectRequired = false ;

	CdDcdPosXy	aColumnNumberFocus = 
		m_pCWndDcdGrid->getCFocus()->getFocusCellColumnNumber() ;
	//aColumnNumberFocus = tH[JXZ̗ԍ

	// ----------------------------------------------------------------
	//	AJ[Z̐K(AJ[ZObh͈̔͊OȂA
	//	NULL ɏC
	// ----------------------------------------------------------------
	if ( posxyColumnNumberAnchorCellNew != ColumnNumberPosXy_NULL() )
	{
		if ( !( 
			0 <= m_ColumnNumberAnchorCell.getX() && 
			m_ColumnNumberAnchorCell.getX() < m_pCWndDcdGrid->getCXDcdGrid()->getXColumnCount() &&
			0 <= m_ColumnNumberAnchorCell.getY() && 
			m_ColumnNumberAnchorCell.getY() < m_pCWndDcdGrid->getCXDcdGrid()->getYColumnCount() ) )
		{
			posxyColumnNumberAnchorCellNew = ColumnNumberPosXy_NULL() ;
		}
	}

	// ----------------------------------------------------------------
	//	tH[JXZ̈ړɏ]
	//	m_ColumnNumberSelect,m_ColumnNumberAnchorCell XV܂B
	// ----------------------------------------------------------------

	CSelect*	pCSelect = m_pCWndDcdGrid->getCSelect() ;
	CdDcdZoneXy	zonexyColumnNumberSelectLimit = 
		pCSelect->getColumnNumberSelectLimitRegularized() ;
	//zonexyColumnNumberSelectLimit = I\ȃZ̗ԍ͈̔́B

	// --------------------------------
	//CtrlShiftȂԂŁAhbO(MouseMove,^C}XN[)ȊOɂtH[JXړ
	//@ AJ[Z͍XVBׂẴZ̑IԂB
	// --------------------------------

	if ( m_ColumnNumberFocus_Old != aColumnNumberFocus )
	{	//	tH[JXZړ
		if ( !m_pCWndDcdGrid->isCtrlPressed() && 
			!m_pCWndDcdGrid->isShiftPressed() && 
			!m_pCWndDcdGrid->isDragging() )
		{	//CtrlShiftȂԂŁA
			//	hbO(MouseMove,^C}XN[)ȊOɂtH[JXړ
			
			//AJ[Z͍XVB
			posxyColumnNumberAnchorCellNew = aColumnNumberFocus ;

			// ׂẴZ̑IԂ
			bClearSelectRequired = true ;
		}
		// --------------------------------
	}
	
	// --------------------------------
	//	CtrlꂽԂŁAhbOȊOɂtH[JXړ
	//	@AJ[Z̑IԂIɂB
	//	@@AJ[ZNULLɂB(RandomSelect̃AJ[ŹA
	//	@@RandomSelectɂ鏉̑IgOsꂽɁA
	//	@@1񂾂IԂɂ܂B)
	// --------------------------------
	if ( m_ColumnNumberFocus_Old != aColumnNumberFocus )
	{	//	tH[JXZړ
		if ( m_pCWndDcdGrid->isCtrlPressed() && 
			!m_pCWndDcdGrid->isDragging() )
		{
				//	AJ[Z̑IԂIɂB
				{
					CSelectCell* pCell = NULL ;
					if ( m_ColumnNumberAnchorCell != CFocus::ColumnNumberPosXy_NULL() )
					{
						pCell = m_pCWndDcdGrid->getCSelect()->getCell( 
							m_ColumnNumberAnchorCell.getX() ,
							m_ColumnNumberAnchorCell.getY() ) ;
						if ( pCell != NULL )
						{
							pCell->setIsSelected( true ) ;
						}
						m_ColumnNumberAnchorCell = CFocus::ColumnNumberPosXy_NULL() ;
					}
				}
		}
	}



	// ----------------------------------------------------------------
	//	̍XV
	// ----------------------------------------------------------------
	if ( m_ColumnNumberAnchorCell != posxyColumnNumberAnchorCellNew )
	{
		m_ColumnNumberAnchorCell = posxyColumnNumberAnchorCellNew ;
		bRv = true ;
	}
	if ( bClearSelectRequired )		// ׂẴZ̑IԂ
	{
		m_pCWndDcdGrid->getCSelect()->clearSelect() ;
		bRv = true ;
	}

	// --------------------------------
	//	OlXV
	// --------------------------------
	m_ColumnNumberFocus_Old = aColumnNumberFocus ;

	return bRv ;	
}

bool CRandomSelect::update_adjustProp_updateCSelectCell() 
{
	//	ZIԂ̍XV́A OnLButtonDown(),OnKeyDown() ōs߁A
	//	ł͏͂܂B
	return false ;
}

	// --------------------------------
	//@name CWndDcdGrid ̈Ϗ
	// --------------------------------
bool CRandomSelect::update_adjustProp() 
{
	bool	bRv = false ;
	if ( m_bIsEnable )
	{
		//	tH[JXZ̈ړɏ]āA
		//	m_ColumnNumberAnchorCell , m_ColumnNumberSelect XV܂B
		//	
		//	m_ColumnNumberAnchorCellEm_ColumnNumberSelect 𐳋K܂B
		bRv |= update_adjustProp_updateColumnNumberSelect() ;

		//	IZ̏ԂACSelectCell ɔf
		bRv |= update_adjustProp_updateCSelectCell() ;
	}
	else
	{
		m_ColumnNumberAnchorCell = ColumnNumberPosXy_NULL() ;
	}

	return bRv ;	
}

bool CRandomSelect::update_updateScreen() 
{
	bool bRv = false ;
	//	̃NXł͏͂܂(ĕ`́ACSelect ɂčs܂)
	return bRv ;
}
bool CRandomSelect::OnPaint( IfDcdTarget* pIfDcdTarget ) 
{
	bool bRv = false ;
	//	̃NXł͏͂܂(ĕ`́ACSelect ɂčs܂)
	return bRv ;
}

void CRandomSelect::OnSize(UINT nType, int cx, int cy)
{
	//	̃NXł͏͂܂
}

void CRandomSelect::OnSetFocus(CWnd* pOldWnd)
{
	//	̃NXł́A͂܂B
}

void CRandomSelect::OnKillFocus(CWnd* pNewWnd)
{
	//	̃NXł́A͂܂B
}




void CRandomSelect::OnLButtonDown(UINT nFlags, CPoint point) 
{
	//	CWndDcdGrid ̓ꃁ\bḧϏ󂯂܂B

	//Ctrl+Obhł̃}EXNbN@n
	//	@AJ[Z̑IԂIɂB
	//	@ tH[JXZ̑IԂgO
	if ( m_bIsEnable )	//	_IL
	{
		CdDcdPosXy	posCursorPos( point.x , point.y ) ;
		CDcdGridCell* pCell = 
			m_pCWndDcdGrid->getCellOfPos( posCursorPos ) ;
		if ( pCell != NULL )
		{
			//	}EXZɂԂŃNbN
			if ( m_pCWndDcdGrid->isCtrlPressed() )	//	Ctrl
			{
				//	Ctrl+Obhł̃}EXNbN

				//	 tH[JXZ̑IԂgO
				{
					CSelectCell* pCSelectCell = getFocusSelectCell() ;
					if ( pCSelectCell != NULL )
					{
						pCSelectCell->setIsSelected( 
							!pCSelectCell->getIsSelected() ) ;
					}
				}

				//	AJ[Z̑IԂIɂB
				//note:
				//	̏́AutH[JXZ̑IԂgOv
				//	sKv܂B
				//	t̏ꍇ́A
				//		_ZÎȂԂŁACtrl+Space
				//		_ZÎȂԂŁACtrlȂtH[JXZNbN
				//	̂ꂩsƂɁAtH[JXZIԂɂȂ܂B
				{
					CSelectCell* pCell = NULL ;
					if ( m_ColumnNumberAnchorCell != CFocus::ColumnNumberPosXy_NULL() )
					{
						pCell = m_pCWndDcdGrid->getCSelect()->getCell( 
							m_ColumnNumberAnchorCell.getX() ,
							m_ColumnNumberAnchorCell.getY() ) ;
						m_ColumnNumberAnchorCell = CFocus::ColumnNumberPosXy_NULL() ;
						pCell->setIsSelected( true ) ;
					}
				}

			}
		}
	}
	
}


void CRandomSelect::OnLButtonUp(UINT nFlags, CPoint point) 
{
	//	CWndDcdGrid ̓ꃁ\bḧϏ󂯂܂B
	//
	//	̃NXł́A͂܂B
}

void CRandomSelect::OnMouseMove(UINT nFlags, CPoint point) 
{
	//	CWndDcdGrid ̓ꃁ\bḧϏ󂯂܂B
	//
	//	̃NXł́A͂܂B
}

void CRandomSelect::OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags) 
{
	//	CWndDcdGrid ̓ꃁ\bḧϏ󂯂܂B
	//
	//Ctrl+SpaceL[@n
	//@tH[JXZ̑IԂgO
	if ( m_bIsEnable )	//	_IL
	{
		if ( m_pCWndDcdGrid->isCtrlPressed() && 
			nChar == VK_SPACE )
		{
				//	Ctrl+SpaceL[
				
				//	 tH[JXZ̑IԂgO
				{
					CSelectCell* pCSelectCell = getFocusSelectCell() ;
					if ( pCSelectCell != NULL )
					{
						pCSelectCell->setIsSelected( 
							!pCSelectCell->getIsSelected() ) ;
					}
				}
				//	AJ[Z̑IԂIɂB
				//note:
				//	̏́AutH[JXZ̑IԂgOv
				//	sKv܂B
				//	t̏ꍇ́A
				//		_ZÎȂԂŁACtrl+Space
				//		_ZÎȂԂŁACtrlȂtH[JXZNbN
				//	̂ꂩsƂɁAtH[JXZIԂɂȂ܂B
				{
					CSelectCell* pCell = NULL ;
					if ( m_ColumnNumberAnchorCell != CFocus::ColumnNumberPosXy_NULL() )
					{
						pCell = m_pCWndDcdGrid->getCSelect()->getCell( 
							m_ColumnNumberAnchorCell.getX() ,
							m_ColumnNumberAnchorCell.getY() ) ;
						m_ColumnNumberAnchorCell = CFocus::ColumnNumberPosXy_NULL() ;
						pCell->setIsSelected( true ) ;
					}
				}

		}
	}
}

void CRandomSelect::InvalidateGrid( ) 
{
	//	̃NXł͏͂܂(ĕ`́ACSelect ɂčs܂)
}

	// ********************************
	//	RXgN^
	// ********************************
CRandomSelect::CRandomSelect( CWndDcdGrid* pCWndDcdGrid ) 
	: m_pCWndDcdGrid( pCWndDcdGrid )
	, m_bIsEnable( true ) 
	, m_ColumnNumberFocus_Old( ColumnNumberPosXy_NULL() ) 
{
}
CRandomSelect::~CRandomSelect() 
{
}

	// ********************************
	//@name CSelect ֘A
	// ********************************
CWndDcdGrid* CRandomSelect::getCWndDcdGrid() 
{
	return m_pCWndDcdGrid ;
}

	// ********************************
	//@name CSelect 
	// ********************************
bool CRandomSelect::getIsEnable() 
{
	return m_bIsEnable ;
}
void CRandomSelect::setIsEnable( bool value ) 
{
	m_bIsEnable = value ;
}
CdDcdPosXy	CRandomSelect::getColumnNumberAnchorCell()
{
	return m_ColumnNumberAnchorCell;
}


} //namespace WndDcdGrid3
} //namespace DcdGrid
} //namespace DcDrawLib
