/*
	OuDia - Win32 Application Software to draw a "Train Service Planning
 Diagram" based on a "Train Timetable".

Copyright (C) 2006-2017 take-okm

This program is free software; you can redistribute it and/or modify it 
under the terms of the GNU General Public License as published by the Free 
Software Foundation; either version 3 of the License, or (at your option) 
any later version. 

This program is distributed in the hope that it will be useful, but WITHOUT 
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or 
FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for 
more details. 

You should have received a copy of the GNU General Public License along with
 this program. If not, see <http://www.gnu.org/licenses/>.

  In addition, as a special exception, take-okm
  gives permission to link the code of this program with
  the "MFC(Microsoft Foundation Class library) Version 9.0" 
  (or with modified versions of "MFC Version 9.0" that use the same license as 
  "MFC Version 9.0" ), and distribute linked combinations including
  the two.  You must obey the GNU General Public License in all
  respects for all of the code used other than  "MFC".  If you modify
  this file, you may extend this exception to your version of the
  file, but you are not obligated to do so.  If you do not wish to
  do so, delete this exception statement from your version.


(: 

	OuDia - Ԏ\ƂɁA_CO`悷Win32AvP[V
B

Copyright (C) 2006-2017 take-okm 

̃vO̓t[\tgEFAłBȂ͂At[\tgEFA
cɂĔsꂽGNU ʌOp(o[W3Aȍ~̃o[W
̂ǂꂩ)߂̉ōĔЕz܂͉ 邱Ƃł܂B

̃vO͗Lpł邱ƂĔЕz܂A*S̖ۏ *łB
Ɖ\̕ۏ؂ړIւ̓ḰAOɎꂽ̂ ܂߁AS
܂BڂGNU ʌOpB

Ȃ͂̃vOƋɁAGNU ʌOp̃Rs[ꕔ 󂯎
Ă͂łB󂯎ĂȂ΁A<http://www.gnu.org/licenses/> 
B

)

  āAʂȗOƂāAtake-okm ͂̃vÕR[h 
  "MFC(Microsoft Foundation Class library) Version 9.0" 
  (  邢 "MFC Version 9.0" ƓCZXKpꂽ
  "MFC Version 9.0" ̉ςꂽo[W)ƃNA
  Nꂽ҂܂ތ앨Еz鋖^܂B
  Ȃ "MFC" ȊOŎgĂ邷ׂ
  ̃R[hɊւĂ͑SʓIGNUʌOp_񏑂ɏ]Ȃ
  Ȃ܂BȂ̃t@CςȂ΁AȂ̗͂O
  Ȃ̃o[W̃t@CɈ݂邱Ƃł܂A
  `͂܂BO݂Ȃ΁A̗O
  Ȃ̃o[W͍폜ĂB)
*/
/** @file */
//$Id: CNodeContainer.h 294 2016-06-11 05:10:03Z okm $
#pragma once
#include <deque>
#include "NsMu\Mui.h"
#include "str\OuPropertiesText\CNode.h"
#include "str\OuPropertiesText\CPropertyString.h"
#include "str\OuPropertiesText\CInNameIndexContainer.h"
#include "str\OuPropertiesText\IfNodeContainerConst.h"

namespace OuLib{
namespace Str{
namespace OuPropertiesText{



// ****************************************************************
//	CNodeContainer
// ****************************************************************
/**
@brief
	Node IuWFNgێReiłB

	Rei Ou<CNode> i[邷ׂĂpublic\bh
	(set()Einsert() Ȃ)́A
	œnꂽ CNode  clone i[܂B
	Rei Ou<CNode> 擾邷ׂẴ\bh́A
	Rei CNode ւ̎QƂԂ܂B
*/
class CNodeContainer : public Mui< Ou<CNode> >
{
public:
	typedef Ou<CNode>	ElementType ;
	typedef std::deque< Ou<CNode> >	ElementTypeStlCont ;
private:
	// ----------------------------------------------------------------
	//	CNodeContainer::CaConst
	// ----------------------------------------------------------------
	/**
		CNodeContainer ɑ΂āA
		IfNodeContainerConst C^[tF[X
		ANZX邽߂̃A_v^NXłB
		
		CNodeContainer ́ÃA_v^W񂵂ĂA
		getIfNodeContainerConst() \bhŁA
		̃A_v^ւ̃|C^Ԃ܂B
	*/
	class CaConst : public IfNodeContainerConst 
	{
	public:
		// ********************************
		///@name	IfNodeContainerConst-Property̎擾
		// ********************************
		///@{
		/**
			Property  Name ɑΉ Value 擾܂B
		@param strName [in]
			Property  Name w肵ĂB
		@return
			ΉValueԂ܂B

			NameɑΉ Property Ȃꍇ́A
			󕶎Ԃ܂B

			Name ɑΉ 2ȏCPropertyString CX^X
			ꍇ́AInNameIndex ł CPropertyString  Value 
			Ԃ܂B
		*/
		virtual std::string getValue( const std::string& strName )const ;
		///@}

	public:
		// ********************************
		///@name	Mu
		// ********************************
		///@{
		
		/**
		 * @return
		 * 	ReiɊi[Ăvf̌Ԃ܂B
		 */
		virtual int	size()const ;
		/**
		 * 	ReíACfNXŎw肳ꂽꏊɊi[Ă
		 * 	vfԂ܂B
		 *
		 * @param iIndex [in]
		 * 	On܂CfNXw肵ĂB
		 * 	͈͂͂Oȏ size() łB
		 *	AAINT_MAX ́Aw肵̂Ƃ݂Ȃ܂B
		 * @return
		 * 	CfNXŎw肳ꂽvfԂ܂B
		 */
		virtual Ou<const CNode> get( int iIndex )const ;
		
		///@}
		
	public:
		// ********************************
		///@name	CNodeContainer-InNameIndexł̃ANZX
		// ********************************
		///@{
		
		/**
	 		w Name vf̌Ԃ܂B
		 @param strName [in]
			Name w肵ĂB
		 @return
	 		vf̌Ԃ܂B
		*/
		virtual int	sizeInName( const std::string& strName )const ;
		/**
	 		ReíAw Name vfԂ܂B
		 @param strName [in]
			Name w肵ĂB
		 @param iInNameIndex [in]
	 		InNameIndex w肵ĂB
			InNameIndex ́ÃRei̓ Name  Node ł́A
			On܂CfNXłB
			͈͂͂Oȏ sizeInName() łB
			AAINT_MAX ́Aw肵̂Ƃ݂Ȃ܂B
		 @return
	 		CfNXŎw肳ꂽvfԂ܂B
		*/
		virtual Ou<const CNode> getInName( const std::string& strName , int iInNameIndex )const ;
		
		

		/**
			InNameIndex ReĩCfNXɕϊ܂B
		@param strName [in]
			Name w肵ĂB
		@param iInNameIndex [in]
	 		On܂CfNXw肵ĂB
	 		͈͂͂Oȏ sizeInName() łB
	 		AAINT_MAX ́Aw肵̂Ƃ݂Ȃ܂B
		@return
			CfNX Ԃ܂B
			-	-1 ;	//	CfNXsłB
		*/
		virtual int indexOfInNameIndex( 
			const std::string& strName ,
			int iInNameIndex )const ;
		/**
			ReĩCfNXAInNameIndex ɕϊ܂B
		@param iIndex [in]
	 		On܂CfNXw肵ĂB
	 		͈͂͂Oȏ size() łB
	 		AAINT_MAX ́Aw肵̂Ƃ݂Ȃ܂B
		@return
			InNameIndex Ԃ܂B
		*/
		virtual int indexToInNameIndex( 
			int iIndex )const ;

		///@}
	};
	friend class CaConst ;

private:
	// ********************************
	///@name	W
	// ********************************
	///@{
	/**
		Ou<CNode>[ index ] ̌`ŁAm[hێ܂B
	*/
	ElementTypeStlCont	m_contCNode ;

	/**
		CNodeContainer ɑ΂āA
		IfNodeContainerConst C^[tF[X
		ANZX邽߂̃A_v^NXłB
		
		CNodeContainer ́ÃA_v^W񂵂ĂA
		getIfNodeContainerConst() \bhŁA
		̃A_v^ւ̃|C^Ԃ܂B
	*/
	CaConst	m_CaConst ;
	///@}

	// --------------------------------
	///@name	f[^
	// --------------------------------
	///@{
	/**
		index[ Name ][InNameIndex ] ̌`ŁA
		Index  InNameIndex ̑Ώƕ\ێ܂B
	*/
	CInNameIndexContainer	m_CInNameIndexContainer;
	///@}
	
private:
	// --------------------------------
	///@name	֐
	// --------------------------------
	///@{
	/**
		Property  Name ɑΉ CPropertyString ΁A
		̗vfւ̃|C^擾邱Ƃł܂B
		̃IuWFNg̑ύX邱ƂɂA
		Rei Property ύX邱Ƃł܂B
	@param strName [in]
		Property  Name w肵ĂB
	@return
		Ή CPropertyString ւ̎QƂԂ܂B

		NameɑΉ Property Ȃꍇ́A
		NULLԂ܂B

		Name ɑΉ 2ȏCPropertyString CX^X
		ꍇ́AInNameIndex ł CPropertyString  CPropertyString 
		Ԃ܂B
	*/
	Ou<CPropertyString> getCPropertyString( const std::string& strName )const ;
	///@}
	
public:
	// ********************************
	//	RXgN^
	// ********************************
	CNodeContainer();
	virtual ~CNodeContainer();
	/**
		value W񂷂SĂ Node 
		Rs[쐬AW񂵂܂B
		value ƃIuWFNgL邱Ƃ͂܂B
	*/
	CNodeContainer( const CNodeContainer& value );
	/**
		value W񂷂SĂ Node 
		Rs[쐬AW񂵂܂B
		value ƃIuWFNgL邱Ƃ͂܂B
	*/
	CNodeContainer& operator=( const CNodeContainer& value );
public:
	// ********************************
	///@name	W
	// ********************************
	///@{
	/**
	@return
		Node IuWFNgێReiQƂC^[tF[XłB\n
		̃C^[tF[X́ACNodeContainer ̑SẴm[hɑ΂
		Ou<const CNode> 擾邱Ƃł܂A
		m[h̒ǉEύXE폜͂ł܂B
	*/
	virtual const IfNodeContainerConst* getIfNodeContainerConst()const ;
	///@}
public:
	// ********************************
	///@name	CNodeContainer-Property̎擾ݒ
	// ********************************
	///@{
	/**
		Property  Name  Value ݒ肵܂B
	@param strName [in]
		Property  Name w肵ĂB
	@param strValue [in]
		Property  Value w肵ĂB

		Name ɑΉ Property (CPropertyString) 
		this ̃Reiɑ݂Ȃꍇ́A
		CPropertyString IuWFNgReiɐVKǉ܂B

		Name ɑΉ CPropertyString ݂Ăꍇ́A
		CPropertyStroing IuWFNg Value ㏑܂B
		O2ȏCPropertyString CX^X
		ꍇ́AInNameIndex ł CPropertyString  Value 
		㏑܂B
	*/
	virtual void setValue( const std::string& strName , 
		const std::string& strValue ) ;

	/**
		Property  Name ɑΉ Value 擾܂B
	@param strName [in]
		Property  Name w肵ĂB
	@return
		ΉValueԂ܂B

		NameɑΉ Property Ȃꍇ́A
		󕶎Ԃ܂B

		Name ɑΉ 2ȏCPropertyString CX^X
		ꍇ́AInNameIndex ł CPropertyString  Value 
		Ԃ܂B
	*/
	virtual std::string getValue( const std::string& strName )const ;
	///@}

public:
	// ********************************
	///@name	Mu
	// ********************************
	///@{
	
	/**
	 * @return
	 * 	ReiɊi[Ăvf̌Ԃ܂B
	 */
	virtual int	size()const ;
	/**
	 * 	ReíACfNXŎw肳ꂽꏊɊi[Ă
	 * 	vfԂ܂B
	 *
	 * @param iIndex [in]
	 * 	On܂CfNXw肵ĂB
	 * 	͈͂͂Oȏ size() łB
	 *	AAINT_MAX ́Aw肵̂Ƃ݂Ȃ܂B
	 * @return
	 * 	CfNXŎw肳ꂽvfԂ܂B
	 */
	virtual ElementType get( int iIndex )const ;
	
	///@}
public:
	// ********************************
	///@name	Mui
	// ********************************
	///@{
	
	/**
	 * 	ReíACfNXŎw肳ꂽꏊɁA
	 * 	vf㏑܂B
	 * @param element [in]
	 * 	vfw肵ĂB
	 * @param iIndex [in]
	 * 	On܂CfNXw肵ĂB
	 * 	͈͂͂Oȏ size() łB
	 *	AAINT_MAX ́Aw肵̂Ƃ݂Ȃ܂B
	 * @return
	 * 	0ȏ͐A̐̓G[ł
	 */
	virtual int set( const ElementType& element , int iIndex ) ;

	/**
	 * 	ReíACfNXŎw肳ꂽꏊɁA
	 * 	vfǉ܂B
	 * @param element [in]
	 * 	vfw肵ĂB
	 * @param iIndex [in]
	 * 	On܂CfNXw肵ĂB
	 * 	͈͂͂Oȏ size() ȉłB
	 * 	ÓA擪Esize()Ȃ疖ւ̒ǉɂȂ܂B
	 *	AAINT_MAX ́Aw肵̂Ƃ݂Ȃ܂B
	 * @return
	 * 	0ȏ͐A̐̓G[ł
	 */
	virtual int insert( const ElementType& element , int iIndex = INT_MAX ) ;
	
	/**
	 * 	ReíACfNXŎw肳ꂽꏊ
	 * 	vf폜܂B
	 * @param iIndex [in]
	 * 	On܂CfNXw肵ĂB
	 * 	͈͂͂Oȏ size() łB
	 * 	AAINT_MAX ́Aw肵̂Ƃ݂Ȃ܂B
	 * @param iSize [in]
	 * 	폜vf̐w肵ĂB
	 * 	AAINT_MAX ́A iIndex 疖܂ł\܂B
	 * @attention
	 *	iIndex  iSize ̗ INT_MAX ɂ邱Ƃ͂ł܂B
	 * @return
	 * 	0ȏ͐A̐̓G[ł
	 */
	virtual int erase( int iIndex  , int iSize = 1 ) ;
	
	///@}
public:
	// ********************************
	///@name	CNodeContainer-InNameIndexł̃ANZX
	// ********************************
	///@{
	
	/**
	 	w Name vf̌Ԃ܂B
	 @param strName [in]
		Name w肵ĂB
	 @return
	 	vf̌Ԃ܂B
	*/
	virtual int	sizeInName( const std::string& strName )const ;
	/**
	 	ReíAw Name vfԂ܂B
	 @param strName [in]
		Name w肵ĂB
	 @param iInNameIndex [in]
	 	InNameIndex w肵ĂB
		InNameIndex ́ÃRei̓ Name  Node ł́A
		On܂CfNXłB
		͈͂͂Oȏ sizeInName() łB
		AAINT_MAX ́Aw肵̂Ƃ݂Ȃ܂B
	 @return
	 	CfNXŎw肳ꂽvfԂ܂B
	*/
	virtual ElementType getInName( const std::string& strName , int iInNameIndex )const ;
	
	
	/**
	 	ReíACfNXŎw肳ꂽꏊɁA
	 	vf㏑܂B
	@param element [in]
	 	vfw肵ĂB
	@param iInNameIndex [in]
	 	On܂InNameIndexw肵ĂB
	 	͈͂͂Oȏ size() łB
		AAINT_MAX ́Aw肵̂Ƃ݂Ȃ܂B
	@return
	 	0ȏ͐A̐̓G[ł
	*/
	virtual int setInName( 
		const ElementType& element , 
		int iInNameIndex ) ;

	/**
	 	ReíACfNXŎw肳ꂽꏊɁA
	 	vfǉ܂B
	@param element [in]
	 	vfw肵ĂB
	@param iInNameIndex [in]
	 	On܂InNameIndexw肵ĂB
	 	͈͂͂Oȏ sizeInName() ȉłB
	 	ÓA擪EsizeInName()Ȃ疖ւ̒ǉɂȂ܂B
		AAINT_MAX ́Aw肵̂Ƃ݂Ȃ܂B
	@return
	 	0ȏ͐A̐̓G[ł
	*/
	virtual int insertInName( 
		const ElementType& element , 
		int iInNameIndex = INT_MAX ) ;
	
	/**
	 	ReíACfNXŎw肳ꂽꏊ
	 	vf폜܂B
	@param strName [in]
		Name w肵ĂB
	@param iInNameIndex [in]
	 	On܂CfNXw肵ĂB
	 	͈͂͂Oȏ sizeInName() łB
	 	AAINT_MAX ́Aw肵̂Ƃ݂Ȃ܂B
	@param iSize [in]
	 	폜vf̐w肵ĂB
	 	AAINT_MAX ́A iIndex 疖܂ł\܂B
	@attention
		iIndex  iSize ̗ INT_MAX ɂ邱Ƃ͂ł܂B
	@return
	 	0ȏ͐A̐̓G[ł
	*/
	virtual int eraseInName( const std::string& strName , 
		int  iInNameIndex  , int iSize = 1 ) ;
	/**
		InNameIndex ReĩCfNXɕϊ܂B
	@param strName [in]
		Name w肵ĂB
	@param iInNameIndex [in]
	 	On܂CfNXw肵ĂB
	 	͈͂͂Oȏ sizeInName() łB
	 	AAINT_MAX ́Aw肵̂Ƃ݂Ȃ܂B
	@return
		CfNX Ԃ܂B
		-	-1 ;	//	CfNXsłB
	*/
	virtual int indexOfInNameIndex( 
		const std::string& strName ,
		int iInNameIndex )const ;
	/**
		ReĩCfNXAInNameIndex ɕϊ܂B
	@param iIndex [in]
	 	On܂CfNXw肵ĂB
	 	͈͂͂Oȏ size() łB
	 	AAINT_MAX ́Aw肵̂Ƃ݂Ȃ܂B
	@return
		InNameIndex Ԃ܂B
	*/
	virtual int indexToInNameIndex( 
		int iIndex )const ;

	///@}
	
};


} //namespace OuPropertiesText{
} //namespace Str{
} //namespace OuLib{
