/*
	OuDia - Win32 Application Software to draw a "Train Service Planning
 Diagram" based on a "Train Timetable".

Copyright (C) 2006-2017 take-okm

This program is free software; you can redistribute it and/or modify it 
under the terms of the GNU General Public License as published by the Free 
Software Foundation; either version 3 of the License, or (at your option) 
any later version. 

This program is distributed in the hope that it will be useful, but WITHOUT 
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or 
FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for 
more details. 

You should have received a copy of the GNU General Public License along with
 this program. If not, see <http://www.gnu.org/licenses/>.

  In addition, as a special exception, take-okm
  gives permission to link the code of this program with
  the "MFC(Microsoft Foundation Class library) Version 9.0" 
  (or with modified versions of "MFC Version 9.0" that use the same license as 
  "MFC Version 9.0" ), and distribute linked combinations including
  the two.  You must obey the GNU General Public License in all
  respects for all of the code used other than  "MFC".  If you modify
  this file, you may extend this exception to your version of the
  file, but you are not obligated to do so.  If you do not wish to
  do so, delete this exception statement from your version.


(: 

	OuDia - Ԏ\ƂɁA_CO`悷Win32AvP[V
B

Copyright (C) 2006-2017 take-okm 

̃vO̓t[\tgEFAłBȂ͂At[\tgEFA
cɂĔsꂽGNU ʌOp(o[W3Aȍ~̃o[W
̂ǂꂩ)߂̉ōĔЕz܂͉ 邱Ƃł܂B

̃vO͗Lpł邱ƂĔЕz܂A*S̖ۏ *łB
Ɖ\̕ۏ؂ړIւ̓ḰAOɎꂽ̂ ܂߁AS
܂BڂGNU ʌOpB

Ȃ͂̃vOƋɁAGNU ʌOp̃Rs[ꕔ 󂯎
Ă͂łB󂯎ĂȂ΁A<http://www.gnu.org/licenses/> 
B

)

  āAʂȗOƂāAtake-okm ͂̃vÕR[h 
  "MFC(Microsoft Foundation Class library) Version 9.0" 
  (  邢 "MFC Version 9.0" ƓCZXKpꂽ
  "MFC Version 9.0" ̉ςꂽo[W)ƃNA
  Nꂽ҂܂ތ앨Еz鋖^܂B
  Ȃ "MFC" ȊOŎgĂ邷ׂ
  ̃R[hɊւĂ͑SʓIGNUʌOp_񏑂ɏ]Ȃ
  Ȃ܂BȂ̃t@CςȂ΁AȂ̗͂O
  Ȃ̃o[W̃t@CɈ݂邱Ƃł܂A
  `͂܂BO݂Ȃ΁A̗O
  Ȃ̃o[W͍폜ĂB)
*/
/*
// ****************************************************************
//	CconvCentDed.h
// ****************************************************************
*/
#ifndef  CconvCentDed_h
#define  CconvCentDed_h

/** @file */

#include "CentDedEki.h"
#include "CentDedRessyasyubetsu.h"
#include "CentDedEkiJikoku.h"
#include "CentDedRessya.h"
#include "CentDedRessyaCont.h"
#include "CentDedDia.h"
#include "CentDedRosen.h"
#include "str/CdConnectedString2.h"
#include "DcDraw/CDcdFreeLine.h"

// ****************************************************************
//	CconvCentDed
// ****************************************************************
/**
 *	@brief
 *	  DiagramEdit ̃GeBeBNX̃IuWFNg̑f[^̓eA
 *	̃f[^`ɕϊ֐^Ă܂B
 *
 *	   CdConnectedString2 IuWFNgƂ̊Ԃ̕ϊT|[gĂ܂B
 *	
 */
class CconvCentDed
{
// ********************************
//	CconvCentDed
// ********************************
 public:

	// ********************************
	//	CentDedEki
	// ********************************
	
	/**
	 *	  CdConnectedString IuWFNgɁA
	 *	  CentDedEki ̑ǉ܂B
	 *	@param aCentDedEki [in]
	 *	  CentDedEki w肵ĂB
	 *	@param pCdConnectedString [in,out]
	 *	  ̊֐́ÃIuWFNgɁA CdConnectedString2::CdItem 
	 *	ǉ܂B
	 *	  ̃IuWFNg܂ŕێĂ CdConnectedString2::CdItem 
	 *	ێ܂B
	 *	@return
	 *	   0 ȏAG[Ȃ畉̐łB
	 *	-	-11 ;	//	Ekimei w肳Ă܂B
	 *	-	-22 ;	//	Ekijikokukeisiki ̒lsłB
	 *	-	-32 ;	//	Ekikibo ̒lsłB
	 */
	int CentDedEki_To_CdConnectedString( 
			const CentDedEki& aCentDedEki , 
			CdConnectedString2* pCdConnectedString ) ;
	
	/**
	 *	  CdConnectedString IuWFNgA
	 *	  CentDedEki_To_CdConnectedString() ֐ɂč쐬ꂽ
	 *	ACeǂݍ݁A CentDedEki IuWFNgɔf܂B
	 *	
	 *	@param pCentDedEki [out]
	 *	  ̊֐͂̃IuWFNgɁA𔽉f܂B
	 *	@param aCdConnectedString [in]
	 *	  ێĂ CdConnectedString IuWFNgw肵ĂB
	 *	@return
	 *	   0 ȏAG[Ȃ畉̐łB
	 *	-	-11 ;	//	Ekimei w肳Ă܂B
	 *	-	-22 ;	//	Ekijikokukeisiki ̒lsłB
	 *	-	-32 ;	//	Ekikibo ̒lsłB
	 */
	int CentDedEki_From_CdConnectedString( 
			CentDedEki* pCentDedEki ,
			const CdConnectedString2& aCdConnectedString ) ;
	
	// ********************************
	//	CentDedRessyasyubetsu
	// ********************************
	
	/**
	 *	  CdConnectedString IuWFNgɁA
	 *	  CentDedRessyasyubetsu ̑ǉ܂B
	 *	@param aCentDedRessyasyubetsu [in]
	 *	  CentDedRessyasyubetsu w肵ĂB
	 *	@param pCdConnectedString [in,out]
	 *	  ̊֐́ÃIuWFNgɁA CdConnectedString2::CdItem 
	 *	ǉ܂B
	 *	  ̃IuWFNg܂ŕێĂ CdConnectedString2::CdItem 
	 *	ێ܂B
	 *	@return
	 *	   0 ȏAG[Ȃ畉̐łB
	 *	-	-11 ;	//	Ekimei w肳Ă܂B
	 *	-	-22 ;	//	Ekijikokukeisiki ̒lsłB
	 *	-	-32 ;	//	Ekikibo ̒lsłB
	 */
	int CentDedRessyasyubetsu_To_CdConnectedString( 
			const CentDedRessyasyubetsu& aCentDedRessyasyubetsu , 
			CdConnectedString2* pCdConnectedString ) ;
	
	/**
	 *	  CdConnectedString IuWFNgA
	 *	  CentDedRessyasyubetsu_To_CdConnectedString() ֐ɂč쐬ꂽ
	 *	ACeǂݍ݁A CentDedRessyasyubetsu IuWFNgɔf܂B
	 *	
	 *	@param pCentDedRessyasyubetsu [out]
	 *	  ̊֐͂̃IuWFNgɁA𔽉f܂B
	 *	@param aCdConnectedString [in]
	 *	  ێĂ CdConnectedString IuWFNgw肵ĂB
	 *	@return
	 *	   0 ȏAG[Ȃ畉̐łB
	 *	-	-11 ;	//	Ekimei w肳Ă܂B
	 *	-	-22 ;	//	Ekijikokukeisiki ̒lsłB
	 *	-	-32 ;	//	Ekikibo ̒lsłB
	 */
	int CentDedRessyasyubetsu_From_CdConnectedString( 
			CentDedRessyasyubetsu* pCentDedRessyasyubetsu ,
			const CdConnectedString2& aCdConnectedString ) ;
	
	/**
	 *	CentDedRessyasyubetsu::ESenStyle ̒lƁA
	 *	uv bool ƂɁA
	 *	CDcdFreeLine::CdLineProp IuWFNgɑ
	 *	ݒ肵܂B
	 * @param aCOLORREF [in] 
	 *	̐Fw肵ĂB
	 * @param eSenStyle [in]
	 *	̌`w肵ĂB
	 * @param bIsBold [in]
	 *	Ȃ true , łȂȂ false w肵ĂB
	 * @param pCdLineProp [out]
	 *	̊֐͂̃IuWFNgɁA
	 *	ݒ肵܂B
	 */
	void CentDedRessyasyubetsu_to_CDcdFreeLineProp(
		COLORREF aCOLORREF ,
		CentDedRessyasyubetsu::ESenStyle eSenStyle , 
		bool bIsBold , 
		CDcdFreeLine::CdLineProp* pCdLineProp )	;
	
	
	// ********************************
	//	CentDedRessya
	// ********************************
	
	/**
	 *	  CdConnectedString IuWFNgɁA
	 *	  CentDedRessya ̑ǉ܂B
	 *	@param pCentDedRessya [in]
	 *	  CentDedRessya w肵ĂB
	 *	@param pCdConnectedString [in,out]
	 *	  ̊֐́ÃIuWFNgɁA CdConnectedString2::CdItem 
	 *	ǉ܂B
	 *	  ̃IuWFNg܂ŕێĂ CdConnectedString2::CdItem 
	 *	ێ܂B
	 *	@return
	 *	   0 ȏAG[Ȃ畉̐łB
	 *	-	-12 ;	//	DiagramEkiatsukai ̒lsłB
	 */
	int CentDedRessya_To_CdConnectedString( 
			const CentDedRessya* pCentDedRessya , 
			CdConnectedString2* pCdConnectedString ) ;
	
	/**
	 *	  CdConnectedString IuWFNgA
	 *	  CentDedRessya_To_CdConnectedString() ֐ɂč쐬ꂽ
	 *	ACeǂݍ݁A CentDedRessya IuWFNgɔf܂B
	 *	
	 *	  A
	 *
	 *		- ԕ
	 *		- IuWFNg܂ wwx ̐
	 *
	 *	́AύX܂B̒ĺA֐ďoɂĐݒ肳Ă
	 *	Kv܂B
	 *	@param pCentDedRessya [in,out]
	 *	  ̊֐͂̃IuWFNgɁAԂ̑𔽉f܂B
	 *	\n AIuWFNg̑wԕx
	 *	܂ wwx ͕̐ύX܂B
	 *	̒ĺA֐ďoɂĐݒ肳ĂKv܂B
	 *	@param aCdConnectedString [in]
	 *	  ێĂ CdConnectedString IuWFNgw肵ĂB
	 *	@return
	 *	   0 ȏAG[Ȃ畉̐łB
	 *	-	-12 ;	//	DiagramEkiatsukai ̒lsłB
	 */
	int CentDedRessya_From_CdConnectedString( 
			CentDedRessya* pCentDedRessya ,
			const CdConnectedString2& aCdConnectedString ) ;
	
	
	// ********************************
	//	CentDedRessyaCont
	// ********************************
	
	/**
	 *	  CdConnectedString IuWFNgɁA
	 *	  CentDedRessyaCont ̑ǉ܂B
	 *	@param pCentDedRessyaCont [in]
	 *	  CentDedRessya w肵ĂB
	 *	@param pCdConnectedString [in,out]
	 *	  ̊֐́ÃIuWFNgɁA CdConnectedString2::CdItem 
	 *	ǉ܂B
	 *	  ̃IuWFNg܂ŕێĂ CdConnectedString2::CdItem 
	 *	ێ܂B
	 *	@return
	 *	   0 ȏAG[Ȃ畉̐łB
	 *	-	-12 ;	//	DiagramEkiatsukai ̒lsłB
	 */
	int CentDedRessyaCont_To_CdConnectedString( 
			const CentDedRessyaCont* pCentDedRessyaCont , 
			CdConnectedString2* pCdConnectedString ) ;
	
	/**
	 *	  CdConnectedString IuWFNgA
	 *	  CentDedRessya_To_CdConnectedString() ֐ɂč쐬ꂽ
	 *	ACeǂݍ݁A CentDedRessya IuWFNgɔf܂B
	 *	
	 *	@param pCentDedRessya [in,out]
	 *	  ̊֐͂̃Rei̖ɁA
	 *	aCdConnectedString IuWFNgɕۑĂ鑮̃IuWFNg
	 *	ǉ܂B
	 *	\n AǉIuWFNg wwx ̐́A
	 *	m_iEkiCount Ɍ܂Ă܂B aCdConectedString ɕۑĂ
	 *	Ԃ葽wwxێĂꍇ́AIw̎
	 *	؎̂ĂƂȂ܂B
	 *	@param aCdConnectedString [in]
	 *	  ێĂ CdConnectedString IuWFNgw肵ĂB
	 *	@return
	 *	   0 ȏAG[Ȃ畉̐łB
	 *	-	-12 ;	//	DiagramEkiatsukai ̒lsłB
	 */
	int CentDedRessyaCont_From_CdConnectedString( 
			CentDedRessyaCont* pCentDedRessyaCont ,
			const CdConnectedString2& aCdConnectedString ) ;
	
	
	// ********************************
	//	CentDedDia
	// ********************************
	
	/**
	 *	  CdConnectedString IuWFNgɁA
	 *	  CentDedDia ̑ǉ܂B
	 *	@param pCentDedDia [in]
	 *	  CentDedDia w肵ĂB
	 *	@param pCdConnectedString [in,out]
	 *	  ̊֐́ÃIuWFNgɁA CdConnectedString2::CdItem 
	 *	ǉ܂B
	 *	  ̃IuWFNg܂ŕێĂ CdConnectedString2::CdItem 
	 *	ێ܂B
	 *	@return
	 *	   0 ȏAG[Ȃ畉̐łB
	 *	-	-12 ;	//	DiagramEkiatsukai ̒lsłB
	 */
	int CentDedDia_To_CdConnectedString( 
			const CentDedDia* pCentDedDia , 
			CdConnectedString2* pCdConnectedString ) ;
	
	/**
	 *	  CdConnectedString IuWFNgA
	 *	  CentDedDia_To_CdConnectedString() ֐ɂč쐬ꂽ
	 *	ACeǂݍ݁A CentDedDia IuWFNgɔf܂B
	 *	
	 *	@param pCentDedDia [in,out]
	 *	  ̊֐͂̃IuWFNgɁA𔽉f܂B
	 *	  ̃IuWFNgɂ́A炩 ww̐xEwԎʐx
	 *	ݒ肳ĂȂĂ͂Ȃ܂B
	 *	@param aCdConnectedString [in]
	 *	  ێĂ CdConnectedString IuWFNgw肵ĂB
	 *	@return
	 *	   0 ȏAG[Ȃ畉̐łB
	 *	-	-12 ;	//	DiagramEkiatsukai ̒lsłB
	 */
	int CentDedDia_From_CdConnectedString( 
			CentDedDia* pCentDedDia ,
			const CdConnectedString2& aCdConnectedString ) ;
	
	// ********************************
	//	CentDedRosen
	// ********************************
	
	/**
	 *	  CdConnectedString IuWFNgɁA
	 *	  CentDedRosen ̑ǉ܂B
	 *	@param pCentDedRosen [in]
	 *	  CentDedRosen w肵ĂB
	 *	@param pCdConnectedString [in,out]
	 *	  ̊֐́ÃIuWFNgɁA CdConnectedString2::CdItem 
	 *	ǉ܂B
	 *	  ̃IuWFNg܂ŕێĂ CdConnectedString2::CdItem 
	 *	ێ܂B
	 *	@return
	 *	   0 ȏAG[Ȃ畉̐łB
	 */
	int CentDedRosen_To_CdConnectedString( 
			const CentDedRosen* pCentDedRosen , 
			CdConnectedString2* pCdConnectedString ) ;
	
	/**
	 *	  CdConnectedString IuWFNgA
	 *	  CentDedRosen_To_CdConnectedString() ֐ɂč쐬ꂽ
	 *	ACeǂݍ݁A CentDedRosen IuWFNgɔf܂B
	 *	
	 *	@param pCentDedRosen [out]
	 *	  ̊֐͂̃IuWFNgɁA𔽉f܂B
	 *	@param aCdConnectedString [in]
	 *	  ێĂ CdConnectedString IuWFNgw肵ĂB
	 *	@return
	 *	   0 ȏAG[Ȃ畉̐łB
	 *	-	-2 ;	//	wԎʁx́AȂƂ
	 *				//	݂ȂĂ͂Ȃ܂B
	 *	-	-52 ;	//	N_̐ݒ肪sK؂łB
	 */
	int CentDedRosen_From_CdConnectedString( 
			CentDedRosen* pCentDedRosen ,
			const CdConnectedString2& aCdConnectedString ) ;
	
	
};	
#endif /*CconvCentDed_h*/
	
