/*
	OuDia - Win32 Application Software to draw a "Train Service Planning
 Diagram" based on a "Train Timetable".

Copyright (C) 2006-2017 take-okm

This program is free software; you can redistribute it and/or modify it 
under the terms of the GNU General Public License as published by the Free 
Software Foundation; either version 3 of the License, or (at your option) 
any later version. 

This program is distributed in the hope that it will be useful, but WITHOUT 
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or 
FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for 
more details. 

You should have received a copy of the GNU General Public License along with
 this program. If not, see <http://www.gnu.org/licenses/>.

  In addition, as a special exception, take-okm
  gives permission to link the code of this program with
  the "MFC(Microsoft Foundation Class library) Version 9.0" 
  (or with modified versions of "MFC Version 9.0" that use the same license as 
  "MFC Version 9.0" ), and distribute linked combinations including
  the two.  You must obey the GNU General Public License in all
  respects for all of the code used other than  "MFC".  If you modify
  this file, you may extend this exception to your version of the
  file, but you are not obligated to do so.  If you do not wish to
  do so, delete this exception statement from your version.


(: 

	OuDia - Ԏ\ƂɁA_CO`悷Win32AvP[V
B

Copyright (C) 2006-2017 take-okm 

̃vO̓t[\tgEFAłBȂ͂At[\tgEFA
cɂĔsꂽGNU ʌOp(o[W3Aȍ~̃o[W
̂ǂꂩ)߂̉ōĔЕz܂͉ 邱Ƃł܂B

̃vO͗Lpł邱ƂĔЕz܂A*S̖ۏ *łB
Ɖ\̕ۏ؂ړIւ̓ḰAOɎꂽ̂ ܂߁AS
܂BڂGNU ʌOpB

Ȃ͂̃vOƋɁAGNU ʌOp̃Rs[ꕔ 󂯎
Ă͂łB󂯎ĂȂ΁A<http://www.gnu.org/licenses/> 
B

)

  āAʂȗOƂāAtake-okm ͂̃vÕR[h 
  "MFC(Microsoft Foundation Class library) Version 9.0" 
  (  邢 "MFC Version 9.0" ƓCZXKpꂽ
  "MFC Version 9.0" ̉ςꂽo[W)ƃNA
  Nꂽ҂܂ތ앨Еz鋖^܂B
  Ȃ "MFC" ȊOŎgĂ邷ׂ
  ̃R[hɊւĂ͑SʓIGNUʌOp_񏑂ɏ]Ȃ
  Ȃ܂BȂ̃t@CςȂ΁AȂ̗͂O
  Ȃ̃o[W̃t@CɈ݂邱Ƃł܂A
  `͂܂BO݂Ȃ΁A̗O
  Ȃ̃o[W͍폜ĂB)
*/
/*
// ****************************************************************
//	CaValueCont.h
// ****************************************************************
*/
/** @file */
#ifndef  CaValueCont_h
#define  CaValueCont_h

#include "./IfValueCont.h"
// ****************************************************************
//	CaValueCont
// ****************************************************************
/**
 * @brief
 * yTvz
 *   A_v^NXłBlێRei 
 *	"IfValueCont< ElementType >" 𑀍ΏۂƂARei
 *	vfւ̃|C^EQƂԂ "IfContGet" C^[tF[Xɕϊ܂B
 * 
 * (  |C^ێReiɂ́ÃA_v^͎g܂)
 * 
 *   ̃A_v^NXgƁAȉ̃C^[tF[X擾
 *	Ƃł܂BΉ郁\bhĂяoĂB
 *
 * 	- "IfContGet< ElementType* >" EEE getIfContGetPtr()
 * 	- "IfContGet< const ElementType* >" EEE getIfContGetConstPtr() 
 * 	- "IfContGet< ElementType& >" EEE getIfContGetRef()
 * 	- "IfContGet< const ElementType& >" EEE getIfContGetConstRef() 
 * 
 * @param ElementType
 *	ΏۃIuWFNgi[Ăf[^̌^w肵ĂB
 *	ΏۃIuWFNǵA "IfCont<ElementType*>" C^[tF[X
 *	T|[g܂B
 *	̃f[^^́Al^łȂĂ͂Ȃ܂i|C^EQƂ͎gpł܂j
 */
template < class ElementType > class CaValueCont 
{
// ********************************
///@name ֘A
// ********************************
///@{
 private:
	/**
	 *	ΏۃIuWFNgƂȂAReiłB
	 *	̃IuWFNg̔j̐Ӗ́ANX[U[ɂ܂B
	 *	̃IuWFNǵAthisƂ̊֘AۂĂԂ́A
	 *	ȂĂ͂Ȃ܂B
	 */
	IfValueCont<ElementType>*	m_pAdaptee ;
///@}

// ********************************
///@name 
// ********************************
///@{
 private:
	// ********************************
	//	"IfContGet< ElementType* >" EEE getIfContGetPtr()
	// ********************************
	/**
	 * @brief
	 *	CaValueCont::getIfContGetPtr() \bhԂC^[tF[X
	 *	NXłB
	 */
	class XIfContGetPtr : public IfContGet< ElementType* >
	{
	 public:
		virtual int	size()const{
			CaValueCont* pOuter = (CaValueCont*)((char*)this - offsetof(CaValueCont,m_xIfContGetPtr) ) ;
			return pOuter->m_pAdaptee->size() ; } ;
		virtual ElementType* get( int idx )const {
			CaValueCont* pOuter = (CaValueCont*)((char*)this - offsetof(CaValueCont,m_xIfContGetPtr) ) ;
			ElementType*	pRv = pOuter->m_pAdaptee->getp( idx ) ;
			return ( pRv ) ;
		};
	}	m_xIfContGetPtr ;
	friend class XIfContGetPtr ;
	// ********************************
	// 	"IfContGet< const ElementType* >" EEE getIfContGetConstPtr() 
	// ********************************
	/**
	 * @brief
	 *	CaValueCont::getIfContGetConstPtr() \bhԂC^[tF[X
	 *	NXłB
	 */
	class XIfContGetConstPtr : public IfContGet< const ElementType* >
	{
	 public:
		virtual int	size()const{
			CaValueCont* pOuter = (CaValueCont*)((char*)this - offsetof(CaValueCont,m_xIfContGetConstPtr) ) ;
			return pOuter->m_pAdaptee->size() ; } ;
		virtual const ElementType* get( int idx )const {
			CaValueCont* pOuter = (CaValueCont*)((char*)this - offsetof(CaValueCont,m_xIfContGetConstPtr) ) ;
			ElementType*	pRv = pOuter->m_pAdaptee->getp( idx ) ;
			return ( pRv ) ;
		};
	}	m_xIfContGetConstPtr ;
	friend class XIfContGetConstPtr ;

	// ********************************
	// 	"IfContGet< ElementType& >" EEE getIfContGetRef()
	// ********************************
	/**
	 * @brief
	 *	CaValueCont::getIfContGetRef() \bhԂC^[tF[X
	 *	NXłB
	 */
	class XIfContGetRef : public IfContGet< ElementType& >
	{
	 public:
		virtual int	size()const{
			CaValueCont* pOuter = (CaValueCont*)((char*)this - offsetof(CaValueCont,m_xIfContGetRef) ) ;
			return pOuter->m_pAdaptee->size() ; } ;
		virtual ElementType& get( int idx )const {
			CaValueCont* pOuter = (CaValueCont*)((char*)this - offsetof(CaValueCont,m_xIfContGetRef) ) ;
			ElementType&	pRv = *pOuter->m_pAdaptee->getp( idx ) ;
			return ( pRv ) ;
		};
	}	m_xIfContGetRef ;
	friend class XIfContGetRef ;
	// ********************************
	// 	"IfContGet< const ElementType& >" EEE getIfContGetConstRef() 
	// ********************************
	/**
	 * @brief
	 *	CaValueCont::getIfContGetConstRef() \bhԂC^[tF[X
	 *	NXłB
	 */
	class XIfContGetConstRef : public IfContGet< const ElementType& >
	{
	 public:
		virtual int	size()const{
			CaValueCont* pOuter = (CaValueCont*)((char*)this - offsetof(CaValueCont,m_xIfContGetConstRef) ) ;
			return pOuter->m_pAdaptee->size() ; } ;
		virtual const ElementType& get( int idx )const {
			CaValueCont* pOuter = (CaValueCont*)((char*)this - offsetof(CaValueCont,m_xIfContGetConstRef) ) ;
			ElementType&	pRv = *pOuter->m_pAdaptee->getp( idx ) ;
			return ( pRv ) ;
		};
	}	m_xIfContGetConstRef ;
	friend class XIfContGetConstRef ;

///@}
// ********************************
//	RXgN^
// ********************************
 public:
	CaValueCont( IfValueCont<ElementType>* pAdaptee ) : 
		m_pAdaptee( pAdaptee ) {};
 private:
	CaValueCont( const CaValueCont<ElementType>& ){};
	CaValueCont& operator=( const CaValueCont<ElementType>& ){ return *this ;};

// ********************************
//	CaValueCont
// ********************************
 public:
	// ********************************
	///@name ֘A
	// ********************************
	///@{
	IfValueCont<ElementType>*	getAdaptee(){	return m_pAdaptee ;};
	const IfValueCont<ElementType>*	getAdaptee()const{	return m_pAdaptee ;};
	CaValueCont& setAdaptee( IfValueCont<ElementType>*	value )
	{
		m_pAdaptee = value ; 	return *this ;
	};
	///@}
	// ********************************
	///@name 
	// ********************************
	///@{
	IfContGet< ElementType* >* getIfContGetPtr(){
		return &m_xIfContGetPtr ;};
	IfContGet< const ElementType* >*  getIfContGetConstPtr(){
		return &m_xIfContGetConstPtr ;};
	IfContGet< ElementType& >* getIfContGetRef(){
		return m_xIfContGetRef ;};
	IfContGet< const ElementType& >* getIfContGetConstRef(){
		return &m_xIfContGetConstRef ;};

	const IfContGet< ElementType* >* getIfContGetPtr()const {
		return &m_xIfContGetPtr ;};
	const IfContGet< const ElementType* >*  getIfContGetConstPtr()const {
		return &m_xIfContGetConstPtr ;};
	const IfContGet< ElementType& >* getIfContGetRef()const {
		return m_xIfContGetRef ;};
	const IfContGet< const ElementType& >* getIfContGetConstRef()const {
		return &m_xIfContGetConstRef ;};
	///@}
};

#endif /*CaValueCont_h*/
