/*
	OuDia - Win32 Application Software to draw a "Train Service Planning
 Diagram" based on a "Train Timetable".

Copyright (C) 2006-2017 take-okm

This program is free software; you can redistribute it and/or modify it 
under the terms of the GNU General Public License as published by the Free 
Software Foundation; either version 3 of the License, or (at your option) 
any later version. 

This program is distributed in the hope that it will be useful, but WITHOUT 
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or 
FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for 
more details. 

You should have received a copy of the GNU General Public License along with
 this program. If not, see <http://www.gnu.org/licenses/>.

  In addition, as a special exception, take-okm
  gives permission to link the code of this program with
  the "MFC(Microsoft Foundation Class library) Version 9.0" 
  (or with modified versions of "MFC Version 9.0" that use the same license as 
  "MFC Version 9.0" ), and distribute linked combinations including
  the two.  You must obey the GNU General Public License in all
  respects for all of the code used other than  "MFC".  If you modify
  this file, you may extend this exception to your version of the
  file, but you are not obligated to do so.  If you do not wish to
  do so, delete this exception statement from your version.


(: 

	OuDia - Ԏ\ƂɁA_CO`悷Win32AvP[V
B

Copyright (C) 2006-2017 take-okm 

̃vO̓t[\tgEFAłBȂ͂At[\tgEFA
cɂĔsꂽGNU ʌOp(o[W3Aȍ~̃o[W
̂ǂꂩ)߂̉ōĔЕz܂͉ 邱Ƃł܂B

̃vO͗Lpł邱ƂĔЕz܂A*S̖ۏ *łB
Ɖ\̕ۏ؂ړIւ̓ḰAOɎꂽ̂ ܂߁AS
܂BڂGNU ʌOpB

Ȃ͂̃vOƋɁAGNU ʌOp̃Rs[ꕔ 󂯎
Ă͂łB󂯎ĂȂ΁A<http://www.gnu.org/licenses/> 
B

)

  āAʂȗOƂāAtake-okm ͂̃vÕR[h 
  "MFC(Microsoft Foundation Class library) Version 9.0" 
  (  邢 "MFC Version 9.0" ƓCZXKpꂽ
  "MFC Version 9.0" ̉ςꂽo[W)ƃNA
  Nꂽ҂܂ތ앨Еz鋖^܂B
  Ȃ "MFC" ȊOŎgĂ邷ׂ
  ̃R[hɊւĂ͑SʓIGNUʌOp_񏑂ɏ]Ȃ
  Ȃ܂BȂ̃t@CςȂ΁AȂ̗͂O
  Ȃ̃o[W̃t@CɈ݂邱Ƃł܂A
  `͂܂BO݂Ȃ΁A̗O
  Ȃ̃o[W͍폜ĂB)
*/
/*
// ****************************************************************
//	CentDedEkiCont.cpp
// ****************************************************************
*/
#include "stdafx.h"

#include "CentDedEkiCont.h"

#ifndef _CONSOLE
#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif
#endif


// ----------------------------------------------------------------
//	CentDedEkiCont::ContKudari
// ----------------------------------------------------------------
int CentDedEkiCont::ContKudari::size()const 
{
	CentDedEkiCont* pAdaptee = (CentDedEkiCont*)( (char*)this - offsetof( CentDedEkiCont , CentDedEkiCont::m_xContKudari ) ) ;
	
	return pAdaptee->size() ;
}
CentDedEkiCont::CdDedEki CentDedEkiCont::ContKudari::get(int iEkiOrder )const 
{
	CentDedEkiCont* pAdaptee = (CentDedEkiCont*)( (char*)this - offsetof( CentDedEkiCont , CentDedEkiCont::m_xContKudari ) ) ;
	
	int iEkiIndex = pAdaptee->EkiIndexOfEkiOrder( Ressyahoukou_Kudari , iEkiOrder ) ;
	CentDedEki aCentDedEki = pAdaptee->m_CentDedEkiCont.get( iEkiIndex ) ;

	CentDedEkiCont::CdDedEki aCdDedEki( 
		aCentDedEki.getEkimei() , 
		aCentDedEki.getEkijikokukeisiki() == CentDedEki::Jikokukeisiki_Hatsuchaku || 
		aCentDedEki.getEkijikokukeisiki() == CentDedEki::Jikokukeisiki_KudariChaku , 
		aCentDedEki.getEkijikokukeisiki() == CentDedEki::Jikokukeisiki_Hatsuchaku || 
		aCentDedEki.getEkijikokukeisiki() == CentDedEki::Jikokukeisiki_Hatsu || 
		aCentDedEki.getEkijikokukeisiki() == CentDedEki::Jikokukeisiki_NoboriChaku ,
		aCentDedEki.getEkikibo() ,
		aCentDedEki.getKyoukaisen() ) ;

	if ( iEkiOrder == pAdaptee->size() - 1 ){
		//	I_wł́Aw`́wxȊOȂA
		//	̂ݕ\Ƃ܂B
		//	܂AE͂Ȃɂ܂B
		if ( aCentDedEki.getEkijikokukeisiki() != CentDedEki::Jikokukeisiki_Hatsuchaku ){
			aCdDedEki.setChakujikokuHyouji( true ) ;
			aCdDedEki.setHatsujikokuHyouji( false ) ;
		}
		aCdDedEki.setKyoukaisen( false ) ;	
	}


	return ( aCdDedEki ) ;
	
}
// ----------------------------------------------------------------
//	CentDedEkiCont::ContNobori
// ----------------------------------------------------------------
int CentDedEkiCont::ContNobori::size()const 
{
	CentDedEkiCont* pAdaptee = (CentDedEkiCont*)( (char*)this - offsetof( CentDedEkiCont , CentDedEkiCont::m_xContNobori ) ) ;
	
	return pAdaptee->size() ;
}
CentDedEkiCont::CdDedEki CentDedEkiCont::ContNobori::get(int iEkiOrder )const 
{
	CentDedEkiCont* pAdaptee = (CentDedEkiCont*)( (char*)this - offsetof( CentDedEkiCont , CentDedEkiCont::m_xContNobori ) ) ;
	
	int iEkiIndex = pAdaptee->EkiIndexOfEkiOrder( Ressyahoukou_Nobori , iEkiOrder ) ;
	CentDedEki aCentDedEki = pAdaptee->m_CentDedEkiCont.get( iEkiIndex ) ;
	CentDedEki aCentDedEkiPrev ;
	if ( iEkiIndex > 0 ){
		aCentDedEkiPrev = pAdaptee->m_CentDedEkiCont.get( iEkiIndex - 1 ) ;
	}

	CentDedEkiCont::CdDedEki aCdDedEki( 
		aCentDedEki.getEkimei() , 
		aCentDedEki.getEkijikokukeisiki() == CentDedEki::Jikokukeisiki_Hatsuchaku || 
		aCentDedEki.getEkijikokukeisiki() == CentDedEki::Jikokukeisiki_NoboriChaku , 
		aCentDedEki.getEkijikokukeisiki() == CentDedEki::Jikokukeisiki_Hatsuchaku || 
		aCentDedEki.getEkijikokukeisiki() == CentDedEki::Jikokukeisiki_Hatsu || 
		aCentDedEki.getEkijikokukeisiki() == CentDedEki::Jikokukeisiki_KudariChaku ,
		aCentDedEki.getEkikibo() ,
		aCentDedEkiPrev.getKyoukaisen() ) ;

	if ( iEkiOrder == pAdaptee->size() - 1 ){
		//	I_wł́Aw`́wxȊOȂA
		//	̂ݕ\Ƃ܂B
		//	܂AE͂Ȃɂ܂B
		if ( aCentDedEki.getEkijikokukeisiki() != CentDedEki::Jikokukeisiki_Hatsuchaku ){
			aCdDedEki.setChakujikokuHyouji( true ) ;
			aCdDedEki.setHatsujikokuHyouji( false ) ;
		}
		aCdDedEki.setKyoukaisen( false ) ;	
	}


	return ( aCdDedEki ) ;
	
}
// ****************************************************************
//	CentDedEkiCont
// ****************************************************************
// ********************************
//	RXgN^
// ********************************
CentDedEkiCont::CentDedEkiCont() 
{
	m_pCaValueCont = new CaValueCont<CentDedEki>( &m_CentDedEkiCont ) ;
}
CentDedEkiCont::CentDedEkiCont( const CentDedEkiCont& value ) 
{
	m_pCaValueCont = new CaValueCont<CentDedEki>( &m_CentDedEkiCont ) ;
	m_CentDedEkiCont = value.m_CentDedEkiCont ;
}
CentDedEkiCont& CentDedEkiCont::operator=( const CentDedEkiCont& value ) 
{
	m_CentDedEkiCont = value.m_CentDedEkiCont ;
	return *this ;
}
CentDedEkiCont::~CentDedEkiCont() 
{
	delete m_pCaValueCont ;
}

// ********************************
//	CentDedEkiCont
// ********************************
	// ********************************
	//@name CentDedEkiCont-
	// ********************************
int CentDedEkiCont::EkiIndexOfEkiOrder( 
	ERessyahoukou eRessyahoukou , int iEkiOrder )const 
{
	int iRv = iEkiOrder ;
	if ( eRessyahoukou == Ressyahoukou_Nobori ){
		iRv = size() - 1 - iEkiOrder ;
	}
	return ( iRv ) ;
}
int CentDedEkiCont::EkiOrderOfEkiIndex(  
	ERessyahoukou eRessyahoukou , int iEkiIndex )const 
{
	int iRv = iEkiIndex ;
	if ( eRessyahoukou == Ressyahoukou_Nobori ){
		iRv = size() - 1 - iEkiIndex ;
	}
	return ( iRv ) ;
}

int CentDedEkiCont::JikokuhyouIndexOfJikokuOrder( 
		ERessyahoukou eRessyahoukou , 
		int iJikokuOrder  )const
{
	//	JikokuOrder肵AJikokuOrder܂B
	int iJikokuhyouIndex = -1 ;	

	const IfContGet<CentDedEkiCont::CdDedEki>* pCdDedEkiCont = 
		getIfContGet( eRessyahoukou ) ;

	if ( iJikokuOrder == INT_MAX )
	{
		iJikokuOrder = pCdDedEkiCont->size() * 2 ;
	}
	if ( !( 0 <= iJikokuOrder && iJikokuOrder <= INT_MAX ) )
	{
		return -1 ;
	}
	else	
	{
		int iJikokuhyouIndexCurr = 0 ;
		int iJikokuOrderCurr = 0 ; 
		for ( iJikokuOrderCurr = 0 ; 
			iJikokuOrderCurr < iJikokuOrder ; iJikokuOrderCurr ++ )
		{
			int iEkiOrderCurr = iJikokuOrderCurr / 2 ;
			int iHatsu = iJikokuOrderCurr % 2 ;
			CdDedEki aCdDedEki = pCdDedEkiCont->get( iEkiOrderCurr ) ;
			if ( iHatsu == 0 && aCdDedEki.getChakujikokuHyouji() )
			{
				iJikokuhyouIndexCurr ++ ;
			}
			if ( iHatsu == 1 && aCdDedEki.getHatsujikokuHyouji() )
			{
				iJikokuhyouIndexCurr ++ ;
			}
		}
		//iJikokuhyouIndexCurr = w肳ꂽJikokuOrder ȑOɕ\鎞̐

		if ( iJikokuOrder == pCdDedEkiCont->size() * 2 )
		{
			//	\񐔂ׂĂ擾܂B
			iJikokuhyouIndex = iJikokuhyouIndexCurr ;
		}
		else
		{
			int iEkiOrderCurr = iJikokuOrderCurr / 2 ;
			int iHatsu = iJikokuOrderCurr % 2 ;
			CdDedEki aCdDedEki = pCdDedEkiCont->get( iEkiOrderCurr ) ;
			if ( iHatsu == 0 && aCdDedEki.getChakujikokuHyouji() )
			{
				iJikokuhyouIndex = iJikokuhyouIndexCurr ;
			}
			else if ( iHatsu == 1 && aCdDedEki.getHatsujikokuHyouji() )
			{
				iJikokuhyouIndex = iJikokuhyouIndexCurr ;
			}
		}

	}
	return iJikokuhyouIndex ;

}

int CentDedEkiCont::JikokuOrderOfJikokuhyouIndex( 
		ERessyahoukou eRessyahoukou , 
		int iJikokuhyouIndex  )const 
{
	const IfContGet<CentDedEkiCont::CdDedEki>* pCdDedEkiCont = 
		getIfContGet( eRessyahoukou ) ;

	int iJikokuhyouIndexCurr = 0 ;
	int iJikokuOrderCurr = 0 ; 
	int iJikokuOrder = -1 ;

	for ( iJikokuOrderCurr = 0 ; 
		iJikokuOrderCurr < pCdDedEkiCont->size() * 2  ; 
		iJikokuOrderCurr ++ )
	{
		int iEkiOrderCurr = iJikokuOrderCurr / 2 ;
		int iHatsu = iJikokuOrderCurr % 2 ;
		CdDedEki aCdDedEki = pCdDedEkiCont->get( iEkiOrderCurr ) ;
		if ( iHatsu == 0 && aCdDedEki.getChakujikokuHyouji() )
		{
			if ( iJikokuhyouIndexCurr == iJikokuhyouIndex )
			{
				iJikokuOrder = iJikokuOrderCurr ;
				break ;
			}
			iJikokuhyouIndexCurr ++ ;
		}
		if ( iHatsu == 1 && aCdDedEki.getHatsujikokuHyouji() )
		{
			if ( iJikokuhyouIndexCurr == iJikokuhyouIndex )
			{
				iJikokuOrder = iJikokuOrderCurr ;
				break ;
			}
			iJikokuhyouIndexCurr ++ ;
		}
	}
	//iJikokuhyouIndexCurr = w肳ꂽJikokuOrder ȑOɕ\鎞̐
	//iJikokuhyouIndexCurr = w肳ꂽJikokuOrder ȑOɕ\鎞̐

	return iJikokuOrder ;
}
