/*
	OuDia - Win32 Application Software to draw a "Train Service Planning
 Diagram" based on a "Train Timetable".

Copyright (C) 2006-2017 take-okm

This program is free software; you can redistribute it and/or modify it 
under the terms of the GNU General Public License as published by the Free 
Software Foundation; either version 3 of the License, or (at your option) 
any later version. 

This program is distributed in the hope that it will be useful, but WITHOUT 
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or 
FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for 
more details. 

You should have received a copy of the GNU General Public License along with
 this program. If not, see <http://www.gnu.org/licenses/>.

  In addition, as a special exception, take-okm
  gives permission to link the code of this program with
  the "MFC(Microsoft Foundation Class library) Version 9.0" 
  (or with modified versions of "MFC Version 9.0" that use the same license as 
  "MFC Version 9.0" ), and distribute linked combinations including
  the two.  You must obey the GNU General Public License in all
  respects for all of the code used other than  "MFC".  If you modify
  this file, you may extend this exception to your version of the
  file, but you are not obligated to do so.  If you do not wish to
  do so, delete this exception statement from your version.


(: 

	OuDia - Ԏ\ƂɁA_CO`悷Win32AvP[V
B

Copyright (C) 2006-2017 take-okm 

̃vO̓t[\tgEFAłBȂ͂At[\tgEFA
cɂĔsꂽGNU ʌOp(o[W3Aȍ~̃o[W
̂ǂꂩ)߂̉ōĔЕz܂͉ 邱Ƃł܂B

̃vO͗Lpł邱ƂĔЕz܂A*S̖ۏ *łB
Ɖ\̕ۏ؂ړIւ̓ḰAOɎꂽ̂ ܂߁AS
܂BڂGNU ʌOpB

Ȃ͂̃vOƋɁAGNU ʌOp̃Rs[ꕔ 󂯎
Ă͂łB󂯎ĂȂ΁A<http://www.gnu.org/licenses/> 
B

)

  āAʂȗOƂāAtake-okm ͂̃vÕR[h 
  "MFC(Microsoft Foundation Class library) Version 9.0" 
  (  邢 "MFC Version 9.0" ƓCZXKpꂽ
  "MFC Version 9.0" ̉ςꂽo[W)ƃNA
  Nꂽ҂܂ތ앨Еz鋖^܂B
  Ȃ "MFC" ȊOŎgĂ邷ׂ
  ̃R[hɊւĂ͑SʓIGNUʌOp_񏑂ɏ]Ȃ
  Ȃ܂BȂ̃t@CςȂ΁AȂ̗͂O
  Ȃ̃o[W̃t@CɈ݂邱Ƃł܂A
  `͂܂BO݂Ȃ΁A̗O
  Ȃ̃o[W͍폜ĂB)
*/
/*
// ****************************************************************
//	CentDedRessyasyubetsu.h
// ****************************************************************
*/
/** @file */
#ifndef  CentDedRessyasyubetsu_h
#define  CentDedRessyasyubetsu_h

#include <string>

#include "DcDraw\CdColorProp.h"
#include "DcDraw\CdFontProp.h"


// ****************************************************************
//	CentDedRessyasyubetsu
// ****************************************************************
/**
 * @brief
 *	yTvz  DiagramEdit ́AHŉ^sԂ́wԎʁx
 *	Pނ\܂B
 *	
 *	  ƂāAwʖxƁA̗Ԏʂ\鎞\r[E
 *	_COr[ł̕`FEX^Cێ܂B
 */
class CentDedRessyasyubetsu
{
// ********************************
//	Ci[^Cv
// ********************************
 public:
	/**
	 *	()̌`\񋓂łB
	 */
	enum ESenStyle
	{
		/**  */
		SenStyle_Jissen = 0 ,
		/** j */
		SenStyle_Hasen ,
		/** _ */
		SenStyle_Tensen ,
		/** _ */
		SenStyle_Ittensasen ,
	};
	
// ********************************
///@name 
// ********************************
///@{
 private:
	/**
	 *	ʖB
	 *
	 *	KĺA󕶎B
	 *
	 *	̒l󕶎̏ꍇÃIuWFNg͖łB
	 */
	std::string	m_strSyubetsumei ;
	
	/**
	 *	́iʖ̗́jB
	 *
	 *	KĺA󕶎B
	 */
	std::string	m_strRyakusyou ;
	
	/**
	 *	\F(_CO̗ԏ̕F˂܂)
	 *
	 *	KĺAB
	 */
	CdColorProp	m_colorJikokuhyouMojiColor ;
	/**
		ԎʌŗĹA\tHgB

		\r[ŁA̎ʂ̗Ԃ̏Ɏg܂B
		NULLȂÃtHgiCdDedDispProp::m_fontpropJikokuhyouFontj
		g܂B
	*/
	CdFontProp m_fontJikokuhyouFont ;
	/**
	 *	_CO̐FB
	 *
	 *	KĺAB
	 */
	CdColorProp	m_colorDiagramSenColor ;

	/**
	 *	_CO̐X^CB
	 *
	 *	KĺA SenStyle_Jissen
	 */
	ESenStyle	m_eDiagramSenStyle ;
	
	/**
	 *	_CO̐̑B
	 *
	 *	_CO̐ł trueB
	 *	אȂ false łB
	 *
	 *	KĺA false łB
	 */
	bool m_bDiagramSenIsBold ;
	/**
		ԎʌŗĹA_COʗԃtHgB

		_COr[ŁA̎ʂ̗Ԃ̏Ɏg܂B
		NULLȂÃtHgiCdDedDispProp::m_fontpropDiaRessyaFontj
		g܂B
	*/
	CdFontProp m_fontDiagramRessyaFont ;
///@}
// ********************************
//	RXgN^
// ********************************
 public:
	/**
	 * @param strSyubetsumei [in]
	 *	ʖB
	 * @param strRyakusyou [in]
	 *	́iʖ̗́jB
	 * @param colorJikokuhyouMojiColor [in]
	 *	\FB
	 * @param colorDiagramSenColor [in] 
	 *	_CO̐FB
	 * @param eDiagramSenStyle [in]
	 *	_CO̐X^CB
	 * @param bDiagramSenIsBold [in]
	 *	_CO̐̑B
	 *	_CO̐ł trueB
	 *	אȂ false łB
	 */
	CentDedRessyasyubetsu( 
			const std::string& strSyubetsumei ,
			const std::string& strRyakusyou ,
			CdColorProp	colorJikokuhyouMojiColor = CdColorProp( 0 , 0 ,0 ), 
			CdColorProp	colorDiagramSenColor = CdColorProp( 0 , 0 , 0 ),
			ESenStyle	eDiagramSenStyle = SenStyle_Jissen ,
			bool bDiagramSenIsBold = false ) :
		m_strSyubetsumei( strSyubetsumei ) ,
		m_strRyakusyou( strRyakusyou ) ,
		m_colorJikokuhyouMojiColor( colorJikokuhyouMojiColor ) , 
		m_colorDiagramSenColor( colorDiagramSenColor ) ,
		m_eDiagramSenStyle( eDiagramSenStyle ) ,
		m_bDiagramSenIsBold( bDiagramSenIsBold ){};

	CentDedRessyasyubetsu() :
		m_colorJikokuhyouMojiColor( CdColorProp( 0 , 0 , 0 ) ) , 
		m_colorDiagramSenColor( CdColorProp( 0 , 0 , 0  ) ) ,
		m_eDiagramSenStyle( SenStyle_Jissen ) ,
		m_bDiagramSenIsBold( false ){};



// ********************************
//	CentDedRessyasyubetsu
// ********************************
 public:
	// ********************************
	///@name 
	// ********************************
	///@{
	std::string	getSyubetsumei()const{	return 	m_strSyubetsumei ;};
	CentDedRessyasyubetsu& setSyubetsumei( const std::string& value )
	{	m_strSyubetsumei = value ; return *this ; } ;

	std::string	getRyakusyou()const{	return m_strRyakusyou ;};
	CentDedRessyasyubetsu& setRyakusyou( const std::string& value )
	{	m_strRyakusyou = value ; return *this ; } ;
	
	CdColorProp	getJikokuhyouMojiColor()const{
		return m_colorJikokuhyouMojiColor ;};
	CentDedRessyasyubetsu& setJikokuhyouMojiColor( const CdColorProp&	value )
	{	m_colorJikokuhyouMojiColor = value ; return *this ; } ;

	CdFontProp getJikokuhyouFont()const
	{	return m_fontJikokuhyouFont ;};
	CentDedRessyasyubetsu& setJikokuhyouFont( const CdFontProp& value )
	{	m_fontJikokuhyouFont = value ; return *this ;};

	CdColorProp	getDiagramSenColor()const{
		return 	m_colorDiagramSenColor ;};
	CentDedRessyasyubetsu& setDiagramSenColor( const CdColorProp&	value ){
		m_colorDiagramSenColor = value ; return *this ; } ;

	ESenStyle	getDiagramSenStyle()const{	return m_eDiagramSenStyle ;};
	CentDedRessyasyubetsu& setDiagramSenStyle( ESenStyle value ){
		m_eDiagramSenStyle = value ; return *this ;};
	bool getDiagramSenIsBold()const{ return m_bDiagramSenIsBold ; };
	CentDedRessyasyubetsu& setDiagramSenIsBold( bool value ){
		m_bDiagramSenIsBold = value ; return *this ;};

	CdFontProp getDiagramRessyaFont()const
	{	return m_fontDiagramRessyaFont ;};
	CentDedRessyasyubetsu& setDiagramRessyaFont( const CdFontProp& value )
	{	m_fontDiagramRessyaFont = value ; return *this ;};


	///@}

	// ********************************
	///@name 
	// ********************************
	///@{

	///@}
};


#endif /*CentDedRessyasyubetsu_h*/


