/*
	OuDia - Win32 Application Software to draw a "Train Service Planning
 Diagram" based on a "Train Timetable".

Copyright (C) 2006-2017 take-okm

This program is free software; you can redistribute it and/or modify it 
under the terms of the GNU General Public License as published by the Free 
Software Foundation; either version 3 of the License, or (at your option) 
any later version. 

This program is distributed in the hope that it will be useful, but WITHOUT 
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or 
FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for 
more details. 

You should have received a copy of the GNU General Public License along with
 this program. If not, see <http://www.gnu.org/licenses/>.

  In addition, as a special exception, take-okm
  gives permission to link the code of this program with
  the "MFC(Microsoft Foundation Class library) Version 9.0" 
  (or with modified versions of "MFC Version 9.0" that use the same license as 
  "MFC Version 9.0" ), and distribute linked combinations including
  the two.  You must obey the GNU General Public License in all
  respects for all of the code used other than  "MFC".  If you modify
  this file, you may extend this exception to your version of the
  file, but you are not obligated to do so.  If you do not wish to
  do so, delete this exception statement from your version.


(: 

	OuDia - Ԏ\ƂɁA_CO`悷Win32AvP[V
B

Copyright (C) 2006-2017 take-okm 

̃vO̓t[\tgEFAłBȂ͂At[\tgEFA
cɂĔsꂽGNU ʌOp(o[W3Aȍ~̃o[W
̂ǂꂩ)߂̉ōĔЕz܂͉ 邱Ƃł܂B

̃vO͗Lpł邱ƂĔЕz܂A*S̖ۏ *łB
Ɖ\̕ۏ؂ړIւ̓ḰAOɎꂽ̂ ܂߁AS
܂BڂGNU ʌOpB

Ȃ͂̃vOƋɁAGNU ʌOp̃Rs[ꕔ 󂯎
Ă͂łB󂯎ĂȂ΁A<http://www.gnu.org/licenses/> 
B

)

  āAʂȗOƂāAtake-okm ͂̃vÕR[h 
  "MFC(Microsoft Foundation Class library) Version 9.0" 
  (  邢 "MFC Version 9.0" ƓCZXKpꂽ
  "MFC Version 9.0" ̉ςꂽo[W)ƃNA
  Nꂽ҂܂ތ앨Еz鋖^܂B
  Ȃ "MFC" ȊOŎgĂ邷ׂ
  ̃R[hɊւĂ͑SʓIGNUʌOp_񏑂ɏ]Ȃ
  Ȃ܂BȂ̃t@CςȂ΁AȂ̗͂O
  Ȃ̃o[W̃t@CɈ݂邱Ƃł܂A
  `͂܂BO݂Ȃ΁A̗O
  Ȃ̃o[W͍폜ĂB)
*/
/*
// ****************************************************************
//	CDcdFillRectangleTextV.cpp
// ****************************************************************
*/
//#include "stdafx.h"

#include <deque>
using namespace std ;

#include "CDcdFillRectangleTextV.h"
#include "DcDraw/CaDcdTargetItemPosition.h"
#include "DcDraw/CConverter_WinGdi.h"
#include "str/CStrCharSizeMb.h"

//#ifdef _DEBUG
//#define new DEBUG_NEW
//#undef THIS_FILE
//static char THIS_FILE[] = __FILE__;
//#endif

// ********************************
//	RXgN^
// ********************************
CDcdFillRectangleTextV::CDcdFillRectangleTextV( 
		const tstring&			strText  ,
		const CdFontProp&	aCdFontProp  ,
		int						iLinesExtentX  ,
		int						iLinesExtentY  ,
		COLORREF	colorrefText , 
		int						logicalunitFrameWidth   ,
		int						logicalunitFrameHeight   ,
		const CdPenProp&		aCdPenProp ,
		const CdBrushProp& 		aCdBrushProp ,
		const tstring&			strExtent )
	: m_CDcdFillrect( aCdBrushProp ) 
	, m_CDcdRectangle(  aCdPenProp ) 
	, m_CDcdText( "" , CdDrawTextProp( aCdFontProp , CConverter_WinGdi().CdColorPropOf( colorrefText ) ) , strExtent)
	, m_logicalunitFrameWidth( logicalunitFrameWidth )
	, m_logicalunitFrameHeight( logicalunitFrameHeight )
	, m_strText( strText ) 
	, m_iLinesExtentX( iLinesExtentX )
	, m_iLinesExtentY( iLinesExtentY ) 
{
	if ( m_CDcdText.getExtent().empty() ){
		m_CDcdText.setExtent( "" ) ;
	}
}


CDcdFillRectangleTextV::CDcdFillRectangleTextV( 
		const CdPenProp&		aCdPenProp ,
		int						logicalunitFrameWidth ,
		int						logicalunitFrameHeight ,
		const tstring&			strText ,
		const CdFontProp&	aCdFontProp ,
		int						iLinesExtentX ,
		int						iLinesExtentY ,
		COLORREF	colorrefText , 
		const CdBrushProp& 		aCdBrushProp ,
		const tstring&			strExtent 
	) 
	: m_CDcdFillrect( aCdBrushProp ) 
	, m_CDcdRectangle(  aCdPenProp ) 
	, m_CDcdText( "" , CdDrawTextProp( aCdFontProp , CConverter_WinGdi().CdColorPropOf( colorrefText ) ) , strExtent)
	, m_logicalunitFrameWidth( logicalunitFrameWidth )
	, m_logicalunitFrameHeight( logicalunitFrameHeight )
	, m_strText( strText ) 
	, m_iLinesExtentX( iLinesExtentX )
	, m_iLinesExtentY( iLinesExtentY ) 
{
	if ( m_CDcdText.getExtent().empty() ){
		m_CDcdText.setExtent( "" ) ;
	}
}

CDcdFillRectangleTextV::CDcdFillRectangleTextV() 
	: m_logicalunitFrameWidth( 0 )
	, m_logicalunitFrameHeight( 0 )
	, m_iLinesExtentX ( 1 ) 
	, m_iLinesExtentY( 1 ) 
{
	if ( m_CDcdText.getExtent().empty() ){
		m_CDcdText.setExtent( "" ) ;
	}
}
	
CDcdFillRectangleTextV::~CDcdFillRectangleTextV() 
{
}
// ********************************
//	IfDcDraw
// ********************************
bool CDcdFillRectangleTextV::DcDraw( IfDcdTarget* pIfDcdTarget ) 
{
	bool	bRv = false ;

	//	wiuV
	{
		if ( m_CDcdFillrect.DcDraw( pIfDcdTarget ) ) {
			bRv = true ;
		}
	}
	//	g
	{
		if ( m_CDcdRectangle.DcDraw( pIfDcdTarget ) ) {
			bRv = true ;
		}
	}

	// --------------------------------
	//	eLXg
	// --------------------------------

	//	m_CDcdText ́A㉺E񂹂ɂ܂B
	//	́ApP\ۂɁAɕ\邽߂łB
	{
		CdDrawTextProp	aCdDrawTextProp = m_CDcdText.getCdDrawTextProp() ;
		aCdDrawTextProp.setCdDrawTextFormat( 
			CdDrawTextFormat(
				 CdDrawTextFormat::H_CENTER , 
				CdDrawTextFormat::V_SINGLELINT_CENTER 
			) 
		) ;
		m_CDcdText.setCdDrawTextProp( aCdDrawTextProp ) ;
	}

	CdDcdZoneXy	aCdDcdZoneXy ;
	{
		aCdDcdZoneXy = pIfDcdTarget->getZone() ;
		aCdDcdZoneXy.setX( CdDcdZone( 
			aCdDcdZoneXy.getX().getPos() + m_logicalunitFrameWidth , 
			aCdDcdZoneXy.getX().getSize() - m_logicalunitFrameWidth * 2 )
			)  ;
		aCdDcdZoneXy.setY( CdDcdZone( 
			aCdDcdZoneXy.getY().getPos() + m_logicalunitFrameHeight , 
			aCdDcdZoneXy.getY().getSize() - m_logicalunitFrameHeight * 2 )
			)  ;
	}
	//aCdDcdZoneXy = eLXg`悷̈łB
	//	IfDcdTargeẗ̗悩A㉺E̘g̈̈łB

	CdDcdSizeXy	sizeExtent ;
	{	
		bRv = m_CDcdText.getItemSize( pIfDcdTarget , &sizeExtent ) ;
		if ( !bRv ){
			return ( bRv ) ;
		}
		sizeExtent.setX( max( sizeExtent.getX() , sizeExtent.getY() ) ) ;
		sizeExtent.setY( sizeExtent.getX() ) ;
	}
	//sizeExtent = eLXgP̃TCYB
	//	ATCY͐`ɂȂ悤ɍœK܂B
	//	܂AX,ŶA傫̕ӂɍ킹܂B

	// ----------------------------------------------------------------
	//	ctHg𐶐
	// ----------------------------------------------------------------
	HFONT hfontVertical = NULL ;
	{
		CdFontProp	aCdFontPropV = m_CDcdText.getCdDrawTextProp().getCdFontProp() ;
		string strFacename = aCdFontPropV.getFacename() ;
		if ( !( strFacename.size() >= 1 && strFacename.substr( 0 , 1 ) == "@" ) ){
			strFacename = string( "@" ) + strFacename ;
		}
		aCdFontPropV.setFacename( strFacename ) ;
		aCdFontPropV.setIsEscapementVertical() ;
		hfontVertical = pIfDcdTarget->CreateFont( aCdFontPropV ) ;

		if ( hfontVertical != NULL ){
			string strFacenameSelected  ;
			{
				HFONT hfontOld = (HFONT)SelectObject( pIfDcdTarget->getHdc() , hfontVertical ) ;
				int iLen = GetTextFace( pIfDcdTarget->getHdc() , 0 , NULL ) ;
				vector<TCHAR>	szFace( iLen + 1 ) ;
				GetTextFace( pIfDcdTarget->getHdc() , (int)szFace.size() , &szFace[0] ) ;
				strFacenameSelected = &szFace[0] ;
				if ( hfontOld != NULL ){
					SelectObject( pIfDcdTarget->getHdc() , hfontOld ) ;
					hfontOld = NULL ;
				}
			}
			//strFacenameSelected = ۂɍ쐬ꂽtHg
			//	^CvtFCXBvƈقȂꍇ܂B

			if ( strFacenameSelected != aCdFontPropV.getFacename() ){
				hfontVertical = NULL ;
			}
		}
	}
	//hfontVertical = cp̃tHg
	//	AҒʂ̃tHgłȂ
	//	ivtHg̃^CvtFCXƁA
	//	ۂɐtHg̃^CvtFCXقȂjꍇ
	//	NULL Ƃ܂B
	//	̏ꍇActHg͎gp܂B

	// ----------------------------------------------------------------
	//	ctHggȂꍇ̂߁A
	//	ꕔ̕ϊi"["  "|"Ɂj
	// ----------------------------------------------------------------
	string	strText = m_strText ;
	if ( hfontVertical == NULL ){
		//	"-","|","","[" ́Ac_ɕύX܂B 
		CStrCharSizeMb	aCStrCharSizeMb( strText ) ;
		int iBidx = 0 ;
		for ( iBidx = 0 ; iBidx < aCStrCharSizeMb.ByteLength() ;
				iBidx = aCStrCharSizeMb.BidxNextChar( iBidx ) ){
			string strChar = strText.substr( iBidx , aCStrCharSizeMb.CsizeOfBidx( iBidx ) ) ;
			if ( strChar == "-" || strChar == "|" ||
					strChar == "" || strChar == "[" ){
				strText.erase( iBidx , aCStrCharSizeMb.CsizeOfBidx( iBidx ) ) ;
				strText.insert( iBidx , "|" ) ;
				aCStrCharSizeMb.scan( strText ) ;
			}
		}
	}
	//strText = ctHggȂꍇ́A
	//	ꕔ̕ϊi"["  "|"Ɂj܂B

	// --------------------------------
	//	`悷̂ɕKv
	//	SpubNJEg
	// --------------------------------
	deque<int> ariBidx ;
	{
		CStrCharSizeMb	aCStrCharSizeMb( strText ) ;
		int iBidx = 0 ;
		for ( iBidx = 0 ; iBidx < aCStrCharSizeMb.ByteLength() ;
				iBidx = aCStrCharSizeMb.BidxNextChar( iBidx ) ){
			ariBidx.push_back( iBidx ) ;
		}
		ariBidx.push_back( iBidx ) ;
	}
	//ariBidx=̎n܂̃CfNXێzłB
	//	vf́A{PipESpPƐ܂j

	{
		for ( int idx = 0 ; idx < (int)ariBidx.size() - 2 ; idx ++ ){
			if ( ariBidx[idx] + 1 == ariBidx[idx+1] && 
					ariBidx[idx+1] + 1 == ariBidx[idx+2] ){
				//	݂̈ʒúAPoCgQAĂ܂B
				//	́AQoCgɂ܂B
				ariBidx.erase( ariBidx.begin() + idx + 1 , ariBidx.begin() + idx + 2 ) ;
			}
		}
	}
	//ariBidx=̎n܂̃CfNXێzł
	//	(1oCgQAĂꍇ́AQoCggɂ܂)B
	//	vf́ASp{P
	//	ipQ̑ǵASpPƐ܂B
	//	pPꍇ́APƐ܂B)

	int iLines = 0 ;	
	int iXOffset = 0 ;
	{
		iLines = ( (int)ariBidx.size() - 1 + m_iLinesExtentY - 1 ) 
			/ m_iLinesExtentY ;
		iXOffset = 
			( aCdDcdZoneXy.getX().getSize() - iLines * sizeExtent.getX() ) 
			/ 2 ;
	}
	//iLines = m_strText \̂ɕKvȁA̍s
	//iXOffset = m_strText ̕`́A[̍WB
	//	́AaCdDcdZoneXy.X.Pos ̃ItZbgł


	// --------------------------------
	//	Sp̃ubNPʂŁA`
	// --------------------------------
	for ( int idxChar = 0 ; idxChar < (int)ariBidx.size() - 1 ; idxChar ++ ){
		int idxCharY = idxChar % m_iLinesExtentY ;
		int idxCharX = idxChar / m_iLinesExtentY ;
		
		CdDcdZoneXy	zoneChar( 
			CdDcdZone( 
				aCdDcdZoneXy.getX().getPos() + iXOffset + 
				( iLines - 1 - idxCharX ) * sizeExtent.getX() ,
				sizeExtent.getX() ) ,
			CdDcdZone( 
				aCdDcdZoneXy.getY().getPos() + idxCharY * sizeExtent.getY() ,
				sizeExtent.getY() ) 
		) ;
		string strChar = strText.substr( 
			ariBidx[idxChar], 
			ariBidx[idxChar+1] - ariBidx[idxChar] ) ;
		//strChar=\镶łB
		//	Sp̏ꍇ͂PƂȂ܂A
		//	p̏ꍇ́ApQAĂꍇ͂QA
		//	pP̏ꍇ͂PƂȂ܂B

		CStrCharSizeMb	aCStrCharSizeMb( strChar ) ;
		if ( aCStrCharSizeMb.CsizeOfBidx( 0 ) > 1 && hfontVertical != NULL ){
			// --------------------------------
			//	SpiPj
			// --------------------------------
			CConverter_WinGdi	aConv ;
			
			HFONT hfontOld = (HFONT)SelectObject( pIfDcdTarget->getHdc() , hfontVertical ) ;
			int iBkModeOld = SetBkMode( pIfDcdTarget->getHdc() , TRANSPARENT ) ;
			COLORREF colTextColorOld = SetTextColor( 
				pIfDcdTarget->getHdc() , 
				aConv.COLORREFOf( m_CDcdText.getCdDrawTextProp().getTextColor() ) ) ;

			TextOut( pIfDcdTarget->getHdc() , 
				zoneChar.getX().getEndPos() + 1 ,	//	́{ṔAۂ̉ʂŒl
				zoneChar.getY().getPos() , 
				strChar.c_str() , 
				(int)strChar.size() ) ;
			
			SetTextColor( pIfDcdTarget->getHdc() , colTextColorOld ) ;
			SetBkMode( pIfDcdTarget->getHdc() , iBkModeOld ) ;
			if ( hfontOld != NULL ){
				SelectObject( pIfDcdTarget->getHdc() , hfontOld ) ;
				hfontOld = NULL ;
			}
			bRv = true ;
		}	else	{
			// --------------------------------
			//	piPQj
			//	́Aʏ̃tHgŕ`悵܂B
			// --------------------------------
		m_CDcdText.setText( strChar ) ;
		
		CaDcdTargetItemPosition	aTarget( pIfDcdTarget ,  zoneChar ) ;
		if ( m_CDcdText.DcDraw( &aTarget ) ) {
			bRv = true ;
		}
	} 
	} 
	
	return ( bRv ) ;
}
	
bool CDcdFillRectangleTextV::getItemSize( IfDcdTarget* pIfDcdTarget , 
							CdDcdSizeXy* pCdDcdSizeXy ) 
{
	bool bRv = false ;
	CdDcdSizeXy	sizeExtent ;
	{	
		bRv = m_CDcdText.getItemSize( pIfDcdTarget , &sizeExtent ) ;
		if ( !bRv ){
			return ( bRv ) ;
		}
		sizeExtent.setX( max( sizeExtent.getX() , sizeExtent.getY() ) ) ;
		sizeExtent.setY( sizeExtent.getX() ) ;
	}
	//sizeExtent = eLXgP̃TCYB
	//	ATCY͐`ɂȂ悤ɍœK܂B
	//	܂AX,ŶA傫̕ӂɍ킹܂B


	pCdDcdSizeXy->setX( sizeExtent.getX() * m_iLinesExtentX + m_logicalunitFrameWidth * 2 ) ;
	pCdDcdSizeXy->setY( sizeExtent.getY() * m_iLinesExtentY + m_logicalunitFrameHeight * 2 ) ;
	return ( true ) ;
	}
