/*
	OuDia - Win32 Application Software to draw a "Train Service Planning
 Diagram" based on a "Train Timetable".

Copyright (C) 2006-2017 take-okm

This program is free software; you can redistribute it and/or modify it 
under the terms of the GNU General Public License as published by the Free 
Software Foundation; either version 3 of the License, or (at your option) 
any later version. 

This program is distributed in the hope that it will be useful, but WITHOUT 
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or 
FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for 
more details. 

You should have received a copy of the GNU General Public License along with
 this program. If not, see <http://www.gnu.org/licenses/>.

  In addition, as a special exception, take-okm
  gives permission to link the code of this program with
  the "MFC(Microsoft Foundation Class library) Version 9.0" 
  (or with modified versions of "MFC Version 9.0" that use the same license as 
  "MFC Version 9.0" ), and distribute linked combinations including
  the two.  You must obey the GNU General Public License in all
  respects for all of the code used other than  "MFC".  If you modify
  this file, you may extend this exception to your version of the
  file, but you are not obligated to do so.  If you do not wish to
  do so, delete this exception statement from your version.


(: 

	OuDia - Ԏ\ƂɁA_CO`悷Win32AvP[V
B

Copyright (C) 2006-2017 take-okm 

̃vO̓t[\tgEFAłBȂ͂At[\tgEFA
cɂĔsꂽGNU ʌOp(o[W3Aȍ~̃o[W
̂ǂꂩ)߂̉ōĔЕz܂͉ 邱Ƃł܂B

̃vO͗Lpł邱ƂĔЕz܂A*S̖ۏ *łB
Ɖ\̕ۏ؂ړIւ̓ḰAOɎꂽ̂ ܂߁AS
܂BڂGNU ʌOpB

Ȃ͂̃vOƋɁAGNU ʌOp̃Rs[ꕔ 󂯎
Ă͂łB󂯎ĂȂ΁A<http://www.gnu.org/licenses/> 
B

)

  āAʂȗOƂāAtake-okm ͂̃vÕR[h 
  "MFC(Microsoft Foundation Class library) Version 9.0" 
  (  邢 "MFC Version 9.0" ƓCZXKpꂽ
  "MFC Version 9.0" ̉ςꂽo[W)ƃNA
  Nꂽ҂܂ތ앨Еz鋖^܂B
  Ȃ "MFC" ȊOŎgĂ邷ׂ
  ̃R[hɊւĂ͑SʓIGNUʌOp_񏑂ɏ]Ȃ
  Ȃ܂BȂ̃t@CςȂ΁AȂ̗͂O
  Ȃ̃o[W̃t@CɈ݂邱Ƃł܂A
  `͂܂BO݂Ȃ΁A̗O
  Ȃ̃o[W͍폜ĂB)
*/
/*
// ****************************************************************
//	CGdiCache.h
// ****************************************************************
*/
/** @file */
#ifndef  CGdiCache_h
#define  CGdiCache_h

#include <windows.h>
#include <map>
#include "./CdFontProp.h"
#include "./CdPenProp.h"
#include "./CdBrushProp.h"

// ****************************************************************
//	CGdiCache
// ****************************************************************
/**
 * @brief
 *	GDIIuWFNg̑ƁAnh̑Ώƕ\ێ܂B
 *	Ώƕ\ɃGgȂꍇ́AGDIIuWFNg̃nh𐶐āA
 *	Ώƕ\ɒǉ܂B
 *
 *	Ώƕ\ɒǉGgGDIIuWFNg̃nh̔j̐Ӗ́A
 *	this ɂ܂B
 *
 * ygz
 *
 *	PD  RXgN^ŃIuWFNg𐶐ĂB
 *
 *	QD  CreateFont() gƁAw肳ꂽ CdFontProp ɑΉ
 *	tHgnh𐶐ĕԂ܂BɁAƃnhΏƕ\
 *	 m_HFONTMap ɓo^܂B
 *	  ɓ CreateFont() Ăяoꂽꍇ́AO
 *	tHgnhԂ܂B
 *	
 *	RD  fXgN^ł́AΏƕ\ m_HFONTMap ɓo^Ă
 *	tHgnhׂĉ܂B
 */
class CGdiCache
{
// ********************************
//	Ci[^Cv
// ********************************
 public:

	typedef std::map< CdFontProp , HFONT >	HFONTMap ;
	typedef std::map< CdPenProp , HPEN >	HPENMap ;
	typedef std::map< CdBrushProp , HBRUSH >	HBRUSHMap ;

// ********************************
///@name W
// ********************************
///@{
 private:
	/**
	 *	tHgƃtHgnh̑Ώƕ\łB
	 *	HFONT ̔j̐Ӗ this ɂ܂B
	 */
	HFONTMap	m_HFONTMap ;
	/**
	 *	yƃynh̑Ώƕ\łB
	 *	HPEN ̔j̐Ӗ this ɂ܂B
	 */
	HPENMap	m_HPENMap ;
	/**
	 *	uVƃuVnh̑Ώƕ\łB
	 *	HBRUSH ̔j̐Ӗ this ɂ܂B
	 */
	HBRUSHMap	m_HBRUSHMap ;
///@}

// ********************************
//	RXgN^
// ********************************
 public:
	CGdiCache() ;
	virtual ~CGdiCache() ;

// ********************************
//	CGdiCache
// ********************************
 public:
	/**
	 * 	CdFontPropIuWFNg̑ƂɁAtHg𐶐܂
	 * @param aCdFontProp [in]
	 * 	tHgw肵ĂB
	 * @param hDc [in]
	 * 	CdFontProp IuWFNgɐݒ肳Ă鍂
	 * 	PointTextHeight Ŏw肳Ăꍇ́ALOGFONTɕϊ
	 * 	ۂɂ́A̕ϊɂ́AtHg̕`sHDCKvłB
	 * 	ɂ́AHDCw肵ĂB
	 * 	ÃP[XHDC NULL w肵ꍇ́AXN[DC
	 * 	ƂLOGFONT\̂쐬܂B
	 * 	CdFontProp IuWFNgɐݒ肳Ă鍂
	 * 	Logicalunit... Ŏw肳Ăꍇ́AHDCɂ
	 * 	Ӗ܂B
	 * @return
	 *	tHg̃nhԂ܂B
	 *	̃nh̔j̐Ӗ́Athisɂ܂B
	 *	֐ďóAnhĂ͂܂B
	 */
	virtual HFONT	CreateFont(  const CdFontProp& aCdFontProp , 
			HDC hDc ) ;
	
	/**
	 * 	CdPenPropIuWFNg̑ƂɁAy𐶐܂
	 * @param aCdPenProp [in]
	 * 	yw肵ĂB
	 * @return
	 *	ỹnhԂ܂B
	 *	̃nh̔j̐Ӗ́Athisɂ܂B
	 *	֐ďóAnhĂ͂܂B
	 */
	virtual HPEN	CreatePen(  const CdPenProp& aCdPenProp ) ;

	/**
	 * 	CdBrushPropIuWFNg̑ƂɁAy𐶐܂
	 * @param aCdBrushProp [in]
	 * 	yw肵ĂB
	 * @return
	 *	ỹnhԂ܂B
	 *	̃nh̔j̐Ӗ́Athisɂ܂B
	 *	֐ďóAnhĂ͂܂B
	 */
	virtual HBRUSH	CreateBrush(  const CdBrushProp& aCdBrushProp ) ;
};
#endif /*CGdiCache_h*/

