/*
	OuDia - Win32 Application Software to draw a "Train Service Planning
 Diagram" based on a "Train Timetable".

Copyright (C) 2006-2017 take-okm

This program is free software; you can redistribute it and/or modify it 
under the terms of the GNU General Public License as published by the Free 
Software Foundation; either version 3 of the License, or (at your option) 
any later version. 

This program is distributed in the hope that it will be useful, but WITHOUT 
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or 
FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for 
more details. 

You should have received a copy of the GNU General Public License along with
 this program. If not, see <http://www.gnu.org/licenses/>.

  In addition, as a special exception, take-okm
  gives permission to link the code of this program with
  the "MFC(Microsoft Foundation Class library) Version 9.0" 
  (or with modified versions of "MFC Version 9.0" that use the same license as 
  "MFC Version 9.0" ), and distribute linked combinations including
  the two.  You must obey the GNU General Public License in all
  respects for all of the code used other than  "MFC".  If you modify
  this file, you may extend this exception to your version of the
  file, but you are not obligated to do so.  If you do not wish to
  do so, delete this exception statement from your version.


(: 

	OuDia - Ԏ\ƂɁA_CO`悷Win32AvP[V
B

Copyright (C) 2006-2017 take-okm 

̃vO̓t[\tgEFAłBȂ͂At[\tgEFA
cɂĔsꂽGNU ʌOp(o[W3Aȍ~̃o[W
̂ǂꂩ)߂̉ōĔЕz܂͉ 邱Ƃł܂B

̃vO͗Lpł邱ƂĔЕz܂A*S̖ۏ *łB
Ɖ\̕ۏ؂ړIւ̓ḰAOɎꂽ̂ ܂߁AS
܂BڂGNU ʌOpB

Ȃ͂̃vOƋɁAGNU ʌOp̃Rs[ꕔ 󂯎
Ă͂łB󂯎ĂȂ΁A<http://www.gnu.org/licenses/> 
B

)

  āAʂȗOƂāAtake-okm ͂̃vÕR[h 
  "MFC(Microsoft Foundation Class library) Version 9.0" 
  (  邢 "MFC Version 9.0" ƓCZXKpꂽ
  "MFC Version 9.0" ̉ςꂽo[W)ƃNA
  Nꂽ҂܂ތ앨Еz鋖^܂B
  Ȃ "MFC" ȊOŎgĂ邷ׂ
  ̃R[hɊւĂ͑SʓIGNUʌOp_񏑂ɏ]Ȃ
  Ȃ܂BȂ̃t@CςȂ΁AȂ̗͂O
  Ȃ̃o[W̃t@CɈ݂邱Ƃł܂A
  `͂܂BO݂Ȃ΁A̗O
  Ȃ̃o[W͍폜ĂB)
*/
/*
// ****************************************************************
//	./CdDeviceUnitSize.h
// ****************************************************************
*/
/** @file */
#ifndef  CdDeviceUnitSize_h
#define  CdDeviceUnitSize_h

#include <windows.h>

#include "./DcdType.h"

// ****************************************************************
//	CdDeviceUnitSize
// ****************************************************************
/**
 * @brief
 * yTvz
 * 	foCXPʁisNZjł̃TCYێ܂B
 *
 *	̃NX́ADPIiC`̃sNZj̒lƂɁA
 *
 *		foCXPʁ|P
 *
 *	̕ϊs܂B
 *	  Pʂ́Aȉ̂̂T|[g܂B
 *
 *	- |Cg(1C`=72|Cg)
 *	- Twip(PC`=72*20 Twip)
 *	- 1/1000 C`
 *	- C`ij
 *	- m(1/1000 mm)(PC`25.4mm)
 *	- ij(PC`25.4mm)
 *	
 *	hNXƂȂ CdDeviceUnitSizeX E CdDeviceUnitSizeY ł́A
 *	foCXPʁ|_P ̕ϊł悤ɂȂ܂B\n
 *	Pʁ|_Pʂ̕ΐA
 *
 *		Pʁ|foCXPʁ|_P
 *		
 *	̂悤ɁAUfoCXPʂoRΉ\łB
 *
 * ygz
 *
 * PD  RXgN^ł́ADPIw肵ĂB
 *
 * QD  Ȍ́APf[^NXƓl̎gł܂B
 *
 *	ʏ́AhNXƂȂ CdDeviceUnitSizeX E CdDeviceUnitSizeY 
 *	g܂B
 */
class CdDeviceUnitSize
{
// ********************************
/// @name 
// ********************************
///@{
 private:
	/**
	 *	DPI ̒liPC`̃sNZjłB
	 *
	 *	͒ʏADCƂ
	 *	( GetDeviceCaps(LOGPIXELSX) , GetDeviceCaps(LOGPIXELSY) )
	 *	肵܂B
	 *	RXgN^Ō܂܂B
	 * @attention
	 *	̒l 0 ɂĂƁAR[ZɂȂ܂B
	 */
	int m_iDpi ;

	/**
	 * 	foCXPʂł̃TCYłB
	 */
	DcdSize	m_sizeDeviceUnitSize ;
///@}
	
// ********************************
//	RXgN^
// ********************************
 public:
	/**
	 * @param iDpi [in]
	 *	DPI ̒lłB\n
	 *	͒ʏADCƂ
	 *	( GetDeviceCaps(LOGPIXELSX) , GetDeviceCaps(LOGPIXELSY) )
	 *	肵܂B
	 * @param sizeDeviceUnitSize [in]
	 * 	foCXPʂł̃TCYłB
	 */
	CdDeviceUnitSize( 
		int iDpi ,
		DcdSize	sizeDeviceUnitSize = 0 ) :
		m_iDpi( iDpi ) ,
		m_sizeDeviceUnitSize( sizeDeviceUnitSize ){};
	
	virtual ~CdDeviceUnitSize(){};

// ********************************
//	CdDeviceUnitSize
// ********************************
 public:
	
	// ********************************
	///@name CdDeviceUnitSize-
	// ********************************
	///@{
	int getDpi()const{	return m_iDpi ;};
	CdDeviceUnitSize& setDpi( int value ){	m_iDpi = value ; return *this ; } ;
	DcdSize	getDeviceUnitSize()const{	return m_sizeDeviceUnitSize ;	} ;
	CdDeviceUnitSize& setDeviceUnitSize( DcdSize value ){
		m_sizeDeviceUnitSize = value ;	return *this ;	} ;
	
	/** setDeviceUnitSize() Ɠł */
	CdDeviceUnitSize& operator=( DcdSize value ){
		return setDeviceUnitSize( value ) ; } ;
	/** getDeviceUnitSize() Ɠł */
	operator DcdSize()const{	return getDeviceUnitSize() ; } ;
	///@}

	// ********************************
	///@name CdDeviceUnitSize-
	// ********************************
	///@{
	/**
	 * @return
	 * 	|CgPʂŁATCY擾܂
	 */
	DcdSize	getPointSize()const{
		return MulDiv( m_sizeDeviceUnitSize , 72 , m_iDpi ) ;
	};
	/**
	 * 	|CgPʂŁATCYݒ肵܂
	 * @param value [in]
	 *	|CgPʂł̃TCYw肵ĂB
	 */
	CdDeviceUnitSize& setPointSize( DcdSize	value ){
		m_sizeDeviceUnitSize = MulDiv( value , m_iDpi ,72 ) ;	
		return *this ; } ;
	
	
	/**
	 * @return
	 * 	TwipPʂŁATCY擾܂
	 */
	DcdSize	getTwipSize()const{
		return MulDiv( m_sizeDeviceUnitSize , 72*20 , m_iDpi ) ;
	};
	/**
	 * 	Twip PʂŁATCYݒ肵܂
	 * @param ev [in]
	 *	TwipPʂł̃TCYw肵ĂB
	 */
	CdDeviceUnitSize& setTwipSize( DcdSize	value ){
		m_sizeDeviceUnitSize = MulDiv( value , m_iDpi , 72*20 ) ;
		return *this ; } ;
	
	/**
	 * @return
	 * 	1/1000 C`PʂŁATCY擾܂
	 */
	DcdSize	getMilliInchSize()const{
		return MulDiv( m_sizeDeviceUnitSize , 1000 , m_iDpi ) ;
	};
	/**
	 * 	1/1000 C` PʂŁATCYݒ肵܂
	 * @param ev [in]
	 *	1/1000 C`Pʂł̃TCYw肵ĂB
	 */
	CdDeviceUnitSize& setMilliInchSize( DcdSize	value ){
		m_sizeDeviceUnitSize = MulDiv( value , m_iDpi , 1000 ) ;
		return *this ; } ;
	
	
	/**
	 * @return
	 * 	ʂPʂŁATCY擾܂
	 */
	DcdSize	getMicroMetersSize()const{
		return MulDiv( m_sizeDeviceUnitSize , 25400 , m_iDpi ) ;
	};
	/**
	 * 	ʂ PʂŁATCYݒ肵܂
	 * @param ev [in]
	 *	ʂ Pʂł̃TCYw肵ĂB
	 */
	CdDeviceUnitSize& setMicroMetersSize( DcdSize	value ){
		m_sizeDeviceUnitSize = MulDiv( value , m_iDpi , 25400 ) ;
		return *this ; } ;
	
	/**
	 * @return
	 * 	C`PʁijŁATCY擾܂
	 */
	double	getInchSize()const{
		return (double)m_sizeDeviceUnitSize * 1 / m_iDpi ;
	};
	/**
	 * 	C` P()ŁATCYݒ肵܂
	 * @param ev [in]
	 *	C`Pʂł̃TCYw肵ĂB
	 */
	CdDeviceUnitSize& setInchSize( double value ){
		m_sizeDeviceUnitSize = (DcdSize)( value * m_iDpi / 1 ) ;
		return *this ; } ;
	
	
	/**
	 * @return
	 * 	PʁijŁATCY擾܂
	 */
	double	getMmSize()const{
		return (double)m_sizeDeviceUnitSize * 25.4 / m_iDpi ;
	};
	/**
	 * 	 PʁijŁATCYݒ肵܂
	 * @param ev [in]
	 *	 Pʂł̃TCYw肵ĂB
	 */
	CdDeviceUnitSize& setMmSize( double	value ){
		m_sizeDeviceUnitSize = (DcdSize)( value * m_iDpi / 25.4 ) ;
		return *this ; } ;
	
	
	///@}
};

#endif /*CdDeviceUnitSize_h*/
