/*
	OuDia - Win32 Application Software to draw a "Train Service Planning
 Diagram" based on a "Train Timetable".

Copyright (C) 2006-2017 take-okm

This program is free software; you can redistribute it and/or modify it 
under the terms of the GNU General Public License as published by the Free 
Software Foundation; either version 3 of the License, or (at your option) 
any later version. 

This program is distributed in the hope that it will be useful, but WITHOUT 
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or 
FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for 
more details. 

You should have received a copy of the GNU General Public License along with
 this program. If not, see <http://www.gnu.org/licenses/>.

  In addition, as a special exception, take-okm
  gives permission to link the code of this program with
  the "MFC(Microsoft Foundation Class library) Version 9.0" 
  (or with modified versions of "MFC Version 9.0" that use the same license as 
  "MFC Version 9.0" ), and distribute linked combinations including
  the two.  You must obey the GNU General Public License in all
  respects for all of the code used other than  "MFC".  If you modify
  this file, you may extend this exception to your version of the
  file, but you are not obligated to do so.  If you do not wish to
  do so, delete this exception statement from your version.


(: 

	OuDia - Ԏ\ƂɁA_CO`悷Win32AvP[V
B

Copyright (C) 2006-2017 take-okm 

̃vO̓t[\tgEFAłBȂ͂At[\tgEFA
cɂĔsꂽGNU ʌOp(o[W3Aȍ~̃o[W
̂ǂꂩ)߂̉ōĔЕz܂͉ 邱Ƃł܂B

̃vO͗Lpł邱ƂĔЕz܂A*S̖ۏ *łB
Ɖ\̕ۏ؂ړIւ̓ḰAOɎꂽ̂ ܂߁AS
܂BڂGNU ʌOpB

Ȃ͂̃vOƋɁAGNU ʌOp̃Rs[ꕔ 󂯎
Ă͂łB󂯎ĂȂ΁A<http://www.gnu.org/licenses/> 
B

)

  āAʂȗOƂāAtake-okm ͂̃vÕR[h 
  "MFC(Microsoft Foundation Class library) Version 9.0" 
  (  邢 "MFC Version 9.0" ƓCZXKpꂽ
  "MFC Version 9.0" ̉ςꂽo[W)ƃNA
  Nꂽ҂܂ތ앨Еz鋖^܂B
  Ȃ "MFC" ȊOŎgĂ邷ׂ
  ̃R[hɊւĂ͑SʓIGNUʌOp_񏑂ɏ]Ȃ
  Ȃ܂BȂ̃t@CςȂ΁AȂ̗͂O
  Ȃ̃o[W̃t@CɈ݂邱Ƃł܂A
  `͂܂BO݂Ȃ΁A̗O
  Ȃ̃o[W͍폜ĂB)
*/
/*
// ****************************************************************
//	CdFilenameStr.cpp
// ****************************************************************
*/
#include "Str\CdFilenameStr.h"
#include "Str\CStrCharSizeMb.h"

// ****************************************************************
//	CdFilenameStr
// ****************************************************************

// ********************************
//	RXgN^EfXgN^
// ********************************
CdFilenameStr::CdFilenameStr() 
	: m_bIsRelativePath( false ) 
	, m_bIsValidFilename( true ) 
{
}
	//[in]strFilename
	//	tpXihCuEfBNgEt@Cj
	//	w肵ĂB
	//[in]bIsValidFilename
	//	̃pXAt@Ĉ`łȂ^łB
	//	̏ꍇ́AԉE '\' ̉E̓t@CƂ݂Ȃ܂B
	//	̃pXAt@ĈȂ`ł΋UłB
	//	̏ꍇ́AԉE '\' ̉EfBNgƂ݂Ȃ܂B
CdFilenameStr::
CdFilenameStr( std::string strFilename , bool bIsValidFilename ) 
{
	setFullpathFilename( strFilename, bIsValidFilename ) ;
}


// ********************************
//	CdFilenameStr
// ********************************
	// --------------------------------
	//	
	// --------------------------------

std::string	CdFilenameStr::Drive() const 
{
	return ( m_strDrive ) ;
}
CdFilenameStr& CdFilenameStr::setDrive( const std::string& ev ) 
{
	m_strDrive = ev ;
	return ( *this ) ;
}
	
CdFilenameStr::ContstrDir	CdFilenameStr::Dirs()const
{
	return ( m_contstrDir ) ;
}

CdFilenameStr& CdFilenameStr::setDirs( const CdFilenameStr::ContstrDir& ev ) 
{
	m_contstrDir = ev ;
	return ( *this ) ;
}
	
	
int CdFilenameStr::DirCount()const 
{
	return ( m_contstrDir.size() ) ;
}

std::string CdFilenameStr::DirAt( int idx )const 
{
	if ( 0 <= idx && idx < (int)m_contstrDir.size() ){
		return ( m_contstrDir.at( idx ) ) ;
	}
	return ( "" ) ;
}
	
CdFilenameStr& 	CdFilenameStr::addDirLast( const std::string& ev ) 
{
	m_contstrDir.push_back( ev ) ;
	return ( *this ) ;
}

CdFilenameStr& 	CdFilenameStr::addDirAt( int index , const std::string& ev ) 
{
	m_contstrDir.insert( m_contstrDir.begin() + index , ev ) ;
	return ( *this ) ;
}
	
CdFilenameStr& 	CdFilenameStr::delDirLast() 
{
	m_contstrDir.pop_back() ;
	return ( *this ) ;
}
CdFilenameStr& 	CdFilenameStr::delDirAt( int index ) 
{
	m_contstrDir.erase( m_contstrDir.begin() + index ) ;
	return ( *this ) ;
}
	
std::string CdFilenameStr::BaseFilename() const 
{
	return ( m_strBaseFilename ) ;
}

CdFilenameStr& CdFilenameStr::setBaseFilename( const std::string& ev ) 
{
	m_strBaseFilename = ev ;
	return ( *this ) ;
}
	
std::string CdFilenameStr::Extension() const 
{
	return ( m_strExtension ) ;
}

CdFilenameStr& CdFilenameStr::setExtension( const std::string& ev ) 
{
	m_strExtension = ev ;
	return ( *this ) ;
}
	
bool CdFilenameStr::IsRelativePath() const 
{
	return ( m_bIsRelativePath ) ;
}

CdFilenameStr& CdFilenameStr::setIsRelativePath( bool ev ) 
{
	m_bIsRelativePath = ev  ;
	return ( *this ) ;
}
	
bool CdFilenameStr::IsValidFilename() const 
{
	return ( m_bIsValidFilename ) ;
}

CdFilenameStr& CdFilenameStr::setIsValidFilename( bool ev ) 
{
	m_bIsValidFilename = ev  ;
	return ( *this ) ;
}
	
std::string CdFilenameStr::	Filename() const 
{
	std::string	strRv = m_strBaseFilename ;
	if ( !m_strExtension.empty() ){
		strRv += "." ;
		strRv += m_strExtension ;
	}
	return ( strRv ) ;
}
	
CdFilenameStr& CdFilenameStr::setFilename( std::string ev ) 
{
	CStrCharSizeMb	ite( ev ) ;
	int	iBidx ;
	for ( iBidx = ite.BidxLast() ; iBidx >  0 ; iBidx = ite.BidxNextChar( iBidx , -1 ) ) {
		if ( ite.CsizeOfBidx( iBidx ) == 1 ){
			if ( ev[iBidx] == '.' ) {
				break ;	//	iExtPeriod = gq̑O'.'̃CfNXłB
			}
			if ( ev[iBidx]  == '\\' || ev[iBidx]  == ':' ){
				iBidx = -1 ;
				break ;
					//iBidx = -1͊gq݂ȂƂ܂B
			}
		}
	}
	//iBidx = gq̑O'.'̃CfNXłB
	//	݂Ȃ-1ł
	if ( iBidx > 0 ){
		m_strBaseFilename = ev.substr( 0 , iBidx ) ; 
		m_strExtension    = ev.substr( iBidx + 1 ) ; 
	}	else	{
		m_strBaseFilename = ev ;
		m_strExtension.erase() ;
	}
	return ( *this ) ;
}
	
// --------------------------------
	
std::string CdFilenameStr::FullpathFilename() const 
{
	std::string	strRv ;

	//hCu
	if ( !m_strDrive.empty() ){
		strRv += m_strDrive ;
		strRv += ':' ;
	}

	if ( !m_bIsRelativePath ){
		strRv += '\\' ;
	}
	
	int idxDir ;
	for ( idxDir = 0 ; idxDir < (int)m_contstrDir.size() ; idxDir ++ ){
		std::string strDir = m_contstrDir[ idxDir ] ;
		strRv += strDir ;
		if ( idxDir < (int)m_contstrDir.size() - 1 || m_bIsValidFilename ){
			strRv += '\\' ;
		}
	}
	if ( m_bIsValidFilename ){
		strRv += Filename() ;
	}
	return ( strRv ) ;
}

CdFilenameStr& CdFilenameStr::setFullpathFilename( std::string ev ) 
{
	// --------------------------------
	//	ׂč폜
	// --------------------------------
	m_strDrive.erase() ;
	m_contstrDir.clear() ;
	m_bIsRelativePath = true ;
	m_strBaseFilename.erase() ;
	m_strExtension.erase() ;
	// --------------------------------
	//	hCu
	// --------------------------------
	{
		CStrCharSizeMb	ite( ev )  ;
		int	iBidx ;
		for ( iBidx = 0 ; iBidx < ite.ByteLength() ; iBidx = ite.BidxNextChar( iBidx ) ) {
			if ( ite.CsizeOfBidx( iBidx ) == 1 ){
				if ( ev[ iBidx ] == ':' ) {
					break ;	
					//iBidx = hCûƂ':'̃CfNXłB
				}
				if (ev[ iBidx ] == '\\' || ev[ iBidx ] == '.' ){
					iBidx = ite.ByteLength() ;	
					//iBidx = ite.ByteLength()  ́A
					//		hCuȂƂ܂B
				}
			}
		}
		if ( iBidx < ite.ByteLength()  ){
			m_strDrive = ev.substr( 0 , iBidx ) ; 
			ev = ev.substr( iBidx + 1 ) ; 
		}
	}	
	//ev = hCuƎ':'폜̂
	//	Ȃ܂B

	// --------------------------------
	//	t@C	
	// --------------------------------
	if ( m_bIsValidFilename ){
		CStrCharSizeMb	ite( ev )  ;
		int	iBidx ;
		for ( iBidx = ite.BidxLast() ; iBidx >= 0 ; iBidx = ite.BidxNextChar( iBidx , -1 ) ){
			if ( ite.CsizeOfBidx( iBidx ) == 1 ){
				if ( ev[ iBidx ] == '\\' ){
					break ;	//	iBidx = t@C̒O'\'':'̃CfNXłB
				}
			}
		}
		setFilename( ev.substr( iBidx + 1 ) ) ;
		ev = ev.substr( 0 , iBidx + 1 ) ; 
	}
	//ev = t@C폜̂
	//	Ȃ܂B

	// --------------------------------
	//	擪Ɩ '\' 
	// --------------------------------
	if ( ev.length() > 0 ){
		CStrCharSizeMb	ite( ev )  ;
		if ( ite.CsizeOfBidx( 0 ) == 1 && ev[0] == '\\' ){
			m_bIsRelativePath = false ;	
			//	fBNg̐擪'\' ȂA΃pXłB
			ev = ev.substr( 1 ) ;
		}		
	}
	//ev=擪 '\' 폜܂B

	if ( ev.length() > 0 ){
		CStrCharSizeMb	ite( ev )  ;
		if ( ite.CsizeOfBidx( ite.BidxLast() ) == 1 && ev[ite.BidxLast()] == '\\' ){
			ev = ev.substr( 0 , ite.BidxLast() ) ;
		}		
	}
	//ev= '\' 폜܂B

	// --------------------------------
	//	fBNgA '\' E
	//	؂藣܂B
	// --------------------------------
	while( ev.length() > 0 ){
		CStrCharSizeMb	ite( ev )  ;
		int	iBidx ;
		for ( iBidx = 0 ; iBidx < ite.ByteLength() ; iBidx = ite.BidxNextChar( iBidx ) ){
			if ( ite.CsizeOfBidx( iBidx ) == 1 ){
				if ( ev[ iBidx ] == '\\' ) {
					break ;	
					//iBidx = hCûƂ'\'̃CfNXłB
				}
			}
		}
		m_contstrDir.push_back( ev.substr( 0 , iBidx ) ) ; 
		ev = ev.substr( iBidx ) ; 
		ite.scan( ev ) ;
		if ( ite.ByteLength() > 0 ){
			if ( ite.CsizeOfBidx( 0 ) == 1 ){
				if ( ev[0] == '\\' ) {
					ev = ev.substr( 1 ) ;
				}
			}
		}
	}	

	return ( *this ) ;
}
CdFilenameStr& CdFilenameStr::setFullpathFilename( std::string ev , 
										bool bIsValidFilename ) 
{
	m_bIsValidFilename = bIsValidFilename ;
	return ( setFullpathFilename( ev ) ) ;
}
	
CdFilenameStr& CdFilenameStr::ChangeDir( const CdFilenameStr& ev ) 
{
	// --------------------------------
	//	fBNg
	// --------------------------------
	if ( ev.IsRelativePath() ){
		//	΃pX̏ꍇ́AfBNg͑ΈړƂȂ܂B
		int idx ;
		for ( idx = 0 ; idx < ev.DirCount() ; idx ++ ){
			std::string strDir = ev.DirAt( idx ) ;
			if ( strDir == "." ){
			}	else if ( strDir == ".." ){
				if ( m_contstrDir.size() > 0 ){
					m_contstrDir.pop_back() ;
				}
			}	else	{
				m_contstrDir.push_back( strDir ) ;
			}			
		}
	}	else	{
		//	΃pX̏ꍇ́AfBNg͂ɂȂ܂B
		m_contstrDir.clear() ;
		int idx ;
		for ( idx = 0 ; idx < ev.DirCount() ; idx ++ ){
			m_contstrDir.push_back( ev.DirAt( idx ) ) ;
		}
	}
	// --------------------------------
	//	hCu
	// --------------------------------
	if ( ev.Drive().length() > 0 ){
		setDrive( ev.Drive() ) ;
	}
	// --------------------------------
	//	t@C
	// --------------------------------
	if ( ev.Filename().length() > 0 ){
		setFilename( ev.Filename() ) ;
	}
	return ( *this ) ;
}

int CdFilenameStr::ChangeToRelativeDir( const CdFilenameStr& ev ) 
{
	int	merrRv = 0 ;

	CdFilenameStr	aFilenameStrBase( ev ) ;
	// --------------------------------
	//	hCu
	// --------------------------------
	if ( merrRv >= 0 ){
		if ( Drive().length() > 0 && ev.Drive().length() > 0 
				&& Drive() != ev.Drive() ){
			//	oʁX̃hCuw肳Ăꍇ́A
			//	΃pXւ̕ῗł܂B
			merrRv = -1 ;	//	 hCuقȂ邽߁A΃pXɂ͂ł܂B
		}	else	{
			setDrive( "" ) ;
			aFilenameStrBase.setDrive( "" ) ;
		}
	}

	// --------------------------------
	//	fBNg
	// --------------------------------
	if ( merrRv >= 0 ){
		if ( IsRelativePath() ){
			merrRv = -2 ;	//	 this΃pXł
		}	else if ( aFilenameStrBase.IsRelativePath() ){
			merrRv = -3 ;	//	 ev΃pXł
		} 
	}
	if ( merrRv >= 0 ){
		//this𑊑΃pXɕύX܂B
		setIsRelativePath( true ) ;
		aFilenameStrBase.setIsRelativePath( true ) ;
		
		while ( DirCount() > 0 
				&& aFilenameStrBase.DirCount() > 0 
				&& DirAt( 0 ) == aFilenameStrBase.DirAt( 0 ) 
				&& DirAt( 0 ) != "." 
				&& DirAt( 0 ) != ".." ){
			delDirAt( 0 ) ;
			aFilenameStrBase.delDirAt( 0 ) ;
		} 
		//	擪̋ʂ̃fBNg폜܂B

		//	
		int iLi ;
		for ( iLi = 0 ; iLi < aFilenameStrBase.DirCount() ; iLi ++ ){
			addDirAt( 0 , ".." ) ;
		}
	}
	// --------------------------------
	//	t@C
	// --------------------------------
	if ( merrRv >= 0 ){
		if ( Filename().length() > 0 ){
			if ( aFilenameStrBase.Filename().length() > 0 ){
				setFilename( ev.Filename() ) ;
			}
		}
	}
	return ( merrRv ) ;
};


