/*
	OuDia - Win32 Application Software to draw a "Train Service Planning
 Diagram" based on a "Train Timetable".

Copyright (C) 2006-2017 take-okm

This program is free software; you can redistribute it and/or modify it 
under the terms of the GNU General Public License as published by the Free 
Software Foundation; either version 3 of the License, or (at your option) 
any later version. 

This program is distributed in the hope that it will be useful, but WITHOUT 
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or 
FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for 
more details. 

You should have received a copy of the GNU General Public License along with
 this program. If not, see <http://www.gnu.org/licenses/>.

  In addition, as a special exception, take-okm
  gives permission to link the code of this program with
  the "MFC(Microsoft Foundation Class library) Version 9.0" 
  (or with modified versions of "MFC Version 9.0" that use the same license as 
  "MFC Version 9.0" ), and distribute linked combinations including
  the two.  You must obey the GNU General Public License in all
  respects for all of the code used other than  "MFC".  If you modify
  this file, you may extend this exception to your version of the
  file, but you are not obligated to do so.  If you do not wish to
  do so, delete this exception statement from your version.


(: 

	OuDia - Ԏ\ƂɁA_CO`悷Win32AvP[V
B

Copyright (C) 2006-2017 take-okm 

̃vO̓t[\tgEFAłBȂ͂At[\tgEFA
cɂĔsꂽGNU ʌOp(o[W3Aȍ~̃o[W
̂ǂꂩ)߂̉ōĔЕz܂͉ 邱Ƃł܂B

̃vO͗Lpł邱ƂĔЕz܂A*S̖ۏ *łB
Ɖ\̕ۏ؂ړIւ̓ḰAOɎꂽ̂ ܂߁AS
܂BڂGNU ʌOpB

Ȃ͂̃vOƋɁAGNU ʌOp̃Rs[ꕔ 󂯎
Ă͂łB󂯎ĂȂ΁A<http://www.gnu.org/licenses/> 
B

)

  āAʂȗOƂāAtake-okm ͂̃vÕR[h 
  "MFC(Microsoft Foundation Class library) Version 9.0" 
  (  邢 "MFC Version 9.0" ƓCZXKpꂽ
  "MFC Version 9.0" ̉ςꂽo[W)ƃNA
  Nꂽ҂܂ތ앨Еz鋖^܂B
  Ȃ "MFC" ȊOŎgĂ邷ׂ
  ̃R[hɊւĂ͑SʓIGNUʌOp_񏑂ɏ]Ȃ
  Ȃ܂BȂ̃t@CςȂ΁AȂ̗͂O
  Ȃ̃o[W̃t@CɈ݂邱Ƃł܂A
  `͂܂BO݂Ȃ΁A̗O
  Ȃ̃o[W͍폜ĂB)
*/
//$Id: CNodeContainer.cpp 10 2012-08-26 09:48:47Z okm $
#include "Ou\dynamic_castOu.h"
#include "Ou\OuNew.h"
#include "CNodeContainer.h"
namespace OuPropertiesText{

// ----------------------------------------------------------------
//	CNodeContainer::CaConst
// ----------------------------------------------------------------
// ********************************
//@name	IfNodeContainerConst-Property̎擾
// ********************************
string CNodeContainer::CaConst::getValue( const string& strName )const 
{
	const CNodeContainer* pOuter = (const CNodeContainer*)(
		(char*)this - offsetof( CNodeContainer , m_CaConst ) ) ;
	return pOuter->getValue( strName ) ;
}
// ********************************
//@name	IfContGet
// ********************************
int	CNodeContainer::CaConst::size()const 
{
	const CNodeContainer* pOuter = (const CNodeContainer*)(
		(char*)this - offsetof( CNodeContainer , m_CaConst ) ) ;
	return pOuter->size() ;
}
Ou<const CNode> CNodeContainer::CaConst::get( int iIndex )const 
{
	const CNodeContainer* pOuter = (const CNodeContainer*)(
		(char*)this - offsetof( CNodeContainer , m_CaConst ) ) ;
	return pOuter->get( iIndex ) ;
}
// ********************************
//@name	CNodeContainer-InNameIndexł̃ANZX
// ********************************
int	CNodeContainer::CaConst::sizeInName( const string& strName )const 
{
	const CNodeContainer* pOuter = (const CNodeContainer*)(
		(char*)this - offsetof( CNodeContainer , m_CaConst ) ) ;
	return pOuter->sizeInName( strName ) ;
}
Ou<const CNode> CNodeContainer::CaConst::getInName( 
	const string& strName , 
	int iInNameIndex )const 
{
	const CNodeContainer* pOuter = (const CNodeContainer*)(
		(char*)this - offsetof( CNodeContainer , m_CaConst ) ) ;
	return pOuter->getInName( strName , iInNameIndex ) ;
}
		
int CNodeContainer::CaConst::indexOfInNameIndex( 
			const string& strName ,
			int iInNameIndex )const 
{
	const CNodeContainer* pOuter = (const CNodeContainer*)(
		(char*)this - offsetof( CNodeContainer , m_CaConst ) ) ;
	return pOuter->indexOfInNameIndex( strName , iInNameIndex ) ;
}

int CNodeContainer::CaConst::indexToInNameIndex( 
			int iIndex )const 
{
	const CNodeContainer* pOuter = (const CNodeContainer*)(
		(char*)this - offsetof( CNodeContainer , m_CaConst ) ) ;
	return pOuter->indexToInNameIndex( iIndex ) ;
}


// ****************************************************************
//	CNodeContainer
// ****************************************************************
	// --------------------------------
	//@name	֐
	// --------------------------------
Ou<CPropertyString> CNodeContainer::getCPropertyString( const string& strName )const 
{
	Ou<CPropertyString>	pCPropertyString ;
	int iInNameIndex ;
	int iSizeInName = sizeInName( strName ) ;
	for ( iInNameIndex = 0 ; iInNameIndex < iSizeInName ; iInNameIndex ++ )
	{
		Ou<CNode> pCNode = m_contCNode[ indexOfInNameIndex( strName , iInNameIndex ) ] ;
		pCPropertyString = dynamic_castOu< CPropertyString >( pCNode ) ;
		if ( pCPropertyString != NULL )
		{
			break ;
		}
	}
	return pCPropertyString ;
}
	// ********************************
	//	RXgN^
	// ********************************

CNodeContainer::CNodeContainer()
{
}

CNodeContainer::~CNodeContainer()
{
}
CNodeContainer::CNodeContainer( const CNodeContainer& value )
	: m_CInNameIndexContainer( value.m_CInNameIndexContainer ) 
{
	//modify container
	m_contCNode.resize( value.size() ) ;
	int idx ;
	for (idx = 0 ; idx < value.size() ; idx ++ )
	{
		m_contCNode[idx] = value.get( idx )->clone() ;
	}
}
CNodeContainer& CNodeContainer::operator=( const CNodeContainer& value )
{
	//modify container
	m_contCNode.resize( value.size() ) ;
	int idx ;
	for (idx = 0 ; idx < value.size() ; idx ++ )
	{
		m_contCNode[idx] = value.get( idx )->clone() ;
	}

	m_CInNameIndexContainer = value.m_CInNameIndexContainer ; 
	return *this ;
}
	// ********************************
	//@name	W
	// ********************************
const IfNodeContainerConst* CNodeContainer::getIfNodeContainerConst()const 
{
	return &m_CaConst ;
}


	// ********************************
	//@name	CNodeContainer-Property̎擾ݒ
	// ********************************
void CNodeContainer::setValue( const string& strName , 
		const string& strValue ) 
{
	Ou<CPropertyString> pCPropertyString = getCPropertyString( strName ) ;
	if ( pCPropertyString == NULL )
	{
		pCPropertyString = OuNew<CPropertyString>( new CPropertyString( strName , strValue ) ) ; 

		//modify container
		m_contCNode.push_back( pCPropertyString ) ;

		m_CInNameIndexContainer.insert( pCPropertyString->getName() ) ;

	}
	else
	{
		pCPropertyString->setValue( strValue ) ;
	}
}

string CNodeContainer::getValue( const string& strName )const 
{
	string	strValue ;
	Ou<CPropertyString> pCPropertyString = getCPropertyString( strName ) ;
	if ( pCPropertyString != NULL )
	{
		strValue = pCPropertyString->getValue() ;
	}
	return ( strValue ) ;
}

	// ********************************
	//@name	IfContGet
	// ********************************
int	CNodeContainer::size()const 
{
	return (int)m_contCNode.size() ;
}
CNodeContainer::ElementType 
CNodeContainer::get( int iIndex )const 
{
	return m_contCNode[iIndex] ;
}
	
	// ********************************
	//@name	IfCont
	// ********************************
int CNodeContainer::set( const CNodeContainer::ElementType& element , int iIndex ) 
{
	if ( iIndex == INT_MAX )
	{
		iIndex = (int)m_contCNode.size() - 1 ;
	}
	if ( !( 0 <= iIndex && iIndex < (int)m_contCNode.size() ) ) 
	{
		return -1 ;
	}

	//modify container
	m_contCNode[iIndex] = element->clone() ;

	m_CInNameIndexContainer.erase( iIndex ) ;
	m_CInNameIndexContainer.insert( element->getName() , iIndex ) ;

	return 0 ;
}

int CNodeContainer::insert( const CNodeContainer::ElementType& element , int iIndex  ) 
{
	if ( iIndex == INT_MAX )
	{
		iIndex = (int)m_contCNode.size() ;
	}
	if ( !( 0 <= iIndex && iIndex <= (int)m_contCNode.size() ) ) 
	{
		return -1 ;
	}

	//modify container
	m_contCNode.insert( m_contCNode.begin() + iIndex , 
		element->clone() ) ;

	m_CInNameIndexContainer.insert( element->getName() , iIndex ) ;

	return 0 ;
}
int CNodeContainer::erase( int iIndex  , int iSize  ) 
{
	if ( iIndex == INT_MAX && iSize == INT_MAX )
	{
		return -1 ;
	}
	if ( iIndex == INT_MAX )
	{
		iIndex = (int)m_contCNode.size() - iSize ;
	}
	if ( iSize == INT_MAX )
	{
		iSize = (int)m_contCNode.size() - iIndex ;
	}
	if ( !( 0 <= iIndex && iIndex+iSize <= (int)m_contCNode.size() ) ) 
	{
		return -1 ;
	}

	//modify container
	m_contCNode.erase( 
		m_contCNode.begin() + iIndex ,
		m_contCNode.begin() + iIndex + iSize ) ;

	m_CInNameIndexContainer.erase( iIndex , iSize ) ;

	return 0 ;
}
	

int	CNodeContainer::sizeInName( const string& strName )const 
{
	return m_CInNameIndexContainer.sizeInName( strName ) ;

}
CNodeContainer::ElementType 
CNodeContainer::getInName( const string& strName , int iInNameIndex )const
{
	int iIndex = indexOfInNameIndex( strName , iInNameIndex ) ;
	if ( !( 0 <= iIndex && iIndex < (int)m_contCNode.size() ) )
	{
		return Ou<CNode>() ;
	}
	return m_contCNode[iIndex] ;
}
int CNodeContainer::setInName( 
		const ElementType& element , 
		int iInNameIndex ) 
{
	int iIndex = indexOfInNameIndex( element->getName() , iInNameIndex ) ;
	if ( !( 0 <= iIndex && iIndex < (int)m_contCNode.size() ) )
	{
		return -1 ;
	}

	//modify container
	m_contCNode[iIndex] = element->clone() ;

	m_CInNameIndexContainer.erase( iIndex ) ;
	m_CInNameIndexContainer.insert( element->getName() , iIndex ) ;
	return 0 ;
}

int CNodeContainer::insertInName( 
		const ElementType& element , 
		int iInNameIndex ) 
{
	if ( iInNameIndex == INT_MAX )
	{
		iInNameIndex = sizeInName( element->getName() ) ;
	}
	if ( !( 0 <= iInNameIndex && iInNameIndex <= sizeInName( element->getName() ) ) )
	{
		return -1 ;
	}
	// --------------------------------
	int iIndex = indexOfInNameIndex( element->getName() , iInNameIndex ) ;
	if ( iIndex < 0 )
	{
		if ( 0 == sizeInName( element->getName() ) )
		{
			iIndex = (int)m_contCNode.size()  ;
		}
		else
		{
			iIndex = indexOfInNameIndex( 
				element->getName() , 
				sizeInName( element->getName() ) - 1 ) + 1 ;
		}
	}

	//modify container
	m_contCNode.insert( 
		m_contCNode.begin() + iIndex , element->clone() ) ;

	m_CInNameIndexContainer.insert( element->getName() , iIndex ) ;

	return 0 ;
}
int CNodeContainer::eraseInName( const string& strName , 
		int  iInNameIndex  , int iSize ) 
{
	if ( iInNameIndex == INT_MAX && iSize == INT_MAX )
	{
		return -1 ;
	}
	if ( iInNameIndex == INT_MAX )
	{
		iInNameIndex = sizeInName( strName ) - iSize ;
	}
	if ( iSize == INT_MAX )
	{
		iSize = sizeInName( strName ) - iInNameIndex ;
	}
	if ( !( 0 <= iInNameIndex && iInNameIndex+iSize <= sizeInName( strName ) ) ) 
	{
		return -1 ;
	}
	// --------------------------------
	for ( iSize-- ; iSize >= 0 ; iSize -- )
	{
		int iIndex = indexOfInNameIndex( strName , iInNameIndex + iSize ) ;
		
		//modify container
		m_contCNode.erase( 
			m_contCNode.begin() + iIndex ) ;

		m_CInNameIndexContainer.erase( iIndex ) ;
	}
	return 0 ;
}

int CNodeContainer::indexOfInNameIndex( 
		const string& strName ,
		int iInNameIndex )const 
{
	int iInNameIndexCurr = -1 ;
	if ( !( 0 <= iInNameIndex && iInNameIndex < sizeInName( strName ) ) )
	{
		return -1 ;
	}
	return m_CInNameIndexContainer.indexOfInNameIndex( strName , iInNameIndex ) ;

}
int CNodeContainer::indexToInNameIndex( 
		int iIndex )const 
{
	int iInNameIndexCurr = 0 ;
	if ( !( 0 <= iIndex && iIndex < (int)m_contCNode.size() ) )
	{
		return -1 ;
	}
	// --------------------------------
	return m_CInNameIndexContainer.indexToInNameIndex( 
		m_contCNode[iIndex]->getName() , 
		iIndex ) ;
}


}	//namespace OuPropertiesText
