/*
	OuDia - Win32 Application Software to draw a "Train Service Planning
 Diagram" based on a "Train Timetable".

Copyright (C) 2006-2017 take-okm

This program is free software; you can redistribute it and/or modify it 
under the terms of the GNU General Public License as published by the Free 
Software Foundation; either version 3 of the License, or (at your option) 
any later version. 

This program is distributed in the hope that it will be useful, but WITHOUT 
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or 
FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for 
more details. 

You should have received a copy of the GNU General Public License along with
 this program. If not, see <http://www.gnu.org/licenses/>.

  In addition, as a special exception, take-okm
  gives permission to link the code of this program with
  the "MFC(Microsoft Foundation Class library) Version 9.0" 
  (or with modified versions of "MFC Version 9.0" that use the same license as 
  "MFC Version 9.0" ), and distribute linked combinations including
  the two.  You must obey the GNU General Public License in all
  respects for all of the code used other than  "MFC".  If you modify
  this file, you may extend this exception to your version of the
  file, but you are not obligated to do so.  If you do not wish to
  do so, delete this exception statement from your version.


(: 

	OuDia - Ԏ\ƂɁA_CO`悷Win32AvP[V
B

Copyright (C) 2006-2017 take-okm 

̃vO̓t[\tgEFAłBȂ͂At[\tgEFA
cɂĔsꂽGNU ʌOp(o[W3Aȍ~̃o[W
̂ǂꂩ)߂̉ōĔЕz܂͉ 邱Ƃł܂B

̃vO͗Lpł邱ƂĔЕz܂A*S̖ۏ *łB
Ɖ\̕ۏ؂ړIւ̓ḰAOɎꂽ̂ ܂߁AS
܂BڂGNU ʌOpB

Ȃ͂̃vOƋɁAGNU ʌOp̃Rs[ꕔ 󂯎
Ă͂łB󂯎ĂȂ΁A<http://www.gnu.org/licenses/> 
B

)

  āAʂȗOƂāAtake-okm ͂̃vÕR[h 
  "MFC(Microsoft Foundation Class library) Version 9.0" 
  (  邢 "MFC Version 9.0" ƓCZXKpꂽ
  "MFC Version 9.0" ̉ςꂽo[W)ƃNA
  Nꂽ҂܂ތ앨Еz鋖^܂B
  Ȃ "MFC" ȊOŎgĂ邷ׂ
  ̃R[hɊւĂ͑SʓIGNUʌOp_񏑂ɏ]Ȃ
  Ȃ܂BȂ̃t@CςȂ΁AȂ̗͂O
  Ȃ̃o[W̃t@CɈ݂邱Ƃł܂A
  `͂܂BO݂Ȃ΁A̗O
  Ȃ̃o[W͍폜ĂB)
*/
// ****************************************************************
// $Id: CConvFile_Oudia101To102.h 10 2012-08-26 09:48:47Z okm $
// ****************************************************************
#ifndef  CConvFile_Oudia101To102_h
#define  CConvFile_Oudia101To102_h
/** @file */

#include "IfConvFile.h"

#include "Str\OuPropertiesText\CConvNodeContainer.h"
#include "Str\OuPropertiesText\CDirectory.h"
#include "DcdCd\DcDrawProp\CdFontProp.h"

namespace ConvFile_Oudia101To102{

using namespace std ;
using namespace OuPropertiesText ;

/**
@brief
	OuDiat@C Ver.1.01  Ver.1.02 ɕϊ܂B

	ϊéAȉ̂ƂłB

@code
FileType
	  "OuDia.1.01""OuDia.1.02" ɕϊ܂B
Rosen.Eki[0].Ekijikokukeisiki
	@"Jikokukeisiki_Hatsu""Jikokukeisiki_NoboriChaku" ɕύX
Rosen.Eki[].Ekijikokukeisiki
	@"Jikokukeisiki_Hatsu""Jikokukeisiki_KudariChaku" ɕύX
DispProp.JikokuhyouVFont
	@DispProp.JikokuhyouFont[0] ̃tFCX̐擪 "@" t^ 
	CreateFont() s܂B
	@ꂽtHg̑A̒lɃZbg܂B
FileTypeAppComment
	"ConvFileOudia101To102 Ver 0.01"
@endcode



*/
class CConvFile_Oudia101To102 : public IfConvFile
{
private:
	// --------------------------------
	///@name ֐
	// --------------------------------
	///@{
	/**
		.oud t@C̃[gm[hReiA
		Rosen.Eki[0] ̃m[hRei擾܂B
	@param pCNodeContainer [in]
		.oud t@C̃[gm[hReiw肵ĂB
	@return
		m[hReĩ|C^Ԃ܂B
	*/
	Ou<CDirectory> getEki0FromOudFile( 
		CNodeContainer* pCNodeContainer ) ;

	/**
		.oud t@C̃[gm[hReiA
		Rosen.Eki[] ̃m[hRei擾܂B
	@param pCNodeContainer [in]
		.oud t@C̃[gm[hReiw肵ĂB
	@return
		m[hReĩ|C^Ԃ܂B
	*/
	Ou<CDirectory> getEkiLastFromOudFile( 
		CNodeContainer* pCNodeContainer ) ;

	/**
		.oud t@C̃[gm[hReiA
		DispProp.JikokuhyouFont[0] 擾܂B
	@param pCNodeContainer [in]
		.oud t@C̃[gm[hReiw肵ĂB
	@return
		m[h̒lԂ܂B
		m[hȂ΁A󕶎Ԃ܂B
	*/
	string readJikokuhou0FontFromOudFile( 
		const IfNodeContainerConst* pCNodeContainer ) ;

	/**
		.oud t@C
		DispProp.JikokuhyouVFont m[hɁAݒ肵܂B
	@param pCNodeContainer [in]
		.oud t@C̃[gm[hReiw肵ĂB
	@param strValue [in]
		ݒ肷镶w肵ĂB
	@return
		0ȏAG[Ȃ畉̐łB
		-	-1 ;	//	"DispProp" m[h܂
	*/
	int writeJikokuhouVFontToOudFile( 
		const CNodeContainer* pCNodeContainer ,
		const string& strValue ) ;

	/**
		tHg tHgvpeBA
		ctHg̃tHgvpeB𐶐܂B
	@param aCdFontProp [in]
		tHg̃vpeBw肵ĂB
	@return
		ctHg̃vpeBԂ܂B
		ʏ́AtHg̃vpeB̃tFCX
		@@ t^ĐtHg̃vpeBłB
	*/
	CdFontProp createVFontPropFromHFont( 
		const CdFontProp& aCdFontProp ) ;
	///@}

public:
	// ********************************
	//	RXgN^
	// ********************************
	CConvFile_Oudia101To102();
	virtual ~CConvFile_Oudia101To102();
public:
	// ********************************
	///@name IfConvFile
	// ********************************
	///@{
	/**
		LeftFormat  RightFormat ւ̕ϊs܂B

	@param pLeftFormat [in]
		LeftFormat ̃f[^w肵ĂB
	@param pRightFormat [out]
		̊֐͕ϊA
		̃obt@ɁARightFormat ̃f[^݂܂B
	@param pErrorInfoString [out] 
		̊֐͕ϊsA
		̃obt@ɃG[̓e
		݂܂B
		AAׂĂ ConvFile NX̋@\T|[gĂ킯ł
		܂B
	@return  
		 0 ȏAG[Ȃ畉̐łB
		-	-1 ;	//	FileType ܂B
		-	-11 ;	//	t@CtH[}bgł͂܂B
	*/
	virtual int LeftToRight( 
		const IfByteBuffer* pLeftFormat , 
		IfByteBuffer* pRightFormat , 
		IfByteBuffer* pErrorInfoString ) ; 

	/**
		LeftFormat ϊ\ȃtH[}bgł邩ۂ
		肵܂B
		
		̊֐ LeftFormat ̃f[^̓ɑ΂ĊȒPȌ
		s܂B
		̊֐ĂA LeftToRight() Ƃ
		܂B

	yz

@	  .oud t@C  Oudia.5 ł́A [FileType] ɁA"OuDia.5" LqĂ܂B
		
	@param pLeftFormat [in]
		LeftFormat ̃f[^w肵ĂB
	@return  
		 0 ȏAG[Ȃ畉̐łB
		-	0 ȏ ;	//	ϊ\ȃtH[}bgłB
		-	-1 ;	//	FileType ܂B
		-	-11 ;	//	t@CtH[}bgł͂܂B
	*/
	virtual int isLeftFormat( 
		const IfByteBuffer* pLeftFormat)  ; 

	/**
	@return 
		- true ;	//	RightToLeft(),isRightFormat() \bhT|[gĂ܂B
		- false ;	//	RightToLeft(),isRightFormat() \bhT|[gĂ܂B
	*/
	virtual bool RightToLeftIsSupported() ; 

	/**
		RightFormat  LeftFormat ւ̕ϊs܂B
	@param pRightFormat [in]
		RightFormat ̃f[^w肵ĂB
	@param pLeftFormat [out]
		̊֐͕ϊA
		̃obt@ɁALeftFormat ̃f[^݂܂B
	@param pErrorInfoString [out] 
		̊֐͕ϊsA
		̃obt@ɃG[̓e
		݂܂B
		AAׂĂ ConvFile NX̋@\T|[gĂ킯ł
		܂B
		svłNULLł܂܂B
	@return  
		 0 ȏAG[Ȃ畉̐łB
		-	-1 ;	//	pLeftFormat ͐ LeftFormat ł͂܂B
		-	-2 ;	//	̃\bh̓T|[gĂ܂B
	*/
	virtual int RightToLeft( 
		const IfByteBuffer* pRightFormat , 
		IfByteBuffer* pLeftFormat , 
		IfByteBuffer* pErrorInfoString ) ; 

	/**
		RightFormat ϊ\ȃtH[}bgł邩ۂ
		肵܂B
		
		̊֐ RightFormat ̃f[^̓ɑ΂ĊȒPȌ
		s܂B
		̊֐ĂA LeftFromRight() Ƃ
		܂B
	@param pRightFormat [in]
		RightFormat ̃f[^w肵ĂB
	@return  
		 0 ȏAG[Ȃ畉̐łB
		-	0 ȏ ;	//	ϊ\ȃtH[}bgłB
		-	-1 ;	//	pRightFormat ͐ RightFormat ł͂܂B
		-	-2 ;	//	̃\bh̓T|[gĂ܂B
	*/
	virtual int isRightFormat( 
		const IfByteBuffer* pRightFormat ) ; 
	///@}

};


} //namespace ConvFile_Oudia101To102



#endif //CConvFile_Oudia101To102_h


