/*
	OuDia - Win32 Application Software to draw a "Train Service Planning
 Diagram" based on a "Train Timetable".

Copyright (C) 2006-2017 take-okm

This program is free software; you can redistribute it and/or modify it 
under the terms of the GNU General Public License as published by the Free 
Software Foundation; either version 3 of the License, or (at your option) 
any later version. 

This program is distributed in the hope that it will be useful, but WITHOUT 
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or 
FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for 
more details. 

You should have received a copy of the GNU General Public License along with
 this program. If not, see <http://www.gnu.org/licenses/>.

  In addition, as a special exception, take-okm
  gives permission to link the code of this program with
  the "MFC(Microsoft Foundation Class library) Version 9.0" 
  (or with modified versions of "MFC Version 9.0" that use the same license as 
  "MFC Version 9.0" ), and distribute linked combinations including
  the two.  You must obey the GNU General Public License in all
  respects for all of the code used other than  "MFC".  If you modify
  this file, you may extend this exception to your version of the
  file, but you are not obligated to do so.  If you do not wish to
  do so, delete this exception statement from your version.


(: 

	OuDia - Ԏ\ƂɁA_CO`悷Win32AvP[V
B

Copyright (C) 2006-2017 take-okm 

̃vO̓t[\tgEFAłBȂ͂At[\tgEFA
cɂĔsꂽGNU ʌOp(o[W3Aȍ~̃o[W
̂ǂꂩ)߂̉ōĔЕz܂͉ 邱Ƃł܂B

̃vO͗Lpł邱ƂĔЕz܂A*S̖ۏ *łB
Ɖ\̕ۏ؂ړIւ̓ḰAOɎꂽ̂ ܂߁AS
܂BڂGNU ʌOpB

Ȃ͂̃vOƋɁAGNU ʌOp̃Rs[ꕔ 󂯎
Ă͂łB󂯎ĂȂ΁A<http://www.gnu.org/licenses/> 
B

)

  āAʂȗOƂāAtake-okm ͂̃vÕR[h 
  "MFC(Microsoft Foundation Class library) Version 9.0" 
  (  邢 "MFC Version 9.0" ƓCZXKpꂽ
  "MFC Version 9.0" ̉ςꂽo[W)ƃNA
  Nꂽ҂܂ތ앨Еz鋖^܂B
  Ȃ "MFC" ȊOŎgĂ邷ׂ
  ̃R[hɊւĂ͑SʓIGNUʌOp_񏑂ɏ]Ȃ
  Ȃ܂BȂ̃t@CςȂ΁AȂ̗͂O
  Ȃ̃o[W̃t@CɈ݂邱Ƃł܂A
  `͂܂BO݂Ȃ΁A̗O
  Ȃ̃o[W͍폜ĂB)
*/
/*
// ****************************************************************
//	CDcdFillrectRop.h
// ****************************************************************
*/
/** @file */
#ifndef  CDcdFillrectRop_h
#define  CDcdFillrectRop_h

#include "IfDcDraw.h"
#include "DcdCd\DcDrawProp\CdPenProp.h"
#include "DcdCd\DcDrawProp\CdBrushProp.h"

// ****************************************************************
//	CDcdFillrectRop
// ****************************************************************
/**
 @brief
 yTvz
  DcDrawfIuWFNgłB̈hԂ܂B
  CDcdFillRectƂ͈قȂAROP(X^Iy[V)Kpł܂B

  ̃IuWFNgɑ΂ DcDraw() ĂяoƁÄ̗ŜA
Ŏw肳ꂽFinb`p^[jœh܂B

  ̃NXł́AROP(X^Iy[V)w肷邱ƂɂA
ủ݂ʏ̕`e𔒍]AƂ`悪ł܂v

@note

  CDcdFillRect ɂ́AROPKp邱Ƃł܂B
  CDcdRectangle ɂROPKpł܂ACDcdRectangleŗ̈̓hԂsƁA
hԂ̈悪E1sNZE1sNZȂ܂B
  ̃NXł́ÂQ̖Ă܂B
  ̂߁ARectangle() API ̈ɂ1sNZEɍLln܂B
  
*/
class CDcdFillrectRop : public IfDcDraw
{
// ********************************
///	@name 
// ********************************
///@{
 private:
	/**
	*	hԂɎgpuV̑ێ܂B
	*/
	CdBrushProp	m_CdBrushProp	;
	/**
		Oi[h R2 萔Ŏw肵܂B
		ĺAR2_COPYPEN łB
	*/
	int m_iR2DrawMode	;
	
///@}
	
// ********************************
//	RXgN^
// ********************************
 public:
	/**
	 @param aCdBrushProp
		hԂɎgpuV̑w肵ĂB
	@param iR2DrawMode [in]
		Oi[h R2 萔Ŏw肵ĂB
		ĺAR2_COPYPEN łB
	@see SetROP2()
	*/
	CDcdFillrectRop( 
		const CdBrushProp& aCdBrushProp , 
		int iR2DrawMode )	;
	CDcdFillrectRop() ;
	virtual ~CDcdFillrectRop() ;
	
// ********************************
///@name	IfDcDraw
// ********************************
///@{
 public:
	/**
	* 	`v܂B
	* 	̊֐́A pIfDcdTarget ɁA`s܂B
	*
	*	yI[oChz
	*	  nꂽ̈AuVœhԂ܂B
	* @param pIfDcdTarget  [in]
	* 	̃IuWFNgɕ`s킹DCƗ̈w肵ĂB
	* @return
	* 	`sꍇ͐^Ë̗ւ̕`悪łȂꍇ͋UłB
	*/
	virtual bool DcDraw( IfDcdTarget* pIfDcdTarget ) ;
	
	/**
	* 	̃IuWFNg`悷ACȇ傫܂Ăꍇ́A
	* 	̑傫𒲂ׂ邱Ƃł܂B
	* 	֐Ăяo IfDcDraw IuWFNg`悷ꍇɂ́A
	* 	֐ĂяóÅ֐ŃACȇ傫𒲂ׂāA
	* 	K؂ȃCAEglĂADcDraw() s邱Ƃł܂B
	*
	*	yI[oChz
	*	  ̃NXł́AT|[gĂ܂B
	* @param pIfDcdTarget [in]
	* 	̃IuWFNgɕ`s킹DCƗ̈w肵ĂB
	* @param pCdDcdSizeXy [out]
	* 	̃IuWFNg̕`悷ACȇ傫܂Ăꍇ́A
	* 	̊֐͂̃AhXɁÃACẽTCYԂ܂B
	* 	̃IuWFNg̕`悷ACȇ傫܂ĂȂꍇ́A
	* 	̒l͕słB
	* @return
	* 	̃IuWFNg̕`悷ACȇ傫܂ĂāA
	* 	̑傫 *pCdDcdSizeXyɏ񂾏ꍇ͐^łB
	* 	łȂꍇ́AUłB
	*	@n
	*	yI[oChz  UԂ܂B
	*/
	virtual bool getItemSize( IfDcdTarget* pIfDcdTarget , 
							CdDcdSizeXy* pCdDcdSizeXy ) ;
///@}
// ********************************
//	CDcdFillrectRop
// ********************************
 public:
	// ********************************
	///@name 
	// ********************************
	///@{
	virtual CdBrushProp	getCdBrushProp(){	return m_CdBrushProp	;	} ;
	virtual CDcdFillrectRop& setCdBrushProp( const CdBrushProp& ev ){
		m_CdBrushProp	= ev ;	return *this ; } ;
	virtual int getR2DrawMode()const{	return m_iR2DrawMode	;};
	virtual CDcdFillrectRop& setR2DrawMode( int value )
	{	m_iR2DrawMode = value ;	return *this 	;};
	///@}
};

#endif /*CDcdFillrectRop_h*/
