/*
	OuDia - Win32 Application Software to draw a "Train Service Planning
 Diagram" based on a "Train Timetable".

Copyright (C) 2006-2017 take-okm

This program is free software; you can redistribute it and/or modify it 
under the terms of the GNU General Public License as published by the Free 
Software Foundation; either version 3 of the License, or (at your option) 
any later version. 

This program is distributed in the hope that it will be useful, but WITHOUT 
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or 
FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for 
more details. 

You should have received a copy of the GNU General Public License along with
 this program. If not, see <http://www.gnu.org/licenses/>.

  In addition, as a special exception, take-okm
  gives permission to link the code of this program with
  the "MFC(Microsoft Foundation Class library) Version 9.0" 
  (or with modified versions of "MFC Version 9.0" that use the same license as 
  "MFC Version 9.0" ), and distribute linked combinations including
  the two.  You must obey the GNU General Public License in all
  respects for all of the code used other than  "MFC".  If you modify
  this file, you may extend this exception to your version of the
  file, but you are not obligated to do so.  If you do not wish to
  do so, delete this exception statement from your version.


(: 

	OuDia - Ԏ\ƂɁA_CO`悷Win32AvP[V
B

Copyright (C) 2006-2017 take-okm 

̃vO̓t[\tgEFAłBȂ͂At[\tgEFA
cɂĔsꂽGNU ʌOp(o[W3Aȍ~̃o[W
̂ǂꂩ)߂̉ōĔЕz܂͉ 邱Ƃł܂B

̃vO͗Lpł邱ƂĔЕz܂A*S̖ۏ *łB
Ɖ\̕ۏ؂ړIւ̓ḰAOɎꂽ̂ ܂߁AS
܂BڂGNU ʌOpB

Ȃ͂̃vOƋɁAGNU ʌOp̃Rs[ꕔ 󂯎
Ă͂łB󂯎ĂȂ΁A<http://www.gnu.org/licenses/> 
B

)

  āAʂȗOƂāAtake-okm ͂̃vÕR[h 
  "MFC(Microsoft Foundation Class library) Version 9.0" 
  (  邢 "MFC Version 9.0" ƓCZXKpꂽ
  "MFC Version 9.0" ̉ςꂽo[W)ƃNA
  Nꂽ҂܂ތ앨Еz鋖^܂B
  Ȃ "MFC" ȊOŎgĂ邷ׂ
  ̃R[hɊւĂ͑SʓIGNUʌOp_񏑂ɏ]Ȃ
  Ȃ܂BȂ̃t@CςȂ΁AȂ̗͂O
  Ȃ̃o[W̃t@CɈ݂邱Ƃł܂A
  `͂܂BO݂Ȃ΁A̗O
  Ȃ̃o[W͍폜ĂB)
*/
/*
// ****************************************************************
// $Id: CaContentPosToDcdTarget_Dim.h 10 2012-08-26 09:48:47Z okm $
// ****************************************************************
*/
/** @file */
#ifndef  DcDraw_DcdCd_Pos_CaContentPosToDcdTarget_Dim_h
#define  DcDraw_DcdCd_Pos_CaContentPosToDcdTarget_Dim_h
#include "DcdCd\Pos\CconvContentPosToTarget.h"
#include "DcDraw\IfDcdTarget.h"

class CconvContentPosToDcdTarget ;	//	outer̎Q

// ****************************************************************
//	CaContentPosToDcdTarget_Dim
// ****************************************************************
/**
@brief
  CaContentPosToDcdTarget_Dim ́A
  CconvContentPosToDcdTarget ɏW񂳂܂B
  
  ̃NX͒ۃNXłB
  IfDcdTarget* Ƃ\bhĂяoA
  calcCdDcdZone() ֐ `̈ɕϊāA
  m_pCconvContentPosToTarget ɈϏ܂B
*/
class CaContentPosToDcdTarget_Dim
{
public:
	// ********************************
	//	Ci[^Cv
	// ********************************
	
private:
	// ********************************
	///@name ֘A
	// ********************************
	///@{
	///@}
	// ********************************
	///@name 
	// ********************************
	///@{
	/**	
		IfDcdTarget ̉EE̗]T̈ێ܂B
		IfDcdTarget ̍WnŎw肵܂B
	
		WnɂẮAẼRec
		ʊO(IfDcdTargeẗ̗O)ɂȂꍇ܂B
		
		̒l1ȏɂ邱ƂɂARec
		ʓ̂Eɕ\邱Ƃł܂B
	*/
	DcdSize m_sizeDcdMargin ;
	///@}

protected:
	// --------------------------------
	///@name I[oCh
	// --------------------------------
	///@{
	/**
	@return 
		IfDcdTarget ̕`̈Ԃ܂B
	*/
	virtual CdDcdZone calcCdDcdZone( IfDcdTarget* pIfDcdTarget ) = 0 ;
	///@}

public:
	// ********************************
	//	RXgN^
	// ********************************
	CaContentPosToDcdTarget_Dim(
		DcdSize sizeDcdMargin );
	virtual ~CaContentPosToDcdTarget_Dim(){} ;


public:
	// ********************************
	///@name CconvContentPosToTarget-
	// ********************************
	///@{
	CconvContentPosToTarget::EMode	getMode()const ;
	void setMode( CconvContentPosToTarget::EMode	value ) ;

	DcdPos	getContentPos()const ;
	void setContentPos( DcdPos value ) ;

	double getTargetPosPerContent()const ;
	DcdSize	getContentSize()const ;
	///@}
	
public:
	// ********************************
	///@name CconvContentPosToTarget-TargetPosPerContent,ContentSize 擾Eݒ
	// ********************************
	///@{
	/**
		g嗦擾邱Ƃł܂B
	@param pIfDcdTarget[in]
		`Ώۂw肵ĂB
		NULLȂA̓s܂B
	@return
		g嗦BRegWṔATargetPos ̐B

	*/
	double getTargetPosPerContent( 
		IfDcdTarget* pIfDcdTarget ) ;

	/**
		g嗦ݒ肷邱Ƃł܂B
	@param value[in]
		g嗦BRegWṔATargetPos ̐B
	@param pIfDcdTarget[in]
		`Ώۂw肵ĂB
		NULLȂA̓s܂B
	*/
	void setTargetPosPerContent( double value , 
		IfDcdTarget* pIfDcdTarget ) ;

	/**
		TargetZoneɕ\Reg̑傫擾邱Ƃł܂B
	@param pIfDcdTarget[in]
		`Ώۂw肵ĂB
		NULLȂA̓s܂B
	@return
		TargetZoneɕ\Reg̑傫B
	*/
	DcdSize getContentSize( IfDcdTarget* pIfDcdTarget ) ;

	/**
		TargetZoneɕ\Reg̑傫ݒ肷邱Ƃł܂B
	@param value[in]
		TargetZoneɕ\Reg̑傫B
	@param pIfDcdTarget[in]
		`Ώۂw肵ĂB
		NULLȂA̓s܂B
	*/
	void setContentSize( DcdSize value , IfDcdTarget* pIfDcdTarget ) ;

	/**
		TargetZoneɕ\Reg̎n_Ɗg嗦ݒ肷邱Ƃł܂B
	@param posContentPos [in]
		TargetPos̍ɕ`悳Content́AContentPosWB
	@param dTargetPosPerContentX [in]
		g嗦BRegWṔATargetPos ̐B
	@param pIfDcdTarget[in]
		`Ώۂw肵ĂB
		NULLȂA̓s܂B
	*/
	void setContentPosAndRate( 
		DcdPos posContentPos , 
		double dTargetPosPerContent ,
		IfDcdTarget* pIfDcdTarget ) ;

	/** 
		TargetZoneɕ\Reg̎n_Ƒ傫擾邱Ƃł܂B
	@param pIfDcdTarget[in]
		`Ώۂw肵ĂB
		NULLȂA̓s܂B
	@return
		TargetZoneɕ\Reg̈ʒuƑ傫B
	*/
	CdDcdZone getContentZone( IfDcdTarget* pIfDcdTarget ) ;

	/**
		TargetZoneɕ\Reg̎n_Ƒ傫ݒ肷邱Ƃł܂B
	@param zoneContent[in]
		TargetZoneɕ\Reg̎n_Ƒ傫B
	@param pIfDcdTarget[in]
		`Ώۂw肵ĂB
		NULLȂA̓s܂B
	*/
	void setContentZone( const CdDcdZone& zoneContent , 
		IfDcdTarget* pIfDcdTarget ) ;


	///@}
public:
	// ********************************
	///@name CconvContentPosToTarget-Wϊ
	// ********************************
	///@{
	/**
		ContentPos ̍WATargetZone ̍Wɕϊ܂B
	@param posContent [in]
		ϊΏۂ̍Ww肵ĂB
	@param pIfDcdTarget[in]
		`Ώۂw肵ĂB
		NULL ͎wł܂B
	*/
	DcdPos	ContentPosToTarget( 
		DcdPos posContent , IfDcdTarget* pIfDcdTarget ) ;

	/**
		ContentPos ̍WATargetZone ̍Wɕϊ܂B
	@param posContent [in]
		ϊΏۂ̍Ww肵ĂB
	@param pIfDcdTarget[in]
		`Ώۂw肵ĂB
		NULL ͎wł܂B
	*/
	CdDcdZone	ContentZoneToTarget( 
		const CdDcdZone& zoneContent , IfDcdTarget* pIfDcdTarget) ;

	/**
		TargetZone ̍WAContentPos ɕϊ܂B
	@param posTarget[in]
		ϊΏۂ̍Ww肵ĂB
	@param pIfDcdTarget[in]
		`Ώۂw肵ĂB
		NULL ͎wł܂B
	*/
	DcdPos	ContentPosFromTarget( 
		DcdPos posTarget , IfDcdTarget* pIfDcdTarget ) ;

	/**
		TargetZone ̍WAContentPos ɕϊ܂B
	@param zoneTarget [in]
		ϊΏۂ̍Ww肵ĂB
	@param pIfDcdTarget[in]
		`Ώۂw肵ĂB
		NULL ͎wł܂B
	*/
	CdDcdZone	ContentZoneFromTarget( 
		const CdDcdZone& zoneTarget , IfDcdTarget* pIfDcdTarget ) ;

	///@}
public:
	// ********************************
	///@name CconvContentPosToTargetDim-֘A
	// ********************************
	///@{
	virtual CconvContentPosToTarget* getCconvContentPosToTarget()=0 ;
	virtual const CconvContentPosToTarget* getCconvContentPosToTarget()const=0  ;
	///@}
public:
	// ********************************
	///@name CaContentPosToDcdTarget_Dim-
	// ********************************
	///@{
	DcdSize getDcdMargin()const ;
	void setDcdMargin(DcdSize value ) ;
	///@}
};

#endif //DcDraw_DcdCd_Pos_CaContentPosToDcdTarget_Dim_h
