/*
	OuDia - Win32 Application Software to draw a "Train Service Planning
 Diagram" based on a "Train Timetable".

Copyright (C) 2006-2017 take-okm

This program is free software; you can redistribute it and/or modify it 
under the terms of the GNU General Public License as published by the Free 
Software Foundation; either version 3 of the License, or (at your option) 
any later version. 

This program is distributed in the hope that it will be useful, but WITHOUT 
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or 
FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for 
more details. 

You should have received a copy of the GNU General Public License along with
 this program. If not, see <http://www.gnu.org/licenses/>.

  In addition, as a special exception, take-okm
  gives permission to link the code of this program with
  the "MFC(Microsoft Foundation Class library) Version 9.0" 
  (or with modified versions of "MFC Version 9.0" that use the same license as 
  "MFC Version 9.0" ), and distribute linked combinations including
  the two.  You must obey the GNU General Public License in all
  respects for all of the code used other than  "MFC".  If you modify
  this file, you may extend this exception to your version of the
  file, but you are not obligated to do so.  If you do not wish to
  do so, delete this exception statement from your version.


(: 

	OuDia - Ԏ\ƂɁA_CO`悷Win32AvP[V
B

Copyright (C) 2006-2017 take-okm 

̃vO̓t[\tgEFAłBȂ͂At[\tgEFA
cɂĔsꂽGNU ʌOp(o[W3Aȍ~̃o[W
̂ǂꂩ)߂̉ōĔЕz܂͉ 邱Ƃł܂B

̃vO͗Lpł邱ƂĔЕz܂A*S̖ۏ *łB
Ɖ\̕ۏ؂ړIւ̓ḰAOɎꂽ̂ ܂߁AS
܂BڂGNU ʌOpB

Ȃ͂̃vOƋɁAGNU ʌOp̃Rs[ꕔ 󂯎
Ă͂łB󂯎ĂȂ΁A<http://www.gnu.org/licenses/> 
B

)

  āAʂȗOƂāAtake-okm ͂̃vÕR[h 
  "MFC(Microsoft Foundation Class library) Version 9.0" 
  (  邢 "MFC Version 9.0" ƓCZXKpꂽ
  "MFC Version 9.0" ̉ςꂽo[W)ƃNA
  Nꂽ҂܂ތ앨Еz鋖^܂B
  Ȃ "MFC" ȊOŎgĂ邷ׂ
  ̃R[hɊւĂ͑SʓIGNUʌOp_񏑂ɏ]Ȃ
  Ȃ܂BȂ̃t@CςȂ΁AȂ̗͂O
  Ȃ̃o[W̃t@CɈ݂邱Ƃł܂A
  `͂܂BO݂Ȃ΁A̗O
  Ȃ̃o[W͍폜ĂB)
*/
/*
// ****************************************************************
//	CconvDcdPosOnZone_PosOrgAndRate.h
// $Id: CconvDcdPosOnZone_PosOrgAndRate.h 10 2012-08-26 09:48:47Z okm $
// ****************************************************************
*/
/** @file */
#ifndef  CconvDcdPosOnZone_PosOrgAndRate_h
#define  CconvDcdPosOnZone_PosOrgAndRate_h
#include "DcdCd\Pos\CdDcdZone.h"
#include "DcdCd\Pos\CconvDcdPosOnZone.h"
// ****************************************************************
//	CconvDcdPosOnZone_PosOrgAndRate
// ****************************************************************
/**
 @brief
	yTvz
	  Q̈ꎟWn̊ԂŁAWϊ܂B
	
	  ̃NX́AWn Zone1 ̍WlA Zone2 ̍Wl
	ϊ邱Ƃł܂B
	
	  Wn Zone1  Zone2 ́A
	  
      - m_posZone1Org FDcdPos	Zone1̎n_
      - m_posZone2Org FDcdPos	Zone2̎n_
      - m_dZone2PerZone1 Fdouble Zone1ł̍W1ɑΉAZone2ł̍W
	 
	ŕ\܂B

  i1jWnA
	-	m_posZone1Org = 0 
	-	m_posZone2Org = 0 
	-	m_dZone2PerZone1 = 2

	łꍇÁA
	  uWn Zone1 ̈ʒu 0 Zone2 ̈ʒu 0 ƂȂB
	  ̈ʒuƂāAZone1̋1AZone2̋ m_dZone2PerZone1 ƂȂv
	ƂӖ܂B
	
	  ̏ԂŁA
	
	  Zone1̈ʒu 5  Zone2 ɕϊƁA 10 ƂȂ܂B
	
	  ܂AZone1 ͈̔(CdDcdZone){ Pos= 3 , Size=5 } A
	Zone2 ɕϊƁA{ Pos=6 , Size=10 } ƂȂ܂B
	
  i2jWnA
	-	m_posZone1Org = 5 
	-	m_posZone2Org = 0 
	-	m_dZone2PerZone1 = 2

	łꍇÁA
	  uWn Zone1 ̈ʒu 0 Zone2 ̈ʒu 0 ƂȂB
	  ̈ʒuƂāAZone1̋1AZone2̋ m_dZone2PerZone1 ƂȂv
	ƂӖ܂B
	
	  ̏ԂŁA
	
	  Zone1̈ʒu 5  Zone2 ɕϊƁA 0 ƂȂ܂B
	
	  ܂AZone1 ͈̔(CdDcdZone){ Pos= 3 , Size=5 } A
	Zone2 ɕϊƁA{ Pos=-4 , Size=10 } ƂȂ܂B

@ref cconvdcdposonzone_posorgandrate_towindowscroll

@ref cconvdcdposonzone_posorgandrate 
 
 */
class CconvDcdPosOnZone_PosOrgAndRate : public CconvDcdPosOnZone
{
 private:
	// ********************************
	///@name 
	// ********************************
	///@{
	/**
		Wn Zone1 ̎n_Bl=0
	 */
	DcdPos	m_posZone1Org ;
	
	/**
		Wn Zone2̎n_Bl=0
	 */
	DcdPos	m_posZone2Org ;

	/**
    	 Zone1ł̍W1ɑΉAZone2ł̍WB
		0 w肵ꍇ̓́Aʂ̃\bh̐QƂĂB
		l=1
	*/
	double m_dZone2PerZone1 ;
	///@}
 public:
	// ********************************
	//	RXgN^
	// ********************************
	/**
	@param posZone1Org [in]
		Wn Zone1 ̎n_B
	@param posZone2Org [in]
		Wn Zone2̎n_
	@param dZone2PerZone1 [in]
    	 Zone1ł̍W1ɑΉAZone2ł̍W
		0 w肵Ȃłi[ZɂȂ܂jB
	*/
	CconvDcdPosOnZone_PosOrgAndRate( 
		DcdPos	posZone1Org , 
		DcdPos	posZone2Org ,
		double dZone2PerZone1 ) ;

	/**
	 ̃RXgN^́Alɏ܂B
	 */
	CconvDcdPosOnZone_PosOrgAndRate() ;

	virtual ~CconvDcdPosOnZone_PosOrgAndRate() ;

 public:
	// ********************************
	///@name CconvDcdPosOnZone_PosOrgAndRate-
	// ********************************
	///@{
	/**
		Wn Zone1 ̎n_Bl=0
	 */
	DcdPos	getZone1Org()const{	return m_posZone1Org ;};
	void setZone1Org( DcdPos value )
	{	m_posZone1Org = value ;};
	DcdPos	getZone2Org()const{	return m_posZone2Org ;};
	void setZone2Org( DcdPos value )
	{	m_posZone2Org = value ;};
	double getZone2PerZone1()const{	return m_dZone2PerZone1 ;};
	void setZone2PerZone1( double value )
	{	m_dZone2PerZone1 = value ;};
	///@}
	
	// ********************************
	///@name CconvDcdPosOnZone-
	// ********************************
	///@{
	/**
		Zone1 ̍Wn
		ł̈ʒuA
		Zone2 ̍Wn
		ɕϊ܂B
	 @param value [in]
		ϊO̒lw肵ĉB
	 @return
		ϊ̒lԂ܂B
		
		m_dZone2PerZone1=0̏ꍇ́Am_posZone2Org ɂȂ܂B
	 */
	virtual DcdPos Zone1PosToZone2( DcdPos value )const ;
	
	/**
		Zone2 ̍Wn
		ł̈ʒuA
		Zone1 ̍Wn
		ɕϊ܂B
	 @param value [in]
		ϊO̒lw肵ĉB
	 @return
		ϊ̒lԂ܂B
		m_dZone2PerZone1=0̏ꍇ́Am_posZone1Org ɂȂ܂B
	 */
	virtual DcdPos Zone1PosFromZone2( DcdPos value )const ;

	/**
		Zone1 ̍Wn
		ł͈̔͂A
		Zone2 ̍Wn
		ɕϊ܂B
	 @param value [in]
		ϊO̒lw肵ĉB
	 @return
		ϊ̒lԂ܂B
		m_dZone2PerZone1=0̏ꍇ́ACdDcdZone(m_posZone1Org,0) ɂȂ܂B
	 */
	virtual CdDcdZone Zone1ToZone2( const CdDcdZone& value )const ;
	
	/**
		Zone2 ̍Wn
		ł͈̔͂A
		Zone1 ̍Wn
		ɕϊ܂B
	 @param value [in]
		ϊO̒lw肵ĉB
	 @return
		ϊ̒lԂ܂B
		m_dZone2PerZone1=0̏ꍇ́ACdDcdZone(m_posZone2Org,0) ɂȂ܂B
	 */
	virtual CdDcdZone Zone1FromZone2( const CdDcdZone& value )const ;
	///@}
	
	
};


/**
@page cconvdcdposonzone_posorgandrate_towindowscroll CconvDcdPosOnZone_PosOrgAndRate gXN[\EChEւ̍Wϊ

@CconvDcdPosOnZone_PosOrgAndRate gāAhLgŜ̍WA
XN[\ȃEChȄ̍Wɕϊ邱Ƃł܂B

	- Zone1=hLgŜ̍Wn
	- Zone2=EChE̍Wn

(1)@ȉ̂悤ɑݒ肵ĂB

	- Zone1Org=EChEōɕ\AhLg̍WB
	- Zone2PerZone1=EChEł̕\{B2ȂAhLg1̒A
		EChE2hbgɕ\܂B
	- Zone2Org=EChE̍̍WB

(2)Zone1PosToZone2,Zone1ToZone2 ŁAhLgWEChE̍W
ϊł܂B

*/


#endif /*CconvDcdPosOnZone_PosOrgAndRate_h*/
