/*
	OuDia - Win32 Application Software to draw a "Train Service Planning
 Diagram" based on a "Train Timetable".

Copyright (C) 2006-2017 take-okm

This program is free software; you can redistribute it and/or modify it 
under the terms of the GNU General Public License as published by the Free 
Software Foundation; either version 3 of the License, or (at your option) 
any later version. 

This program is distributed in the hope that it will be useful, but WITHOUT 
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or 
FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for 
more details. 

You should have received a copy of the GNU General Public License along with
 this program. If not, see <http://www.gnu.org/licenses/>.

  In addition, as a special exception, take-okm
  gives permission to link the code of this program with
  the "MFC(Microsoft Foundation Class library) Version 9.0" 
  (or with modified versions of "MFC Version 9.0" that use the same license as 
  "MFC Version 9.0" ), and distribute linked combinations including
  the two.  You must obey the GNU General Public License in all
  respects for all of the code used other than  "MFC".  If you modify
  this file, you may extend this exception to your version of the
  file, but you are not obligated to do so.  If you do not wish to
  do so, delete this exception statement from your version.


(: 

	OuDia - Ԏ\ƂɁA_CO`悷Win32AvP[V
B

Copyright (C) 2006-2017 take-okm 

̃vO̓t[\tgEFAłBȂ͂At[\tgEFA
cɂĔsꂽGNU ʌOp(o[W3Aȍ~̃o[W
̂ǂꂩ)߂̉ōĔЕz܂͉ 邱Ƃł܂B

̃vO͗Lpł邱ƂĔЕz܂A*S̖ۏ *łB
Ɖ\̕ۏ؂ړIւ̓ḰAOɎꂽ̂ ܂߁AS
܂BڂGNU ʌOpB

Ȃ͂̃vOƋɁAGNU ʌOp̃Rs[ꕔ 󂯎
Ă͂łB󂯎ĂȂ΁A<http://www.gnu.org/licenses/> 
B

)

  āAʂȗOƂāAtake-okm ͂̃vÕR[h 
  "MFC(Microsoft Foundation Class library) Version 9.0" 
  (  邢 "MFC Version 9.0" ƓCZXKpꂽ
  "MFC Version 9.0" ̉ςꂽo[W)ƃNA
  Nꂽ҂܂ތ앨Еz鋖^܂B
  Ȃ "MFC" ȊOŎgĂ邷ׂ
  ̃R[hɊւĂ͑SʓIGNUʌOp_񏑂ɏ]Ȃ
  Ȃ܂BȂ̃t@CςȂ΁AȂ̗͂O
  Ȃ̃o[W̃t@CɈ݂邱Ƃł܂A
  `͂܂BO݂Ȃ΁A̗O
  Ȃ̃o[W͍폜ĂB)
*/
/*
// ****************************************************************
//	stringSplit.h
// ****************************************************************
*/
/** @file 
*	@brief
* yTvz
* 	A؂ƂȂ镶ŕ֐ splitc ,A joinc 
*	^Ă܂B
*/
#ifndef  stringSplit_h
#define  stringSplit_h

#ifndef  NO_OuLib_NAMESPACE
/** @namespace
*/
namespace OuLib{
#endif /*NO_OuLib_NAMESPACE*/

/**
* 	؂蕶ɕāA̗vfi[ReiԂ܂B
* 	 STL ERei STL ̕NXΏۂƂSTLRei
* 	z肵Ă܂B
* @param StringContainerType
*	STLΏۂƂSTLReiw肵ĂB
* 	Ŏw肵^A߂ľ^ƂȂ܂B	\n
* 	ij std::deque<std::string>  std::vector<std::string> Ȃ
* @param chSplit [in]
* 	  ؂蕶w肵ĂB
* @param eStr [in]
* 	  ̑ΏۂƂȂ镶w肵ĂB
* @param bDropEmpty [in]
*	-  ^ȂA؂蕶̊Ԃ󕶎̏ꍇA
*	̏ꏊɑΉvfi󕶎j
*	ReiɊi[܂B\n
*	-   UȂA؂蕶̊Ԃ󕶎̏ꍇłA\n
*	ReiɊi[܂B
*	  l͋UłB
* @return
* 	  ̕i[ReiԂ܂B
*
* @b gp
* @code
	string	aConnectedString( "PROTOCOL=TCP;REMOTEIPADDR=192.168.0.1" ) ;
	deque<string>	strRv3= splitc< deque<string> >( ';' , aConnectString ) ;
	//	strRv3[0] = "PROTOCOL=TCP"
	//	strRv3[1] = "REMOTEIPADDR=192.168.0.1"
	//	ƂȂ܂
	//
* @endcode
*
* @note
*	eStr 󕶎̏ꍇA
*	 bDropEmpty UȂÅ֐͋󕶎Pi[
*	ReiԂ܂(󕶎vfƂ݂Ȃł)B
*	 bDropEmpty ^ȂÅ֐͗vfO
*	ReiԂ܂(󕶎͎̂Ă邩ł)B
*	
*/
template< class StringContainerType > 
StringContainerType splitc( 
		typename StringContainerType::value_type::const_reference chSplit , 
		typename StringContainerType::const_reference strEv ,
		bool bDropEmpty = false )
{
	StringContainerType	contRv ;
	typedef typename StringContainerType::value_type	StringType ;
	typedef typename StringType::size_type				StringSizeType ;

	StringSizeType	len = strEv.length() ;
	StringSizeType	posItemBegin = 0 ;
	while ( posItemBegin <= len ){
		// --------------------------------
		//	CdItem͈̔͂
		// --------------------------------
		StringSizeType posSplit = 
			strEv.find( chSplit , posItemBegin ) ;
		if ( posSplit == StringType::npos ){
			posSplit = len ;
		}
		//posSplit = ̏I[AACe؂蕶wĂ܂B 
		//posItemBegin`posSplit = ̃ACe

		{
			StringType strItem = 
				strEv.substr( posItemBegin , posSplit - posItemBegin ) ;
			if ( !( strItem.empty() && bDropEmpty ) ){
				contRv.push_back( strItem ) ;
			}
		}
		posItemBegin = posSplit + 1  ;
	}
	return ( contRv ) ;
}

/**
* 	ReiɊi[Ă镶A؂蕶}Č܂B
* 	 STL ERei STL ̕NXΏۂƂSTLRei
* 	z肵Ă܂B
* @param StringContainerType
* 	STLΏۂƂSTLReiw肵ĂB
* 	Ŏw肵^AcontStř^ƂȂ܂B	\n
* 	ij std::deque<std::string>  std::vector<std::string> Ȃ
* @param chSplit [in]
* 	؂蕶w肵ĂB
* @param contStr [in]
* 	i[Reiw肵ĂB
* @param bDropEmpty [in]
*	-   ^ȂARei̗vfɋ󕶎񂪂ꍇA
*	̗vf͖܂iΉ؂蕶
*	㕶ɒǉ܂jB
*	-   UȂARei̗vfɋ󕶎񂪂ꍇA
*	؂蕶㕶ɒǉ܂B
*	  l͋UłB
* @return
* 	̕Ԃ܂B
*
* @b gp
* @code
	deque<string>	strRv3 ;
	strRv3.push_back( "PROTOCOL=TCP" ) ;
	strRv3.push_back( "REMOTEIPADDR=192.168.0.1" ) ;
	string	aConnectedString = joinc( ';' , strRv3 ) ;
	//	aConnectedString="PROTOCOL=TCP;REMOTEIPADDR=192.168.0.1" 
	//	ƂȂ܂
	//
* @endcode
*/
template< class StringContainerType > 
typename StringContainerType::value_type joinc(
	typename StringContainerType::value_type::const_reference chSplit , 
	const StringContainerType& contStr  ,
	bool bDropEmpty = false )
{
	typedef typename StringContainerType::value_type	StringType ;
	StringType	strRv ;

	// --------------------------------
	//	ʕ̃TCYTZ
	// --------------------------------
	{
		long	lSize = 0 ;
		typename StringContainerType::const_iterator	ite ;
		for ( ite = contStr.begin() ; ite != contStr.end() ; ite ++ ){
			if ( !( ite->empty() && bDropEmpty ) ){
				if ( !strRv.empty() ){
					lSize += 1 ;
				}
				lSize += (long)ite->size() ;
			}
		}
		strRv.reserve( lSize ) ;
	}
	// --------------------------------
	{
		typename StringContainerType::const_iterator	ite ;
		for ( ite = contStr.begin() ; ite != contStr.end() ; ite ++ ){
			if ( !( ite->empty() && bDropEmpty ) ){
				if ( ite != contStr.begin() ){
					strRv += chSplit ;
				}
				strRv += *ite ;
			}
		}
	}
	return ( strRv ) ;
}

#ifndef  NO_OuLib_NAMESPACE
};
#endif /*NO_OuLib_NAMESPACE*/


#endif /*stringSplit_h*/
