/*
	OuDia - Win32 Application Software to draw a "Train Service Planning
 Diagram" based on a "Train Timetable".

Copyright (C) 2006-2017 take-okm

This program is free software; you can redistribute it and/or modify it 
under the terms of the GNU General Public License as published by the Free 
Software Foundation; either version 3 of the License, or (at your option) 
any later version. 

This program is distributed in the hope that it will be useful, but WITHOUT 
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or 
FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for 
more details. 

You should have received a copy of the GNU General Public License along with
 this program. If not, see <http://www.gnu.org/licenses/>.

  In addition, as a special exception, take-okm
  gives permission to link the code of this program with
  the "MFC(Microsoft Foundation Class library) Version 9.0" 
  (or with modified versions of "MFC Version 9.0" that use the same license as 
  "MFC Version 9.0" ), and distribute linked combinations including
  the two.  You must obey the GNU General Public License in all
  respects for all of the code used other than  "MFC".  If you modify
  this file, you may extend this exception to your version of the
  file, but you are not obligated to do so.  If you do not wish to
  do so, delete this exception statement from your version.


(: 

	OuDia - Ԏ\ƂɁA_CO`悷Win32AvP[V
B

Copyright (C) 2006-2017 take-okm 

̃vO̓t[\tgEFAłBȂ͂At[\tgEFA
cɂĔsꂽGNU ʌOp(o[W3Aȍ~̃o[W
̂ǂꂩ)߂̉ōĔЕz܂͉ 邱Ƃł܂B

̃vO͗Lpł邱ƂĔЕz܂A*S̖ۏ *łB
Ɖ\̕ۏ؂ړIւ̓ḰAOɎꂽ̂ ܂߁AS
܂BڂGNU ʌOpB

Ȃ͂̃vOƋɁAGNU ʌOp̃Rs[ꕔ 󂯎
Ă͂łB󂯎ĂȂ΁A<http://www.gnu.org/licenses/> 
B

)

  āAʂȗOƂāAtake-okm ͂̃vÕR[h 
  "MFC(Microsoft Foundation Class library) Version 9.0" 
  (  邢 "MFC Version 9.0" ƓCZXKpꂽ
  "MFC Version 9.0" ̉ςꂽo[W)ƃNA
  Nꂽ҂܂ތ앨Еz鋖^܂B
  Ȃ "MFC" ȊOŎgĂ邷ׂ
  ̃R[hɊւĂ͑SʓIGNUʌOp_񏑂ɏ]Ȃ
  Ȃ܂BȂ̃t@CςȂ΁AȂ̗͂O
  Ȃ̃o[W̃t@CɈ݂邱Ƃł܂A
  `͂܂BO݂Ȃ΁A̗O
  Ȃ̃o[W͍폜ĂB)
*/
/*
// ****************************************************************
//	vectorToFile.cpp
// ****************************************************************
//yTvz
//	vector<char> ̓et@C֏o
//	t@C̓e vector<char> ւ̓ǂݍ
//	s֐łB
*/
#include "stdafx.h"
#include "vectorToFile.h"
#include <stdio.h>
namespace OuLib {

// ****************************************************************


//	t@CɁAaVector Ɋi[Ăf[^݂܂B
//	Win32̏ꍇ́AoCi[hł݂̏ƂȂ܂B
//[in]aVector
//	̊֐́A̔z̓et@Cɏ݂܂B
//[in]strFilename
//	ݐ̃t@Cw肵ĂB
//	֐sOɃt@C݂Ăꍇ́A̓ej܂B
//[retval]
//	0:
//	̐̓G[łB
//	-1:	t@CI[vł܂B
//	-2 ;	//	݂Ɏs܂B
int vectorToFile( const std::vector<char>& aVector , 
					const std::string& strFilename ) 
{
	int	iRv = 0 ;
	if ( strFilename.empty() )
	{
		iRv = -1 ;	//	t@CI[vG[
	}
	if ( iRv >= 0 )
	
	{
		FILE*	pFile = fopen( strFilename.c_str() , "wb" ) ;
		
		if ( pFile != NULL ){
			int	iReadBytes = 0 ;
			iReadBytes = fwrite( &aVector.front() , 1 , 
								aVector.size() , pFile ) ;
			if ( iReadBytes != aVector.size() ){
				iRv = -2 ;	//	݂Ɏs܂B
			}
			if ( fclose( pFile ) != 0 ){
				if ( iRv >= 0 ){
					iRv = -2 ;	//	݂Ɏs܂B
				}
			}
		}	else	{
			iRv = -1 ;	//	t@CI[vG[
		}
	}
	return ( iRv ) ;
}



//	t@C̓eApVector Ɋi[܂B
//	Win32̏ꍇ́AoCi[hł̓ǂݍ݂ƂȂ܂B
//[out]pVector
//	̊֐́A̔zɁAt@C̓e݂܂B
//	zɂłɃf[^ꍇ́A̓ej܂B
//[in]strFilename
//	ǂݍރt@Cw肵ĂB
//[retval]
//	0:
//	̐̓G[łB
//	-1:	t@CI[vł܂B
//	-2 ;	//	ǂݍ݂Ɏs܂B
int vectorFromFile( std::vector<char>* pVector , 
					const std::string& strFilename ) 
{
	int	iRv = 0 ;
	
	if ( strFilename.empty() )
	{
		iRv = -1 ;	//	t@CI[vG[
	}
	
	
	if ( iRv >= 0 ){
		pVector->clear() ;
	}
	if ( iRv >= 0 ){
		
		
		FILE*	pFile = fopen( strFilename.c_str() , "rb" ) ;
		
		if ( pFile != NULL ){
			char	szLs[1024] ;
			int	iReadBytes = 0 ;
			do{
				iReadBytes = fread( szLs , 1 , sizeof(szLs) , pFile ) ;
				if ( iReadBytes > 0 ){
					pVector->insert( pVector->end() , szLs , 
													szLs + iReadBytes ) ;
				}	else if ( iReadBytes < 0 ){
					iRv = -2 ;	//	ǂݍ݂Ɏs܂B
				}
			}	while ( iReadBytes > 0 && iRv >= 0 ) ;
			if ( fclose( pFile ) != 0 ){
				if ( iRv >= 0 ){
					iRv = -2 ;	//	ǂݍ݂Ɏs܂B
				}
			}
		}	else	{
			iRv = -1 ;	//	t@CI[vG[
		}

	}
	return ( iRv ) ;
}





//	t@CɁAaString Ɋi[Ăf[^݂܂B
//	Win32̏ꍇ́AeLXg[hł݂̏ƂȂ܂B
//[in]aString
//	̊֐́A̓̕et@Cɏ݂܂B
//[in]strFilename
//	ݐ̃t@Cw肵ĂB
//	֐sOɃt@C݂Ăꍇ́A̓ej܂B
//[retval]
//	0:
//	̐̓G[łB
//	-1:	t@CI[vł܂B
//	-2 ;	//	݂Ɏs܂B
int stringToFile( const std::string& aString , 
					const std::string& strFilename ) 
{
	int	iRv = 0 ;
	if ( strFilename.empty() )
	{
		iRv = -1 ;	//	t@CI[vG[
	}
	if ( iRv >= 0 ){
		FILE*	pFile = fopen( strFilename.c_str() , "wt" ) ;
		
		if ( pFile != NULL ){
			int	iReadBytes = 0 ;
			iReadBytes = fwrite( aString.c_str() , 1 , 
								aString.size() , pFile ) ;
			if ( iReadBytes != aString.size() ){
				iRv = -2 ;	//	݂Ɏs܂B
			}
			if ( fclose( pFile ) != 0 ){
				if ( iRv >= 0 ){
					iRv = -2 ;	//	݂Ɏs܂B
				}
			}
		}	else	{
			iRv = -1 ;	//	t@CI[vG[
		}
	}
	return ( iRv ) ;
}



//	t@C̓eApVector Ɋi[܂B
//	Win32̏ꍇ́AoCi[hł̓ǂݍ݂ƂȂ܂B
//[out]pVector
//	̊֐́A̔zɁAt@C̓e݂܂B
//	zɂłɃf[^ꍇ́A̓ej܂B
//[in]strFilename
//	ǂݍރt@Cw肵ĂB
//[retval]
//	0:
//	̐̓G[łB
//	-1:	t@CI[vł܂B
//	-2 ;	//	ǂݍ݂Ɏs܂B
//	-3 ;	//	t@Cɂ'\0' ܂܂܂B
#include <sys/types.h>
#include <sys/stat.h>

int stringFromFile( std::string* pString , 
					const std::string& strFilename ) 
{
	int	iRv = 0 ;
	
	if ( strFilename.empty() )
	{
		iRv = -1 ;	//	t@CI[vG[
	}

	
	if ( iRv >= 0 ){
		pString->erase() ;
	}
	// --------------------------------
	//	t@CTCYǂ݂āA
	//	string Ƀm
	// --------------------------------
	if ( iRv >= 0 ){
		long lSize = 0 ;
		struct _stat aStat ;
		if ( _stat( strFilename.c_str() , &aStat ) == 0 ){
			lSize = aStat.st_size ;
			if ( lSize > 0 ){
				pString->reserve( lSize ) ;
			}
		}

		
	}
	// --------------------------------
	if ( iRv >= 0 )
	{
		
		
		FILE*	pFile = fopen( strFilename.c_str() , "rt" ) ;
		
		if ( pFile != NULL ){
			char	szLs[1024+1] ;
			int	iReadBytes = 0 ;
			do{
				iReadBytes = fread( szLs , 1 , sizeof(szLs) - 1 , pFile ) ;
				if ( iReadBytes > 0 ){
					szLs[iReadBytes] = '\0' ;
					int idx ;
					for ( idx = 0 ; szLs[idx] != '\0' ; idx ++ ){} ;
					if ( idx != iReadBytes ){
						iRv = -3 ;	//	t@Cɂ'\0' ܂܂܂B
					}	else	{
						*pString += szLs ;
					}
				}	else if ( iReadBytes < 0 ){
					iRv = -2 ;	//	ǂݍ݂Ɏs܂B
				}
			}	while ( iReadBytes > 0 && iRv >= 0 ) ;
			if ( fclose( pFile ) != 0 ){
				if ( iRv >= 0 ){
					iRv = -2 ;	//	ǂݍ݂Ɏs܂B
				}
			}
		}	else	{
			iRv = -1 ;	//	t@CI[vG[
		}

	}
	return ( iRv ) ;
}




};
