/*
	OuDia - Win32 Application Software to draw a "Train Service Planning
 Diagram" based on a "Train Timetable".

Copyright (C) 2006-2017 take-okm

This program is free software; you can redistribute it and/or modify it 
under the terms of the GNU General Public License as published by the Free 
Software Foundation; either version 3 of the License, or (at your option) 
any later version. 

This program is distributed in the hope that it will be useful, but WITHOUT 
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or 
FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for 
more details. 

You should have received a copy of the GNU General Public License along with
 this program. If not, see <http://www.gnu.org/licenses/>.

  In addition, as a special exception, take-okm
  gives permission to link the code of this program with
  the "MFC(Microsoft Foundation Class library) Version 9.0" 
  (or with modified versions of "MFC Version 9.0" that use the same license as 
  "MFC Version 9.0" ), and distribute linked combinations including
  the two.  You must obey the GNU General Public License in all
  respects for all of the code used other than  "MFC".  If you modify
  this file, you may extend this exception to your version of the
  file, but you are not obligated to do so.  If you do not wish to
  do so, delete this exception statement from your version.


(: 

	OuDia - Ԏ\ƂɁA_CO`悷Win32AvP[V
B

Copyright (C) 2006-2017 take-okm 

̃vO̓t[\tgEFAłBȂ͂At[\tgEFA
cɂĔsꂽGNU ʌOp(o[W3Aȍ~̃o[W
̂ǂꂩ)߂̉ōĔЕz܂͉ 邱Ƃł܂B

̃vO͗Lpł邱ƂĔЕz܂A*S̖ۏ *łB
Ɖ\̕ۏ؂ړIւ̓ḰAOɎꂽ̂ ܂߁AS
܂BڂGNU ʌOpB

Ȃ͂̃vOƋɁAGNU ʌOp̃Rs[ꕔ 󂯎
Ă͂łB󂯎ĂȂ΁A<http://www.gnu.org/licenses/> 
B

)

  āAʂȗOƂāAtake-okm ͂̃vÕR[h 
  "MFC(Microsoft Foundation Class library) Version 9.0" 
  (  邢 "MFC Version 9.0" ƓCZXKpꂽ
  "MFC Version 9.0" ̉ςꂽo[W)ƃNA
  Nꂽ҂܂ތ앨Еz鋖^܂B
  Ȃ "MFC" ȊOŎgĂ邷ׂ
  ̃R[hɊւĂ͑SʓIGNUʌOp_񏑂ɏ]Ȃ
  Ȃ܂BȂ̃t@CςȂ΁AȂ̗͂O
  Ȃ̃o[W̃t@CɈ݂邱Ƃł܂A
  `͂܂BO݂Ȃ΁A̗O
  Ȃ̃o[W͍폜ĂB)
*/
/*
// ****************************************************************
//	CdDedDispProp.cpp
// ****************************************************************
*/
/** @file */
#include "stdafx.h"
#include "..\DedRosenFileData\CdDedDispProp.h"

namespace DedRosenFileData{

// ****************************************************************
//	CdDedDispProp
// ****************************************************************

	// ********************************
	//	RXgN^
	// ********************************
CdDedDispProp::CdDedDispProp() :
		m_fontpropJikokuhyouVFont( 9 , "@lr SVbN" ) ,
		m_fontpropDiaEkimeiFont( 9 ,"lr SVbN"  ) ,
		m_fontpropDiaJikokuFont( 9 ,"lr SVbN"  ) ,
		m_fontpropDiaRessyaFont( 9 ,"lr SVbN"  ) ,
		m_fontpropViewComment( 9 ,"lr SVbN"  ) ,
		m_colorDiaMojiColor( CdColorProp( 0 , 0 , 0 ) ) ,
		m_colorDiaHaikeiColor( CdColorProp( 255 , 255 , 255 ) ) ,
		m_colorDiaRessyaColor( CdColorProp( 0 , 0 , 0 ) ) ,
		m_colorDiaJikuColor( CdColorProp(192 , 192 , 192 ) ) ,
		m_iEkimeiLength( 6 ) ,
		m_iJikokuhyouRessyaWidth( 5 ) 
{
	for ( int idx = 0 ; 
		idx < sizeof(m_arJikokuhyouFont) / sizeof(m_arJikokuhyouFont[0]) ;
		idx ++ )
	{
		m_arJikokuhyouFont[idx].setPointTextHeight( 9 )
			.setFacename("lr SVbN" ) ;
		if ( idx == 1 )
		{
			m_arJikokuhyouFont[idx].setBold( true ) ;
		}
		else if ( idx == 2 )
		{
			m_arJikokuhyouFont[idx].setItaric( true ) ;
		}
		else if ( idx == 3 )
		{
			m_arJikokuhyouFont[idx].setBold( true ).setItaric( true ) ;
		}

	}
};
	
	
// ********************************
//@name CdDedDispProp-
// ********************************
CdFontProp	CdDedDispProp::getJikokuhyouFont(int idx )const
{
	return 	m_arJikokuhyouFont[idx] ;
};
CdDedDispProp& CdDedDispProp::setJikokuhyouFont( 
	int idx , 
	const CdFontProp& value )
{
	m_arJikokuhyouFont[idx] = value ; 
	return *this ;
};

CdFontProp	CdDedDispProp::getJikokuhyouVFont()const
{	return m_fontpropJikokuhyouVFont ;}
CdDedDispProp& CdDedDispProp::setJikokuhyouVFont( const CdFontProp& value )
{	 m_fontpropJikokuhyouVFont = value ; return *this ;}


CdFontProp	CdDedDispProp::getDiaEkimeiFont()const
{
	return 	m_fontpropDiaEkimeiFont ;
};
CdDedDispProp& CdDedDispProp::setDiaEkimeiFont( const CdFontProp& value )
{
	m_fontpropDiaEkimeiFont = value ; return *this ;
};
CdFontProp	CdDedDispProp::getDiaJikokuFont()const
{
	return 	m_fontpropDiaJikokuFont ;
};
CdDedDispProp& CdDedDispProp::setDiaJikokuFont( const CdFontProp& value )
{
	m_fontpropDiaJikokuFont = value ; return *this ;
};
CdFontProp	CdDedDispProp::getDiaRessyaFont()const
{
	return 	m_fontpropDiaRessyaFont ;
};
CdDedDispProp& CdDedDispProp::setDiaRessyaFont( const CdFontProp& value )
{
	m_fontpropDiaRessyaFont = value ; return *this ;
};
CdFontProp	CdDedDispProp::getViewCommentFont()const
{	return m_fontpropViewComment ;};
CdDedDispProp& CdDedDispProp::setViewCommentFont( const CdFontProp& value )
{
	m_fontpropViewComment = value ; return *this ; 
};
		
		
CdColorProp	CdDedDispProp::getDiaMojiColor()const
{
	return m_colorDiaMojiColor ;
};
CdDedDispProp& CdDedDispProp::setDiaMojiColor( const CdColorProp& value )
{
	m_colorDiaMojiColor = value ; return *this ;
};
CdColorProp	CdDedDispProp::getDiaHaikeiColor()const
{
	return m_colorDiaHaikeiColor ;
};
CdDedDispProp& CdDedDispProp::setDiaHaikeiColor( const CdColorProp& value )
{
	m_colorDiaHaikeiColor = value ; return *this ;
};
CdColorProp	CdDedDispProp::getDiaRessyaColor()const
{
	return m_colorDiaRessyaColor ;
};
CdDedDispProp& CdDedDispProp::setDiaRessyaColor( const CdColorProp& value )
{
	m_colorDiaRessyaColor = value ; return *this ;
};
CdColorProp	CdDedDispProp::getDiaJikuColor()const
{
	return m_colorDiaJikuColor ;
};
CdDedDispProp& CdDedDispProp::setDiaJikuColor( const CdColorProp& value )
{
	m_colorDiaJikuColor = value ; return *this ;
};

int CdDedDispProp::getEkimeiLength()const
{ return m_iEkimeiLength ;};
CdDedDispProp& CdDedDispProp::setEkimeiLength( int value )
{
	m_iEkimeiLength = value ;
	if ( m_iEkimeiLength < 1 ){
		m_iEkimeiLength = 1 ;
	}
	if ( m_iEkimeiLength > 29 ){
		m_iEkimeiLength = 29 ;
	}
	return *this ;
};

int CdDedDispProp::getJikokuhyouRessyaWidth()const
{	return m_iJikokuhyouRessyaWidth ; };
CdDedDispProp& CdDedDispProp::setJikokuhyouRessyaWidth( int value )
{	
	m_iJikokuhyouRessyaWidth = value ;	
	if ( m_iJikokuhyouRessyaWidth < 4 )
	{
		m_iJikokuhyouRessyaWidth = 4 ;
	}
	if ( m_iJikokuhyouRessyaWidth > 8 )
	{
		m_iJikokuhyouRessyaWidth = 8 ;
	}
	return *this ;
};

std::string CdDedDispProp::createEkimeiExtentString()const 
{
	std::string	strRv ;
	for ( int idx = 0 ; idx < m_iEkimeiLength ; idx ++ )
	{
		strRv += "" ;
	}
	return strRv ;
};


void CdDedDispProp::clear()
{
	*this = CdDedDispProp() ; 
} ;

} //namespace DedRosenFileData
