/*
	OuDia - Win32 Application Software to draw a "Train Service Planning
 Diagram" based on a "Train Timetable".

Copyright (C) 2006-2017 take-okm

This program is free software; you can redistribute it and/or modify it 
under the terms of the GNU General Public License as published by the Free 
Software Foundation; either version 3 of the License, or (at your option) 
any later version. 

This program is distributed in the hope that it will be useful, but WITHOUT 
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or 
FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for 
more details. 

You should have received a copy of the GNU General Public License along with
 this program. If not, see <http://www.gnu.org/licenses/>.

  In addition, as a special exception, take-okm
  gives permission to link the code of this program with
  the "MFC(Microsoft Foundation Class library) Version 9.0" 
  (or with modified versions of "MFC Version 9.0" that use the same license as 
  "MFC Version 9.0" ), and distribute linked combinations including
  the two.  You must obey the GNU General Public License in all
  respects for all of the code used other than  "MFC".  If you modify
  this file, you may extend this exception to your version of the
  file, but you are not obligated to do so.  If you do not wish to
  do so, delete this exception statement from your version.


(: 

	OuDia - Ԏ\ƂɁA_CO`悷Win32AvP[V
B

Copyright (C) 2006-2017 take-okm 

̃vO̓t[\tgEFAłBȂ͂At[\tgEFA
cɂĔsꂽGNU ʌOp(o[W3Aȍ~̃o[W
̂ǂꂩ)߂̉ōĔЕz܂͉ 邱Ƃł܂B

̃vO͗Lpł邱ƂĔЕz܂A*S̖ۏ *łB
Ɖ\̕ۏ؂ړIւ̓ḰAOɎꂽ̂ ܂߁AS
܂BڂGNU ʌOpB

Ȃ͂̃vOƋɁAGNU ʌOp̃Rs[ꕔ 󂯎
Ă͂łB󂯎ĂȂ΁A<http://www.gnu.org/licenses/> 
B

)

  āAʂȗOƂāAtake-okm ͂̃vÕR[h 
  "MFC(Microsoft Foundation Class library) Version 9.0" 
  (  邢 "MFC Version 9.0" ƓCZXKpꂽ
  "MFC Version 9.0" ̉ςꂽo[W)ƃNA
  Nꂽ҂܂ތ앨Еz鋖^܂B
  Ȃ "MFC" ȊOŎgĂ邷ׂ
  ̃R[hɊւĂ͑SʓIGNUʌOp_񏑂ɏ]Ȃ
  Ȃ܂BȂ̃t@CςȂ΁AȂ̗͂O
  Ȃ̃o[W̃t@CɈ݂邱Ƃł܂A
  `͂܂BO݂Ȃ΁A̗O
  Ȃ̃o[W͍폜ĂB)
*/
/*
// ****************************************************************
//	CDedRessyaSoater.h
// $Id: CDedRessyaSoater.h 141 2012-10-20 08:03:25Z okm $
// ****************************************************************
*/
/** @file */
#ifndef  CDedRessyaSoater_h
#define  CDedRessyaSoater_h
#include "entDed\CentDedRosen.h"
#include "IfProgress.h"

namespace entDed{

// ****************************************************************
//	CDedRessyaSoater
// ****************************************************************
/**
@brief
yTvz
	CentDedRessyaDia ̗Ԃ̃\[gsNXB
	
	̃NX͒ۃNXłB
	hNXŃI[oChsA\[gASYKv܂B
	
yI[oChz

	1.  sortRessyaIndex() ̃I[oChsĂB
	@̊֐ł́AԃCfNXێReĩ\[gsĂB
	@(ԃCfNXReiɊi[ꂽ\[gʂɏ]
	  CentDedRessya ̃\[gŝ́A sortRessyaIndex() ̌Ăяoł sort() 
	 ӖłB)
	 (ԃIuWFNg CentDedRessya ł͂ȂAԃCfNX int \[g
	 dlɂȂĂ̂́AptH[}X̂߂łBCentDedRessya ̃Rs[ɂ
	 Ԃ邽߂łB)
	
ygz
	
	1.  RXgN^ŃIuWFNg𐶐ĂB
	
	2.@sort() \bhĂяoƁAthiśAw肳ꂽԃReîׂĂ̗Ԃ\[g܂B
*/
class CDedRessyaSoater
{
protected:
	// --------------------------------
	///@name sort ̉֐(templatep^[)
	// --------------------------------
	///@{
	/**
		\[gsIndexێReiɁA
		AԂ̗Indexi[܂B
	@param iRessyaIndex [in]
		擪̗Indexw肵ĂB
	@param iRessyaCount [in]
		Ԃ̐w肵ĂB
	@param muRessyaIndexOrder [out]
		̊֐͂̃ReiɁA
		iRessyaIndex ` iRessyaIndex + iRessyaCount - 1 
		AԂŊi[܂B
		̃Rei܂ŕێĂf[^͔j܂B

	*/
	static void makeRessyaIndex( 
		int iRessyaIndex , int iRessyaCount , 
		Mui<int>* muRessyaIndexOrder ) ;


	/**
		w肳ꂽIndex\[g܂B
	@param pRessyaCont [in]
		\[gΏۂ̗ԂێԂ̃Reiw肵ĂB
	@param muRessyaIndexOrder [in,out]
		\[gsIndexێReiw肵ĂB
		(FIndex0`4\[gꍇ́A
		{0,1,2,3,4} 5̗vfReiw肵ĂB
		̊֐͂̔zAwOrdeȓIndexɃ\[g܂B
	@param pIfProgress [in]
		iԂ̒ʒm󂯂ꍇ́AiԒʒm󂯎
		CX^Xւ̃|C^w肵ĂB
		NULLȂÅ֐͐iԂ̒ʒms܂B
	@note 
		̊֐œ\[gʂ
		sortRessyaByRessyaIndexOrder() ɓnƂɂA
		ԃRei\[g邱Ƃł܂B

	yI[oChz
	@hNXł́Å֐I[oChāA
	 ԃCfNXێReĩ\[gsĂB
	@(ԃCfNXReiɊi[ꂽ\[gʂɏ]
	  CentDedRessya ̃\[gŝ́A sortRessyaIndex() ̌Ăяoł sort() 
	 ӖłB)
	*/
	virtual void sortRessyaIndex( 
		const CentDedRessyaCont* pRessyaCont , 
		Mui<int>* muRessyaIndexOrder , 
		IfProgress* pIfProgress ) = 0 ;


	/**
		 index (int)ێReiɏ]āA
		ԃRei̗Ԃ̕яA
		ւ܂B
	@param muRessyaIndexOrder [in]
		IndexێReiw肵ĂB
	@param pRessyaCont [in,out]
		בւ̑ΏۂƂȂԃReiw肵ĂB
		̊֐͂̔zAmuRessyaIndexOrder ̏
		בւ܂B
	*/
	static void sortRessyaByRessyaIndexOrder( 
		const Mu<int>* muRessyaIndexOrder,
		CentDedRessyaCont* pRessyaCont ) ;
	///@}

public:
	// ********************************
	//	RXgN^EfXgN^
	// ********************************
	virtual ~CDedRessyaSoater(){} ;

public:
	// ********************************
	///@name 
	// ********************************
	///@{
	/**
		w肳ꂽԃRei̗ԂAŎw肳ꂽŃ\[g܂B
	@param pRessyaCont [in,out]
		בւ̑ΏۂƂȂԃReiw肵ĂB
	@param pIfProgress [in]
		iԂ̒ʒm󂯂ꍇ́AiԒʒm󂯎
		CX^Xւ̃|C^w肵ĂB
		NULLȂÅ֐͐iԂ̒ʒms܂B
	*/
	virtual void sort( 
		CentDedRessyaCont* pRessyaCont ,
		IfProgress* pIfProgress ) ;
	///@}

};

} //namespace entDed

#endif /*CDedRessyaSoater_h*/
