/*
	OuDia - Win32 Application Software to draw a "Train Service Planning
 Diagram" based on a "Train Timetable".

Copyright (C) 2006-2017 take-okm

This program is free software; you can redistribute it and/or modify it 
under the terms of the GNU General Public License as published by the Free 
Software Foundation; either version 3 of the License, or (at your option) 
any later version. 

This program is distributed in the hope that it will be useful, but WITHOUT 
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or 
FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for 
more details. 

You should have received a copy of the GNU General Public License along with
 this program. If not, see <http://www.gnu.org/licenses/>.

  In addition, as a special exception, take-okm
  gives permission to link the code of this program with
  the "MFC(Microsoft Foundation Class library) Version 9.0" 
  (or with modified versions of "MFC Version 9.0" that use the same license as 
  "MFC Version 9.0" ), and distribute linked combinations including
  the two.  You must obey the GNU General Public License in all
  respects for all of the code used other than  "MFC".  If you modify
  this file, you may extend this exception to your version of the
  file, but you are not obligated to do so.  If you do not wish to
  do so, delete this exception statement from your version.


(: 

	OuDia - Ԏ\ƂɁA_CO`悷Win32AvP[V
B

Copyright (C) 2006-2017 take-okm 

̃vO̓t[\tgEFAłBȂ͂At[\tgEFA
cɂĔsꂽGNU ʌOp(o[W3Aȍ~̃o[W
̂ǂꂩ)߂̉ōĔЕz܂͉ 邱Ƃł܂B

̃vO͗Lpł邱ƂĔЕz܂A*S̖ۏ *łB
Ɖ\̕ۏ؂ړIւ̓ḰAOɎꂽ̂ ܂߁AS
܂BڂGNU ʌOpB

Ȃ͂̃vOƋɁAGNU ʌOp̃Rs[ꕔ 󂯎
Ă͂łB󂯎ĂȂ΁A<http://www.gnu.org/licenses/> 
B

)

  āAʂȗOƂāAtake-okm ͂̃vÕR[h 
  "MFC(Microsoft Foundation Class library) Version 9.0" 
  (  邢 "MFC Version 9.0" ƓCZXKpꂽ
  "MFC Version 9.0" ̉ςꂽo[W)ƃNA
  Nꂽ҂܂ތ앨Еz鋖^܂B
  Ȃ "MFC" ȊOŎgĂ邷ׂ
  ̃R[hɊւĂ͑SʓIGNUʌOp_񏑂ɏ]Ȃ
  Ȃ܂BȂ̃t@CςȂ΁AȂ̗͂O
  Ȃ̃o[W̃t@CɈ݂邱Ƃł܂A
  `͂܂BO݂Ȃ΁A̗O
  Ȃ̃o[W͍폜ĂB)
*/
/*
// ****************************************************************
//	entDed\CRessyaContUnifier.cpp
// $Id: CRessyaContUnifier.cpp 378 2016-11-16 21:10:54Z okm $
// ****************************************************************
*/
/** @file */
#include "stdafx.h"
#include <vector>
#include "CRessyaContUnifier.h"

namespace entDed{
	using std::string ;

// ****************************************************************
//	CRessyaContUnifier
// ****************************************************************
	// ********************************
	//@name CRessyaContUnifier-static 
	// ********************************
void CRessyaContUnifier::unify( 
		Mui<CentDedRessya>* pMuiRessya ,
		int iRessyaIndex ,
		int iRessyaIndex2 ) 
{
	CentDedRessya	aRessya = pMuiRessya->get( iRessyaIndex ) ;
	CentDedRessya	aRessya2 = pMuiRessya->get( iRessyaIndex2 ) ;
	// ================================	
	//	w
	// ================================	
	for ( int iEkiOrder = 0 ; iEkiOrder < aRessya.getCentDedEkiJikokuCount() ; iEkiOrder ++ )
	{
		CentDedEkiJikoku	aJikoku = aRessya.getCentDedEkiJikoku( iEkiOrder ) ;
		CentDedEkiJikoku	aJikoku2 = aRessya2.getCentDedEkiJikoku( iEkiOrder ) ;
		//	iRessyaIndex2 ԁEʉ߂ȂAw̓Rs[܂B
		//	ẃANULLȊȌꍇ̓Rs[܂B
		if ( aJikoku2.getEkiatsukai() == CentDedEkiJikoku::Ekiatsukai_Teisya ||
			aJikoku2.getEkiatsukai() == CentDedEkiJikoku::Ekiatsukai_Tsuuka )
		{
			aJikoku.setEkiatsukai( aJikoku2.getEkiatsukai() ) ;
			if ( !aJikoku2.getChakujikoku().isNull() )
			{
				aJikoku.setChakujikoku( aJikoku2.getChakujikoku() ) ;
			}
			if ( !aJikoku2.getHatsujikoku().isNull() )
			{
				aJikoku.setHatsujikoku( aJikoku2.getHatsujikoku() ) ;
			}

			aRessya.setCentDedEkiJikoku( iEkiOrder , aJikoku ) ;
		}
	}
	// ================================	
	//	^sȂEoRȂ ĔzuB
	//	nw`Iw̉^sȂ͌oRȂ
	//	nwȑOEIwȌ̌oRȂ͉^sȂɁAύX܂
	// ================================	
	int iRunFirstEkiOrder = aRessya.getRunFirstEkiOrder() ;
	int iRunLastEkiOrder = aRessya.getRunLastEkiOrder() ;
	for ( int iEkiOrder = 0 ; iEkiOrder < aRessya.getCentDedEkiJikokuCount() ; iEkiOrder ++ )
	{
		CentDedEkiJikoku aEkiJikoku = aRessya.getCentDedEkiJikoku( iEkiOrder ) ;

		//	nw`Iw̉^sȂ͌oRȂɕύX
		if ( iRunFirstEkiOrder <= iEkiOrder && 
			iEkiOrder <= iRunLastEkiOrder )
		{
			if ( aEkiJikoku.getEkiatsukai() == CentDedEkiJikoku::Ekiatsukai_None )
			{
				aEkiJikoku.setEkiatsukai( CentDedEkiJikoku::Ekiatsukai_Keiyunasi );
			}
		}
		//	nwȑOEIwȌ̌oRȂ͉^sȂɁAύX܂
		else 
		{
			if ( aEkiJikoku.getEkiatsukai() == CentDedEkiJikoku::Ekiatsukai_Keiyunasi )
			{
				aEkiJikoku.setEkiatsukai( CentDedEkiJikoku::Ekiatsukai_None );
			}
		}

		aRessya.setCentDedEkiJikoku( iEkiOrder , aEkiJikoku ) ;
	}
	// ================================	
	//	1Ԗڂ̗Ԃɉwݒ
	//	2Ԗڂ̗Ԃ͍폜
	// ================================	
	pMuiRessya->set( aRessya , iRessyaIndex ) ;
	pMuiRessya->erase( iRessyaIndex2 ) ;
}

	// ********************************
	//	RXgN^EfXgN^
	// ********************************
CRessyaContUnifier::CRessyaContUnifier()
{
}
CRessyaContUnifier::~CRessyaContUnifier() 
{
}

	// ********************************
	//@name 
	// ********************************
void CRessyaContUnifier::unify( 
		Mui<CentDedRessya>* pMuiRessya ,
		IfProgress* pIfProgress ) 
{
	int iRv = 0 ; 

	// Ԕԍ̃LbV쐬
	//	́ApMuiRessya->get()x(ڂ́ACentDedRessyãRs[RXgN^x)
	//	߂łB
	vector<string>	arstrRessyabangou ;
	arstrRessyabangou.reserve( pMuiRessya->size() ) ;
	for ( int iRessyaIndex = 0 ; iRessyaIndex < pMuiRessya->size() ; iRessyaIndex ++ )
	{
		arstrRessyabangou.push_back( pMuiRessya->get( iRessyaIndex ).getRessyabangou() ) ;
	}

	//	Ԕԍ̓̂{
	for ( int iRessyaIndex = 0 ; 
		iRv == 0 && iRessyaIndex < pMuiRessya->size() - 1 ; 
		iRessyaIndex ++ )
	{
		string	strRessyabangou = arstrRessyabangou[iRessyaIndex] ;

		//	Ԕԍ󕶎łȂꍇɂA{s܂
		if ( strRessyabangou.length() > 0 )
		{
			//	{Ώۂ̗Ԃ
			for ( int iRessyaIndex2 = iRessyaIndex + 1 ;
				iRessyaIndex2 <  pMuiRessya->size() ;
				iRessyaIndex2 ++ )
			{
				//	ԔԍȂA{s܂B
				if ( strRessyabangou == arstrRessyabangou[iRessyaIndex2] )
				{
					unify( pMuiRessya , iRessyaIndex , iRessyaIndex2 ) ;

					//LbV̍XV
					arstrRessyabangou.erase( arstrRessyabangou.begin() + iRessyaIndex2 ) ;

					iRessyaIndex2 -- ;
				}
			}
		}


		// ================================
		//	i\
		// ================================
		if ( pIfProgress != NULL )
		{
			int iProgressResult = pIfProgress->onNotifyProgress( 
				iRessyaIndex , pMuiRessya->size() ) ;
			if ( iProgressResult != 0 )
			{
				iRv = iProgressResult ;
			}
		}
	}
	/*
	//	Ԕԍ̓̂{
	for ( int iRessyaIndex = 0 ; 
		iRv == 0 && iRessyaIndex < pMuiRessya->size() - 1 ; 
		iRessyaIndex ++ )
	{
		CentDedRessya	aRessya = pMuiRessya->get( iRessyaIndex ) ;
		//TODO:Muconst CentDedRessya* 擾悤ɕύX
		string	strRessyabangou = aRessya.getRessyabangou() ;

		//	Ԕԍ󕶎łȂꍇɂA{s܂
		if ( strRessyabangou.length() > 0 )
		{
			CentDedRessya	aRessya2( aRessya.getCentDedEkiJikokuCount() , 
				aRessya.getRessyahoukou() ) ;
			
			int iRessyaIndex2 ;
			// ================================
			//	{Ώۂ̗Ԃ
			// ================================
			for ( iRessyaIndex2 = iRessyaIndex + 1 ;
				iRessyaIndex2 <  pMuiRessya->size() ;
				iRessyaIndex2 ++ )
			{
				aRessya2 = pMuiRessya->get( iRessyaIndex2 ) ;
				//TODO:Muconst CentDedRessya* 擾悤ɕύX

				// ================================
				//	ԔԍȂA{s܂B
				// ================================
				if ( strRessyabangou == aRessya2.getRessyabangou() )
				{
					unify( pMuiRessya , iRessyaIndex , iRessyaIndex2 ) ;
					iRessyaIndex2 -- ;
				}
			}
		}


		// ================================
		//	i\
		// ================================
		if ( pIfProgress != NULL )
		{
			int iProgressResult = pIfProgress->onNotifyProgress( 
				iRessyaIndex , pMuiRessya->size() ) ;
			if ( iProgressResult != 0 )
			{
				iRv = iProgressResult ;
			}
		}
	}
	*/
}

} //namespace entDed


