/*
	OuDia - Win32 Application Software to draw a "Train Service Planning
 Diagram" based on a "Train Timetable".

Copyright (C) 2006-2017 take-okm

This program is free software; you can redistribute it and/or modify it 
under the terms of the GNU General Public License as published by the Free 
Software Foundation; either version 3 of the License, or (at your option) 
any later version. 

This program is distributed in the hope that it will be useful, but WITHOUT 
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or 
FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for 
more details. 

You should have received a copy of the GNU General Public License along with
 this program. If not, see <http://www.gnu.org/licenses/>.

  In addition, as a special exception, take-okm
  gives permission to link the code of this program with
  the "MFC(Microsoft Foundation Class library) Version 9.0" 
  (or with modified versions of "MFC Version 9.0" that use the same license as 
  "MFC Version 9.0" ), and distribute linked combinations including
  the two.  You must obey the GNU General Public License in all
  respects for all of the code used other than  "MFC".  If you modify
  this file, you may extend this exception to your version of the
  file, but you are not obligated to do so.  If you do not wish to
  do so, delete this exception statement from your version.


(: 

	OuDia - Ԏ\ƂɁA_CO`悷Win32AvP[V
B

Copyright (C) 2006-2017 take-okm 

̃vO̓t[\tgEFAłBȂ͂At[\tgEFA
cɂĔsꂽGNU ʌOp(o[W3Aȍ~̃o[W
̂ǂꂩ)߂̉ōĔЕz܂͉ 邱Ƃł܂B

̃vO͗Lpł邱ƂĔЕz܂A*S̖ۏ *łB
Ɖ\̕ۏ؂ړIւ̓ḰAOɎꂽ̂ ܂߁AS
܂BڂGNU ʌOpB

Ȃ͂̃vOƋɁAGNU ʌOp̃Rs[ꕔ 󂯎
Ă͂łB󂯎ĂȂ΁A<http://www.gnu.org/licenses/> 
B

)

  āAʂȗOƂāAtake-okm ͂̃vÕR[h 
  "MFC(Microsoft Foundation Class library) Version 9.0" 
  (  邢 "MFC Version 9.0" ƓCZXKpꂽ
  "MFC Version 9.0" ̉ςꂽo[W)ƃNA
  Nꂽ҂܂ތ앨Еz鋖^܂B
  Ȃ "MFC" ȊOŎgĂ邷ׂ
  ̃R[hɊւĂ͑SʓIGNUʌOp_񏑂ɏ]Ȃ
  Ȃ܂BȂ̃t@CςȂ΁AȂ̗͂O
  Ȃ̃o[W̃t@CɈ݂邱Ƃł܂A
  `͂܂BO݂Ȃ΁A̗O
  Ȃ̃o[W͍폜ĂB)
*/
//$Id: CentDedEkiJikokuCont.cpp 378 2016-11-16 21:10:54Z okm $
/** @file */
#include "stdafx.h"
#include "CentDedEkiJikokuCont.h"
#include "CentDedRosen.h"
#include "CentDedRessya.h"

namespace entDed{

	// ********************************
	//	RXgN^
	// ********************************
CentDedEkiJikokuCont::CentDedEkiJikokuCont() 
{
}
CentDedEkiJikokuCont& CentDedEkiJikokuCont::operator=( const CentDedEkiJikokuCont& value ) 
{
	CentDedRosen* pRosen = getRosen() ;

	//operator=: this Ḧꕔłꍇ́Aw͕̐ύX܂
	if ( pRosen != NULL )
	{
		int i ; 
		for ( i = 0 ;i < this->size() && i < value.size() ; i ++ )
		{
			this->set( value.get( i ) , i ) ; 
		}
		//	Eӂ̕vfȂꍇ́Aӂ̎cvf͋Ŗ߂܂B
		for ( ; i < this->size() ; i++ )
		{
			this->set( CentDedEkiJikoku() , i ) ; 
		}
	}
	else
	{
		super::operator =( value ) ;
	}
	return *this ;
}


	// ********************************
	///@name Mui
	// ********************************
int CentDedEkiJikokuCont::insert( const CentDedEkiJikoku& element , int iIndex )
{
	CentDedRosen* pRosen = getRosen() ;

	//	ԂḦꕔłꍇ̓G[B
	//	(ƂƉwƉw̐vĂȂꍇ́AG[ɂȂق
	//	悢܂B)
	if ( pRosen != NULL && pRosen->getCentDedEkiCont()->size() == size() )
	{
		return -11 ;	//	ԂḦꕔłꍇAw̒ǉ͂ł܂B
	}

	return super::insert( element , iIndex ) ;
}
	
int CentDedEkiJikokuCont::erase( int iIndex  , int iSize ) 
{
	CentDedRosen* pRosen = getRosen() ;

	//	ԂḦꕔłꍇ̓G[B
	if ( pRosen != NULL && pRosen->getCentDedEkiCont()->size()  == size() )
	{
		return -11 ;	//	ԂḦꕔłꍇAw̍폜͂ł܂B
	}
	return super::erase( iIndex , iSize ) ;
}
	
int CentDedEkiJikokuCont::set( const CentDedEkiJikoku& element , int iIndex )
{
	return super::set( element , iIndex ) ;
}


	// ********************************
	//@name CentDedEkiJikokuCont-֘A
	// ********************************
CentDedRosen* CentDedEkiJikokuCont::getRosen()
{
	CentDedRessya* pRessya = getRessya() ;
	if ( pRessya == NULL ){	return NULL ;}
	CentDedRessyaCont* pDiaCont = dynamic_cast<CentDedRessyaCont*>( pRessya->getParent() ) ;
	if ( pDiaCont == NULL ){	return NULL ;}
	return pDiaCont->getRosen() ;
}
const CentDedRosen* CentDedEkiJikokuCont::getRosen()const
{
	const CentDedRessya* pRessya = getRessya() ;
	if ( pRessya == NULL ){	return NULL ;}
	const CentDedRessyaCont* pDiaCont = dynamic_cast<const CentDedRessyaCont*>( pRessya->getParent() ) ;
	if ( pDiaCont == NULL ){	return NULL ;}
	return pDiaCont->getRosen() ;
}

	// ********************************
	//@name CentDedEkiJikokuTrackCont-
	// ********************************
int CentDedEkiJikokuCont::setable(  const CentDedEkiJikoku& element , int iIndex )const 
{
	const CentDedRosen* pCentDedRosen = getRosen() ;
	if ( pCentDedRosen != NULL )
	{
	}
	return 0 ; 
}

int CentDedEkiJikokuCont::getIndex( const CentDedEkiJikoku* element )const
{
	const Mu<const CentDedEkiJikoku*>* pMu = getMuPtr() ;
	for ( int idx = 0 ; idx < pMu->size() ; idx ++ ){
		if ( pMu->get( idx ) == element ){	return idx ;}
	}
	return -1 ;
}
void CentDedEkiJikokuCont::adjust()
{
	//w(CentDedEkiJikoku)̗vfwRei(CentDedEkiCont)
	//ƈقȂꍇ́AwǉE폜܂B
	CentDedRosen* pCentDedRosen = getRosen() ;
	if ( pCentDedRosen != NULL )
	{
		CentDedEkiCont* pCentDedEkiCont = pCentDedRosen->getCentDedEkiCont() ;
		//	wȂꍇ͒ǉ
		while ( size() < pCentDedEkiCont->size() )
		{
			insert( CentDedEkiJikoku() ) ; 
		}
		//	wꍇ͍폜
		while( size() >  pCentDedEkiCont->size() )
		{
			erase( INT_MAX ) ;
		}

	}

	// --------------------------------
	Mu<CentDedEkiJikoku*>* pMu = getMuPtr() ;
	for ( int idx = 0 ; idx < pMu->size() ; idx ++ ){
		pMu->get( idx )->adjust() ;
	}
}

	// ********************************
	//@name CentDedRosen-qIuWFNg̑̒ʒm
	// ********************************
void CentDedEkiJikokuCont::onEkiInsert( int iEkiOrder )
{
	super::insert( CentDedEkiJikoku() , iEkiOrder ) ;
}

void CentDedEkiJikokuCont::onEkiErase( int iEkiOrder  )
{
	super::erase( iEkiOrder ) ;
}

void CentDedEkiJikokuCont::onEkiTrackInsert( int iEkiOrder , int iEkiTrackIndex )
{
	getMuPtr()->get( iEkiOrder )->onEkiTrackInsert(  iEkiTrackIndex ) ;
}
void CentDedEkiJikokuCont::onEkiTrackErase( int iEkiOrder , int iEkiTrackIndex )
{
	getMuPtr()->get( iEkiOrder )->onEkiTrackErase( iEkiTrackIndex ) ;
}



}; //namespace entDed

