/*
	OuDia - Win32 Application Software to draw a "Train Service Planning
 Diagram" based on a "Train Timetable".

Copyright (C) 2006-2017 take-okm

This program is free software; you can redistribute it and/or modify it 
under the terms of the GNU General Public License as published by the Free 
Software Foundation; either version 3 of the License, or (at your option) 
any later version. 

This program is distributed in the hope that it will be useful, but WITHOUT 
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or 
FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for 
more details. 

You should have received a copy of the GNU General Public License along with
 this program. If not, see <http://www.gnu.org/licenses/>.

  In addition, as a special exception, take-okm
  gives permission to link the code of this program with
  the "MFC(Microsoft Foundation Class library) Version 9.0" 
  (or with modified versions of "MFC Version 9.0" that use the same license as 
  "MFC Version 9.0" ), and distribute linked combinations including
  the two.  You must obey the GNU General Public License in all
  respects for all of the code used other than  "MFC".  If you modify
  this file, you may extend this exception to your version of the
  file, but you are not obligated to do so.  If you do not wish to
  do so, delete this exception statement from your version.


(: 

	OuDia - Ԏ\ƂɁA_CO`悷Win32AvP[V
B

Copyright (C) 2006-2017 take-okm 

̃vO̓t[\tgEFAłBȂ͂At[\tgEFA
cɂĔsꂽGNU ʌOp(o[W3Aȍ~̃o[W
̂ǂꂩ)߂̉ōĔЕz܂͉ 邱Ƃł܂B

̃vO͗Lpł邱ƂĔЕz܂A*S̖ۏ *łB
Ɖ\̕ۏ؂ړIւ̓ḰAOɎꂽ̂ ܂߁AS
܂BڂGNU ʌOpB

Ȃ͂̃vOƋɁAGNU ʌOp̃Rs[ꕔ 󂯎
Ă͂łB󂯎ĂȂ΁A<http://www.gnu.org/licenses/> 
B

)

  āAʂȗOƂāAtake-okm ͂̃vÕR[h 
  "MFC(Microsoft Foundation Class library) Version 9.0" 
  (  邢 "MFC Version 9.0" ƓCZXKpꂽ
  "MFC Version 9.0" ̉ςꂽo[W)ƃNA
  Nꂽ҂܂ތ앨Еz鋖^܂B
  Ȃ "MFC" ȊOŎgĂ邷ׂ
  ̃R[hɊւĂ͑SʓIGNUʌOp_񏑂ɏ]Ȃ
  Ȃ܂BȂ̃t@CςȂ΁AȂ̗͂O
  Ȃ̃o[W̃t@CɈ݂邱Ƃł܂A
  `͂܂BO݂Ȃ΁A̗O
  Ȃ̃o[W͍폜ĂB)
*/
/*
// ****************************************************************
//	CDcdText.h
// ****************************************************************
*/
/** @file */
#ifndef  CDcdText_h
#define  CDcdText_h

#include <string>

#include "str\tstring.h"

#include "DcDraw\/IfDcDraw.h"
#include "DcdCd\DcDrawProp\CdDrawTextProp.h"

namespace DcDrawLib{
namespace DcDraw{

// ****************************************************************
//	CDcdText
// ****************************************************************
/**
* @brief
* yTvz
* 	   DcDrawfɂAeLXg̕`sACełB
*
*	  ̃IuWFNgɑ΂ DcDraw() ĂяoƁAw肳ꂽ̈
*	 m_strText ̃eLXg݂܂B
*/
class CDcdText : public IfDcDraw
{
// ********************************
///@name 
// ********************************
///@{
 private:
	/**
	*	`悷镶łB
	*	ftHgł͋󕶎łB
	*/
	tstring			m_strText ;

	/**
	*	eLXg`悷ۂ̑ێ܂B
	*	ftHgł́ADEFAULT_GUI_FONT Psŕ`悵܂B
	*/
	CdDrawTextProp	m_CdDrawTextProp ;
	
	/**
	*	̕`敔ȋ傫̖ڈƂȂ
	*	łB
	*	getItemSize() ́A̕\ł镝Ԃ܂B
	*	getItemSize() gȂ̂ł΁Ȃ͎g܂B
	*
	*	ftHg͋󕶎łB̏ꍇAgetItemSize() ́A
	*	m_strText `悷̂ɕKvȃTCYԂ܂B
	*/
	tstring			m_strExtent ;
	
	/**
	*	̕`敔ȋ傫̍sł
	*	getItemSize() ́A̍s\ł鍂Ԃ܂B
	*	getItemSize() gȂ̂ł΁Ȃ͎g܂B
	*
	*	ftHg͂PłB
	*/
	int				m_iLinesExtent ;
	
///@}

	
// ********************************
//	RXgN^
// ********************************
 public:
	/**
	* @param strText [in]
	*	`悷镶łB
	* @param aCdDrawTextProp [in]
	*	eLXg`悷ۂ̑ێ܂B
	*	ftHgł́ADEFAULT_GUI_FONT Psŕ`悵܂B
	* @param strExtent [in]
	*	̕`敔ȋ傫̖ڈƂȂ
	*	ł
	*	ftHg͋󕶎łB̏ꍇAgetItemSize() ́A
	*	strText `悷̂ɕKvȃTCYԂ܂B
	* @param iLinesExtent [in]
	*	̕`敔ȋ傫̍sł
	*	getItemSize() ́A̍s\ł鍂Ԃ܂B
	*	ftHg͂PłB
	*/
	CDcdText( 
		const tstring&			strText,
		const CdDrawTextProp&	aCdDrawTextProp ,
		const tstring&			strExtent = TEXT("") ,
		int						iLinesExtent = 1 
	) ;
	
	CDcdText() ;
	
	virtual ~CDcdText() ;
	
// ********************************
///@name	IfDcDraw
// ********************************
///@{
 public:
	/**
	* 	`v܂B
	* 	̊֐́A pIfDcdTarget ɁA`s܂B
	*
	*	yI[oChz
	*	  nꂽ̈ɁA m_strText `悵܂B
	* @param pIfDcdTarget  [in]
	* 	̃IuWFNgɕ`s킹DCƗ̈w肵ĂB
	* @return
	* 	`sꍇ͐^Ë̗ւ̕`悪łȂꍇ͋UłB
	*/
	virtual bool DcDraw( IfDcdTarget* pIfDcdTarget ) ;
	
	/**
	* 	̃IuWFNg`悷ACȇ傫܂Ăꍇ́A
	* 	̑傫𒲂ׂ邱Ƃł܂B
	* 	֐Ăяo IfDcDraw IuWFNg`悷ꍇɂ́A
	* 	֐ĂяóÅ֐ŃACȇ傫𒲂ׂāA
	* 	K؂ȃCAEglĂADcDraw() s邱Ƃł܂B
	*
	*	yI[oChz
	*	  m_strExtent  m_lineExtent ƂɁÄ̃TCYvZ܂B
	* @param pIfDcdTarget [in]
	* 	̃IuWFNgɕ`s킹DCƗ̈w肵ĂB
	* @param pCdDcdSizeXy [out]
	* 	̃IuWFNg̕`悷ACȇ傫܂Ăꍇ́A
	* 	̊֐͂̃AhXɁÃACẽTCYԂ܂B
	* 	̃IuWFNg̕`悷ACȇ傫܂ĂȂꍇ́A
	* 	̒l͕słB
	* @return
	* 	̃IuWFNg̕`悷ACȇ傫܂ĂāA
	* 	̑傫 *pCdDcdSizeXyɏ񂾏ꍇ͐^łB
	* 	łȂꍇ́AUłB
	*/
	virtual bool getItemSize( IfDcdTarget* pIfDcdTarget , 
							CdDcdSizeXy* pCdDcdSizeXy ) ;
///@}
// ********************************
//	CDcdText
// ********************************
 public:
	// ********************************
	///	@name 
	// ********************************
	///@{
	virtual tstring			getText(){	return m_strText ;	} ;
	virtual CDcdText& setText( const tstring& ev ){	
		m_strText = ev ;	return *this ; } ;
//	virtual CDcdText& setBkColor( const tstring& ev ){	
//		m_SetBkColor = ev ;	return *this ; } ;
	virtual CdDrawTextProp	getCdDrawTextProp(){	return m_CdDrawTextProp ;};
	virtual CDcdText& setCdDrawTextProp( const CdDrawTextProp& ev ){
		m_CdDrawTextProp = ev ;	return *this ; } ;
	virtual tstring			getExtent(){	return m_strExtent ;	} ;
	virtual CDcdText& setExtent( const tstring& ev ){
		m_strExtent = ev ;	return *this ;	};
	virtual int				getLinesExtent(){	return m_iLinesExtent ;	} ;
	virtual CDcdText& setLinesExtent( int ev ){
		m_iLinesExtent = ev ;	return *this ; } ;
	///@}
};

} //namespace DcDraw
} //namespace DcDrawLib

#endif /*CDcdText_h*/
