/*
	OuDia - Win32 Application Software to draw a "Train Service Planning
 Diagram" based on a "Train Timetable".

Copyright (C) 2006-2017 take-okm

This program is free software; you can redistribute it and/or modify it 
under the terms of the GNU General Public License as published by the Free 
Software Foundation; either version 3 of the License, or (at your option) 
any later version. 

This program is distributed in the hope that it will be useful, but WITHOUT 
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or 
FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for 
more details. 

You should have received a copy of the GNU General Public License along with
 this program. If not, see <http://www.gnu.org/licenses/>.

  In addition, as a special exception, take-okm
  gives permission to link the code of this program with
  the "MFC(Microsoft Foundation Class library) Version 9.0" 
  (or with modified versions of "MFC Version 9.0" that use the same license as 
  "MFC Version 9.0" ), and distribute linked combinations including
  the two.  You must obey the GNU General Public License in all
  respects for all of the code used other than  "MFC".  If you modify
  this file, you may extend this exception to your version of the
  file, but you are not obligated to do so.  If you do not wish to
  do so, delete this exception statement from your version.


(: 

	OuDia - Ԏ\ƂɁA_CO`悷Win32AvP[V
B

Copyright (C) 2006-2017 take-okm 

̃vO̓t[\tgEFAłBȂ͂At[\tgEFA
cɂĔsꂽGNU ʌOp(o[W3Aȍ~̃o[W
̂ǂꂩ)߂̉ōĔЕz܂͉ 邱Ƃł܂B

̃vO͗Lpł邱ƂĔЕz܂A*S̖ۏ *łB
Ɖ\̕ۏ؂ړIւ̓ḰAOɎꂽ̂ ܂߁AS
܂BڂGNU ʌOpB

Ȃ͂̃vOƋɁAGNU ʌOp̃Rs[ꕔ 󂯎
Ă͂łB󂯎ĂȂ΁A<http://www.gnu.org/licenses/> 
B

)

  āAʂȗOƂāAtake-okm ͂̃vÕR[h 
  "MFC(Microsoft Foundation Class library) Version 9.0" 
  (  邢 "MFC Version 9.0" ƓCZXKpꂽ
  "MFC Version 9.0" ̉ςꂽo[W)ƃNA
  Nꂽ҂܂ތ앨Еz鋖^܂B
  Ȃ "MFC" ȊOŎgĂ邷ׂ
  ̃R[hɊւĂ͑SʓIGNUʌOp_񏑂ɏ]Ȃ
  Ȃ܂BȂ̃t@CςȂ΁AȂ̗͂O
  Ȃ̃o[W̃t@CɈ݂邱Ƃł܂A
  `͂܂BO݂Ȃ΁A̗O
  Ȃ̃o[W͍폜ĂB)
*/
/*
// ****************************************************************
//	CSelect.h
//$Id: CSelect.h 296 2016-06-11 05:40:21Z okm $
// ****************************************************************
*/
/** @file */
#ifndef  DcDraw_DcdGrid_WndDcdGrid3_CSelect_h
#define  DcDraw_DcdGrid_WndDcdGrid3_CSelect_h

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include <afxwin.h>
#include "NsOu\Ou.h"
#include "DcDraw\IfDcDraw.h"
#include "DcdGrid\WndDcdGrid3\CSelectCell.h"

namespace DcDrawLib{
namespace DcdGrid{
namespace WndDcdGrid3{
	
class CPropStack ;

// ****************************************************************
//	WndDcdGrid3::CSelect
// ****************************************************************
/**
@brief
	CWndDcdGrid CellSelect(ZI)NX̂łB

 WndDcdGrid3::CWndDcdGrid ׂ̂ẴZIԂێNXłB
 ZP̑IԂێ CSelectCell AZ̐W񂵂܂B
 
 ̃NX́A CWndDcdGrid  Iɐ邽߂ɑ݂܂B
ȊO̗pl͂܂B

 ygz

(1) ̃NX̃IuWFNǵA WndDcdGrid3::CWndDcdGrid Ő܂B
WndDcdGrid3::CWndDcdGrid::getCSelect() ŁAIuWFNgɃANZXł܂B

(2) @WndDcdGrid3::CSelect::getCell() \bhŁAZ̑I󋵂
\ WndDcdGrid3::CSelectCell IuWFNg擾邱Ƃł܂B
 WndDcdGrid3::CSelectCell::setIsSelected() \bhp邱ƂɂA
ZIԂɂ邱Ƃł܂B

*/
class CSelect
{
	friend class CWndDcdGrid ;
public:
	// ****************************************************************
	//	CWndDcdGrid::CSelect::ESelectMode
	// ****************************************************************
	/**
		CWndDcdGrid̃ZĨ[h\܂B
	*/
	enum ESelectMode
	{ 
		/// (ftHg)I͕s\łB(CSelectCell::m_bIsSelected ͖)
		SelectMode_NONE , 	
		/// XEY񗼕̑I\łB
		SelectMode_XY , 
		/// X̑Î݉\łBY͏펞SIƂȂ܂B
		SelectMode_XColumn , 
		/// Y̑Î݉\łBX͏펞SIƂȂ܂B
		SelectMode_YColumn ,
	};
protected:
	// --------------------------------
	//	Ci[^Cv
	// --------------------------------
	typedef	std::deque< CSelectCell* > CSelectYColumnCellCont ;
	typedef	std::deque< CSelectYColumnCellCont* > CSelectCellCont ;
private:
	// ********************************
	///@name ֘A
	// ********************************
	///@{
	/**
		ÓA CWndDcdGrid ւ̊֘AłB
		̃IuWFNg̔j̐Ӗ́ANX[U[ɂ܂B
		̃IuWFNǵA this 蒷ȂĂ͂Ȃ܂B
		RXgN^Ō܂܂B
	 */
	CWndDcdGrid*	m_pCWndDcdGrid ;

	/**
		IZɑ΂āAI}[N`悷
		DcDraw IuWFNgłB
	 */
	Ou<IfDcDraw>	m_pIfDcDrawSelect ;
	///@}

private:
	// ********************************
	///@name 
	// ********************************
	///@{
	/**
		I}[N̕`̈Ɍr܂߂邩ۂ̎włB
		- true: I}[N̕`̈ɁAZ̉EǍr܂߂܂B
			ԍĚr(ObhŜ̍Ěr)͔͈͂Ɋ܂߂܂B
		- false: I}[N̕`̈ɁAZ̉EǍr܂߂܂B

		l true łB
	*/
	bool m_bIncludeRbBorder ;

	/**
		CWndDcdGrid̃ZĨ[h\܂B
		ĺA SelectMode_NONE łB
	*/
	ESelectMode	m_eSelectMode ;

	/**
		I\͈́B
		Pʂ̓ZԍłB

		̑́AZ̐傫lƂ邱Ƃł܂B@n
		(m_ColumnNumberSelectLimit.getX().getEndPos()
			>CDcdGrid::getXColumnCount()
		ɂȂ邱Ƃł܂BYlłB)

		I\Ȕ͈́BftHǵAX,YƂ 
		Pos 0 ASizeINT_MAXƂȂ܂B
	*/
	CdDcdZoneXy	m_ColumnNumberSelectLimit ;

	/**
	@brief CWndDcdGridŜ̍XV̗L/

	  ZI̕ύX CWndDcdGrid ŜXV邩ۂw肵܂B

	  - true: (ftHg)ZI(CSelectCell::m_bIsSelected)̕ύXɁA
	  	CWndDcdGrid ŜXV܂( CWndDcdGrid::update())Ăяo)B
	  - false: ZI(CSelectCell::m_bIsSelected)̕ύXɂA 
	  	CWndDcdGrid Ŝ̍XV͍s܂B

	   false  true ɕύXꍇ́ACWndDcdGrid ŜXV܂B

	  uZI̕ύXv́A
	  	CSelectCell::m_bIsSelected ̕ωw܂B
	*/
	bool m_bUpdateCWndDcdGrid ;

	///@}
 private:
	// ********************************
	///	@name W
	// ********************************
	///@{
	/**
	  	ZIuWFNgێReiłB
	  	
	  	̃Rei̗vf́AYColumn ̐ɓȂ܂B
	  	̃Rei̊evf́A XColumn  CDcdGridCell ێ
	  	ReiłB
	  	
	  	āA
	  
	  	m_CDcdGridCellCont[Yԍ][Xԍ]
	  
	  	̌`ŁAΉ CDcdGridCell IuWFNgɃANZXł܂B
	  
	  	ReĩIuWFNg̔j̐Ӗ́Athisɂ܂B
	 */
	CSelectCellCont 	m_CSelectCellCont ;
	///@}
public:
	// ********************************
	///@name 萔
	// ********************************
	///@{
	///@}

private:
	// --------------------------------
	///@name f[^
	// --------------------------------
	///@{
	/**
		CWndDcdGrid̃ZĨ[h̑OlB
		update_updateScreen() ōXV܂B
		
		̑́Am_eSelectMode  SelectMode_NONE ̂ƂɁA
		̃NX̏yʉ邽߂Ɏgp܂B
		
		m_eSelectMode  SelectMode_NONE ɕύXꂽꍇ́A
		SĂ̑IZ܂B
		
		m_eSelectMode  SelectMode_NONE łԂ́A
		update_adjustProp()Eupdate_updateScreen()EOnPaint()
		Ƀ^[܂B
		
	*/
	ESelectMode	m_eSelectMode_Prev ;

	/**
		IĂZ̐B
		update_adjustProp() ōXV܂B
	*/
	int	m_iSelectedCellCount ;

	///@}

protected:
	// --------------------------------
	///@name ֐
	// --------------------------------
	///@{


	/**
	  setYColumnCount()  insertYColumn() ̉֐łB

	  YPAẅʒuɒǉ܂B
	  ̊֐́A 
	    m_CDcdGridXColumnCont,m_CDcdGridYColumnCont,
	    m_CDcdGridCellCont
	̑s܂B
	adjustProp() ͍s܂B

	@param iYColumnNumber [in]
		  Yԍw肵ĂB
		VǉꂽY񂪁AYԍɂȂ܂B
		͈͂ 0 ȏ getYColumnNumber() ȉŁA
		0 Ȃ擪EgetYColumnNumber() Ȃ疖ւ̒ǉƂȂ܂B
		  A INT_MAX w肷ƁAw肵ƂɂȂ܂B
	@return
		0ȏAG[Ȃ畉̐łB
		-	-2 ;	//	CfNXs
	 */
	int insertYColumn_insertColumnCell( int iYColumnNumber ) ;

	/**
	  setXColumnCount()  insertXColumn() ̉֐łB

	  XPAẅʒuɒǉ܂B
	  ̊֐́A 
	    m_CDcdGridXColumnCont,m_CDcdGridYColumnCont,
	    m_CDcdGridCellCont
	̑s܂B
	  adjustProp() ͍s܂B

	@param iXColumnNumber [in]
		Xԍw肵ĂB
		VǉꂽX񂪁AXԍɂȂ܂B
		͈͂ 0 ȏ getXColumnNumber() ȉŁA
		0 Ȃ擪EgetXColumnNumber() Ȃ疖ւ̒ǉƂȂ܂B
		  A INT_MAX w肷ƁAw肵ƂɂȂ܂B
	@return
		0ȏAG[Ȃ畉̐łB
		-	-2 ;	//	CfNXs
	 */
	int insertXColumn_insertColumnCell( int iXColumnNumber ) ;
	
	/**
  	setYColumnCount()  eraseYColumn() ̉֐łB
  
  	YPA폜܂B
  	̊֐́A 
  	m_CDcdGridXColumnCont,m_CDcdGridYColumnCont,
  	m_CDcdGridCellCont
  	̑s܂B
  	adjustProp() ͍s܂B

	@param iYColumnNumber [in]
  		Yԍw肵ĂB
  		͈͂ 0 ȏ getYColumnNumber() łB
  		  A INT_MAX w肷ƁAw肵ƂɂȂ܂B
	@return
	  	0ȏAG[Ȃ畉̐łB
	   -	-2 ;	//	CfNXs
	 */
	int eraseYColumn_eraseColumnCell( int iYColumnNumber ) ;

	/**
	setXColumnCount()  eraseXColumn() ̉֐łB

	XPA폜܂B
	̊֐́A 
	m_CDcdGridXColumnCont,m_CDcdGridYColumnCont,
	m_CDcdGridCellCont
	̑s܂B
	adjustProp() ͍s܂B

	@param iXColumnNumber [in]
	  	Xԍw肵ĂB
	  	͈͂ 0 ȏ getXColumnNumber() łB
	  	  A INT_MAX w肷ƁAw肵ƂɂȂ܂B
	@return
	  	0ȏAG[Ȃ畉̐łB
	   -	-2 ;	//	CfNXs
	 */
	int eraseXColumn_eraseColumnCell( int iXColumnNumber ) ;

	/**
	ZIύX́ACPropStack CX^X𐶐܂B
	̃IuWFNǵAԒ͈ȉ̑ݒ肵܂B

	- CSelect::m_bUpdateCWndDcdGrid = false

	 ɂāAZIύX̕`œK܂B
	 (̃Z̑IύXꍇ́ȂfalseɂԂ
	 Z̑IԂύXĂȂtrueɂ
	 ʂĕ`悷قA悭Ȃ܂B) 
	*/
	Ou<CPropStack> createPropStackForSelectChange() ;

	///@}
protected:
	// --------------------------------
	///@name WndDcdGrid3::CDcdGrid ̈Ϗ
	// --------------------------------
	///@{
	/**
  	  this ́AV Column ꂽɁÅ֐Ăяo܂B
  	  V Column ɑ΂āA IfDcDraw C^[tF[XIuWFNg
  	̐Eo^͂߂Ƃs܂B
  
  	̊֐I[oCh邱ƂɂA Column ɓL̏
  	sƂł܂B
  	
	@param iXColumnNumber [in]
	  	  V Column ̗ԍłB
	@param pCDcdGridXColumn [in,out]
	  	  Vꂽ CDcdGridXColumn IuWFNgłB
	  	  ̊֐͂̃IuWFNgɑ΂āAsƂł܂B
	  	
	[I[oCh]
		 CSelectCell IuWFNg̒ǉE폜s܂B
	 */
	virtual void OnCreateXColumn( int iXColumnNumber ) ;
	
	/**
	  this ́AColumn j钼OɁÅ֐Ăяo܂B
	  j Column ɑ΂āA IfDcDraw C^[tF[XIuWFNg
	o^Ej͂߂Ƃns܂B

	̊֐I[oCh邱ƂɂA Column ɓĽn
	sƂł܂B
	  	
	@param iXColumnNumber [in]
	  	  j Column ̗ԍłB
	  	
	[I[oCh]
	   CSelectCell IuWFNg̒ǉE폜s܂B
	 */
	virtual void OnDeleteXColumn( int iXColumnNumber ) ;

	/**
	  this ́AV Column ꂽɁÅ֐Ăяo܂B
	  V Column ɑ΂āA IfDcDraw C^[tF[XIuWFNg
	̐Eo^͂߂Ƃs܂B

	  ̊֐I[oCh邱ƂɂA Column ɓL̏
	sƂł܂B
	  	
	@param iYColumnNumber [in]
	  V Column ̗ԍłB

	[I[oCh]
	   CSelectCell IuWFNg̒ǉE폜s܂B
	 */
	virtual void OnCreateYColumn( int iYColumnNumber ) ;
	
	/**
	  this ́AColumn j钼OɁÅ֐Ăяo܂B
	  j Column ɑ΂āA IfDcDraw C^[tF[XIuWFNg
	o^Ej͂߂Ƃns܂B

	    ̊֐I[oCh邱ƂɂA Column ɓĽn
	sƂł܂B

	@param iYColumnNumber [in]
		j Column ̗ԍłB

	[I[oCh]
	   CSelectCell IuWFNg̒ǉE폜s܂B
	 */
	virtual void OnDeleteYColumn( int iYColumnNumber ) ;

	///@}
protected:
	// --------------------------------
	///@name CWndDcdGrid ̈Ϗ
	// --------------------------------
	///@{
	/**
		CWndDcdGrid::update() ̉֐łB
	
		- ̕␳
		- CSelectCell ւ̈Ϗ

		s܂B

	y1.̕␳z

	1.ColumnNumberSelectLimitɂACSelectCell::m_bIsSelected ̐KB

	1.1.m_eSelectMode  SelectMode_NONE ̏ꍇA
	ׂẴZIɂ܂B

	1.2.m_eSelectMode  SelectMode_XColumn ̏ꍇA
	Xԍ(c)̃Z̑I󋵂ׂēɂ܂B

	1.2.1.ꂩ̃Z CSelectCell::m_bIsSelected trueɕύXĂA
	ׂẴZtrueɂ܂B

	1.2.2.ꂩ̃Z CSelectCell::m_bIsSelected falseɕύXĂA
	ׂẴZfalseɂ܂B

	1.2,3.Z̑I󋵂ύXĂȂꍇ́A
	SẴZ̑I󋵂Am_ColumnNumberSelectLimit.getY().getPos() 
	I󋵂Ɠɂ܂B

	1.3. m_eSelectMode  SelectMode_YColumn ̏ꍇA
	Yԍ()̃Z̑I󋵂ׂēɂ܂B
	K̕@́A SelectMode_XColumn ƓlłB

	2.ColumnNumberSelectLimitɂACSelectCell::m_bIsSelected ̐KB

	2.1.m_ColumnNumberSelectLimit ȊÖ̗悪IĂꍇ
	̑I܂B
	
	 @return 
		ǨʁA炩̒lωꍇ͐^łB
	 */
	bool update_adjustProp() ;

	/**
	CWndDcdGrid::update() ̉֐łB
	̕ωAʏɔf܂B

	CSelectCell::update_updateScreen() ւ̈Ϗs܂B

	CSelectCell::update_updateScreen() ́Am_bIsSelected 
	ύXꂽAZ̗̈𖳌AXVw܂B
		
	@return 
		炩̒l̕ωʏɔfꍇ͐^łB
	 */
	bool update_updateScreen() ;


	/**
	CWndDcdGrid ̓ꃁ\bḧϏ󂯂܂B

	`v܂B
	̊֐́A pIfDcdTarget ɁA`s܂B

	@param pIfDcdTarget  [in]
	 	̃IuWFNgɕ`s킹DCƗ̈w肵ĂB
	 	CWndDcdGrid̃NCAg̈ IfDcdTarget w肵ĂB
	@return
	 	`sꍇ͐^Ë̗ւ̕`悪łȂꍇ͋UłB
	*/
	virtual bool OnPaint( IfDcdTarget* pIfDcdTarget ) ;

	/**
		CWndDcdGrid ̓ꃁ\bḧϏ󂯂܂B

		̃NXł́A͂܂B
	*/
	void OnSize(UINT nType, int cx, int cy);

	/**
		CWndDcdGrid ̓ꃁ\bḧϏ󂯂܂B

		̃NXł́A͂܂B
	*/
	void OnSetFocus(CWnd* pOldWnd);
	/**
		CWndDcdGrid ̓ꃁ\bḧϏ󂯂܂B

		̃NXł́A͂܂B
	*/
	void OnKillFocus(CWnd* pNewWnd);
	/**
		CWndDcdGrid ̓ꃁ\bḧϏ󂯂܂B

		͂܂
	 */
	virtual void InvalidateGrid( ) ;


	///@}
public:
	// ********************************
	//	RXgN^
	// ********************************
	/**
	@param pCWndDcdGrid [in]
		ÓA CWndDcdGrid ւ̊֘AłB
		̃IuWFNg̔j̐Ӗ́ANX[U[ɂ܂B
		̃IuWFNǵA this 蒷ȂĂ͂Ȃ܂B
	 */
	CSelect( CWndDcdGrid* pCWndDcdGrid ) ;
	virtual ~CSelect() ;
public:
	// ********************************
	///@name CSelect ֘A
	// ********************************
	///@{
	CWndDcdGrid*	getCWndDcdGrid() ;
	Ou<IfDcDraw>	getIfDcDrawSelect() ;
	void setIfDcDrawSelect( Ou<IfDcDraw> value ) ;
	///@}


	// ********************************
	///@name CSelect 
	// ********************************
	///@{
	bool getIncludeRbBorder()const ;
	void setIncludeRbBorder( bool ev )  ;
	ESelectMode	getSelectMode()const ;
	void setSelectMode( ESelectMode	value ) ;
	CdDcdZoneXy	getColumnNumberSelectLimit()const ;
	void setColumnNumberSelectLimit( const CdDcdZoneXy& value ) ;

	/**
	@return
		I\͈́BPʂ̓ZԍłB
		߂ĺA񐔈ȓɐK܂B
		(߂l
		CdDcdZoneXy::getX().getEndPos() ́A
		CDcdGrid::getXColumnCount() ȉɐK܂B
	*/
	CdDcdZoneXy	getColumnNumberSelectLimitRegularized()const ;
 
	bool getUpdateCWndDcdGrid()const ;
	void setUpdateCWndDcdGrid( bool ev ) ;

	///@}
	// ********************************
	///@name CSelect W
	// ********************************
	///@{
	/**
	  	  w肳ꂽYEXԍ́AZIuWFNg CSelectCell ̃|C^
	  	擾邱Ƃł܂B̃|C^gāAZɑ΂鑀
	  	sƂł܂B
	   @param iXColumnNumber [in] 
	  	 Xԍw肵ĂB͈͂́A0ȏ getXColumnCount() łB
	   @param iYColumnNumber [in] 
	  	 Yԍw肵ĂB͈͂́A0ȏ getYColumnCount() łB
	   @return
	  	  ΉZIuWFNgԂ܂B
	  	  CfNXsȏꍇ́ANULLԂ܂B
	  
	  	  ԂꂽIuWFNg̔j̐Ӗ́Athisɂ܂B
	  	  YX CDcdGrid ̕ʂ̃\bhɂč폜ƁAԂꂽ
	  	|C^͖ɂȂ܂B
	  	   thisjꂽƂɂAԂꂽ|C^͖ɂȂ܂B
	 */
	virtual CSelectCell*	getCell( int iXColumnNumber , int iYColumnNumber );
 

	/**
		w CSelectCell IuWFNǵAԍԂ܂B
	@param pCSelectCell [in]
		CDcdGridCell IuWFNgw肵ĂB
	@return
		XԍԂ܂B
		IuWFNg CDcdGrid IuWFNgɏW񂳂ĂȂꍇ́A
		INT_MIN łB
	*/
	virtual int getXColumnNumberOfCell( 
		CSelectCell* pCSelectCell ) ;
	/**
		w CSelectCell IuWFNǵAԍԂ܂B
	@param pCSelectCell [in]
		CDcdGridCell IuWFNgw肵ĂB
	@return
		YԍԂ܂B
		IuWFNg CDcdGrid IuWFNgɏW񂳂ĂȂꍇ́A
		INT_MIN łB
	*/
	virtual int getYColumnNumberOfCell( 
		CSelectCell* pCSelectCell ) ;
	///@}
	// ********************************
	///@name CSelect 
	// ********************************
	///@{
	

	/**
	w̃Z̑I\s͈͂A
	_P(ʏ̓sNZBNCAgW)ŕԂ܂B

	@param pIfDcdTarget [in]
		`Ώۂw肵ĂB
	@param iXColumnNumber [in]
		Z̗ԍw肵ĂB
	@param iYColumnNumber [in]
		Z̗ԍw肵ĂB
	@param bIncludeRbBorder [in]
		true ȂA͈͂ɁAZ̉EǍr܂߂܂B
	@return 
		Z̑I\͈̔͂Ԃ܂B
	@attention
		ԍĚr(ObhŜ̍Ěr)͔͈͂Ɋ܂߂܂B
	*/
	virtual CdDcdZoneXy getZoneOfCellSelection(
		IfDcdTarget* pIfDcdTarget , 
		int iXColumnNumber , int iYColumnNumber , bool bIncludeRbBorder ) ;

	/**
		SẴZI܂B
	*/
	virtual void selectAll() ;
	/**
		SẴZ̑I܂B
	*/
	virtual void clearSelect() ;

	/**
	@return 
		IĂZ̐Ԃ܂B
	*/
	int getSelectedCellCount()const ;

	/**
	@return 
		m_eSelectMode  SelectMode_XColumn ̏ꍇA
		IĂ̐Ԃ܂B

		m_eSelectMode  SelectMode_XColumn ȊȌꍇ0łB
	*/
	int getSelectedXColumnCount()const ;

	/**
	@return 
		m_eSelectMode  SelectMode_YColumn ̏ꍇA
		IĂ̐Ԃ܂B

		m_eSelectMode  SelectMode_YColumn ȊȌꍇ0łB
	*/
	int getSelectedYColumnCount()const ;

	/**
	  m_eSelectMode  SelectMode_XColumn ̏ꍇA
	w̗ Index ̑IԂ擾܂B

	@param iColumnNumber [in]
	  	 Xԍw肵ĂB͈͂́A0ȏ getXColumnCount() łB
	@return 
		񂪑IĂ true B

		m_eSelectMode  SelectMode_XColumn ȊȌꍇA
		̃\bh͖łB
	*/
	bool getXColumnNumberSelected( int iColumnNumber ) ;

	/**
	  m_eSelectMode  SelectMode_XColumn ̏ꍇA
	w̗ Index ̑IԂݒ肵܂B
	  ̃\bhɂAw肳ꂽ̃Z 
	CSelectCell::m_bIsSelected ς܂

	@param iColumnNumber [in]
	  	 Xԍw肵ĂB͈͂́A0ȏ getXColumnCount() łB
	@param bIsSelected [in]
		Iꍇ true A Iꍇ false B

		m_eSelectMode  SelectMode_XColumn ȊȌꍇA
		̃\bh͖łB
	*/
	void setXColumnNumberSelected( int iColumnNumber , bool bIsSelected ) ;

	/**
	  m_eSelectMode  SelectMode_XColumn , SelectMode_YColumn ̏ꍇA
	w̗ Index ̑IԂ擾܂B

	@param iColumnNumber [in]
	  	 Yԍw肵ĂB͈͂́A0ȏ getYColumnCount() łB
	@return 
		񂪑IĂ true B

		m_eSelectMode  SelectMode_YColumn ȊȌꍇA
		̃\bh͖łB
	*/
	bool getYColumnNumberSelected( int iColumnNumber ) ;

	/**
	  m_eSelectMode  SelectMode_YColumn ̏ꍇA
	  w̗ Index ̑IԂݒ肵܂B
	  ̃\bhɂAw肳ꂽ̃Z 
	CSelectCell::m_bIsSelected ς܂

	@param iColumnNumber [in]
	  	Yԍw肵ĂB͈͂́A0ȏ getYColumnCount() łB
	@param bIsSelected [in]
		Iꍇ true A Iꍇ false B

		m_eSelectMode  SelectMode_YColumn ȊȌꍇA
		̃\bh͖łB
	*/
	void setYColumnNumberSelected( int iColumnNumber , bool bIsSelected ) ;

	///@}


};

} //namespace WndDcdGrid3
} //namespace DcdGrid
} //namespace DcDrawLib

#endif //DcDraw_DcdGrid_WndDcdGrid3_CSelect_h
