/*
	OuDia - Win32 Application Software to draw a "Train Service Planning
 Diagram" based on a "Train Timetable".

Copyright (C) 2006-2017 take-okm

This program is free software; you can redistribute it and/or modify it 
under the terms of the GNU General Public License as published by the Free 
Software Foundation; either version 3 of the License, or (at your option) 
any later version. 

This program is distributed in the hope that it will be useful, but WITHOUT 
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or 
FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for 
more details. 

You should have received a copy of the GNU General Public License along with
 this program. If not, see <http://www.gnu.org/licenses/>.

  In addition, as a special exception, take-okm
  gives permission to link the code of this program with
  the "MFC(Microsoft Foundation Class library) Version 9.0" 
  (or with modified versions of "MFC Version 9.0" that use the same license as 
  "MFC Version 9.0" ), and distribute linked combinations including
  the two.  You must obey the GNU General Public License in all
  respects for all of the code used other than  "MFC".  If you modify
  this file, you may extend this exception to your version of the
  file, but you are not obligated to do so.  If you do not wish to
  do so, delete this exception statement from your version.


(: 

	OuDia - Ԏ\ƂɁA_CO`悷Win32AvP[V
B

Copyright (C) 2006-2017 take-okm 

̃vO̓t[\tgEFAłBȂ͂At[\tgEFA
cɂĔsꂽGNU ʌOp(o[W3Aȍ~̃o[W
̂ǂꂩ)߂̉ōĔЕz܂͉ 邱Ƃł܂B

̃vO͗Lpł邱ƂĔЕz܂A*S̖ۏ *łB
Ɖ\̕ۏ؂ړIւ̓ḰAOɎꂽ̂ ܂߁AS
܂BڂGNU ʌOpB

Ȃ͂̃vOƋɁAGNU ʌOp̃Rs[ꕔ 󂯎
Ă͂łB󂯎ĂȂ΁A<http://www.gnu.org/licenses/> 
B

)

  āAʂȗOƂāAtake-okm ͂̃vÕR[h 
  "MFC(Microsoft Foundation Class library) Version 9.0" 
  (  邢 "MFC Version 9.0" ƓCZXKpꂽ
  "MFC Version 9.0" ̉ςꂽo[W)ƃNA
  Nꂽ҂܂ތ앨Еz鋖^܂B
  Ȃ "MFC" ȊOŎgĂ邷ׂ
  ̃R[hɊւĂ͑SʓIGNUʌOp_񏑂ɏ]Ȃ
  Ȃ܂BȂ̃t@CςȂ΁AȂ̗͂O
  Ȃ̃o[W̃t@CɈ݂邱Ƃł܂A
  `͂܂BO݂Ȃ΁A̗O
  Ȃ̃o[W͍폜ĂB)
*/
/*
// ****************************************************************
//	dir\Directries.h
// ****************************************************************
*/
/** @file
* @brief
* yTvz
*	  fBNg̃t@CfBNg̈ꗗ擾֐
*	^Ă܂B
*/
#ifndef  Directries_h
#define  Directries_h
#include <string>
#include <deque>

namespace OuLib{
namespace Dir{


// ****************************************************************
//	IfDirCallback
// ****************************************************************
/**
 * @brief
 *	findDir() E findFile() ֐ɓo^R[obNC^[tF[XłB
 */
class IfDirCallback
{
 public:
	/**
		t@CEfBNgAďoɒʒm܂B
	 @param strName [in]
		t@CEfBNg
	 */
	virtual void OnNameFound( const std::string& strName ) = 0 ;
};



// ****************************************************************
///@name t@C/fBNg
// ****************************************************************
///@{
/**
 	ɍvfBNg܂B

	ʏ̃fBNgɂ Dirnames() gpł܂B

 	fBNg̎wɂ́A*?̃ChJ[h
 	gp邱Ƃł܂B
 	ChJ[h́A̍ŉʂ
 	fBNgɂAgp\ł
 		iF"c:\windows\*" "c:\windows\???" "c:\user\s*" j 
	
	̊֐́AfBNg݂閈ɁAo^ꂽ IfDirCallback 
	C^[tF[X̊֐ IfDirCallback::OnNameFound() Ăяo܂B
 @param strSearch [in]
 	@w肵ĂB
 @param bSubdirectrySearch [in]
 	@^ȂATufBNgΏۂɊ܂߂܂B
 @param pIfDirCallback [in]
	  ̊֐́AfBNg邲ƂɁA
	 pIfDirCallback->OnNameFound() ŁAOʒm܂B
	 NULL ͎wł܂B
 @return
 	  AOȏiO̐jAG[Ȃ畉̐łB
		-	-1 ;	//	p[^sł\n
			strSearch ̖ "."  , ".." w肷邱Ƃ͂ł܂B
 @attention
 	 strSearch ̖ "." ( JgfBNg ) , ".." (efBNg) 
	w肷邱Ƃ͂ł܂B̏ꍇ́A -1 Ԃ܂B
	  JgfBNg̐efBNg̃TufBNgw肷ꍇ́A"..\*"
	w肵ĂB
 */
int findDir( const std::string& strSearch , 
						bool bSubdirectrySearch , 
						IfDirCallback* pIfDirCallback ) ;

/**
 	ɍvt@C܂B

	ʏ̃fBNgɂ Filenames() gpł܂B

 	t@C̎wɂ́A*?̃ChJ[h
 	gp邱Ƃł܂B
 	ChJ[h́A̍ŉʂ
 	t@CɂAgp\ł
 		iF"c:\windows\*" "c:\windows\???" "c:\user\s*" j 
	
	̊֐́At@C݂閈ɁAo^ꂽ IfDirCallback 
	C^[tF[X̊֐ IfDirCallback::OnNameFound() Ăяo܂B
	B* @param strSearch [in]
 	@w肵ĂB
 @param bSubdirectrySearch [in]
 	@^ȂATufBNgΏۂɊ܂߂܂B
 @param pIfDirCallback [in]
	  ̊֐́At@C邲ƂɁA
	 pIfDirCallback->OnNameFound() ŁAOʒm܂B
	 NULL ͎wł܂B
 @return
 	  AOȏiO̐jAG[Ȃs̐łB
 */
int  findFile( const std::string& strSearch , 
						bool bSubdirectrySearch ,
						IfDirCallback* pIfDirCallback ) ;

///@}
// ****************************************************************
///@name fBNg쐬
// ****************************************************************
///@{
/**
	TufBNg쐬܂B
	ĩTufBNgxɍ쐬邱Ƃł܂B
@param strDir [in]
	fBNgw肵ĂB
	 "\" ́AĂȂĂ܂܂B
@return
	 0 ȏAG[Ȃ畉̐łB
	-	1 ;	//	fBNg̍쐬ɐ܂B
	-	0 ;	//	fBNg͊ɑ݂Ă܂B
	-	-1 ;	//	fBNg̍쐬Ɏs܂B
*/
int mkdirs( const std::string& strDir ) ;

/** 
	w肳ꂽfBNgł΁ÃfBNg폜܂B 
	w肳ꂽfBNg̃TufBNg̋̃fBNgׂ 
	폜܂B 

	w肵Ȃꍇ́AJgfBNgw肵̂Ƃ݂Ȃ܂B 

@param strDir [in] 
	폜fBNgw肵ĂB
@param pErrorStream [in]
@return 
	-	0 ;	//	fBNg͍폜ł܂B 
	-	-1 ;	//	strDir̍폜Ɏs܂B 
	-	-2 ;	//	̃fBNgɂ̓t@C܂B 
	-	-3 ;	//	TufBNg̍폜Ɏs܂B 
*/ 
int rmempdir( const std::string& strDir , FILE* pErrorStream ) ;

///@}
// ****************************************************************
//	CDirCallback_StrContainer< class StrContainerType >
// ****************************************************************
/**
 @brief
	findDir() E findFile() ֐Ōt@CA
	STLReiɒǉR[obNNXłB

ygz

  Dirnames() , Filenames() ֐QlɂĂB

 @param StrContainerType
	std::string i[STLReiw肵ĂB@n
	() std::deque< std::string > std::vector< std::string >
*/
template< class StrContainerType >
class CDirCallback_StrContainer : public IfDirCallback
{
 private:
	// ********************************
	/// @name ֘A	
	// ********************************
	///@{
	/**
		findDir() E findFile() ֐Ōt@CA
		ǉSTLReiB
		̃IuWFNg̔j̐Ӗ͕炷[U[ɂ܂B
		̃IuWFNǵA this 蒷ȂĂ
		Ȃ܂B
	 */
	StrContainerType*	m_pStrContainerType ;
	///@}
 public:
	// ********************************
	//	RXgN^
	// ********************************
	/**
	 @param pStrContainerType [in]
		findDir() E findFile() ֐Ōt@CA
		ǉSTLReiB
		̃IuWFNg̔j̐Ӗ̓NX[U[ɂ܂B
		̃IuWFNǵA this 蒷ȂĂ
		Ȃ܂B
	 */
	CDirCallback_StrContainer( StrContainerType* pStrContainerType )
		: m_pStrContainerType( pStrContainerType ){};
 public:
	// ********************************
	///@name IfDirCallback	
	// ********************************
	///@{
	/**
		t@CEfBNgAďoɒʒm܂B
	 @param strName [in]
		t@CEfBNg
	
	 [I[oCh]
		m_pStrContainerType wReiɁCpush_back()\bh
		Oǉ܂B
	 */
	virtual void OnNameFound( const std::string& strName ) 
	{
		m_pStrContainerType->push_back( strName ) ;
	};
	///@}
};

// ****************************************************************
///@name t@C/fBNg
// ****************************************************************
///@{

/**
 	Dirnames() Filenames() t@C̈ꗗi[Rei
 */
typedef std::deque<std::string> ContFilenames ;

/**
 	ɍvfBNgA
 	̈ꗗ̃ReiԂ܂B
 	fBNg̎wɂ́A*?̃ChJ[h
 	gp邱Ƃł܂B
 	ChJ[h́A̍ŉʂ
 	fBNgɂAgp\ł
 		iF"c:\windows\*" "c:\windows\???" "c:\user\s*" j 
@param strSearch
 	@w肵ĂB
@param bSubdirectrySearch
 	@^ȂATufBNgΏۂɊ܂߂܂B
@return
 	  ɍvfBNgi[
 	stlReiłB
@attention
 	 strSearch ̖ "." ( JgfBNg ) , ".." (efBNg) 
	w肷邱Ƃ͂ł܂B̏ꍇ́A ߂l̃Rei
	vf 0 ɂȂ܂B
 */
inline ContFilenames Dirnames( const std::string& strSearch , 
						bool bSubdirectrySearch )
{
	ContFilenames	aContFilename ;
	CDirCallback_StrContainer<ContFilenames>	aCallback( &aContFilename ) ;
	findDir( strSearch , bSubdirectrySearch , &aCallback ); 
	return ( aContFilename ) ;
}

/**
 	ɍvt@CA
 	̈ꗗ̃ReiԂ܂B
 	t@C̎wɂ́A*?̃ChJ[h
 	gp邱Ƃł܂B
 	ChJ[h́A̍ŉʂ
 	t@CɂAgp\ł
 		iF"c:\windows\*" "c:\windows\???" "c:\user\s*" j 
@param strSearch
 	@w肵ĂB
@param bSubdirectrySearch
 	@^ȂATufBNgΏۂɊ܂߂܂B
@return
 	  ɍvt@Ci[
 	stlReiłB
 */
inline ContFilenames Filenames( const std::string& strSearch , 
						bool bSubdirectrySearch )
{
	ContFilenames	aContFilename ;
	CDirCallback_StrContainer<ContFilenames>	aCallback( &aContFilename ) ;
	findFile( strSearch , bSubdirectrySearch , &aCallback ); 
	return ( aContFilename ) ;
}
///@}


} //namespace Dir{
} //namespace OuLib{

#endif /*Directries_h*/

